Welcome to SQL Manager for IB/FB!

EMS SQL Manager for InterBase/Firebird is a powerful tool for InterBase/Firebird database server administration and development. SQL Manager for InterBase/Firebird works with InterBase versions up to 2020 and Firebird versions up to 4.0, and supports all InterBase and Firebird latest features. It offers plenty of powerful tools for experienced users to satisfy all their needs. SQL Manager has a new state-of-the-art graphical user interface with well-described wizard system, so clear in use that even a newbie will not be confused with it.

Visit our web-site for details: https://www.sqlmanager.net/

Key features

  • Compatibility with Firebird server versions up to 4.0 and InterBase server versions up to 2020
  • Support of Unicode data
  • Rapid database management and navigation
  • Easy management of all InterBase and Firebird objects with Unicode supporting editors
  • Advanced data manipulation tools
  • Effective security management
  • Excellent visual and text tools for query building
  • Impressive data export and import capabilities
  • Database Designer to handle database structure in a few clicks
  • Easy-to-use wizards performing InterBase and Firebird services
  • Powerful tools to make your work with InterBase and Firebird as easy as it can be
  • Report designer with clear in use report construction wizard
  • Handy interface with dark schema support

Product information

Homepage | https://www.sqlmanager.net/products/ibfb/manager
Support Ticket System | https://www.sqlmanager.net/support
Register online at | https://www.sqlmanager.net/products/ibfb/manager/buy


What's new

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

What's new?

Version | Release date
SQL Manager for InterBase/Firebird 6.2.2 | November 18, 2024

What's new in SQL Manager for InterBase/Firebird 6.2.2?

  • Foreign keys have been added to Search by metadata.
  • Alias for NCHAR data type has been added.
  • New SQL SECURITY parameter added in triggers editor.
  • Data for BINARY and VARBINARY data types is displayed in BLOB editor now.
  • The issue with connection to Dialect 1 Firebird 4 databases has been fixed.
  • The width of the DB Explorer in Floating windows mode is restored correctly now.
  • Foreign keys were not displayed in DB Explorer in some cases. Fixed now.
  • Some fixes applied to the 'Show data types' option.
  • Automatically set privileges WITH GRANT option have been fixed.
  • Encoding of template files is read correctly now.
  • The correct error is displayed on writing logs to a non-accessible file.
  • Unsupported options disabled for validating InterBase databases.
  • Other fixes and improvements.

See also:

Version history


System requirements

System requirements for SQL Manager for InterBase/Firebird

  • Microsoft Windows XP, Microsoft Windows Server 2003, Microsoft Windows Server 2008, Microsoft Windows Server 2008 R2, Microsoft Windows Server 2012, Microsoft Windows Server 2012 R2, Microsoft Windows Server 2016, Microsoft Windows Server 2019, Microsoft Windows Vista, Microsoft Windows 7, Microsoft Windows 8/8.1, Microsoft Windows 10, Microsoft Windows 11, Microsoft Windows 11 ARM
  • 512 Mb RAM or more; 1024 Mb or more recommended
  • 200 Mb of available HD space for program installation
  • InterBase/Firebird client library. Its bit depth must be the same as the program's.
  • Possibility to connect to any local or remote InterBase/Firebird server
  • Supported InterBase and Firebird server versions: InterBase - up to 2020; Firebird - up to 5.0


Feature Matrix

The FREE Lite version of SQL Manager for InterBase/Firebird does not include all features of the Full version and has some limitations concerning the number of the databases that can be registered and the set of data manipulation and server maintenance tools. The detailed feature matrix is given below.

Note that when using the FREE Lite version of SQL Manager for InterBase/Firebird you can activate a 30-day period of fully-functional usage. After the period expires, you will be able to continue using the Lite version.

For more information on activating the Full version features see Full Mode activation.

 | Full version | Lite version
Latest InterBase and Firebird versions support
Compatible with any Firebird server version up to 5.0 | + | +
Compatible with any InterBase server version up to 2020 | + | +
Compatible with Red Database | + | +
Trigger messages support | + | +
Support of BLOB Filters | + | +
Powerful and easy-to-use graphical user interface
MDI and floating-window styles implementation | + | +
Handy database explorer to manage all InterBase/Firebird objects | + | +
Customizable toolbars for all program windows | + | +
Fully customizable program interface | + | +
Saving all program settings | + | +
Localizable program interface | + | +
Rapid database management and navigation
Multiple host/database connections | + | +
Connecting via local port forwarding through the SSH tunnel | + | -
Registering/unregistering databases for working with the required databases only | + | +
Project mode to work with the needed database objects only | + | +
Multiple user-defined tabs for any tree node to access it in one-click | + | +
Grouping/Ungrouping registered databases by host name | + | +
Easy management of all InterBase/Firebird objects
Creating/dropping databases | + | +
Managing tables and all their subobjects: fields, indices, checks and foreign keys | + | +
Managing views, triggers and stored procedures | + | +
Managing UDFs, exceptions, generators and BLOB filters | + | +
Duplicating all database objects | + | +
Renaming all database objects | + | +
Viewing dependencies between database objects | + | -
Powerful stored procedure debugger | + | -
Advanced data manipulation tools
Powerful BLOB viewer/editor with several types of viewing BLOB data | + | -
Plenty of useful tools such as data grouping, fast searching and filtering | + | +
Master-detail view to work with two linked tables at the same time | + | -
Table and card views to see data the way you like | + | -
Ability to copy and paste selected records | + | -
Advanced printing system | + | +
Exporting data to SQL script as INSERT statement | + | -
Effective security management
Powerful user manager for administering users and privileges | + | +
Grant manager displaying all database object grants in the form of a grid | + | +
Excellent visual and text tools for query building
Visual query builder allowing you to build complicated queries without any knowledge of SQL syntax | + | -
Multiple SQL editors with code completion and syntax highlight | + | +
Large script executing (SQL script editor) | + | +
Viewing query execution plans | + | -
Ability to view query plan as diagram | + | -
SQL Formatter (Available from SQL Editor context menu) | + | -
Report designer with clear in use report construction wizard
New Create Report Wizard allows you to create simple reports in a few clicks | + | -
Managing reports the same way as if they were database objects: accessing reports directly through DB Explorer tree | + | -
Impressive data export and import capabilities
Exporting data to most popular formats: MS Excel, MS Word, HTML, PDF, TXT, CSV, DBF, XML, etc. | + | -
Exporting data to MS Access | + | -
Importing data from MS Excel, DBF, TXT and CSV | + | -
Importing data from MS Access | + | -
Open Ofiice documents support | + | -
Powerful visual database designer
Creating diagram of existing database using Reverse engineering tool | + | -
Dividing diagram into different subject areas located on separate pages | + | -
Navigating through diagram using preview navigation tool | + | -
Creating/editing/dropping tables and table fields, visually setting links between them | + | -
Saving as image or printing database diagram | + | -
Two diagram notations (IDEF1x and IE) | + | -
A lot of visual customization options | + | -
Easy-to-use wizards performing InterBase and Firebird services
Backing up database | + | -
Restoring database | + | -
Database validation | + | -
Database statistics | + | -
Start/Stop database | + | -
Rebuild indices | + | -
Other useful tools to make your work with InterBase/Firebird as easy as it can be
Extracting metadata into text files or SQL script editor | + | -
Powerful print metadata module for creating customizable metadata reports | + | -
Search in metadata | + | -
HTML report generator to create a detailed HTML report about your database quickly | + | -
Report designer for building powerful reports visually | + | -
SQL Monitor | + | +
And other useful features
Keyboard templates | + | +
To-do list | + | +
External tool manager | + | +


Installation

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Installation of SQL Manager for InterBase/Firebird

If you are installing SQL Manager for InterBase/Firebird for the first time on your PC:

  • download the SQL Manager for InterBase/Firebird distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • run IbManagerFullSetup.exe (Full version) or IbManagerLiteSetup.exe (Lite version) from the local directory and follow the instructions of the installation wizard;
  • after the installation process is complete, find the SQL Manager shortcut in the corresponding group of Windows Start menu.

If you want to upgrade an installed copy of SQL Manager for InterBase/Firebird to the latest version:

  • download the SQL Manager for InterBase/Firebird distribution package from the download page available at our site;
  • unzip the downloaded file to any local directory, e.g. C:\unzipped;
  • close SQL Manager application if it is running;
  • run IbManagerFullSetup.exe (Full version) or IbManagerLiteSetup.exe (Lite version) from the local directory and follow the instructions of the installation wizard.

You can update SQL Manager via SQL Manager Direct.

See also:

SQL Manager FAQ


Registration

All purchases are provided by PayPro Global registration service. The PayPro Global order process is protected via a secure connection and makes on-line ordering by credit/debit card quick and safe.

PayPro Global is a global e-commerce provider for software and shareware sales via the Internet. It accepts payments in US Dollars, Euros, Pounds Sterling, Japanese Yen, Australian Dollars, Canadian Dollars or Swiss Franks by Credit Card (Visa, MasterCard/EuroCard, American Express, Diners Club), Bank/Wire Transfer.

If you want to review your order information, or you have questions about ordering or payments please visit our PayPro Global Shopper Support, provided by PayPro Global.

Please note that all of our products are delivered via ESD (Electronic Software Delivery) only. After purchase you will be able to immediately download the registration keys. Also you will receive a copy of registration keys by email. Please make sure to enter a valid email address in your order. If you have not received the keys within 2 hours, please, contact us at sales@sqlmanager.net.

Product distribution | PayPro Global
EMS SQL Manager for InterBase/Firebird (Business license) + 1-Year Maintenance* | Register Now!
EMS SQL Manager for InterBase/Firebird (Business license) + 2-Year Maintenance*
EMS SQL Manager for InterBase/Firebird (Business license) + 3-Year Maintenance*
EMS SQL Manager for InterBase/Firebird (Non-commercial license) + 1-Year Maintenance*
EMS SQL Manager for InterBase/Firebird (Non-commercial license) + 2-Year Maintenance*
EMS SQL Manager for InterBase/Firebird (Non-commercial license) + 3-Year Maintenance*
EMS SQL Manager for InterBase/Firebird (Trial version) | Download Now!
EMS SQL Manager for InterBase/Firebird Freeware | Download Now!

*EMS Maintenance Program provides the following benefits:

  • Free software bug fixes, enhancements, updates and upgrades during the maintenance period
  • Free unlimited communications with technical staff for the purpose of reporting Software failures
  • Free reasonable number of communications for the purpose of consultation on operational aspects of the software

After your maintenance expires you will not be able to update your software or get technical support. To protect your investments and have your software up-to-date, you need to renew your maintenance.

See also:

How to register SQL Manager


How to register SQL Manager

EMS If you have not registered your copy of SQL Manager for InterBase/Firebird yet, you can do it by pressing the Register Now button and entering your registration information in the Register SQL Manager for InterBase/Firebird dialog.

Welcome to SQL Manager - About

To register your newly purchased copy of EMS SQL Manager for InterBase/Firebird, perform the following steps:

  • receive the notification letter from Digital River with the registration info;
  • enter the Registration Name and the Registration Key from this letter;
  • make sure that the registration process has been completed successfully – check the registration information in the About SQL Manager for InterBase/Firebird dialog (use the Help | About menu item to open this dialog).

Welcome to SQL Manager - Register product

See also:

Registration


Version history

Product name | Version | Release date
SQL Manager for InterBase/Firebird | Version 6.2.1 | January 26, 2024
SQL Manager for InterBase/Firebird | Version 6.2 | August 14, 2023
SQL Manager for InterBase/Firebird | Version 6.1.2 | February 22, 2023
SQL Manager for InterBase/Firebird | Version 6.1.1 | November 29, 2022
SQL Manager for InterBase/Firebird | Version 6.1 | July 14, 2022
SQL Manager for InterBase/Firebird | Version 6.0.2 | September 22, 2021
SQL Manager for InterBase/Firebird | Version 6.0 | February 16, 2021
SQL Manager for InterBase/Firebird | Version 5.5.4 | June 3, 2019
SQL Manager for InterBase/Firebird | Version 5.5.3 | December 3, 2018
SQL Manager for InterBase/Firebird | Version 5.5.2 | April 25, 2018
SQL Manager for InterBase/Firebird | Version 5.5.1 | September 08, 2017
SQL Manager for InterBase/Firebird | Version 5.5 | August 01, 2017
SQL Manager for InterBase/Firebird | Version 5.4.4 | June 06, 2017
SQL Manager for InterBase/Firebird | Version 5.4.3 | April 17, 2017
SQL Manager for InterBase/Firebird | Version 5.4.2 | December 6, 2016
SQL Manager for InterBase/Firebird | Version 5.4.1 | November 23, 2016
SQL Manager for InterBase/Firebird | Version 5.4.0.1 | November 9, 2016
SQL Manager for InterBase/Firebird | Version 5.3.0.1 | October 7, 2015
SQL Manager for InterBase/Firebird | Version 5.2.0.1 | February 15, 2010
SQL Manager 2008 for InterBase/Firebird | Version 5.1.0.1 | September 17, 2008
SQL Manager 2008 for InterBase/Firebird | Version 5.0.0.1 | January 25, 2008
SQL Manager 2005 for InterBase/Firebird | Version 4.4.0.1 | November 22, 2006
SQL Manager 2005 for InterBase/Firebird | Version 4.3.0.1 | May 31, 2006
SQL Manager 2005 for InterBase/Firebird | Version 4.2.0.1 | April 4, 2006
SQL Manager 2005 for InterBase/Firebird | Version 4.1.0.1 | February 20, 2006
SQL Manager 2005 for InterBase/Firebird | Version 4.0.0.1 | January 27, 2006
IB/FB Manager | Version 3.9.5.1 | September 8, 2005
IB/FB Manager | Version 3.9.0.2 | February 17, 2005
IB Manager | Version 3.9.0.1 | February 3, 2005
IB Manager | Version 3.8.5.1 | December 7, 2004
IB Manager | Version 3.8.0.1 | August 23, 2004
IB Manager | Version 3.7.0.1 | January 19, 2004
IB Manager | Version 3.6.5.1 | September 5, 2003
IB Manager | Version 3.6.0.1 | July 9, 2003
IB Manager | Version 3.5.0.1 | May 27, 2003
IB Manager | Version 3.4.0.1 | April 21, 2003
IB Manager | Version 3.3.0.1 | March 12, 2003
IB Manager | Version 3.2.5.1 | February 11, 2003
IB Manager | Version 3.2.0.1 | January 21, 2003
IB Manager | Version 3.1.0.1 | January 06, 2003
IB Manager | Version 3.0.0.1 | December 16, 2002

Full version history is available at http://www.sqlmanager.net/products/ibfb/manager/news

Version 6.2.1

1. SQL is not discarded on exit from Query Designer.

2. Object selection mode added to DB Designer.

3. Connection services are now using the main selected service or utility.

4. Find dialog. ESC closes the popup instead of closing the dialog.

5. Data Import. Encoding is defined automatically now for TXT/CSV files.

6. Parameters are now using TYPE OF COLUMN on creating procedures from table.

7. Authorization dialog added to the Database designer.

8. Fix of importing data with floating points.

9. Collation was modified on editing field size. Fixed now.

10. Fixes of editing TIMETZ values with timezone offset.

11. Fixes for work with databases with NONE encoding.

12. Improvements in displaying dark visual schema.

13. Other minor improvements and fixes.

Version 6.2

1. Processing of new data types added: DECFLOAT, REAL, BINARY, VARBINARY.

2. Improvements in debugging triggers and procedures.

3. The arguments of functions and procedures from the package are added to the autocompletion list.

4. On Update and On Delete actions are now displayed in FK list in table editor.

5. SQL script gets editable in the Duplicate wizard.

6. Zooming works smoother in Database Designer now.

7. The issue of working with BOOLEAN parameters in SQL Script resolved.

8. In some cases SQL Editor tabs cleared after updating host alias. Fixed now.

9. Improved interface and printing options in dark visual theme.

Version 6.1.2

1. Increased performance of Dependency tree.

2. Better processing of scaling in Database designer.

3. Columns are now displayed for views in Database designer.

4. New Query Data editor is opened empty with Shift+F12 now.

5. The Average Fetch Time value corrected in the Query Statistics.

6. Dark visual theme is not applied on printing dataset now.

7. The error occurred in EXECUTE BLOCK on use of NUMERIC or DECIMAL parameters.

8. Domains are validated on debugging procedures now.

9. The size of large databases is displayed right in the Database Properties now.

10. Scrolling has been improved for specific user cases.

11. Other improvements and bug fixes.

Version 6.1.1

1. Temporary tables icon added to the DB Explorer.

2. Recent values are now pre-filled automatically for parameters in SQL Editor.

3. The error occurred on running EXECUTE BLOCK. Fixed now.

4. Client sorting works smoothly now for all data types.

5. Current generator value can now be changed from object editor.

6. Return values for INSERT ... RETURNING statement are displayed correctly now.

7. Some improvements in working with Embedded server type.

8. Some minor issues with localizations fixed.

9. Other minor improvements and fixes.

Version 6.1

1. INT128 data type support for Firebird 4.

2. Implemented support for query interrupting in Query editor.

3. Support for Windows 11 ARM.

4. Host aliases added.

5. Added the ability to specify an encryption password on connecting to Interbase databases.

6. Added the ability to securely connect to the database with the isc_dpb_no_db_triggers option.

7. Added an option that disables automatic host availability check.

8. When renaming a table field, it was moved to the end of the field list. Fixed.

9. Scrolling the window with a mouse on hovering.

10. The value of the auto-increment field generator is now shown in the table editor in the field list.

11. Support for new generator options in Firebird 3 and higher.

12. Fixes in Event Monitor to get all notifications.

13. Corrections and improvements in the dark visual theme.

14. You can manually add transaction options in the database settings now.

15. Other changes and improvements.

Version 6.0.2

1. Improved processing of Unicode data.

2. System-generated indices are no longer generated in Extract database wizard.

3. Better processing of embedded servers, including old versions.

4. Default value can be disabled in domain editor now.

5. Parsing of procedures containing cursor has been improved.

6. Other minor fixes.

Version 6.0

1. Support of dark visual scheme added.

2. The new look with updated icons.

3. Editor tabs can be now highlighted with the specified database color.

4. Improved support of high-DPI monitors and large-scale fonts.

5. Support of Unicode for object names added.

6. Support for custom server aliases implemented.

7. Improved search when using regular expressions.

8. JSON tab added for viewing data.

9. SQL parser improved for better performance.

10. Timezone support implemented.

11. Updated SSH library with ECDSA and Ed25519 support.

12. Many other improvements and fixes.

Version 5.5.4

1. Connection to Firebird 4 can be established successfully now.

2. Extract database. FK and PF were not processed correctly in some cases.Fixed now.

3. HEX is now supported in the debugger and parser.

4. Fix for authentication in Firebird 1.5 Embedded.

5. Fix domain editor called from procedure editor.

6. Out parameters are now processed correctly.

7. Other minor fixes.

Version 5.5.3

1. Support of Unicode is added to data filters now.

2. The error of processing arguments for some types of UDFs fixed.

3. The Browse button for selecting the local database was disabled in some cases. Fixed now.

4. Some domain-based variables were processed as Cursor in the debugger. Fixed now.

5. Query builder. Improved resolving of table aliases.

6. Sometimes query results were read-only. Fixed now.

7. Successfully executed queries are now correctly saved in the log.

8. A few fixes in grid levels.

9. DB Explorer tree is refreshed OK with Sort by aliases option enabled.

10. Unique option can be selected for expression index now.

11. We added the possibility to clear parameters history for procedures.

12. Data is sorted correctly locally in asynchronous mode now.

13. Many other bug-fixes and improvements.

Version 5.5.2

1. Password field for encrypted databases has been added.

2. SQL Script performance has been improved.

3. Several triggers can be selected for activation and de-activation now.

4. Minor issues fixed in the debugger.

5. The error on filtering data on the client side has been fixed.

6. Functions with declared functions are supported now.

7. Views were not displayed correctly in VDBD. Fixed now.

8. ARRAY data type is processed correctly now.

9. Field types based on table fields are displayed correctly now.

10. Variables in DB triggers were not refreshed correctly. Fixed now.

11. Grant All\Revoke All operations for table fields work correctly now.

12. Search in the DB tree terminated on opening or closing the folder. Fixed now.

13. Many other fixes and improvements.

Version 5.5.1

1. The protocol for Firebird 3.0 was detected incorrectly. Fixed now.

2. The length for text fields was calculated incorrectly in Export Data wizard. Fixed now.

3. Varaibles were not displayed correctly in object editors. Fixed now.

4. Some fixes in UDF editor.

5. The errors of executing script with DECLARE FILTER statement fixed.

6. Other minor fixes.

Version 5.5

  1. Added support of packages.
  2. Performance of SQL-parser in SQL Script/Editor has ben significantly improved.
  3. Added support of 'Restart With' clause for 'Identity' table fields.
  4. Added the possibility to browse and reuse recently used parameters in Query Data, Procedure Editor and Debugger.
  5. The issues of executing "unknown" statements in SQL Script have been fixed.
  6. The errors of converting specific data types in the Debugger have been fixed.
  7. Data was displayed incorrectly when non-Unicode client charset was set and it did not correspond to the current system locale. Fixed now.
  8. When separate connections were used in SQL Editor, transactions were not ended correctly sometimes. Fixed now.
  9. Unicode characters were displayed incorrectly in Duplicate wizard. Fixed now.
  10. If the script contained 'SET TERM' statements the error occurred on executing it from file. Fixed now.
  11. Many other fixes and improvements.

Version 5.4.4

  1. Fix of errors and hangings in SQL Editor.
  2. Timestamp fields were not quoted on exporting as SQL script. Fixed now.
  3. Boolean values are exported as true\false now.
  4. The ‘Unexpected Output buffer value’ error rarely occurred on connecting to Firebird server. Fixed now.
  5. Procedures were not refreshed correctly sometimes. Fixed now.
  6. Default values for NUMERIC type are now displayed as a number not a string.
  7. The 'Cannot convert value '' to the specified type' error occurred on creating the DATE type parameter in procedures. Fixed now.
  8. Many other improvements and bugfixes.

Version 5.4.3

  1. Support of exporting selected records has been added to Export as SQL Script wizard.
  2. Support of IDENTITY fields in Firebird 3 has been implemented.
  3. Now BLOB text data is opened on the Text tab by default.
  4. Database Designer. Changes in tables are immediately applied to the objects tree now.
  5. The default encoding is applied correctly on saving SQL Editor content to file.
  6. Unicode symbols are exported correctly in Export as SQL Script wizard now.
  7. Multiple operators are copied correctly now in the Compile window.
  8. The queries containing CROSS JOIN operator where not executed correctly. Fixed now.
  9. Parameters in functions are edited correctly now.
  10. GRANT ALL works correctly now in Grant Manager.
  11. SELECT from procedures couldn’t be visualized in Query Builder. Fixed now.
  12. Use of local utilities in services works correctly now.
  13. Other fixes and improvements.

Version 5.4.2

  1. The errors of executing the script in SQL Script and SQL Editor have been fixed.
  2. Transaction was not closed on connecting to InterBase databases. Fixed now.
  3. The views are opened correctly now.
  4. The list of fields was not loaded on creating SUID procedures. Fixed now.
  5. Data Import. Numeric data is imported correctly now.
  6. VDBD performance has been improved.
  7. Many other fixes and improvements.

Version 5.4.1

  1. Constant strings containing comma were handled incorrectly. Fixed now.
  2. Fixed errors of opening Load/Save dialogs in SQL Editor.
  3. Loading some large sets of data caused the 'Access Violation' error. Fixed now.
  4. There were 'List index out of bounds' errors while working with SQL Editor tabs. Fixed now.
  5. Results of the queries starting with 'WITH ...' were displayed incorrectly. Fixed now.
  6. Lots of other fixes.

Version 5.4.0.1

  1. Support for new Firebird 3.0 features:

- SQL Functions and DDL Triggers editors have been added;

- Boolean field type support added;

- DEFAULT CHARSET option support added for the database;

- Linger Interval option support added;

- support for new user privileges added: ifpmUsage, ifpmCreate, ifpmAlter, ifpmDrop.

2. Description and NOT NULL attributes for tables are added with SQL statements instead of using system tables now.

3. Now trigger activity is changed without recreating a trigger, if possible.

4. Support for creating\editing\deleting users with SQL has been added.

5. Work with memory has been optimized.

6. Improved work with large BLOB data.

7. Some errors in PSQL debugger have been fixed.

8. The LOCAL protocol works correctly now.

9. Many other improvements and bug-fixes.

Version 5.3.0.1

  2. Added support of InterBase XE3, InterBase XE7.
  3. Added support of the COALESCE function in Query Designer.
  4. Added support of the 'WHERE CURRENT OF (cursor)' clause in Debugger.
  5. Added support of the 'USING [DESC] INDEX' clause for Foreign Keys.
  6. Implemented support of Unicode for XML format in Export Data function.
  7. Displaying of the database physical size is implemented in the Database Properties dialog.
  8. Database Designer. Highlighting of Foreign Keys fields was implemented.
  9. The 'Quick Save\Quick Load' feature was enhanced. Some bugs were fixed.
  10. The connection restoring ability was enhanced.
  11. Fixed many bugs in Debugger.
  12. Sometimes subobjects were displayed incorrectly in Object Inspector. Fixed now.
  13. Added the possibility to load the latest saved diagram when opening Database Designer.
  14. Added the possibility to use Code Completion feature with the 'OLD/NEW' keywords in Triggers.
  15. Now it is possible to switch off the Precompiler for views.
  16. Lots of fixes in displaying Dates/Milliseconds at the Data tab.
  17. Fixed the memory leak while exporting to CSV.
  18. Localization fixes.
  19. Lots of other improvements and bug-fixes.

Version 5.2.0.1

  1. Windows 7 support
  2. Preliminary support of InterBase 2009
  3. Database Properties: added support of Embedded User Authentication (EUA) for InterBase 7.5 and higher
  4. DB Explorer:
  • Added the Embedded User object for InterBase 7.5 and higher. Creating, editing, duplicating, activating/deactivating and deleting operations are supported
  • It is now possible to activate/deactivate the EUA mode for InterBase 7.5 and higher
  • For Firebird 2.5 it is now possible to create a view from a stored procedure
  • Connection to a database with the Local protocol used was not possible on InterBase Desktop Edition servers. Fixed now
  • Connection to a host with the NTLM authentication caused an error. Fixed now
  • It was impossible to connect to the database the path to which contained Unicode characters. Fixed now
  • Connection to an InterBase database with a client library of version lower than 6.0 caused an error. Fixed now
  • Upon connection to the first newly registered host the list of users was not refreshed. Fixed now
  • When connecting to a host via SSH tunneling with a passphrase request, it was impossible to input the passphrase. Fixed now
  5. User Editor / User Manager: for InterBase 7.5 and higher added an opportunity to work with Embedded Users
  6. Role Editor: for InterBase 7.5 and higher added an opportunity to add Embedded Users to roles
  7. Grant Manager / Permissions frame in object editors: for InterBase 7.5 and higher added the possibility to manage privileges on objects for Embedded Users
  8. Extract Database:
  • for InterBase 7.5 and higher added extraction of Embedded Users
  • data of NUMERIC type was extracted with incorrect delimiter from Firebird 2.1 databases. Fixed now
  • object names were sorted in the descending order upon extraction. Fixed now
  9. Table Editor:
  • changed the method of accumulating script for compiling changes made in the editor
  • added an optional possibility to open a separate editor by double-clicking a trigger displayed under the Triggers tab. Changes made in the separate editor will not be added to the result script of Table Editor. The corresponding option is added to the Environment Options dialog
  • field descriptions were not saved completely. Fixed now
  10. Procedure/Trigger/DB Trigger Editor:
  • Added the possibility to use Explicit Cursors for Firebird 2.x
  • Added the auto-filling cursors ability
  • In Procedure Editor it is now possible to create a view from the stored procedure being edited
  • Using the WEEK keyword in the script resulted in a precompiler error. Fixed now
  • On attempt to compile a procedure containing the CREATE OR ALTER PROCEDURE statements the error occurred. Fixed now
  11. Modal object editor windows are now resizable for the more convenient work
  12. View Editor:for Firebird 2.1 and higher it is now possible to use Common Table Expressions (CTE)
  13. Added an optional possibility to open a separate editor by double-clicking a trigger displayed under the Triggers tab in the Table Editor and the Triggers tab in the View Editor. Changes made in the separate editor will not be added to the result script of the View Editor.
  14. SQL Editor:
  • Added the auto-filling cursors ability for the Execute Block statement
  • Added a scrollbar under the Plan tab
  • Some erroneous queries were executed without any error messages. Fixed now
  • Inputted parameters were not saved upon execution of parameterized queries. Fixed now
  • The Result tab was not displayed in the 'Asynchronous query execution' mode. Fixed now
  • In some queries the ORDER BY clause was truncated. Fixed now
  15. Keyboard Templates: added new keyboard templates
  16. Query Builder: after loading a diagram from file the query was corrupted. Fixed now
  17. Debugger:
  • debugging an object containing EXECUTE STATEMENT caused an error. Fixed now
  • Implemented support of procedures with Explicit Cursors
  18. Export as SQL Script: export of Unicode data was performed incorrectly. Fixed now
  19. Database Designer: Unicode text was displayed incorrectly in comments. Fixed now
  20. Create Updatable View:
  • incorrect script was generated for the Before Update trigger. Fixed now
  • The Compile window did not appear for an invalid script. Fixed now
  21. SQL Monitor: erroneous statements from SQL Script were now displayed by SQL Monitor. Fixed now
  22. Dependency Tree:
  • Added an ability to place the selected object to the display area automatically when the tree of dependencies is large
  • Added an ability to move the tree within the display area holding the left mouse button
  • Changed the drawing of the selected object and recursive objects for better distinction
  • Added diagram layout options: to show all objects, only objects depending on the Root object, or only objects the Root object depends on
  • Added an ability to show/hide domains in the dependency tree
  23. Environment Options:
  • added an option allowing one to specify the database that will be selected for a newly opened editor or a newly started service: the one selected in DB Explorer or in the currently focused editor
  • added an option allowing one to specify the way the editors layout is saved: for each particular object or for all objects of one type
  24. Visual Options:
  • added an ability to set Slants Kind in the Page controls options
  • user-defined visual scheme was only applied upon clicking 'Apply' twice. Fixed now
  25. A number of minor bug-fixes

Version 5.1.0.1

  • Preliminary support of Firebird version 2.5
  • Register Host wizard:

Tick Work with embedded servers is improved. Now you don’t need to copy files to the IB/FB Manager root folder, the server can be registered from any folder to which the server archive was unzipped

Tick Improved the Autodetect client library/security database path function

  • Register Database wizard:

Tick Added options for setting up Data Grid modes for each database

Tick The 'Sort by primary key' option is added, which allows sort data by the primary key on opening the Data Grid

  • Options concerning transaction parameters are added to the Database Registration Info dialog which allows you to set them up for each database
  • Database Properties:

Tick The ability to change parameters of the database which is not connected at the moment is added

Tick Now you are able to set database buffer parameters

Tick Changing of the database dialect was applied only after restarting the program. Fixed now

  • DB Explorer:

Tick Context menu items concerned with launching additional server/database/object tools are placed into the Tasks submenu to reduce the context menu size

Tick Now you can call the debugger for procedures, triggers, DB triggers, as well as for Favorite Queries that contain scripts implicating debugging

Tick The button for switching the search mode is added to the toolbar

Tick When renaming a host which had several databases registered on and after restarting the program, the database structure displayed in the DB Explorer used to be incorrect. Fixed now

  • Table Editor:

Tick New Table Editor form

Tick The ability to create external tables is added

Tick The ability to create global external tables is added

Tick The file name of the external tables used not to be displayed in the DDL. Fixed now

  • Procedure/Trigger/DB Trigger Editor:

Tick The autocompletion function is implemented for parameters and variables

Tick During the compilation process the precision of all parameters and variables of the NUMERIC(x,y) and DECIMAL(x,y) types used to be reduced to the precision of the first parameter. Fixed now

Tick During the compilation process the NULL default value was lost. Fixed now

Tick Using the WEEK keyword in the script resulted in a precompiler error. Fixed now

Tick On attempt to compile a procedure containing the CREATE OR ALTER PROCEDURE statements the error occurred. Fixed now

  • Modal object editor windows are now resizable for the more convenient work
  • SQL Editor:

Tick The ability to call debugger for scripts that implicate debugging is implemented

Tick The autocompletion function is implemented for parameters and variables of the scripts, procedures, triggers, DB triggers and the EXECUTE BLOCK constructions

Tick Usage of the FIRST keyword in a query resulted in an error. Fixed now

Tick Queries with string comments were not executed. Fixed now

  • Data Grid:

Tick The method of work in the asynchronous mode is changed – the usage of a separate connection for each Data Grid allows to perform simultaneous fetching without losing the ability to use other functions of the program

Tick The synchronous mode now allows using the shared connection for all Data Grids, which is essential for the servers with the limited number of allowed connections and for the work with global external tables that remain actual within the connection context

Tick Sorting by primary key is performed optionally now

  • SQL Monitor: refreshing a database with opened SQL Monitor resulted in hanging of the program. Fixed now
  • SQL Script:

Tick The ability to execute scripts/procedures/DB triggers without the SET TERM construction is implemented

Tick The errors occurred during the script execution are fixed

Tick In some rare cases the script execution errors were not displayed. Fixed now

  • Table Altering Monitor is implemented within a separate thread, so that you can take advantages of other program functionalities when working with that tool
  • Extract Database :

Tick DB journals can be extracted now

Tick Conversion of the script to the selected charset occurs now during the extraction and not at the moment of saving to a file which reduces the script generation time

Tick Triggers used to be omitted when extracting the full database. Fixed now

Tick When extracting triggers, some of them were processed with empty bodies. Fixed now

  • Export as SQL Script: conversion of the script to the selected charset occurs now during the extraction and not at the moment of saving to a file which reduces the script generation time
  • Debugger:

Tick The ability to debug Favorite Queries that contain scripts implicating debugging is implemented

Tick The Watches tab is added for displaying parameter and variable values from different contexts in one window

Tick The ability to delete/activate/deactivate all breakpoints at once is implemented

  • Options:

Tick Options concerned with database settings are duplicated/moved to the Database Registration Info form, which allows setting them up for each database separately

Tick The ability to apply default settings (for all or just a separate category of options) is implemented for all option dialogs

Tick The Object Templates form is revised. New templates are added

Tick The ability to save object templates is implemented

Tick The Save Options wizard saves data in a separate thread now, so that you can take advantages of other program functionalities when working with that tool (especially useful when many databases are registered)

  • Database Designer:

Tick Virtual relations can be renamed now

Tick When opening a saved diagram containing virtual relations, those relations used to change their location comparing to the location at the moment of saving. Fixed now

  • Other minor improvements and bug-fixes

Scroll to top

Version 5.0.0.1

  • Full InterBase 2007 and Firebird 2.1 support, including DB triggers, journaling and incremental backup
  • Support of Unicode in SQL Editor, Query Builder, Grid View, Import/Export Data wizards
  • Now you can continue working with SQL Manager while a query is being executed in SQL Editor or Query Builder or while table or view data are being loaded to the editor. A query taking too long to execute can be aborted
  • All wizards, including Import/Export Data wizards, Extract Database wizard, Services wizards, run in background mode now, allowing one to continue working with the program
  • New advanced SQL Editor of the Visual Studio 2005 kind with Code Folding, UNICODE support, code completion, syntax highlight and other useful features
  • Enhanced Import Data Wizard: now data can be imported up to 10 times faster; also added support of the following source file formats: HTML, XML Document, Open Document Format (ODF), Open XML Format (MS Word 2007, MS Excel 2007)
  • Improved Export Data Wizard: now works faster; added several output file formats: XML Document, Open Document Format (ODF), Open XML Format (MS Word 2007, MS Excel 2007)
  • Improved Extract Database Wizard works faster; now it also considers all object dependencies and allows defining the server version to generate the script for
  • Improved DB Explorer in several respects: added a menu for generation of common SQL statements for database objects (Script to SQL Editor, Script to Clipboard) - it is now possible to get CREATE, ALTER, DROP, SELECT statements for each database object
  • Now it is possible to save frequently used queries within the Favorite Queries node of DB Explorer; Favorite Queries can be stored either locally in Windows Registry (in this case they are only available for local users), or in a special table of the database (therefore, the queries can be accessed by all database users)
  • Enhanced Database Designer: added new diagram objects (comment, virtual relationship); now it is possible to include Procedures, Functions and Views in the diagram; one can choose whether only object names or also fields and parameters should be displayed
  • Dependency Tree tool can now be run in the background mode, so that you could continue working with the program
  • Viewing database statistics ability extended. Now you can analyze temporary system tables (must be supported by server)
  • Grid View improved: now the data of a sublevel of the Master or Detail table linked with the current table by a foreign key can be displayed automatically
  • The ability to switch between the visual and non-visual modes in Trigger Editor, View Editor and Procedure Editor is implemented
  • External plugin interface is restored
  • Firebird database alias file support implemented
  • Improved Procedure debugger with the Call Stack feature implemented. Now you can navigate your embedded calls of stored procedures easily
  • Improved Table Editor: now, like in other object editors, the scripts that are connected with the changes made at the Editor window are accumulated and can then be executed at a time during compilation. A user can also select the scripts to be executed
  • The options added that allow the relevant services stop, start and open a database automatically
  • Added the Find Option tool which allows one to find the required option in the scope of all program settings, by a word or an expression from the option title
  • The Recompute All service has been added which allows rebuild all database indexes (or just selected ones) or recalculate their statistics
  • The Search Panel in DB Explorer is enhanced: now you can perform incremental search by names as well as define the search area
  • For users’ convenience the Windows List function is implemented as a separate DB Explorer tab with the search ability
  • In DB Explorer hosts are now named in accordance with the selected connection type (SSH tunneling or direct connection)
  • SQL Script: ability to execute selected statements and statements under cursor added
  • Enhanced reports management system
  • A number of other improvements and bug-fixes

Scroll to top

Version 4.4.0.1

  • Register Database Wizard:

Tick The option that allows to skip refreshing objects on connection to database is added. It is highly recommended to uncheck this option if your database contains many objects or if connection to the database is slow

Tick Import of database registration information from the previous version settings of SQL Manager for IB/FB is improved. Local databases are now registered according to the servers which use similar client libraries for connection

Tick Embedded database registration has become simpler

Tick 'Copy Alias From' option is added in the new database registration dialog

Tick It was impossible to register a database when there were no hosts registered. Fixed now

  • InterBase 2007 partial support implemented. Now the UTF-8, UNICODE_BE, UNICODE_LE charsets are supported
  • SSH Tunneling:

Tick The ability to use one SSH tunnel to establish connection for several hosts/databases at the same time is added

Tick Now it's possible to use tunneling for the services

  • Field Editor:

Tick New Field editor form

Tick Now it's possible to fill the NOT NULL fields which have no DEFAULT value set with the data taken from the fields of the table being edited

  • Data Grid:

Tick The ability to display and edit ARRAY fields is added

Tick When editing data or deleting records in a table which contains no unique or primary key, errors often occurred (the changes were not applied). Fixed now

Tick It was impossible to edit a BLOB type field in Detail Level. Fixed now

  • SQL Reference is available again now. It can be called from object editors
  • Extract Database Wizard:

Tick The ARRAY type data can be saved to an external file now

Tick An option is added which allows to extract metadata of the objects on which the current object depends

Tick The object dependency handling is improved

  • Restore Database interface improved: now it is possible to register the server on which the backup copy will be restored
  • Export as SQL Script: the ARRAY type data can be saved to an external file now
  • Duplicate Object Wizard: now, when duplicating table data, the BLOB and ARRAY type fields can be duplicated
  • SQL Script:

Tick A script can now be executed from cursor; execution of the selected fragment is also possible

Tick String comments (beginning with '--') are recognized correctly now

Tick The ARRAY type data can now be imported from an external file when executing SET BLOBFILE statement

  • Stored Procedure Debugger:

Tick When performing input for the DECIMAL and NUMERIC type parameters the decimal delimiter used to change with a localization applied. Fixed now

Tick The value of the empty string was treated as NULL. Fixed now

Tick The FIRST statement is recognized correctly now

  • UDF Editor/BLOB Filter Editor: Now there's no need to take an object's dependencies into account when changing its parameters
  • Procedure Editor: support of BLOB type parameters for Firebird is implemented
  • The Code Completion feature is implemented for table aliases
  • Dependencies / Dependency Tree: when analyzing dependencies, the objects referred to in CHECK constraint bodies and COMPUTED BY table fields are now taken into account
  • Other minor improvements and bug-fixes

Scroll to top

Version 4.3.0.1

  • Export as SQL Script:

Tick Now you can specify DBMS for which the script should be generated

Tick Now it's possible to export BLOB field content into an external file with the ability to compress data. When executing the result script the data from the external file will be placed into the corresponding fields

  • Extract Database Wizard:

Tick To avoid errors during script execution the 'computed by' fields are moved to the end of table fields list; then their position is restored

Tick Now it is possible to export BLOB field content into an external file with the ability to compress data. When executing the result script the data from the external file will be placed into the corresponding fields

  • DB Explorer: the 'Add to Projects' command is added. Now objects can be added by specifying them in the corresponding dialog, as well as by dragging into Projects folder
  • Dependency Tree: the ability to view dependencies for the domains that refer to other objects via check constraints is added, as well as dependencies for the tables that refer to other objects via Check constraints and those for the tables that use UDFs in their 'computed by' fields
  • Data Grid:

Tick The 'Expand All' and 'Collapse All' context menu items added

Tick The 'Save column sorting' option is added for the 'Save and restore layout' mode

  • CPU usage significantly decreased
  • SQL Editor:

Tick For the queries which allow data insert the ability to import data into the table implemented

Tick The Ctrl+Shift+Enter shortcut for pointing out the corresponding item in DB Explorer tree worked incorrectly. Fixed now

Tick Now it is possible to rename and move query tabs

Tick Query execution time is now displayed in hh:mm:ss format

Tick 'Select All' command didn't work correctly on text that had very long lines (more than 4096 symbols). Fixed now

  • Controls at the toolbars now remain after installing a newer version of the product. To bring them to their default state you can use the corresponding command from Windows menu or corresponding button in the Environment Options dialog
  • Import Data wizard: when setting column correspondence for import from Excel, selecting a new column caused cursor to move to the first column in grid. Fixed now
  • Database Registration Info: When applying changes, the originality of database aliases used not to be checked. Fixed now
  • Database Designer. Switching to another visual scheme didn't take any effect on context menu style. Fixed now
  • Localization:

Tick Russian localization added

Tick Corrections and improvements in German and English localizations

  • Shutdown Database and Bring Database Online services are combined together and placed into Start/Stop Database wizard which allows using templates
  • Domain Editor: the Collation was not displayed when opening Domain Editor. Fixed now
  • SQL Script:

Tick Executing DROP DATABASE statement with database name, login and password without having connected to it first

Tick Now after dropping a database the 'Unregister Database' dialog appears

Tick Handling the AutoDDL mode without SET AUTODDL statement execution

Tick When DROP DATABASE and CONNECT statements are executed without user name and password the Login dialog appears

  • Other minor improvements and bug-fixes

Scroll to top

Version 4.2.0.1

  • German localization added
  • Editor Options: Key Mapping is implemented to set the shortcuts for various commands/operations according to your needs
  • Visual Query Builder: query execution plan is now displayed as a graphical diagram
  • Dependency Tree: the diagram can now be printed
  • Ability to call Register Database Wizard from SQL Script for the databases created is implemented
  • SQL editors:

Tick Next Bookmark, Previous Bookmark context menu items added

Tick in some rare cases, an attempt to use Code Completion tool with 'Trim trailing spaces' option on, cleared all the line with 'Trim trailing spaces' option on. Fixed now

Tick Dragging the field names from SQL Assistant works perfectly now

  • SQL Editor: ability to execute statement under cursor added
  • Database Designer: the Drop Table context menu item worked incorrectly if the field, not the table itself, was selected. Fixed now
  • Import Data Wizard:

Tick Now with the 'Commit changes manually' option switched on at the end of import you will be prompted for an action with transaction

Tick Ability to resize wizard's window added

Tick On setting format for fields to import, the 'Generator Value' and 'Constant Value' options used to be ignored. Fixed now

Tick Having specified user-defined fields to import, the rest of them were filled with empty strings; so that default values defined for the fields were not applied. Fixed now

  • HTML Report: ability to change header/footer of the report added
  • SQL Script: abort executing script confirmation added
  • DB Explorer: the context menu didn't hide when switching to another application. Fixed now
  • Table Editor: the lines exceeding 32 symbols were truncated when exporting lists of subobjects. Fixed now
  • Procedure Editor and Trigger Editor: parameters or variables deleted in editor window used to reappear in trigger/procedure body after compilation. Fixed now
  • On attempt to execute a query or procedure with Date, Timestamp, Time typed parameters, the Conversion Error message appeared. Fixed now
  • There were no checks for the type of file when creating a report by import from file, which initiated errors. Fixed now
  • When creating a report, its components working with data used only the default client library, so that in some rare cases it was impossible to open reports working with the database on a local host. Fixed now
  • Most memory leaks fixed
  • SQL Script: the ability to re-execute the script which finished with errors added
  • When editing the data containing fields with NULL values, changed data used to restore their previous values after commit. Fixed now
  • Other minor improvements and bug-fixes

Scroll to top

Version 4.1.0.1

  • DB Explorer: faster connection and refresh speed
  • The ability to register multiple local servers is added
  • Table Editor: errors used to occur when displaying data from the tables containing many records. Fixed now
  • Dependency Tree: the search method for finding dependent objects is improved
  • SQL Editor, Code Insight: fields of tables and views as well as keywords are now displayed in the drop-down list
  • Create Database: wrong script for creating database used to be generated. Fixed now
  • Domain Editor: the ability to set Charset and Collation restored
  • Field Editor: the ability to set Charset and Collation restored
  • Input Parameters: when opening the 'Parameters' dialog on executing the queries in SQL Editor and Visual Query Builder, an error occurred. Fixed now
  • Form View: Memo fields editor is extended (can be customized in Grid | Advanced section of the Environment Options dialog)
  • SQL Script: multiple windows can be opened now
  • Database Designer: there were no changes seen in opened graphical diagram when the table name or any table field was edited. Fixed now
  • The 'Keyword "DB_KEY" already in list' error message used to appear when connecting to FB 2.0 server. Fixed
  • View Editor: the ability to process views containing FIRST as keyword in the queries added now
  • View Editor: the ability to process views containing CAST as keyword in the queries added now
  • Database Validation Wizard used to ignore the changes made on the first step, which caused an attempt to connect to current database and subsequent error. Fixed now
  • Procedure Editor: the ability to use simultaneous names for variables in different procedures restored
  • DB Explorer: after dropping a table, its triggers were still displayed in the DB Explorer tree. Fixed
  • Field Editor: for autoincrement fields, on renaming the generator its name used to remain unchanged in the trigger's and procedure's body. Fixed now
  • Other minor improvements and bug-fixes

Scroll to top

Version 4.0.0.1

Basic features:

Latest InterBase and Firebird versions support

  • Compatibility with any Firebird server version up to 2.0
  • Compatibility with any InterBase server version up to 7.5
  • Trigger messages support
  • Support of BLOB Filters

Significantly improved user interface

  • New well-described Wizard System to perform complex tasks easily
  • Fast access to most essential actions using Navigation bars in most of the windows
  • New Windows Toolbar to switch windows easily, like in Windows Task Bar
  • Office 11 and Windows XP visual schemes support

Improved Database Explorer

  • Creating tabs for any tree node to access it in one-click
  • Work with multiple selected objects at a time
  • Much more convenient toolbar and context menu

Completely remade Database Designer

  • Obvious new look
  • Dividing diagram into different subject areas located on separate pages
  • Navigating through diagram using preview navigation tool
  • Creating/editing/dropping tables and table fields visually setting links between them
  • Saving as image or printing database diagram
  • Two diagram notations (IDEF1x and IE)
  • A lot of visual customization options

New powerful data management tools

  • Plenty of useful tools such as data grouping, summarizing, fast searching and filtering
  • Master-Detail View to work with two linked tables at the same time
  • Table and Card Views to see data the way you like
  • Ability to copy and paste selected records
  • Advanced printing system
  • Fully customizable interface

New and improved database object editors

  • New procedure and trigger editors with enhanced precompiler
  • New View Editor with automatic generation of view header and ability to create view using Query Designer
  • Quick saving and loading in all database object editors
  • Autosaving database object with opportunity to restore on further connection

New opportunities to work with SQL queries

  • Possibility of creating queries with unions and subqueries visually
  • Ability to view query plans in the form of a diagram

New connection options

  • SSH connections support to encrypt client/server communications for increased security (most suitable in case of Internet connection)

Improved report management

  • The new Create Report Wizard allows you to create a simple report in a few clicks
  • Managing reports in the same way as if they were database objects: accessing reports directly through DB Explorer tree

and more...

Scroll to top

Version 3.9.5.1

  • BLOB Editor: added horizontal and vertical scrollers in the text view
  • Added more national character sets in the database creation window and the Database Properties form
  • Improved localization files
  • Added an ability to fill a newly created NOT NULL field with values of another field
  • Added an ability to display privileges granted to the object at the DDL tab
  • Now database error messages appear to be more informative. Now database error numbers is displayed in addition to the message texts
  • Stored Procedure Debugger: fixed an error when working with data of TIME data type
  • Database Designer: it was impossible to save large database diagram as image (*.jpg, *.png, *.gif, etc.). Fixed now
  • Search in Metadata: while searching in large or remote databases, the manager hung up. Fixed now
  • When losing connection to the database, it remained opened in the program. Fixed now
  • Fixed an error with displaying views created with CHECK OPTION
  • Fixed an error when changing database in the SQL Script Editor
  • Fixed an error when creating index with a name in lowercase in a database of Dialect 1

Scroll to top

Version 3.9.0.2

  • If a database had charset UNICODE_FSS or NONE, then the strings in local character sets didn't display correctly in editor Data tabs. Now in Database Registration Info you can manually disable encoding of Unicode strings to UTF8 to display data correctly
  • Fixed the bug with incorrect processing of IF ... ELSE statements in Stored Procedure Debugger
  • Stored Procedure Debugger: pre-compilation parser now supports ROW_COUNT, INSERTING, DELETING, UPDATING expressions
  • The bugs with separate client libraries for each database are fixed now

Scroll to top

Version 3.9.0.1

  • InterBase 7.5 full support
  • Firebird 1.5 full support
  • SQL Editor: renewed smart Code Insight and Highlight in the editors - now the list of all keywords is set depending on the current database server version
  • Database Registration Info: an ability to choose a separate client library for each registered database was added
  • The "Can't found Database Login dialog.." bug is fixed now
  • DDL tab: fixed the problem with opening the tab
  • It was impossible to create a domain of BIGINT type. Now the bug is fixed
  • It was impossible to create an Autoincrement field of BIGINT type. The problem is solved
  • Fixed the bug with 10000 length limit for CHAR and VARCHAR fields
  • The bug with changing the field type from CHAR or VARCHAR to any numeric type is fixed now
  • COLLATION for the text fields could not be created. Now fixed
  • The ability to set CHARSET property for the BLOB types which don't support it is disabled now
  • SQL Editor: the Result page didn't open after running a query which contained a comment in the first line, beginning with "--". The problem is solved
  • Extract Metadata: the COLLATION property for the domains is shown correctly now
  • Script Comparer: the column index value is counted correctly now in the scripts like "ALTER COLUMN POSITION ..."
  • The current database was disconnected by timeout without possibility to re-connect when the Database Properties window was opened. The bug is fixed
  • Completely remade Restore Database service
  • Stored Procedure Debugger: solved the problem with not returning the output procedure parameter when running "EXECUTE PROCEDURE ... RETURNING_VALUES ..."
  • Stored Procedure Debugger: pressing the Reset button does not cause erasing breakpoints now
  • Stored Procedure Debugger: incorrect results were shown in case of existence "FOR SELECT ..." clause. Fixed now
  • Stored Procedure Editor: the output procedure parameter wasn't returned if the procedure was run without SUSPEND. Now it is solved
  • View Editor: it was impossible to edit simple views. Fixed now
  • Window size and position were set incorrectly by default in SDI mode on multi-monitor systems. Now the bug is fixed
  • Export Data: an exception arose when trying to export data to CSV. Fixed now
  • Some minor improvements and corrections

Scroll to top

Version 3.8.5.1

  • SQL Script Editor: we have added the possibility of executing the construction 'CREATE OR ALTER'
  • Eliminated the error with changing the field type from INTEGER to BIGINT when working with Firebird server
  • Extract Metadata: disabled generation of SQL statements for indexes that correspond to the constraints
  • Extract Metadata: the error with limiting precision to 5 in NUMERIC field types is eliminated
  • Extract Metadata: we have added the showing CHARACTER SET property for input and output parameters of the stored procedures
  • Extract Metadata: eliminated showing COLLATE and NOT NULL properties for domain-based fields
  • Search in Metadata: fixed the bug with hanging-up the program on trying to start search with an empty string
  • The 'Access Violation' arose when closing database if the connection to the server was lost. The problem is fixed
  • 'Database | Disconnect from Database' item of the main menu now works fine

Scroll to top

Version 3.8.0.1

  • Duplicate Table: with this version you can copy the table data just as the table structure
  • Print Data View: now you can customize column widths using the new dialog that is accessible through the Tune Column Widths button on the toolbar of the Print View tab
  • Reports: with this version you can save your reports to XLS, RTF, HTML, JPEG, BMP, and TIFF files. We have added the new save filters for this purpose
  • Print Data View: now the program saves page settings
  • Print Data View: now the program displays the table name on each page of the report
  • Print Data View: fixed a bug that caused incorrect showing of the table report after changing page parameters. Now the program correctly shows printable reports for tables
  • Duplicate Object: fixed a bug that appeared when trying to duplicate an object if the program established connection to two databases simultaneously
  • Export to Excel: we have added an ability to set values of the defined cells, merge cells, and define the page background
  • Export Data: fixed a bug with appearing of the dialog window when clicking the file name in the edit field
  • A bug with displaying and editing bigint fields is fixed
  • Some minor improvements and corrections

Scroll to top

Version 3.7.0.1

  • We have significantly improved the Export Data dialog: now you can add notes, hyperlinks, and charts based on exported data to Excel documents; you can also define graphical styles for column captions, data, footer, and header on export to RTF documents; a possibility to define strip styles is also included
  • We have implemented the Dependency Tree tool: now you can view all the object dependencies in one diagram. To call this tool, use the Tools | Dependency Tree main menu item, or the corresponding button on the toolbar of any object editor
  • Now the Register Database dialog supports .fdb files
  • We have implemented the BIGINT fields support for Firebird 1.5
  • Edit Field: now you can add the primary key using the Edit Field dialog if the table has no primary key
  • Extract Metadata: added a possibility of extracting views in a user-defined order
  • Editor Options: we have added a new option allowing you to define if keyboard templates apply in comment blocks or not
  • We have added the "Number of dropping down items from object list in an editor window" option to the Windows page of the Environment Options dialog. This option defines how many objects are displayed in the drop-down list of objects on the toolbar of any object editor
  • HTML Report: BIGINT fields and Universal triggers are shown correctly now
  • A bug with using universal triggers in Firebird 1.5 is fixed
  • Data Import from MS Access: one table appeared several times in the table list. Now it is fixed
  • Some minor improvements and corrections

Scroll to top

Version 3.6.5.1

  • We've implemented the support of Firebird 1.5 universal triggers. Starting from this version, IB Manager allows you to define several actions for a trigger, such as BEFORE INSERT OR UPDATE, for example. Trigger Editor has been slightly redesigned for this purpose
  • We've significantly improved the Import Data Wizard to make most of new abilities of EMS QuickImport 2 component suite (http://www.ems-hitech.com/quickimport/) available in IB Manager, such as import from XML, import from multiple Excel sheets, importing formulas from Excel, case insensitive replacements, and more (*)
  • We've added a possibility to hide/show the DB Explorer tabs, such as Project, Windows and Recent. If you don't need some of them on the screen, you can uncheck the appropriate options on the DB Explorer tab of the Environment Options dialog
  • We've added the "Show only connected databases for services" option to the Environment Options dialog. If this option is checked, only the connected databases will be available in the service dialogs, such as Database Validation and Database Statistics. This option is available on the Tools page of the Environment Options dialog
  • Fixed a bug with skipping the first statement of a script during its execution from SQL Script Editor in some cases
  • If the list of the stored procedure parameters has been edited just before the procedure execution, the procedure parameter order was generated incorrectly. Now it is fixed
  • Fixed a bug with incorrect type of the last variable displaying in the Stored Procedure Debugger in some cases. (*)
  • Fixed a bug with generating the DDL for an object containing '#' or '%' character in its name
  • Fixed a bug with displaying calculated fields in the Edit Field dialog
  • Fixed a bug with the search/replace function executed for the selected text only
  • Some minor improvements and corrections

Scroll to top

Version 3.6.0.1

  • We have significantly improved Stored Procedure Debugger: now it is possible to trace into a procedure executed from the current one, using the 'Trace into' button and then return to a previous procedure quickly using the 'Run until Return' button. These functions are also available through the F7 and Shift+F8 key shortcuts respectively (*)
  • We have added a Japanese localization to the IB Manager distribution package. Now ten languages are available: English, German, Italian, Spanish, Dutch, Russian, Polish, Brazilian, Hungarian and Japanese
  • Database Designer: we have extended a possibility to save diagrams as graphical images. Now you can save your diagrams to four graphical file formats: bitmap, JPEG image, GIF image and Windows metafile. This feature is available through the 'Save as Image' button of the toolbar (*)
  • Object description definitions are now extracted as UPDATE ... SET RDB$DESCRIPTION = ... statements for Firebird 1.x databases, since Firebird server supports inserting multi-line strings to BLOB fields
  • Grant Manager provides two new menu items now: 'Grant All on All' and 'Revoke All on All'. Use them for granting or revoking all privileges on all objects to the current object
  • Query parameters are parsed correctly by Query Designer now (*)
  • Fixed a bug with setting object names in lower or mixed case in object editors if Firebird database is used
  • Fixed a bug with incorrect field order in the INSERT statement generated by the Export Data as INSERT dialog (*)
  • NUMERIC and DECIMAL fields doesn't change their types to INTEGER or DOUBLE PRECISION after trying to change the dimension anymore
  • Now the Compare Scripts feature generates the result script correctly for tables with different fields order
  • HTML Report generates trigger descriptions correctly now (*)
  • The 'Transaction is active' message doesn't appear anymore after calling the windows list while the Data tab of Table Editor is active
  • Identifiers appearing in the IN (..) clause are parsed correctly by Query Designer now (*)
  • Fixed a bug in the Stored Procedure Debugger with retrieving the count of variables if type conversions are used in the procedure (*)
  • Some minor improvements and corrections

Scroll to top

Version 3.5.0.1

  • Database Designer: we have added a possibility to save the diagram as a bitmap. Now you can save you diagrams to graphical files using the 'Save as Image' button of the toolbar (*)
  • Data View: we have added a possibility to set filter to the Grid View. Now you can filter the current data view using drop-down arrows on the right of the column captions
  • The Create Procedure function is now available for views as well as for tables
  • Now you can hide the Object Explorer tree from object editors permanently by disabling the "Automatically show Object Explorer..." option on the Tools page of the Environment Options dialog
  • The Validate Database option is now enabled by default in the Database Validation dialog to avoid the 'Unsuccessful execution...' error raised if no options were selected
  • DB Explorer: a database closes automatically now if the connection to it has been lost for some reason. It prevents the application from hanging up due to impossibility to disconnect from a database
  • Export Data and Export Data as INSERT items are also available for views in DB Explorer now (*)
  • Character set in the Print View corresponds to the database charset now (*)
  • Fixed a bug with representing the dependencies in View Editor
  • Fixed a bug with adding a trigger using the object explorer of Table Editor. Now names of trigger types appear correctly in the explorer
  • The 'Grant/Revoke on All' menu item works correctly in Grant Manager now
  • Fixed a bug with generating a wrong CREATE TABLE statement in the Export Data as INSERT dialog in case of selecting the fields for export manually from the dual list (*)
  • Fixed a bug with DATE/TIMESTAMP values format in the Stored Procedure Debugger (*)
  • Fixed a bug with BLOB fields truncating during the import data process (*)
  • Fixed a bug with the 'CONTINUE record missing' error while importing data from some Excel files (*)
  • Query result does not become read-only anymore if more than one space appears after the FROM keyword
  • Fixed a bug with the fetching status window in the SQL Editor if the 'Fetch All' option is enabled
  • Fixed a bug with using aggregate functions within the SELECT statement in Query Designer (*)
  • Some minor improvements and corrections

Scroll to top

Version 3.4.0.1

  • We have significantly improved stored procedure/trigger parser as well as Stored Procedure Debugger (*). Now it supports all SQL language extensions for Firebird 1.5 (such as defining variable in its declaration, EXECUTE VARCHAR syntax, CASE syntax), IB 6.5 (such as ROWS syntax) and IB 7.0 (such as BOOLEAN type)
  • Extract Metadata Wizard: we have improved the algorithm of extracting stored procedures to avoid conflicts during their creation. Now you can extract stored procedures as a block of the CREATE PROCEDURE statements with empty bodies preceding another block containing their actual bodies defined in the ALTER PROCEDURE statements. This possibility can be disabled by the 'Extract stored procedures with empty bodies first' option, which is enabled by default
  • We have added a possibility to load an Extract Metadata template automatically on calling the wizard. Now you can set the 'Automatically load template on run' option (Environment Options -> Tools -> Extract Metadata) and select the template file to load on each wizard execution
  • Import Data Wizard: now you can log all the SQL commands executed during the import process into a file. Use the 'Enable SQL Log' option on the last step of the wizard for this purpose (*)
  • Now you can use CONTAINING and STARTING WITH syntax within the WHERE clause in Query Designer (*)
  • Fixed bug with "Transaction is not active" error occurrence on commit in the Import Data Wizard (*)
  • Query Designer doesn't slow down the system anymore (*)
  • Fixed bugs with creating folder and adding objects to the Project View tree of DB Explorer
  • Fixed a bug with impossibility of saving changes in SQL Script
  • Now data table list is properly restored from a template in the Extract Metadata Wizard
  • Data exported to MS Access table started to print even if the corresponding option was unchecked. Now it is fixed (*)
  • Fixed a bug with loading data into the BLOB Editor/Viewer using hexadecimal editor's local menu (*)
  • The UPDATE or INSERT mode of the Import Data Wizard imports data properly now (*)
  • Fixed a bug with autogrants during creating a trigger
  • Some minor improvements and corrections

Scroll to top

Version 3.3.0.1

  • InterBase 7.0 BOOLEAN type is supported by IB Manager now
  • Import Data: a possibility of defining the import mode was added. Now you can define how the records from the source file must be imported to the destination. Six modes of data import are available, which allow you to add all records, add new records only, update or delete existing records in various ways (*)
  • Export Data: a possibility of customizing multi-file export was added to HTML options. Now it is possible to set the maximal count of records in single file, availability of index file and navigation options (*)
  • Query Designer: a possibility of diagram saving/loading was added. Now you can save the current diagram layout to external file for later use (*)
  • Page options were added to the PDF Options page of the Export Data dialog. A possibility to set page size, orientation and margins is available for export to PDF format now (*)
  • The 'Autoconnect on Startup' option was added to the Database Registration Info dialog
  • If the Show Hosts option is enabled, databases are grouped by hosts now in the database lists of all program tools, such as SQL Editor, Table Editor and others
  • New InterBase 7.0 TMP$ objects are also marked as system now
  • Fixed a bug with impossibility of editing parameters and variables values of CHAR and VARCHAR types in the Stored Procedure Debugger window
  • Fixed a bug with multiplying of VARCHAR domain size by 3 in the Domain Editor if the UNICODE_FSS character set was specified
  • Fixed a bug when the DDL was improperly generated for multiple keys definitions
  • Now it is possible to check/uncheck fields in the list when creating view or procedure for a table from Table Editor
  • Fixed a bug with conversion exception raised in the Stored Procedure Debugger window for DATE parameters if system date format is different from InterBase one
  • Fixed a bug with impossibility of setting the Underline option for a font on the Color page of the Editor Options dialog
  • Fixed a bug with improper displaying of the CHECK expression in Domain Editor
  • Fixed a bug with generating field descriptions in HTML Report
  • Fixed a bug with displaying system objects in SQL Assistant if they are in separated node
  • Compare SQL Scripts: fixed a bug in ALTER TRIGGER syntax. Also if two tables have different primary keys, the DROP statement will be generated for the current primary key of target table before the CREATE one
  • Some minor improvements and corrections

Scroll to top

Version 3.2.5.1

  • Database Designer: customizing of the color palette and object appearance was added. Now it is possible to change the appearance of the designer totally by specifying colors and options on the Database Designer page of the Environment Options dialog *
  • Two new grid options were added in addition to the 'Fit columns widths to grid width' option: the 'Save grid view' and 'Autofit columns' options. The 'Save grid view' option should be chosen if you wish grid columns to be saved and restored during the next session. The Autofit columns option will fit column widths to their most wide values
  • The 'Set Defaults to All Child Windows' item was added to the Windows menu. This item sets all the child windows to their default sizes and positions. This function is also available through the Ctrl+Alt+D shortcut
  • Data View: now it is possible to search for the desired value in the current column by typing it in the grid, if the 'Enable auto search in grid' option is checked
  • The 'Always Open the Fields Tab' option works properly now
  • Fixed a bug with using AltGr key for typing characters in editors
  • Fixed a bug with incorrect generation of the ON DELETE/ON UPDATE statements if active program language is different from default
  • Fixed a bug with closing all the child windows even if the Cancel button was pushed in exit confirmation dialog
  • Fixed a bug with disabling the 'Show servers in DB Explorer' option in the Environment Options dialog
  • Fixed a bug with hiding/showing the DB Explorer window by pressing the F11 key
  • Some minor improvements and corrections

Scroll to top

Version 3.2.0.1

  • Autogrants functions were implemented. Now you can automatically grant privileges to stored procedures, triggers and views. This feature is available via the corresponding button of the Procedure Editor, Trigger Editor or View Editor and also via the popup menu in DB Explorer. It's also possible to set grants when objects are compiled. Set proper options on the Tools page of the Environment Options dialog for that purpose
  • A possibility to increase/decrease spinner values in the grid cells using Ctrl+Up and Ctrl+Down combinations instead of Up and Down. You can enable this feature by setting the Use Ctrl+Up to increase spinner values option on the Grid page of the Environment Options dialog
  • An ability to show only connected databases in the drop-down menus was added to all object editors and database tools. This option can be enabled by the corresponding check-box on the Tools page of the Environment Options dialog
  • The DB Explorer state (if it is visible or not) is stored in registry now
  • The 'Smart Tabs' option was added to the Editor Options dialog. Enable it if you want to have tab width values depending on upper lines, or disable it if you want to use tab width values specified by the 'Tab Stops' option
  • Auto search feature is available in SQL Assistant, Query Designer and Database Designer now
  • Database Designer: the Delete key now closes active table(s) in a diagram, Shift+Del is used to drop a table, Ctrl+Del deletes fields within an active table *
  • A possibility to edit the page size manually is added to the Create Database wizard
  • Object descriptions are displayed properly in DB Explorer if 'Show Table Description' is on
  • Stored Procedure Editor displays an error dialog if an exception was raised while executing the procedure
  • Fixed a bug with 'Can't focus disabled or invisible window' error message after opening Table Editor with the Dependencies, Triggers or Description page active
  • Fixed a bug with closing the View Editor after recompiling a view
  • Fixed a bug with "Object ... in use" error during view recompiling
  • Fixed a bug with "List index out of bounds" error while changing autoincrement initial value of a trigger
  • Domain info is visible now in the Add/Edit Column dialog
  • Fixed a bug with extracting objects having names beginning with a digit
  • Fixed a bug with program crashing during export of BLOBs to DBF (see Export Data dialog) *
  • The Compare Script feature is unavailable until both files are specified. It prevents from receiving the I/O error after pushing the 'Finish' button when file name(s) are not specified
  • The Show Tips feature shows the next tip on startup now
  • Fixed a bug with the incorrect behavior of the View Procedure Header button in Stored Procedure Editor
  • The External Tools submenu now available in the Tools menu (see External Tools)
  • The 'Set Default Link Color' button works properly in Database Designer now *
  • Fixed a bug with improper behavior of child windows in MDI environment mode
  • Some minor improvements and corrections

Scroll to top

Version 3.1.0.1

  • Dutch localization was added to IB Manager distribution package. Now six languages are supported: English, German, Italian, Spanish, Dutch and Russian. This list will expand from version to version. You can change the program language through the Options | Select program language... main menu item. IB Manager also allows you to select your language preference at first startup (see Select Program Language)
  • Query Designer was updated to the latest version of EMS QueryBuilder suite (http://www.ems-hitech.com/querybuilder/); a lot of small improvements and corrections have been made
  • Database tools (e.g. SQL Editor, Query Designer *, Database Designer *) now switch to the active database automatically each time when the tool window becomes active
  • Database Designer: a possibility to hide/show grid in database objects was added. This option is available in the Database Designer window through the 'Show Grid in Objects' item of the Display Mode button drop-down menu *
  • SQL Script: now the database drop-down list updates itself in compliance with the databases currently active and reverts to its initial state if the assigned database closes
  • The User Manager window behaviour was changed. It is not a modal window now and it looks like other child windows of the application
  • Print Metadata window has also changed its style *
  • Database Designer & Query Designer: these two windows were redesigned to avoid undesirable toolbar behaviour *
  • The Login prompt dialog appears now if no password is specified in the Database Registration Info
  • "FDB" file extension became a registered file type. Now you're able to register/open Firebird databases by starting a database file from Windows shell
  • Some corrections were applied to User Manager; adding role and some other functionality is now available
  • Fixed a bug with "List index out of bounds" error in the Search in Metadata function. Several minor bugs were also fixed
  • Compare Scripts Wizard: fixed a bug with CHAR/VARCHAR fields which have default values containing more than one word
  • DB Explorer: fixed bug with disappearing object names in the SQL Assistant after switching from the Databases tab to the Windows tab and back again
  • Some minor improvements and corrections

Scroll to top

Version 3.0.0.1

Basic features:

New features – new name!

  • QuickDesk changes its name to IB Manager!

New, modern, and fully customizable user interface!

  • See Editor Options for details

MDI Interface implemented

  • Microsoft Office Style - all program windows are child windows of the main window now. You can customize the Environment Style using the the Environment Options window

HTML Report Generator

  • Create a detailed HTML report of your database quickly

New Query Designer

  • Full support of FB 1.x and IB 6.5 select enhancements

Plan Analyzer

  • Helping you easily understand the query optimization plans in SQL Editor

Multilanguage support

  • Spanish, Italian, German and Russian localizations available, Dutch localization is coming soon

Backup and Restore Templates

  • Make backup and restore even more quickly

New Compare SQL Scripts Module

  • Working much better than the previous one

Data Export to PDF and MS Access

  • Two more popular formats added

Scroll to top

See also:

What's new


EMS SQL Manager FAQ

Please read this page attentively if you have questions about EMS SQL Manager for InterBase/Firebird.

Table of contents

Product questions

  • What is EMS SQL Manager for InterBase/Firebird?
  • What is the difference between Full/Lite editions of EMS InterBase/Firebird?
  • What do I need to start working with EMS SQL Manager for InterBase/Firebird?
  • What is the difference between the Export/Import functions in SQL Manager and the Data Export/Import utilities?
  • What is the difference between the Design Query module in SQL Manager and the SQL Query for InterBase/Firebird utility?
  • What is the difference between the Extract Database function in SQL Manager for InterBase/Firebird and the DB Extract for InterBase/Firebird standalone utility?

Common questions

  • I can't modify DDL. Why?
  • How can I customize data formats in grid?
  • I need to perform some changes in database objects of my test database and then make the same changes on master database. Are there any tools for this purpose in SQL Manager for InterBase/Firebird?
  • When I create database objects, their names are always converted to lower case. How I can prevent it?
  • I am trying to create a report in Report Designer, but I can't get access to the table data: 'Band data source' list is empty.
  • How can I speed up my work with large tables?
  • I have a table with appr. 1000 records only, and a large number of fields. Opening this table on the 'Data' tab takes too much time.

Export/Import questions

  • I'm trying to export data from a table, but BLOB fields are not exported.
  • What is the difference between the "Extract Database" and "Export as SQL Script" functions?
  • How can I change the default directory where exported data are saved?

Question/answer list

Product questions

Q: What is EMS SQL Manager for InterBase/Firebird?

A: EMS SQL Manager for InterBase/Firebird is a powerful tool for InterBase/Firebird administration and development. SQL Manager for InterBase/Firebird works with Firebird server versions up to 4.0 and InterBase server versions up to 2020, and supports all of the latest InterBase/Firebird features. It offers plenty of powerful tools for experienced users to satisfy all their needs. SQL Manager for InterBase/Firebird has a new state-of-the-art graphical user interface with well-described wizard system, so clear in use that even a newbie will not be confused with it.

Q: What is the difference between Full/Lite editions of EMS SQL Manager for InterBase/Firebird?

A: These editions of SQL Manager differ in price and features. To register SQL Manager for InterBase/Firebird, see the Purchase page, and to learn about the difference in features please go to our Feature Matrix page.

Q: What do I need to start working with EMS SQL Manager for InterBase/Firebird?

A: First of all, you must have an opportunity to connect to some local or remote InterBase/Firebird server. Besides, you need your workstation to satisfy the system requirements of SQL Manager for InterBase/Firebird.

Q: What is the difference between the Export/Import functions in SQL Manager and the Data Export/Import utilities?

A: The Data Export/Import for InterBase/Firebird utilities include some additional features which are not available in SQL Manager, such as:

  • export/import data from/to several tables simultaneously;
  • export/import data from/to tables selected from different databases on one host;
  • a command-line utility to export/import data using the configuration file with all the export/import options.

Q: What is the difference between the Design Query module in SQL Manager and the SQL Query for InterBase/Firebird utility?

A: First of all, SQL Query for InterBase/Firebird works faster as it is a much lighter product. Besides, it provides additional features for query building, e.g.:

  • keeping query history which allows you to rollback to any edited query;
  • various interface improvements for more productive and easier work.

Q: What is the difference between the Extract Database function in SQL Manager for InterBase/Firebird and the DB Extract for InterBase/Firebird standalone utility?

A: The DB Extract for InterBase/Firebird utility includes some additional features which are not available in SQL Manager, such as:

  • extracting metadata and/or data from several databases on one host;
  • a console application for performing extract in one-touch;
  • faster extraction speed.

Scroll to top

Common questions

Q: I can't modify DDL. Why?

A: The DDL tab of the SQL Manager editors is read-only. It displays object structure as SQL text and reflects the operations you perform over the object under other editor tabs. To modify an object, you can copy the text to the clipboard and edit it using Execute Script Editor. For more details refer to Viewing object DDL structure.

Q: How can I customize data formats in grid?

A: You can customize all display formats: integer, float, date, time and datetime using the Color & Formats page of the Environment Options dialog.

Q: I need to perform some changes in database objects of my test database and then make the same changes on master database. Are there any tools for this purpose in SQL Manager for InterBase/Firebird?

A: The Database Registration Info dialog provides the Logs section where you can enable logging metadata changes performed over the database and/or SQL queries executed in Query data.

Q: When I create database objects, their names are always converted to lower case. How I can prevent it?

A: Please try to switch off the "Convert created objects' names to lower case" option within the Object Editors section of the Environment Options dialog.

Q: I am trying to create a report in Report Designer, but I can't get access to the table data: 'Band data source' list is empty.

A: It is recommended to use Create Report wizard which is run by right-clicking the Reports node in DB Explorer and selecting the 'New Report...' context menu item. The wizard will create all necessary data sources.

If you still want to use Report Designer, to get the data source in a report, you need to add database and query components to the report.

Q: How can I speed up my work with large tables?

A: For your convenience and to speed up your work, the Data Grid allows customizing a number of data display parameters. Here are the most important of them (accessible through the Grid | Data Options section of the Environment Options dialog):
- Limit options in table and view editors. The 'Select all records of a table' option will enable you to see all table records without extra references to the server, yet in case of large tables or low speed connection channel the data may be fetched with huge delays and the incoming traffic might grow considerably. This mode is recommended when working with local databases or in a private network. The 'Select only' mode restricts the maximum number of records returned after the query. A man cannot process a massive amount of information at once. Hence, we came up with this mode. This mode speeds up table data viewing considerably, prevents hanging and connection timeout. It is recommended to work with large tables, in case of low speed connection channels and when the traffic volume is of importance. This is the default mode. When in this mode, enabling the 'Use SQL sorting in data view' and 'Use SQL filter in data view' options comes really helpful.
- Default Grid Mode. This option defines whether the requested rows will be loaded in the Grid all at once ('Load all rows'), or in parts ('Load visible rows') as the user scrolls down table data. The first mode increases the query opening time, but speeds up scrolling. In the second mode the query opens very fast, but there might be delays when navigating the grid.
- Use SQL sorting in data view. With this option enabled, when the user sets data sorting, a new request is sent to the server, and the result is shown anew in the Grid. Enabling this option is very helpful with the 'Select only' mode enabled, but it increases the traffic. When this option is disabled, sorting is made on the client computer without any references to the server but only loaded data are sorted. That is, if you set 'Select only 1,000 records', then only these records will be sorted.
- Use SQL filter in data view. With this option enabled, the data will be sorted on the server to which a new request is sent, and the result will be shown anew in the Grid. Enabling this option is also helpful when the 'Select only' mode is on, but it increases the traffic. When this option is disabled, the filtering is made on the client computer without any references to the server but only loaded data are filtered. That is, if you set 'Select only 1,000 records', then only these records will be filtered.
We recommend that you set the following option values to achieve maximum efficiency when working with large tables:
- Select only – ON
- Load visible rows – ON
- Use SQL sorting in data view – ON
- Use SQL filter in data view – ON

Q: I have a table with appr. 1000 records only, and a large number of fields. Opening this table on the 'Data' tab takes too much time.

A: You need to set the Grid Mode for the table to 'Load Visible Rows'. Please right click within the table grid and select the 'Grid Mode' | 'Load Visible Rows' context menu item.

Scroll to top

Export/Import questions

Q: I'm trying to export data from a table, but BLOB fields are not exported.

A: Fields of type BLOB are not exported by default. You should select these fields manually at the Selecting fields for export step.

Q: What is the difference between the "Extract Database" and "Export as Execute Script" functions?

A: Export as SQL Script is intended for exporting table data that will be inserted into a database system other than InterBase/Firebird. Use Extract Database Wizard to copy metadata and/or data to a database on InterBase/Firebird afterwards.

Q: How can I change the default directory where exported data are saved?

A: Follow the steps below to change the default directory:

1. Right-click the database alias in DB Explorer and select the 'Database Registration Info...' context menu item (you can also find this item in the 'Database' main menu) to open the Database Registration Info dialog.

2. Proceed to the Directories section within the dialog.

3. Set the 'Default directory for Export Data'.

Scroll to top

If you still have any questions, contact us at our Support Center.


Other EMS Products

Quick navigation

MySQL

Microsoft SQL Server

PostgreSQL

InterBase / FireBird

Oracle

IBM DB2

Tools & components

MySQL

 | SQL Management Studio for MySQL EMS SQL Management Studio for MySQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for MySQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for MySQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for MySQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for MySQL Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to MySQL.
datagenerator | Data Generator for MySQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for MySQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for MySQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for MySQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for MySQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Microsoft SQL Server

 | SQL Management Studio for SQL Server EMS SQL Management Studio for SQL Server is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | EMS SQL Backup for SQL Server Perform backup and restore, log shipping and many other regular maintenance tasks on the whole set of SQL Servers in your company.
sqladmin | SQL Administrator for SQL Server Perform administrative tasks in the fastest, easiest and most efficient way. Manage maintenance tasks, monitor their performance schedule, frequency and the last execution result.
 | SQL Manager for SQL Server Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for SQL Server Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for SQL Server Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for SQL Server Migrate from most popular databases (MySQL, PostgreSQL, Oracle, DB2, InterBase/Firebird, etc.) to Microsoft® SQL Server™.
datagenerator | Data Generator for SQL Server Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for SQL Server Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for SQL Server Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for SQL Server Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for SQL Server Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

PostgreSQL

 | SQL Management Studio for PostgreSQL EMS SQL Management Studio for PostgreSQL is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | EMS SQL Backup for PostgreSQL Creates backups for multiple PostgreSQL servers from a single console. You can use automatic backup tasks with advanced schedules and store them in local or remote folders or cloud storages
 | SQL Manager for PostgreSQL Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for PostgreSQL Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for PostgreSQL Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for PostgreSQL Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, InterBase/Firebird, etc.) to PostgreSQL.
datagenerator | Data Generator for PostgreSQL Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for PostgreSQL Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for PostgreSQL Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for PostgreSQL Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for PostgreSQL Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

InterBase / Firebird

 | SQL Management Studio for InterBase/Firebird EMS SQL Management Studio for InterBase and Firebird is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for InterBase/Firebird Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for InterBase/Firebird Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more
dataimport | Data Import for InterBase/Firebird Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for InterBase/Firebird Migrate from most popular databases (MySQL, SQL Server, Oracle, DB2, PostgreSQL, etc.) to InterBase/Firebird.
datagenerator | Data Generator for InterBase/Firebird Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for InterBase/Firebird Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for InterBase/Firebird Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for InterBase/Firebird Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for InterBase/Firebird Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

Oracle

 | SQL Management Studio for Oracle EMS SQL Management Studio for Oracle is a complete solution for database administration and development. SQL Studio unites the must-have tools in one powerful and easy-to-use environment that will make you more productive than ever before!
 | SQL Manager for Oracle Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for Oracle Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for Oracle Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for Oracle Migrate from most popular databases (MySQL, PostgreSQL, MySQL, DB2, InterBase/Firebird, etc.) to Oracle
datagenerator | Data Generator for Oracle Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
dbcomparer | DB Comparer for Oracle Compare and synchronize the structure of your databases. Move changes on your development database to production with ease.
extract | DB Extract for Oracle Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for Oracle Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
datacomparer | Data Comparer for Oracle Compare and synchronize the contents of your databases. Automate your data migrations from development to production database.
 | Scroll to top

IBM DB2

 | SQL Manager for DB2 Simplify and automate your database development process, design, explore and maintain existing databases, build compound SQL query statements, manage database user rights and manipulate data in different ways.
dataexport | Data Export for DB2 Export your data to any of 20 most popular data formats, including MS Access, MS Excel, MS Word, PDF, HTML and more.
dataimport | Data Import for DB2 Import your data from MS Access, MS Excel and other popular formats to database tables via user-friendly wizard interface.
datapump | Data Pump for DB2 Migrate from most popular databases (MySQL, PostgreSQL, Oracle, MySQL, InterBase/Firebird, etc.) to DB2
datagenerator | Data Generator for DB2 Generate test data for database testing purposes in a simple and direct way. Wide range of data generation parameters.
extract | DB Extract for DB2 Create database backups in the form of SQL scripts, save your database structure and table data as a whole or partially.
query | SQL Query for DB2 Analyze and retrieve your data, build your queries visually, work with query plans, build charts based on retrieved data quickly and more.
 | Scroll to top

Tools & components

advancedexport | Advanced Data Export for RAD Studio VCL Advanced Data Export for RAD Studio VCL allows you to save your data in the most popular office programs formats.
advancedexport | Advanced Data Export .NET Advanced Data Export .NET is a component for Microsoft Visual Studio .NET that will allow you to save your data in the most popular data formats for the future viewing, modification, printing or web publication. You can export data into MS Access, MS Excel, MS Word (RTF), PDF, TXT, DBF, CSV and more! There will be no need to waste your time on tiresome data conversion - Advanced Data Export will do the task quickly and will give the result in the desired format.
advancedimport | Advanced Data Import for RAD Studio VCL Advanced Data Import for RAD Studio VCL will allow you to import your data to the database from files in the most popular data formats.
pdfgenerator | Advanced PDF Generator for RAD Studio Advanced PDF Generator for RAD Studio gives you an opportunity to create PDF documents with your applications written on Delphi or C++ Builder.
querybuilder | Advanced Query Builder for RAD Studio VCL Advanced Query Builder for RAD Studio VCL is a powerful component for Delphi and C++ Builder intended for visual building SQL statements for the SELECT, INSERT, UPDATE and DELETE clauses.
excelreport | Advanced Excel Report for RAD Studio Advanced Excel Report for RAD Studio is a powerful band-oriented generator of template-based reports in MS Excel.
advancedlocalizer | Advanced Localizer for RAD Studio VCL Advanced Localizer for RAD Studio VCL is an indispensable component for Delphi for adding multilingual support to your applications.
 | Scroll to top


Getting Started

SQL Manager for InterBase/Firebird provides you with an ability to contribute to efficient InterBase/Firebird administration and development using a variety of available tools easily and quickly.

The succeeding chapters of this document are intended to inform you about the tools implemented in SQL Manager for InterBase/Firebird. Please see the instructions below to learn how to perform various operations in the easiest way.

  • Selecting style and language
  • How the application looks when you start it for the first time
  • Using Desktop Panel
  • Database navigation
  • Working with database objects
  • Using context menus
  • Working with child windows

See the How to... chapter to view brief instructions on how to perform some operations on databases, database objects, etc.

Enjoy your work with EMS SQL Manager for InterBase/Firebird!

See also:

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Security management

External Tools

How to...


Selecting style and language

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Selecting environment style and program language

Before you start SQL Manager for the first time, you have to choose the appearance style and the interface language. You can change these settings any time using the Environment Options dialog to configure environment style and the language.

Appearance theme

Select the main color theme for the application: Light, Blue or Dark.

Bar style for editors

Here you can define the location of action buttons: RadioButton within the Navigation bar (on the left) and/or RadioButton on the Toolbar.

Program language

Select the interface language from the list of available languages.

Sample

See the example of selected options for interface.

Getting started - Selecting style and language

See also:

First time started

Using Desktop Panel

Database navigation

Working with database objects

Using context menus

Working with windows


First time started

This is how SQL Manager for InterBase/Firebird looks when you start it for the first time. Use the Desktop panel to fulfill any of common tasks: Create a new database, Manage existing database(s), and several tasks that do not require database registration, i.e. Execute script, accessing the reference system or using available Internet resources.

The main menu allows you to perform various Database operations, open To-Do List and activate/deactivate Database Explorer, SQL Assistant and various toolbars within the View menu, manage your databases using items of the Tools and Services menus, customize the application using the Options menu, manage SQL Manager Windows using Window List and other tools, and access Registration information and product documentation, update the product to the latest version using the corresponding items available within the Help menu.

To start working with your InterBase/Firebird server, you should first register the host using Register Host wizard. After that you need to register one or several databases using Register Database Wizard.

By default the corresponding btnRegisterHost Register Host, btnRegisterDB Register Database buttons are available on the toolbar and within the Database menu.

When the database connection settings are specified, you can set connection to your database and proceed to Database navigation, Database Objects management, working with SQL queries and other tools of SQL Manager.

Getting started - First time started

See also:

Selecting style and language

Using Desktop Panel

Database navigation

Working with database objects

Using context menus

Working with windows


Using Desktop Panel

Desktop Panel is the area that is visible when no child windows are open in SQL Manager for InterBase/Firebird. The working area of Desktop Panel is divided into four sections: Getting Started, Database Tools, Help and Support, Internet Resources.

Getting started - Using Desktop Panel

Using the Desktop Panel items you can:

Getting Started

Create a new InterBase/Firebird database

Register existing database(s) to operate them afterwards in SQL Manager

Create a new table within the current database using the New Table window (this item is available if there is at least one active database connection)

Create a new database object within the current database (this item is available if there is at least one active database connection)

Database Tools

Execute a script using Execute Script editor

Query data (this item is available if there is at least one active database connection)

Manage Users allows you to create new or edit existing users using User Manager

Manage permissions on database objects to InterBase/Firebird users using Grant Manager (this item is available if there is at least one active database connection)

Help and Support

Show this help file

Show InterBase and Firebird help file

Internet Resources

Visit SQL Manager Home Page

Browse SQL Manager online documentation

Go to Technical Support Center

Look through the Frequently Asked Questions page

See also:

Selecting style and language

First time started

Database navigation

Working with database objects

Using context menus

Working with windows


Database navigation

After you have registered the required database(s), the corresponding alias(es) appear in the DB Explorer tree on the left. If the Show Hosts option is checked on the Environment Options | DB Explorer page, the host nodes are also displayed in the tree (alternatively, you can use the Show Hosts item of the Database context menu, or the drop-down menu of the View Mode btnViewMode toolbar button for the same purpose).

Getting started - Database navigation

DB Explorer displays all registered hosts and databases. Connected/disconnected hosts and databases can be easily distinguished in the tree: aliases of disconnected hosts and databases are grayed out.

Getting started - Database navigation - Disconnected DB

To connect to a database, simply double-click its alias (or select the database alias in DB Explorer and press Enter). If the connection is successful, the database node expands into a tree of objects.

Now you can navigate within the database objects. Use SQL Assistant to get extended information about the currently selected object.

For your convenience objects having different status (e.g. enabled/disabled) and valid/invalid objects are displayed with different icons in Database Explorer.

Getting started - Database navigation - Object status

See also:

Selecting style and language

First time started

Using Desktop Panel

Working with database objects

Using context menus

Working with windows


Working with database objects

The nodes of the DB Explorer tree allow you to access objects of the selected database. If InterBase/Firebird server you are connected to supports certain types of objects, their nodes will appear in the tree.

Double-click an object group to expand/collapse the corresponding tree node.

Double-click an object to open it in the corresponding editor.

Right-click an object to display its context menu which allows you to perform various operations over the selected object or database.

Getting started - Working with database objects

If you want to use the DB Explorer tree for working with table subobjects (fields, indexes, Foreign keys, etc.), check the Show table subobjects option which is available within the General options group of the Environment Options | DB Explorer page (you can also use the Show Table Subobjects menu item in the drop-down menu of the View Mode btnViewMode toolbar button for the same purpose.)

Getting started - Working with database objects - View Mode

See also:

Selecting style and language

First time started

Using Desktop Panel

Database navigation

Using context menus

Working with windows


Using context menus

The context menus are aimed at facilitating your work with SQL Manager for InterBase/Firebird: you can perform a variety of operations using context menu items.

Select an object in DB Explorer and right-click its alias to open the context menu.

  • Host context menu
  • Database context menu
  • Object context menu

See also:

Selecting style and language

First time started

Using Desktop Panel

Database navigation

Working with database objects

Working with windows


Host context menu

The context menu of a host in the DB Explorer tree allows you to:

  • btnConnectToDB connect/ btnDisconnectFromDB disconnect to/from host;
  • btnCreateDB create a new database at the selected host;
  • register a new database using btnRegisterDB Register Database Wizard;
  • access server tools available in the Tasks submenu;
  • register a new host using btnRegisterHost Register Host Wizard;
  • btnUnregisterHost unregister the selected host;
  • view/edit the selected host properties within the btnHost Host Registration Info dialog;
  • configure representation of hosts and databases in Database Explorer;
  • create a new tab for the selected host to access it through this tab quickly and/or manage the existing tab;
  • search for an object within the tree.

Using context menus - Host context menu

Tasks submenu allows you to:

  • manage iconUserManager users;
  • launch iconEventMonitor Event Monitor;
  • view and edit server messages using btnDBRegistrationInfo Server Messages Editor.

See also:

Database context menu

Object context menu


Database context menu

The context menu of a registered database in the DB Explorer tree allows you to:

  • btnConnectToDB connect to the selected database (if connection to the database is not active yet);
  • btnDisconnectFromDB disconnect from the selected database (if connection to the database has been already activated);
  • btnCreateDB create a new database at the host where the selected database resides;
  • register a new database using btnRegisterDB Register Database Wizard;
  • btnUnregisterDB unregister the selected database;
  • iconDropDatabase drop the selected database;
  • view/edit the selected database registration information within the btnDBRegistrationInfo Database Registration Info dialog;
  • view/edit the btnDBProperties Database properties;
  • access database tools available in the Tasks submenu;
  • register a new host using btnRegisterHost Register Host Wizard;
  • configure representation of hosts and databases in Database Explorer;
  • refresh the selected database;
  • create a new tab for the selected database to access it through this tab quickly and/or manage the existing tab;
  • iconFindObject search for an object within the tree.

Using context menus - Database context menu

Tasks submenu allows you to:

backup database using the wizard;

restore database using the wizard;

iconValidateDatabase validate database;

iconDatabaseStatistics retrieve database statistics;

iconStartDatabase start/stop database;

iconRecomputeIndices recompute all indices of a database;

iconPurgeDatabase purge a database;

btnExtractDB extract database objects and/or data to an Execute Script;

btnPrintMetadata print metadata;

generate html report of the selected objects;

iconToDoList create to-do list;

btnGroupManager manage roles and their privileges;

iconTableAlteringMonitor launch Table Altering Monitor.

See also:

Host context menu

Object context menu


Object context menu

The context menu of an object (e.g. table or view) in the DB Explorer tree allows you to:

  • create a new database object of the same type;
  • edit the selected object in its editor;
  • rename the selected object;
  • drop the selected object from the database;
  • iconDuplicateObject duplicate the selected object (create a new object with the same DDL structure and properties as the selected object has);
  • access common Tasks applied to this object;
  • perform data manipulation operations (for tables and views);
  • define btnGrantManager grants for the selected object;
  • generate the object script and open it in editor;
  • generate the database script and copy its text to Windows clipboard;
  • refresh all objects of the selected object type;
  • view/edit the database registration information within the btnDBRegistrationInfo Database Registration Info dialog (for database objects);
  • btnNewTabFromHere create a new tab for the selected object to access it through this tab quickly and/or manage the existing tab;
  • iconFindObject search for an object within the tree.

Using context menus - Object context menu

See also:

Host context menu

Database context menu


Working with windows

The Windows Toolbar of SQL Manager allows you to switch between child windows easily, like in Windows Task Bar.

To activate the window you need, simply click one of the window buttons. To perform some additional actions with the window, right-click its tab and select the corresponding menu item from the popup menu.

Getting started - Switching windows

If you have multiple windows opened, you can also switch between them using the Ctrl+Tab shortcut.

The Windows menu facilitates your work with SQL Manager windows.

The Windows menu allows you to:

  • view the Windows List within the corresponding tab of DB Explorer;
  • set all current windows cascade:

Getting started - Windows - Cascade

  • minimize all windows;
  • restore all windows;
  • tile all current windows horizontally:

Getting started - Windows - Tile Horizontal

  • tile all current windows vertically:

Getting started - Windows - Tile Vertical

  • set defaults to all windows;
  • reset all toolbars and menus;
  • close all windows;
  • close all editors of the specified object type (can be selected from the submenu);
  • switch to the previous window;
  • switch to the next window;
  • activate one of currently opened windows.

See also:

Selecting style and language

First time started

Using Desktop Panel

Database navigation

Working with database objects

Using context menus


Database Explorer

Database Explorer (or DB Explorer) is the basic window of SQL Manager for InterBase/Firebird for navigation within databases and working with database objects. The tree-like structure of DB Explorer allows you to manage the databases, database objects and perform other everyday operations quickly and easily.

The following list contains the most frequently used features provided by Database Explorer.

  • Managing database registration info
  • Connecting to databases and hosts
  • Performing basic operations upon database objects
  • Selecting multiple objects
  • Navigating database objects using multiple tabs
  • Easy access to recently opened objects
  • Managing favorite objects
  • Searching within the tree
  • Viewing extended information about database objects
  • Configuring Database Explorer
  • Managing Favorite queries

All objects are structured by their types and are available within the corresponding nodes of the tree. The number of objects of each type is displayed in brackets after the node name denoting the object type. To expand/collapse a node, you can double-click it or use the +/- icons.

To view/hide the Database Explorer window, use the View | DB Explorer main menu item or press the F11 key.

DB Explorer - View

Use the Ctrl+Shift+C shortcut to collapse current DB Explorer tree branch and switch to the parent node.

Note that you can change host and database aliases order by dragging them within the DB Explorer tree.

See also:

Getting Started

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Security management

Options

External Tools

How To...


Managing database registration info

After you have created and/or registered your database in SQL Manager for InterBase/Firebird, you can perform a number of operations with the database using the context menu.

If you need to view/edit the registration information of a database, right-click the database alias in DB Explorer and select the Database Registration Info... context menu item to open the Database Registration Info dialog.

DB Explorer - Managing database registration info

See also:

Register Database

Database Registration Info

Database Properties


Connecting to databases and hosts

When the InterBase/Firebird host is registered, and the database registration is complete, you can establish connection to your database.

The simplest way to connect to a database is to double-click its alias in the Database Explorer tree. The same operation can be performed by selecting the Connect to Database or Safe Connect item of the database context menu, or by using the Database | Connect to Database main menu item.

Safe Connect provides a secure connection to the database using the isc_dpb_no_db_triggers parameter.

DB Explorer - Connecting to databases

Alternatively, you can use the Shift+Ctrl+C shortcut, the btnConnectToDB Connect to Database ( btnConnectToDB Connect to Host), or the Safe Connect toolbar buttons.

DB Explorer - Connecting to databases - Toolbar

Before working with server-scoped objects and services, a host connection must be established by selecting the btnConnectToDB Connect to Host item of the host context menu, or by using the Database | Connect to Host main menu item.

DB Explorer - Connecting to host

See also:

Register Database

Database Registration Info


Operations with database objects

Database Explorer allows you to perform various operations with database objects.

To open an object in its editor, you can double-click the object in the DB Explorer tree.

You can also right-click an object within the DB Explorer tree and use its context menu to perform a number of operations:

  • create a new object (the New <object>... item);
  • edit currently selected object (the Edit <object_name>... item);
  • rename currently selected object (the Rename <object_name>... item);
  • drop the selected object from the database (the Drop <object_name>... item);
  • duplicate the selected object (the Duplicate <object_name>... item);
  • define grants for the selected object (the Grants for <object_name>... item).

Note that the context menu contains object-specific items only when the object is currently selected in DB Explorer.

DB Explorer - Operations with database objects

Using drag-and-drop operations you can add objects to Query Data editor, Query Designer or Execute Script Editor. For your convenience the Insert to editor dialog is implemented. The dialog allows you to specify the statement to be inserted into the editor: Name, SELECT, INSERT, UPDATE, DELETE, CREATE, ALTER, DROP, Fields list, Name and Type. If necessary, set the Alias and Prefix for variable.

If more convenient, you can edit the generated statement manually (see Working with query).

DB Explorer - Insert to Editor

See also:

Database Objects Management

Query Editor

Selecting multiple objects


Selecting multiple objects

You can select more than one object in Database Explorer by pressing the Ctrl or the Shift key and selecting multiple objects one by one.

The context menu of several selected objects allows you to:

  • create a new database object of the same type;
  • edit the selected objects;
  • drop the selected objects;
  • perform other operations with the first of the selected objects (see Operations with database objects).

DB Explorer - Selecting multiple objects

Hint: You can move several objects to your projects: just drag and drop the selected objects to the previously created subfolder within the Favorite Objects node of DB Explorer.

See also:

Operations with database and server objects

Database Objects Management

Managing projects


Using tabs for database navigation

To make your work with Database Explorer even more convenient, the capability of working with several tabs is implemented.

You can use tabs when you wish to work with a particular node of the DB Explorer tree only: with a group of objects, or with a specific database Favorite Objects folder. Creating such tabs will minimize scrolling within large trees, you only need to switch between them with a single click on the corresponding tab.

Creating tabs

In order to create a new tab:

  • right-click the node (e.g. the Tables node) for which you wish to create a tab and select the New Tab from Here... context menu item.

Note: A tab can be created only on the basis of a tree node. For example, if the Show Table Subobjects option is disabled in the View Mode menu, the New Tab from Here... item will not be available for tables, since none of them will be a tree node anymore.

DB Explorer - Using tabs - New tab

The specified tabs can be displayed in either of the two views:

  • as icons on the lower pane of DB Explorer:

DB Explorer - Using tabs - View as icons

  • as tabs with captions:

DB Explorer - Using tabs - View as tabs

Hint: You can reorder items in the tabs view by dragging their captions up and down.

To add/remove items to/from the tabs view, you can drag the horizontal splitter up/down:

DB Explorer - Splitter for tabs

or click the Configure buttons icon available in the bottom right corner of the DB Explorer window, and select Show More Buttons / Show Fewer Buttons / Add or Remove Buttons items from the popup menu.

DB Explorer - Using tabs - Add or remove buttons

Note: Navigation through the tabs is also possible with the help of the following shortcuts:

  • Ctrl+Shift+N - move to the next tab;
  • Ctrl+Shift+P - move to the previous tab.

Renaming tabs

In order to rename a tab:

  • switch to the tab by clicking its caption or icon (there can be only one active tab, and it is highlighted with a different color);
  • right-click within the DB Explorer area and select the Rename Current Tab... context menu item.

Removing tabs

In order to remove a tab:

  • switch to the tab by clicking its caption or icon (there can be only one active tab, and it is highlighted with a different color);
  • right-click within the DB Explorer area and select the Delete Current Tab context menu item.

See also:

Managing Favorite Objects

Windows List

Database Objects Management


Recently opened objects

Use the btnRecentObjects Recent Objects button available on the DB Explorer toolbar to access the list of recently opened database objects (during the current session).

This list is common for all registered databases. Next to the object name the database name and the host/address are displayed. Select an object from this list to open it using its editor.

DB Explorer - Recently opened objects

To change the number of objects that are considered 'recent', select the Options | Environment Options main menu item, proceed to the Tools | DB Explorer section within the Environment Options dialog, and set the Recent objects count option value (see Environment Options for details).

See also:

Database Objects Management

Environment Options


Managing favorite objects

Use the Favorite Objects node for each database to work with the selected objects of this database only. You can place any object from the database tree here.

You can also create a separate tab for your project. See Using tabs for database navigation section for details.

DB Explorer - Managing projects - New Subfolder

Creating favorite objects folders

In order to create a new folder:

  • create a folder (if necessary, you can create subfolders inside the project folder) by right-clicking the Projects node and selecting the New Sub Folder... context menu item;
  • enter the folder name within the New Folder dialog.

DB Explorer - Managing projects - Adding objects

Adding objects

In order to add a new object to the folder:

  • extent the Favorite Objects node in DB Explorer;
  • drag an object (or multiple objects) from the database tree to the project folder

or

  • right-click the project folder and select the Add Object... context menu item, or use the Ins key;
  • use the Select Object dialog to specify objects to be added to the project folder.

Removing objects from the folder

In order to remove an object from the folder:

  • right-click the object and select the Remove <object_name> from Favorite Objects context menu item, or use the Shift+Ctrl+Del shortcut;
  • confirm removing in the dialog window.

Note: This operation does not drop the object from the database, but only removes its alias from the project tree.

See also:

Using tabs for database navigation

Select Object dialog

Database Objects Management


Searching within the tree

SQL Manager for InterBase/Firebird provides an ability to search for items within the DB Explorer tree. Searching for items may be useful if you have a lot of database objects, and it may be sometimes hard to find the one you need.

There are two search facilities implemented in SQL Manager for your convenience. You can search for objects within the DB Explorer tree in either of the following ways:

Find Object dialog

To call the Find Object dialog, right-click the Database alias, any database object group nodes or objects in the DB Explorer tree and select the Find Object... context menu item, or use the Ctrl+F.

DB Explorer - Find Object

Available search options are similar to those provided by the Find Text dialog. For detailed description of the search options refer to the Find Text dialog page.

Note: You can specify whether the search will be performed within the entire tree or within the currently selected node only: toggle search mode using the [image] Search by categories button on the Search Panel, or use the corresponding option available in the Tools | DB Explorer section of the Environment Options dialog.

Search Panel

Type in the first letters in the edit-box, and the corresponding object will be highlighted in the tree, as displayed in the picture below. The [image] [image] buttons allow you to define the search direction. The [image] button toggles searching by category. Use the Start-with button (available in customizing the toolbar) to search for the objects staring with the input text.

.

DB Explorer - Search Panel

By default, the Search Panel is activated in the upper area of DB Explorer. To disable the panel, right-click within the panel and deselect the checkbox at the corresponding popup menu item.

DB Explorer - Search Panel - Activate

You can customize search options to your needs in Environment options.

Hint: The Search Panel is dockable, i.e. you can drag it to any location within the DB Explorer form.

See also:

Find Text dialog


SQL Assistant

SQL Assistant which is located at the bottom of the Database Explorer window helps you to work with your database objects. Depending on the current selection in DB Explorer, the SQL Assistant area displays additional information pertaining to the selected object.

DB Explorer - SQL Assistant

If you select a database in DB Explorer, SQL Assistant displays the list of the database object groups and the number of objects in each group.

Selecting an object group in DB Explorer displays the list of the objects in SQL Assistant. Double-clicking the object name in SQL Assistant makes the object available for editing in the appropriate editor. The context menu of the object or group of objects (selected with the Ctrl or Shift keys pressed) allows you to edit or drop the selected objects.

If you select a table or a view in DB Explorer, SQL Assistant displays the list of the table subobjects (e.g. fields and their types) by default. What is displayed in SQL Assistant when a table or a view is selected in DB Explorer depends on the Table Details / View Details selection. Click the View Mode btnViewMode toolbar button and select the Table Details | Show... (or View Details | Show...) drop-down menu item, or use the context menu of SQL Assistant. Possible values are: Show Fields, Show Primary Keys, Show Uniques, Show Foreign Keys, Show Checks, Show Indexes, Show Triggers, Show DDL, Show Description (for tables); Show Fields, Show Triggers, Show DDL, Show Description (for views).

If you select a procedure or a user-defined function in DB Explorer, SQL Assistant lists its parameters by default. Use the Procedure Details / UDF Details | Show... context menu item within the SQL Assistant area to define the content of SQL Assistant when a procedure or a user-defined function is selected in DB Explorer. Possible values are: Show Parameters, Show DDL, Show Description (for procedures); Show Arguments, Show DDL, Show Description (for UDFs).

If you select an exception in DB Explorer, SQL Assistant lists its text by default. Use the Exception Details context menu item within the SQL Assistant area to define the content of SQL Assistant when an exception is selected in DB Explorer. Possible values are: Show Text, Show DDL, Show Description.

If you select a generator in DB Explorer, SQL Assistant lists its value by default. Use the Generator Details context menu item within the SQL Assistant area to define the content of SQL Assistant when a generator is selected in DB Explorer. Possible values are: Show Value, Show DDL.

Selecting other objects in DB Explorer displays the DDL definition in SQL Assistant by default. Use the Other Objects' Details | Show... context menu item within the SQL Assistant area to define the content of SQL Assistant when an object is selected in DB Explorer. Possible values are: Show DDL, Show Description.

DB Explorer - SQL Assistant - Object details

You can also use SQL Assistant to work with your queries quickly. You can drag-and-drop object aliases to the Query Editor, Query Designer or Execute Script Editor working area, in the same way as this operation is performed in Database Explorer.

See also:

Database Objects Management


Configuring Database Explorer

Configuring DB Explorer toolbar

The toolbar of Database Explorer contains most frequently used tools for working with databases and database objects, and a tool for configuring DB Explorer. The following actions are available in the toolbar by default:

  • create a new object;
  • refresh the current tree branch;
  • connect to a database;
  • disconnect from a database;
  • view the selected object properties;
  • configure Database Explorer using the View Mode menu;
  • view the list of recently opened objects;
  • jump to any of registered databases quickly.

Click More buttons... btnMoreButtons on the right side of the toolbar and use the Add or Remove Buttons popup menu items to define the set of actions available in the toolbar. To customize the toolbar, select the Add or Remove Buttons | Customize... item from the popup menu.

DB Explorer - Configuring DB Explorer - Toolbar

Configuring the Search Panel

Click More buttons... btnMoreButtons on the right side of the Search Panel and use the Add or Remove Buttons popup menu items to define the set of the panel elements. To customize the panel, select the Add or Remove Buttons | Customize... item from the popup menu.

DB Explorer - Search Panel - Customize

Using View Mode menu

Use the View Mode btnViewMode toolbar button to configure Database Explorer according to your needs.

The drop-down menu called upon clicking this button allows you to:

  • show/hide table subobjects as child nodes of tables;
  • show/hide view subobjects as child nodes of views;
  • show/hide procedure subobjects as child nodes of procedures;
  • show/hide UDF subobjects as child nodes of UDFs;
  • show/hide host nodes for registered databases;
  • sort the list of databases by their aliases in the DB Explorer tree;
  • show/hide disconnected databases;
  • configure table/view/procedure/UDF/exception/generator/other objects' details for the SQL Assistant area;
  • show/hide error.

DB Explorer - Configuring DB Explorer - View Mode

Use the DB Explorer section of the Environment Options dialog (Options | Environment Options...) to see more options to configure Database Explorer.

See also:

Customize toolbars and menus

DB Explorer options


Managing Favorite queries

Favorite Queries is a new feature of SQL Manager. Now you are provided with an opportunity to save the most frequently used SQL queries as Favorite Queries.

Use the Favorite Queries node of DB Explorer to access the list of your Favorite queries quickly. Queries stored in the database and those stored in Windows registry can be easily distinguished by their icons.

Using the context menu you can create a new Favorite query or edit an existing one using Favorites editor, open any of the existing queries in Query Editor or remove a query if you don't need it any longer.

DB Explorer - Managing Favorite queries

You can also create a separate tab for your Favorite queries. See Using tabs for database navigation section for details.

See also:

Using tabs for database navigation

Favorites editor


Database Management

SQL Manager for InterBase/Firebird provides a number of tools you may need to manage your InterBase/Firebird databases.

Find the list of common database management operations for working in SQL Manager below.

Registering Hosts

  • select the Database | Register Host... main menu item or use the corresponding btnRegisterHost Register Host toolbar button

or

  • right-click any host alias and select the Register Host... context menu item in the DB Explorer tree;
  • set all the necessary options using Register Host wizard which guides you through the entire process of host registration.

Unregistering Hosts

  • select the host to unregister in the DB Explorer tree;
  • select the Database | Unregister Host main menu item or use the corresponding btnUnregisterHost Unregister Host toolbar button

or

  • right-click the host alias and select the Unregister Host context menu item in the DB Explorer tree;
  • confirm unregistering in the corresponding dialog window.

Creating Databases

  • select the Database | Create Database main menu item or use the corresponding btnCreateDB Create Database toolbar button;
  • set all the necessary options using Create Database wizard which guides you through the entire process of creating a new database.

Dropping Databases

  • select the database to drop in the DB Explorer tree;
  • select the Database | Drop Database main menu item;
  • confirm dropping in the corresponding dialog window.

Registering Databases

  • select the Database | Register Database... main menu item or use the corresponding btnRegisterDB Register Database toolbar button

or

  • right-click any database alias and select the Register Database... context menu item in the DB Explorer tree;
  • set all the necessary options using Register Database wizard which guides you through the entire process of database registration.

Unregistering Databases

  • select the database to unregister in the DB Explorer tree;
  • select the Database | Unregister Database main menu item or use the corresponding btnUnregisterDB Unregister Database toolbar button

or

  • right-click the database alias and select the Unregister Database context menu item in the DB Explorer tree;
  • confirm unregistering in the corresponding dialog window.

Connecting to Hosts

  • select the host to connect to in the DB Explorer tree;
  • select the Database | Connect to Host main menu item or use the corresponding btnConnectToDB Connect to Host toolbar button

or

  • right-click the host and select the Connect to Host context menu item in the DB Explorer tree.

Disconnecting from Hosts

  • select the host to disconnect from in the DB Explorer tree;
  • select the Database | Disconnect from Host main menu item or use the corresponding btnDisconnectFromDB Disconnect from Host toolbar button

or

  • right-click the host and select the Disconnect from Host context menu item in the DB Explorer tree.

Connecting to Databases

  • select the database to connect to in the DB Explorer tree;
  • select the Database | Connect to Database main menu item or use the corresponding btnConnectToDB Connect to Database toolbar button

or

  • right-click the database alias and select the Connect to Database context menu item in the DB Explorer tree.

Disconnecting from Databases

  • select the database to disconnect from in the DB Explorer tree;
  • select the Database | Disconnect from Database main menu item or use the corresponding btnDisconnectFromDB Disconnect from Database toolbar button

or

  • right-click the database alias and select the Disconnect from Database context menu item in the DB Explorer tree.

Viewing and Editing Database Registration Info

  • select the database or any of its objects in the DB Explorer tree;
  • select the Database | Database Registration Info... main menu item

or

  • right-click the database alias or any of its objects and select the Database Registration Info... context menu item in the DB Explorer tree.

Viewing and Editing Database Properties

  • select the database in the DB Explorer tree;
  • right-click the database and select the Database Properties... context menu item or use the corresponding btnDBProperties Properties toolbar button

Viewing and Editing Host Registration Info

  • select the host in the DB Explorer tree;
  • select the Database | Host Registration Info... main menu item

or

  • right-click the host alias and select the Host Registration Info... context menu item in the DB Explorer tree.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | Yes
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Getting Started

Database Explorer

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Security management

Options

External Tools

How To...


Register Host wizard

Register Host wizard allows you to register a host in SQL Manager for InterBase/Firebird.

To start the wizard, select the Database | Register Host... main menu item, or use the btnRegisterHost Register Host button on the main toolbar. You can also use the Shift+Ctrl+R shortcut for the same purpose.

  • Setting connection parameters
  • SSH tunneling parameters
  • Setting specific options

See also:

Register Database wizard

Host Registration Info


Setting connection parameters

Use this step of the wizard to set the necessary connection parameters for the new host using the controls available in the Server and Client areas.

Register Host wizard - Setting connection parameters

Server

In this section you need to define connection parameters.

Host name

Type in, or use the drop-down list to specify the host name of the InterBase/Firebird server.

Protocol

Use the drop-down list to select the communication protocol to be used for the connection. Possible values are: Local, TCP/IP, Novell SPX, NetBEUI, Embedded.

Port/service

Use this field to specify a port or service to connect through. By default it is "gds_db" for InterBase and port 3050 for Firebird.

Afterwards you must specify valid authorization info to access the target InterBase/Firebird server: User name and Password.

The default superuser name is 'SYSDBA' with password 'masterkey'.

You can also define the user role in SQL role field.

Pressing the Get Server Preferences button allows the program to do the following actions automatically:

  • get server version (when done the version will be displayed in the title of the section);
  • define security database if possible (a few servers do not allow such an operation);
  • detect client library according to the server version (also shows the version in the corresponding section title) from the following folders (from all successful results the program chooses the one that best corresponds to the server version):

Tick the folder specified in the Client Library field;

Tick the server home folder and subfolders (server must be local and home folder must be specified);

Tick the root folder of SQL Manager;

Tick the folders associated with the Path environment variable;

Tick \Windows and \Windows\System32;

  • set authentication type.

Note: This operation may take a few time if you are getting server preferences for the first time.

Security DB

Authorized InterBase/Firebird users are stored in a security database. Each InterBase/Firebird server has its own security database, which means that a user definition is bound to the server where it is stored. The security database also stores an encrypted password for each user.

Type in or use the ExplorerButton button to specify the path to the security database. The drop-down list contains the previously specified security databases.

Client

In this section you can specify the client settings.

Client library

Client library provides the conduit between the API or object library an application uses to communicate with the DB server and the networking protocols used to exchange data with the network.

Type in or use the ExplorerButton button to specify the path to the client library. For successful connection to the server it is crucial to use the appropriate client library - the one that is compatible with the server you are using: gds32.dll for InterBase and fbclient.dll for Firebird. Please note that the client library file must be located on your local machine (e.g. in the directory where the application is installed). The drop-down list contains the previously specified client libraries.

Hint: Automatic search for the library is performed upon pressing the Get Server Preferences button.

Authentication type

This group is only available in case you connect to Firebird 2.1 or higher. Specify the preferable type of server authentication to be used for the connection:

RadioButton Normal (traditional IB/FB authentication with security database)

The user must identify him/herself with a Firebird username and password, which the server checks against the security database. The Firebird security database is named security2.fdb. For user authentication it has a table named RDB$USERS that stores the new hashed passwords.

RadioButton Win32 NTLM authentication (only FB 2.1 or above)

NTLM credentials are based on data obtained during the interactive Windows logon process. The user is automatically identified by his OS account name. In this case login name will consist of the server name that performed authentication and user name.

RadioButton Mixed

The user either supplies a Firebird username and password, or is logged in with his OS account name.

Note: In Firebird 2.1, if Authentication type is Win32 NTLM or Mixed, Windows administrators automatically receive SYSDBA privileges in all databases, including the security database.

CheckBox Use Secure Shell (SSH) tunneling

Select this option to establish connection to an intermediate SSH server and forward all InterBase/Firebird commands through the secure tunnel.

If this option is checked, you should set tunneling parameters at the SSH tunneling parameters step of the wizard.

CheckBox Use SSL

Enable this option to connect via an encrypted channel.

If this option is checked, you should set tunneling parameters at the SSL parameters step of the wizard.

If Embedded is selected in the Protocol drop-down list, you need to specify embedded server connection properties.

Register Host wizard - Setting connection parameters - Embedded

Host name

Type in, or use the drop-down list to specify the host name of the embedded server.

Client library

Type in or use the ExplorerButton button to specify the path to the client library for the embedded server. The drop-down list contains the previously specified client libraries.

Firebird Embedded Server is intended to work with embedded databases. It consists of one *.dll file - fbembed.dll. This is a special client library that includes the server itself. When an application links to this library it loads the server and allows direct access to any database that is accessible on the local computer. This version of the server does not use a security database. The user name specified during the "logon" (no password authentication occurs) is used to manage user access to database objects (via SQL permissions) but if that user name is SYSDBA (or the owner of the database) then unrestricted access is possible.

Embedded server root

In Firebird 2.1 (and lower) the embedded server root is a directory where the executable file fbguard.exe is stored.

In Firebird 2.5 it is a directory that contains fbembed.dll file.

An embedded server locks a database file for its own exclusive use after successful connection. This means that you cannot access the same database from multiple embedded server processes simultaneously (or from any other servers, once an embedded server has locked the file).

CheckBox Publish root into Path environment variable and server configuration file

Select this option to add the path specified in the Embedded server root field to the 'Path' environment variable and server configuration file.

If you want to use the local utilities (eg, gbak.exe) then you need to rename the library fbembed.dll to fbclient.dll, and place utilities into the folder where embedded server libraries are located.

Click the Next button to proceed to Setting specific options for the host being registered, to the SSH tunneling parameters step of the wizard (if the Use Secure Shell (SSH) tunneling option is enabled for the host), or to the SSL parameters step of the wizard (if the Use SSL option is enabled).


SSH tunneling parameters

Use this step to set SSH tunneling parameters.

Note: This step is only available if the CheckBox Use Secure Shell (SSH) tunneling option was selected at the previous step.

Register Host wizard - SSH tunneling parameters

Specify SSH Host name, SSH port, SSH user name, SSH password, the path to the SSH key file (if necessary) in the corresponding boxes.

See SSH connection properties for details.

Click the Next button to proceed to the Setting specific options step of the wizard.


SSL parameters

SSL preferences allows you to connect to the server via encrypted channel for increased security.

Register Host wizard - SSL

Client certificate

Set the full path to the SSL certificate on the client machine.

Passphrase file

Set the full path to the file containing the key passphrase.

Passphrase

Input passphrase password.

CA file

Specify the name of the certificate authority file.

CA path

Set the path for the location of the certificate authority file.

Click the Next button to proceed to the Setting specific options step of the wizard.


Setting specific options

This step of the wizard allows you to set some specific options for the host being registered.

Register Host wizard - Setting specific options

Path to database utilities

Type in or use the ExplorerButton button to specify the path to InterBase/Firebird database utilities.

Host alias

Set the alias for the current host to be displayed in the DB Explorer.

CheckBox Login prompt before connection

Enables SQL Manager for InterBase/Firebird to prompt for user name and password each time you connect to the host.

CheckBox Autoconnect at startup

With this option set, connection to the registered host is established automatically at application startup.

CheckBox Connect to the host automatically when connecting to any its database

With this option set, the application connects to the host automatically when connection to any of its databases is established.

CheckBox Don't show client library warnings

Turn this option on to skip the message of client library version incompatibility.

CheckBox Create new tab for this host

If this option is checked, the host will be displayed within a separate tab in DB Explorer.

Click the Finish button when done to start working with the newly registered host in SQL Manager for InterBase/Firebird.


Create Database wizard

Create Database wizard allows you to create a new database on your InterBase/Firebird host.

To start the wizard, select the Database | Create Database... main menu item, or use the btnCreateDB Create Database button on the main toolbar.

  • Selecting host
  • Specifying database parameters
  • Defining database files
  • Viewing result SQL statement

See also:

Register Database wizard

Database Registration Info

Database Properties


Selecting host

Use this step of the wizard to select the host for the database to be created.

Switch to Database will be created on a new host if you need to register a new host and create a database. The database will be registered on this host.

Create Database wizard - Selecting host

Host name

Use the drop-down list of registered hosts to select the one where the new database will reside.

Click the Next button to proceed to the Setting connection properties step of the wizard.

See also:

Register Host wizard


Setting connection parameters

If at the first step you indicated that the server is not registered, then at the second step you will need to specify the connection parameters to the server.

Use this step of the wizard to set the necessary connection parameters for the database in the corresponding boxes.

Create Database wizard - New host - Setting connection parameters

Set the server connection parameters and client configuration in the corresponding boxes: host name, protocol, port/service, user name, password, etc.

For more details refer to the Setting connection parameters step of Register Host wizard.

When you are done, click the Next button to proceed to the Specifying database parameters step of the wizard.


Specifying database parameters

Use this step of the wizard to set the necessary connection parameters for the database being created.

Create Database wizard - Specifying database parameters

Database file

Fully qualified database file path

This field requires new database file specification, including full name of the database file. Type in or use the btnSaveAs button to specify the path to the database file. The drop-down list contains the previously specified paths.

Database login

User name

Specify a user name (checked against valid user name and password combinations in the security database on the server where the database will reside).

Password

Specify the password (checked against valid user name and password combinations in the security database on the server where the database will reside).

Other parameters

Page size

Size (in bytes) for database pages. Possible values are 1024, 2048, 4096 (default), or 8192.

SQL dialect

Declares the SQL Dialect for database access.

SQL dialect | Used for
1 | InterBase 5.5 and earlier compatibility
3 | InterBase 6.0; allows you to use delimited identifiers, exact numerics, and DATE, TIME, and TIMESTAMP datatypes

Charset

Use the drop-down list to select the default character set for the database, i.e. the character set used by the server for string (CHAR, VARCHAR, text Blob) columns in the database when no other character set information is provided.

Collation

Select the appropriate sorting option in this list.

Difference file

Optional clause specifying the path and name for the file delta that stores any mutations to the database file after it has been switched to the “copy-safe” mode.

CheckBox Single database file

If you want to store your new database in several files, uncheck this option. By default this option is checked, it means that the database is stored in one file only.

Click the Next button to proceed to the Defining database files step of the wizard, or to the Viewing result SQL statement step, depending on the Single database file option selection.


Defining database files

Specify the parameters of the database single and secondary files.

Note: This step is skipped if you checked the CheckBox Single Database File option on the previous step.

Create Database wizard - Defining database files

Primary database file

CheckBox File length

Enable this option to set the length of the primary database file (the file defined at the previous step). This number indicates when the new database file will be started.

Secondary database files

This group allows you to define one or more secondary database files.

Click the Add button to add a new file, input its name in the File name field, set its length (secondary file length indicates where the next file will be started), or the starting at value (if you haven't set the previous file length) and click the Add button. The file is added to the file list.

Click the Next button to proceed to Viewing result SQL statement.


Viewing result SQL statement

View the result CREATE DATABASE statement issued for the new database creation. For more information see Compile window.

Create Database wizard - Viewing result SQL statement

If the CheckBox Register the database after creating option is checked, the Database Registration Info dialog will appear.


Register Database wizard

Register Database Wizard allows you to register a single database.

To start the wizard, select the Database | btnRegisterDB Register Database... main menu item, or use the btnRegisterDB Register Database button on the main toolbar. You can also use the Shift+Alt+R shortcut for the same purpose.

  • Selecting host

Database is located on a registered host:

  • Setting connection parameters

Database is located on a new host:

  • Setting connection parameters
  • Setting specific options

See also:

Create Database wizard

Database Registration Info

Database Properties


Selecting host

At this step you need to select the host on which the database is located: choose whether the database to be registered is located on a host already registered in SQL Manager, or whether a new host should be registered for the database in the application.

Register Database wizard - Selecting host

RadioButton Database is located on the host already registered in SQL Manager

This option indicates that the database being registered resides on a registered host. Use the Host name drop-down list to select the required host.

RadioButton Database is located on new host

This option indicates that the database being registered resides on a non-registered host.

Click the Next button to proceed to setting connection parameters for database on a registered host, or to setting connection parameters for database on a new host, depending on your selection at this step.


Setting connection parameters

Use this step of the wizard to set the necessary connection parameters for the database in the corresponding boxes.

Register Database wizard - Registered host - Setting connection parameters

User name

Checks the user name against valid user name and password combinations in the security database on the server where the database resides.

Password

Checks the password against valid user name and password combinations in the security database on the server where the database resides.

Role

Specify the SQL role that you adopt on connection to the database. You must have previously been granted membership in the role to gain the privileges of that role.

For more details see the Setting connection parameters step of Register Host wizard.

When you are done, click the Next button to proceed to the Setting specific options step of the wizard.


Setting connection parameters

Use this step of the wizard to set the necessary connection parameters for the database in the corresponding boxes.

Register Database wizard - New host - Setting connection parameters

Set the server connection parameters and client configuration in the corresponding boxes: host name, protocol, port/service, user name, password, etc.

For more details refer to the Setting connection parameters step of Register Host wizard.

When you are done, click the Next button to proceed to the Setting specific options step of the wizard.


Setting specific options

This step of the wizard allows you to set the database name, database alias, character set, and registration options (using the General and Logs tabs).

Register Database wizard - Setting specific options - General

Database name

Type in or use the ExplorerButton Browse button to specify the path to the database file (*.gdb, *.ib for InterBase or *.fdb for Firebird). The drop-down list contains the previously specified paths.

Database alias

Enter the alias to be used to display the database in DB Explorer and SQL Manager tools. By default, a database alias generated by the application has the following format: <database_name> on <host_name_or_address>[:<port>]

Charset

Specify an active character set to use for subsequent database attachments. The Get default button applies the default character set which was specified on creation of the database.

Click Test Connection to check availability of the database at the moment. If connection is successful, you will get the 'Connected!' message; otherwise an error message will be returned.

The General tab allows you to set common database registration options:

Font charset

Specify the character set to be used to display data in the grid.

CheckBox Refresh objects on connection

This option allows you to enable/disable refreshing objects on connection to the database. It is highly recommended to uncheck this option if your database contains many objects or if connection to the database is slow.

CheckBox Autoconnect at startup

With this option set, connection to the registered database is established automatically at application startup.

CheckBox Login prompt before connection

Enables SQL Manager for InterBase/Firebird to prompt for user name and password each time you connect to the database.

CheckBox Edit aliases file (only Firebird)

This option allows editing local Firebird server aliases file.

Register Database wizard - Setting specific options - Logs

The Logs tab allows you to set log options for the database:

CheckBox Enable log of metadata changes

Check this option if you wish to log metadata changes of your database in a file.

Log file

This field is enabled if the Enable log of metadata changes option is selected. Type in or use the Save as btnSaveAs button to specify the path to the *.sql file to store the metadata logs.

CheckBox Enable log of Query Data queries

Check this option if you wish to log your Query Editor queries in a file.

Log file

This field is enabled if the Enable log of Query Data queries option is selected. Type in or use the Save as btnSaveAs button to specify the path to the *.sql file to store the logs of SQL queries.

CheckBox Is Unicode

Enable this option to save logs in Unicode. If the option is disabled, ANSI will be used.

The Copy Alias from... menu allows you to select the alias of a previously registered database and use it for the newly configured database.

Click the Finish button when done to start working with the newly registered database in SQL Manager for InterBase/Firebird.


Database Registration Info

Use the Database Registration Info dialog to view and edit the registration properties of the database.

To open the dialog, select the database or any of its objects in the DB Explorer tree, then select the Database | btnDBRegistrationInfo Database Registration Info... main menu item, or right-click the database alias in DB Explorer and use the btnDBRegistrationInfo Database Registration Info... context menu item. You can also use the btnDBRegistrationInfo Database Registration Info... button on the main toolbar.

  • Editing connection properties
  • Setting common database options
  • Setting display options
  • Setting options for system objects
  • Setting grid and data options
  • Defining transactions
  • Defining events
  • Setting default directories
  • Setting log options
  • Find Option

See also:

Register Database wizard

Create Database wizard

Database Properties


Connection

The Connection section of the Database Registration Info dialog allows you to view and/or edit the connection properties in the corresponding boxes: User name, Password, Role, Database name, Database alias, Charset, Font charset.

Database Registration Info - Editing connection properties

User name

If necessary, edit the user name used to access the database.

Password

If necessary, edit the password used to authenticate the user.

Role

Specify the SQL role that you adopt on connection to the database. You must have previously been granted membership in the role to gain the privileges of that role.

Database name

Type in or use the ExplorerButton Browse button to specify the path to the database file (*.gdb, *.ib for InterBase or *.fdb for Firebird). The drop-down list contains the previously specified paths.

Database alias

Enter the alias to be used to display the database in DB Explorer and SQL Manager tools. By default, a database alias generated by the application has the following format: <database_name> on <host_name_or_address>[:<port>]

Charset

Specify an active character set to use for subsequent database attachments. The Get default button applies the default character set which was specified on creation of the database.

Encryption password

Allows to connect to the InterBase server databases using System Encryption Password.

Once you have specified the connection properties, you can check whether it is possible to establish connection to the database: click the Test Connect button for this purpose. If connection is successful, you will get the 'Connected!' message; otherwise an error message will be returned.

The Load Connection Info menu allows you to select the alias of a previously registered database and use it for the newly created/configured database.


Options

The Options section of the Database Registration Info dialog allows you to set various options for the database.

Database Registration Info - Setting common database options

Customize common database options according to your needs. The detailed description is given below.

CheckBox Login prompt before connection

Enables SQL Manager for InterBase/Firebird to prompt for user name and password each time you connect to the database.

CheckBox Autoconnect at startup

Check this option to specify that SQL Manager for InterBase/Firebird automatically establishes connection to the registered database at application startup.

CheckBox Disconnect automatically when disconnecting from host

When this option is enabled, the application disconnects from the database automatically upon disconnection from the host.

CheckBox Always Capitalize database object names

If this option checked, SQL Manager for InterBase/Firebird automatically capitalizes all database object names. Recommended for working with InterBase 5.x.

CheckBox Quote identifiers if they are reserved words

If this option is checked, then the quotation marks are added automatically to all the identifiers, spelled as InterBase reserved words.

CheckBox Refresh objects on connection

This option allows you to enable/disable refreshing objects on connection to the database. It is highly recommended to uncheck this option if your database contains many objects or if connection to the database is slow.


Display options

The Display Options section of the Database Registration Info dialog allows you to specify which objects will be displayed in the Database Explorer tree.

CheckBox Use custom color for DB editors

With this option checked the text color for editor tabs is black. To apply user font color uncheck the option and select the color.

Database Registration Info - Setting display options

For your convenience the Select All and Deselect All functions are implemented in the context menu of the objects list area.

CheckBox Detect erroneous objects

If this option is selected, invalid objects are detected in the process of database navigation and marked out with a red cross in DB Explorer.

See also:

Database Objects Management

Database Explorer


System objects

The System objects section of the Database Registration Info dialog allows you to specify which system objects will be displayed in the Database Explorer tree.

Database Registration Info - System objects

System objects to display in DB Explorer

CheckBox Show system tables

This option specifies whether system tables are displayed in DB Explorer or not.

CheckBox Show system created indexes

This option specifies whether system indexes are displayed in DB Explorer or not.

CheckBox Show system created constraints

This option specifies whether system constraints are displayed in DB Explorer or not.

CheckBox Show system created domains

This option specifies whether system domains (i.e. the domains having names starting with 'RDB$') are displayed in DB Explorer or not.

CheckBox Show system created triggers

This option specifies whether system triggers (created automatically by the server for implementation of the 'CHECK VALUE...' restrictions) are displayed in DB Explorer or not.

CheckBox Show system created generators

This option specifies whether system generators (i.e. the generators having names starting with 'RDB$') are displayed in DB Explorer or not.

For your convenience the Select All and Deselect All functions are implemented in the context menu of the option group.

CheckBox Allow editing system objects

When this option is enabled, you can edit triggers for system tables and views.

CheckBox Show system tables in performance analysis

Enable the option to include system tables in performance analysis.

See also:

Database Objects Management

Database Explorer


Grid

The Grid section of the Database Registration Info dialog allows you to adjust the default grid mode settings.

Database Registration Info - Grid

CheckBox Enable boolean fields support

If this option is checked, boolean fields are supported in data grid.

CheckBox Set required fields in grids

If this option is checked, you have to set values for all the NOT NULL table fields.

CheckBox Set calculated fields as read-only

If this option is checked, calculated field values cannot be edited.

CheckBox Get default values for fields

If this option is checked, SQL Manager will automatically get the default field values from the database server.

CheckBox Get record count beforehand

If this option is checked, SQL Manager automatically calculates the number of records in table or query. Corresponding information is displayed in the status bar.

CheckBox Trim Char Fields in Grids

If this option is checked, the final spaces in fields of the CHAR type are trimmed during the editing process.

CheckBox Auto Commit Transactions

If this option is checked, SQL Manager automatically commits transactions, otherwise you have to do it manually.

CheckBox Protected edit (block record while editing)

If this option is checked, SQL Manager blocks the record you are editing, so that other users cannot edit this record. This helps to avoid conflicts of collective access to the database.

See also:

Data View


Data options

The Data Options section of the Database Registration Info dialog allows you to define options for data view. These options will be applied only to this database. Default settings for newly registered databases can be defined on the Grid | Data Options page of the Environment Options dialog.

Database Registration Info - Grid - Data options

Advanced

CheckBox Use separate connections for each data view within a database

Select this option to use a separate connection for each data view within a database. Disabling this option is recommended if maximum allowed number of connections is too low.

CheckBox Asynchronous query execution

Check this option to allow executing queries in background mode (asynchronously). Note that this option is only available when the Use separate connections for each data view within a database option is enabled.

CheckBox Perform data sorting on client in data view

If enabled, the data are sorted by SQL Manager for InterBase/Firebird (on the client side). If this option is disabled, the data are sorted on InterBase/Firebird server with the help of the ORDER BY clause used in SQL query.

CheckBox Perform data filtration on client in data view

If enabled, the data are filtered by SQL Manager for InterBase/Firebird (on the client side).

If disabled, SQL filter is used in data view. In this case filtering is performed on the InterBase/Firebird server with the help of the WHERE clause used in SQL query.

With the Perform data sorting on client in data view option enabled, sorting is performed by means of the grid. Otherwise a click on the column header for sorting causes reloading all table data with the selected field in the ORDER BY expression of the SELECT statement.

If the table contains a huge amount of records and the Select only N records mode (see the Default limit options in table and view editors group) is used, this mode is more preferable (e.g. all the records having values starting with "A" will be displayed, and not those which were in originally opened N records).

All above-mentioned is related to the Perform data filtration on client in data view option as well. If the filter is applied to a table containing a great number of records, it is strongly recommended to enable this option - in this case the filter will be applied to all table/view records, not only to those which are displayed at the present moment.

CheckBox Sort by primary key

When enabled, the option allows sorting data by the primary key on opening the data grid.

String fields width (chars)

Using this option you can limit string fields width that may improve performance on large datasets.

Default Grid Mode

RadioButton Load visible rows

The grid loads only a fixed number of dataset records into memory. This option minimizes dataset loading time. The automatic sorting, filtering, summary calculations are not supported in this mode.

RadioButton Load all rows

The grid loads all records from a dataset. This option increases the grid performance by reloading only changed dataset records when updating. In this mode all features (automatic sorting, filtering and summary calculations) are available.

Default Grid Mode defines grid mode which will be used by default.

With the Load all rows option enabled, when loading data, all the records are loaded into grid buffers. In this mode opening the tables with many records may take a very long time. But in this case you have some advantages: e.g. in the filter drop-down list the column headers are displayed with the values for quick filter; it is possible to open several sublevels at the same time when viewing data in master-detail view, etc.

Because opening and other operations with an object consisting of many records takes sufficient time the Load visible rows mode should be used instead. It can be set individually for each table and is saved between sessions (can be set through the context menu of the grid).

Load visible rows mode if records more than...

Set this option to switch to the Load visible rows mode when the number of records in the dataset exceeds the specified value.


Transactions

The Transactions section of the Database Registration Info dialog allows you to set the isolation level for data and metadata. Isolation level determines how a transaction interacts with other simultaneous transactions accessing the same tables.

Database Registration Info - Defining Transactions

Data Transactions Properties | Metadata Transactions Properties

RadioButton Snapshot

Provides a repeatable-read view of the database at the moment the transaction starts. Changes made by other simultaneous transactions are not visible. Snapshot table stability provides a repeatable read of the database by ensuring that transactions cannot write to tables, though they may still be able to read from them.

RadioButton Read committed

Enables transactions to see the most recently committed changes made by other simultaneous transactions. It can also update rows as long as no update conflict occurs. Uncommitted changes made by other transactions remain invisible until committed.

RadioButton Read-only table stability

Defines the 'read-only' access mode when the transactions are only allowed selecting data from the table.

RadioButton Read-write table stability

Defines the read-write access mode when the transactions are allowed to select, insert, update and delete data from the table.

Note: SQL Manager automatically deletes wrong parameters, if any.


Events

The Events section of the Database Registration Info dialog allows you to specify what alerters should be taken into account (which event messages should be displayed in Event Monitor).

Database Registration Info - Defining Events

Add the strings of event messages (the ones set in event alerters) using the Add and Remove buttons. Check CheckBox Registered to register the event in Event Monitor.

Example:

You need to get notification when some event takes place. For this purpose you can use the instruction like POST_EVENT 'event_name' inside a procedure or trigger body:

BEGIN

/* Statements... */

POST_EVENT 'NULL_field_met';

/* Statements... */

END

When the statements are executed the notifications will appear in the Events Monitor window.

See also:

Event Monitor


Directories

The Directories section of the Database Registration Info dialog allows you to set the directories to be used by default for database extract, data export, data import, saving HTML reports, creating reports, saving scripts, backup operations.

Database Registration Info - Setting default directories


Logs

The Logs section of the Database Registration Info dialog allows you to specify log file names for metadata changes logging and SQL query logging, if necessary.

Logging can be useful when you are going to move the changes made in the development database to the production database.

Database Registration Info - Setting log options

Metadata changes

CheckBox Enable log of metadata changes

Check this option if you wish to log metadata changes of your database in a file.

Metadata log file

This field is enabled if the Enable log of metadata changes option is selected. Type in or use the Save as btnSaveAs button to specify the path to the *.sql file to store the metadata logs.

Query data

CheckBox Enable log of Query Data queries

Check this option if you wish to log your queries in a file.

Query Data log file

This field is enabled if the Enable log of Query Data queries option is selected. Type in or use the Save as btnSaveAs button to specify the path to the *.sql file to store the logs of SQL queries: date/time of query execution, SQL text, execution result or errors (if any).

CheckBox In Unicode

Enable this option to save logs in Unicode. If the option is disabled, ANSI will be used.

QuickSave options

Options of this group allow you to set up the Quick save / Quick load feature - automatic saving the DDL and location of database objects using the quick-saving cache.

CheckBox Enable QuickSave every ... Minute(s)

Check this option to enable quick saving recurrently after the specified time interval (in minutes).

Default directory for QuickSave

Type in or use the ExplorerButton button to specify the directory for the quick-saving cache.


Find Option

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

The Find Option section allows you to search for options available within the Database Registration Info dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within the database registration options.

Database Registration Info - Find Option

The Available options area lists all options of the Database Registration category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


Database Properties

The Database Properties dialog allows you to view/edit a number of properties which can be changed to optimize database performance.

To open the dialog, right-click the database alias in DB Explorer and select the Database Properties... context menu item, or use the btnDBProperties Properties button on the DB Explorer toolbar.

A number of database properties that determine the characteristics can be set for each database. These options are unique to each database and do not affect other databases.

  • Info
  • General
  • Active users
  • Description
  • Secondary Files
  • Find Option

See also:

Register Database wizard

Create Database wizard

Database Registration Info


Info

The Info section of the Database Properties displays the summary about database properties. The dialog allows you to view info about database file, charset, memory characteristics and performance statistics.

Database Properties - Info

Database Characteristics

Version

Database version info.

ODS version

On-disk structure version used by the database.

Implementation

Version of the implementation.

File name

Full database file name.

Site name

Database host name.

Default charset

Default charset for the database. It can be changed at General tab.

Default collation

Default collation for the database.

Page size

Database page size (in bytes).

Allocated pages

Number of pages in the database.

Database size

Size of the database (in Mb).

Environment Characteristics

Current memory

The amount of memory in use, in bytes.

Max memory

The maximum number of bytes used by the database.

Performance Statistics

Marks

Count of database pages marked

Fetches

Count of database pages fetched

Reads

Count of database pages read

Writes

Count of database pages written

See also:

General

Active users

Description

Secondary Files

Find Option


General

The General section of the Database Properties dialog allows you to view/edit the general database properties. The list of available options depends on the server type and version.

Database Properties - General

SQL dialect

SQL dialect used. Possible values are: 1, 3.

Sweep interval

Number of transactions after executing which automatic garbage collection is carried out.

Reclaim interval

The interval in seconds. It determines how often the garbage collector thread will run to release memory from unused procedures, triggers, and internal system queries back to InterBase memory heap.

Default charset

Default charset used for the database.

Linger interval

Interval in seconds, which allows the server to keep the database open for a period after the last attachment is closed.

Difference file

File path and name for DIFFERENCE files (.delta files).

Buffers

Pages

Number of database pages per database.

Size

Page size (in kilobytes).

Cache

CheckBox Forces writes

Enables/disables the mode of forced writing data on disk.

CheckBox Group commit

Enables/disables transactions to be committed by a background cache writer thread.

CheckBox Linger interval

Enables/disables interval in seconds, which allows the server to remain active after all users have disconnected.

CheckBox Flush interval

Enables/disables database flush.

Embedded User Authentication

CheckBox Use Embedded User Authentication

Specifies whether Embedded User Authentication is used for the database or not.

CheckBox Enabled

Enables/disables Embedded User Authentication.

CheckBox Reserve page spaces

Enables space reservation.

CheckBox Read only

Enables/disables read-only mode for the database.

See also:

Info

Active users

Description

Secondary Files

Find Option


Active users

The Active Users section of the Database Properties dialog displays the list of currently active database users.

Database Properties - Active users

See also:

Info

General

Description

Secondary Files

Find Option


Description

The Description section of the Database Properties dialog allows you to view/edit optional text to be used as description of the database.

Database Properties - Description

See also:

Info

General

Active users

Secondary Files

Find Option


Secondary Files

The Secondary Files section allows you to view database secondary file(s).

Database Properties - Secondary Files

Length value specifies the maximum size of the secondary database file, in pages.

Starting at value specifies the database page number at which the next secondary database file should start.

Preallocate value specifies additional database space for the new file.

See also:

Info

General

Active users

Description

Find Option


Find Option

The Find Option section allows you to search for options available within the Database Properties dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within the database properties.

Database Properties - Find Option

The Available options area lists all options of the Database Properties category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.

See also:

Info

General

Active users

Description

Secondary Files


Host Registration Info

Use the Host Registration Info dialog to view and edit the registration properties of the host.

To open the dialog, select the Database | btnHost Host Registration Info... main menu item, or right-click the host in the DB Explorer tree, and select the Host Registration Info... context menu item.

  • Connection properties
  • Host options
  • SSH tunneling
  • SSL parameters
  • Find Option

See also:

Register Host wizard


Connection

The Connection section of the Host Registration Info dialog allows you to view and edit connection parameters for the host.

Host Registration Info - Connection

Set the server connection parameters and client configuration in the corresponding boxes: host name, protocol, port/service, user name, password, etc.

For more details refer to the Setting connection parameters step of Register Host wizard.

In case an embedded server (a server with Embedded User Authentication) is used, some connection options are disabled, and the Connection section of the Host Registration Info dialog looks slightly different.

For more details see setting embedded server connection parameters.

Host Registration Info - Connection - Embedded

Note: Backup and Restore of a database located on the Embedded host is only possible via local tools. You need icudt30.dll, icuin30.dll, icuuc30.dll and fbembed.dll (fbembed.dll must be renamed to fbclient.dll) to be located along with gbak.exe file at the folder specified at the Path to database utilities field.

Set the alias in the for the current host in the Host alias field to be displayed in the DB Explorer.

Once you have specified the connection properties, you can check whether it is possible to establish connection to the host: click the Test Connection button for this purpose. If connection is successful, you will get the 'Connected!' message; otherwise an error message will be returned.

See also:

Common host options

SSH tunneling

Find Option


Common host options

The Options section of the Host Registration Info dialog allows you to set various options for the host.

Host Registration Info - Common host options

Customize common host options according to your needs. The detailed description is given below.

CheckBox Login prompt before connection

Enables SQL Manager for InterBase/Firebird to prompt for user name and password each time you connect to the host.

CheckBox Autoconnect at startup

With this option set, connection to the registered host is established automatically at application startup.

CheckBox Connect to the host automatically when connecting to any its database

With this option set, the application connects to the host automatically when connection to any of its databases is established.

CheckBox Don't show client library warnings

Turn this option on to skip the message of client library version incompatibility.

See also:

Connection

SSH tunneling

Find Option


SSH tunneling

The SSH Tunneling section of the Host Registration Info dialog allows you to enable/disable SSH tunneling for connection to the host and its databases, and set all the necessary SSH tunneling parameters. Note that SSH tunneling is only available when the TCP/IP protocol is used.

CheckBox Connect through the Secure Shell (SSH) tunnel

Select this option to establish connection to an intermediate SSH server and forward all InterBase/Firebird commands through the secure tunnel.

Specify SSH Host name, SSH port, SSH user name, SSH password, the path to the SSH key file (if necessary) in the corresponding boxes.

See SSH connection properties for details.

Note: InterBase/Firebird host name on the Connection page should be set relatively to the SSH server in this case. For example, if both InterBase/Firebird and SSH servers are located on the same computer, you should specify localhost as Host name instead of the server's external host name or IP address.

Host Registration Info - SSH Tunneling

See also:

Connection

Common host options

Find Option


SSL parameters

SSL preferences allows you to connect to the server via encrypted channel for increased security.

Host Registration Info - SSL

Client certificate

Set the full path to the SSL certificate on the client machine.

Passphrase file

Set the full path to the file containing the key passphrase.

Passphrase

Input passphrase password.

CA file

Specify the name of the certificate authority file.

CA path

Set the path for the location of the certificate authority file.


Find Option

The Find Option section allows you to search for options available within the Host Registration Info dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within the host registration options.

Host Registration Info - Find Option

The Available options area lists all options of the Host Registration category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.

See also:

Connection

Common host options

SSH tunneling


Database Objects

SQL Manager for InterBase/Firebird provides powerful tools to manage database objects.

To obtain detailed information concerning InterBase/Firebird database objects, refer to the official InterBase/Firebird server documentation.

Note: Before working with database objects in SQL Manager for InterBase/Firebird you should connect to the database first.

Creating Database Objects

  • select the Database | New Object... main menu item;
  • select the type of object within the New Object dialog;
  • follow the steps of the wizard which guides you through the entire process of creating the object, or set the object properties using its editor - depending on the selected object type.

Note that you can also create a database object by selecting the appropriate context menu item of the DB Explorer tree or using the Ctrl+N shortcut.

Editing Database Objects

  • select the database object in the DB Explorer tree;
  • right-click the object to call its context menu and select the Edit <object type> <object name> context menu item, or double-click the object to open it in its editor.

Renaming Database Objects

  • select the object to rename in the DB Explorer tree;
  • right-click the object and select the Rename <object type> <object name>... item from the context menu;
  • edit the object name using the Rename Object... dialog.

Note: This operation is possible for all objects except for tables.

Dropping Database Objects

  • select the database object in the DB Explorer tree;
  • right-click the object to call its context menu and select the Drop <object type> <object name> context menu item;
  • confirm dropping in the dialog window.

When using an object editor, you can benefit from tabs. To switch between tab views, click on their respective tabs at the top of the main editor window. You can do it at any time, since the tab views are absolutely independent.

To compile a newly created or edited object, you can use the iconCompile Compile item available within the Navigation bar or Toolbar of the object editor.

See also:

Getting Started

Database Explorer

Database Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Security management

Options

External Tools

How To...


New Object

The Create New Object dialog allows you to select the type of the object to be created and run the appropriate wizard or editor.

To open the dialog, select the Database | New Object... main menu item.

Use the Database drop-down list to select the alias of the database where the new object should be created. Pick an object type icon and click OK to invoke the corresponding wizard or dialog.

Database Objects management - Create New Object

See also:

Operations with database and server objects

Duplicate Object Wizard


Duplicate Object Wizard

Use the Duplicate Object Wizard to create a new database object of the same type and having the same properties as one of the existing ones.

To run the wizard, select the Database | Duplicate Object... main menu item, or right-click an object of the desired type in the DB Explorer tree and use the Duplicate <object type> <object name>... context menu item.

  • Selecting the source database
  • Selecting object to duplicate
  • Selecting destination database
  • Specifying object details
  • Viewing the new object's definition

See also:

New Object dialog


Selecting the source database

This step of the wizard allows you to select the source database containing the source object to be duplicated.

Duplicate Object Wizard - Selecting the source database

Click the Next button to proceed to the Selecting object to duplicate step of the wizard.


Selecting object to duplicate

Use the Objects drop-down menu to select the type of object you intend to duplicate.

Select a database object to copy its properties to the new object.

Hint: The context menu of the objects list area allows you to specify whether objects of the specified type should be displayed as icons or as list.

Duplicate Object Wizard - Selecting object to duplicate

Click the Next button to proceed to the Selecting destination database step of the wizard.


Selecting destination database

Select the target database to create the new object in, set the name of the new database object.

Table options

CheckBox Copy data

Check this option to copy data from the source table to the new one.

CheckBox Deactivate triggers while data copying

Disables object triggers firing while copying data.

Duplicate Object Wizard - Selecting destination database

CheckBox Copy privileges

Defines whether the privileges on the object should be copied as well (displaying the option depends on the object type).

Click the Next button to proceed to the Specifying object details step of the wizard.


Specifying object details

Specify object details (subobjects, dependent objects) to be duplicated in the target object.

Note: Availability of this step depends on the type of object being duplicated.

Duplicate Object Wizard - Specifying object details

Click the Next button to proceed to the Modifying the new object's definition step of the wizard.


Viewing the new object's definition

This step of the wizard allows you to browse the result SQL statement.

Duplicate Object Wizard - Modifying the new object's definition

Click the Finish button to create the object.


Domains

A Domain is a column definition template, global to the database, upon which actual column definitions in tables may be based.

If there are columns in the database table or in several database tables having the same properties, it is useful to describe such column type and its behavior as a domain, and then correspond each of these columns to this domain.

Domain Editor allows you to define domain properties. It opens automatically when you create a new domain and is available on editing an existing one.

To open a domain in Domain Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing domain
  • Defining domain check
  • Browsing object dependencies
  • Editing object description
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Domain Editor.

Domain Editor - Using Navigation bar

Object

iconDB select a database

select a domain for editing

General

iconCompile compile the domain (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the domain

view the dependency tree for the domain

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

btnEnvironmentOptions open the object editor preferences.

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the domain:

Array dimensions

iconPlus add an array dimension

btnArrowRight insert an array dimension

iconMinus delete the selected array dimension

btnArrowUp move the selected array dimension up

btnArrowDown move the selected array dimension down

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of Domain Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing domain

Use the Domain tab of Domain Editor to create/edit a domain and specify its definition.

Name

Enter a name for the new domain, or modify the name of the domain being edited.

Domain Editor - Editing domain definition

Data type

Select the underlying data type of the domain from the drop-down list, and set its length, scale, charset, collation, segment size, subtype (for BLOB data type: 0 - N/A data, 1 - text data, 2 - BLR (Binary Language Representation) data, etc.), if required for the selected data type.

Advanced

Default value

This specifies a default value for columns based on the domain. If no default value is specified, then the default value is the null value.

Value

Type in the preferable default value for a domain. The data type of the default expression must match the data type of the domain.

CheckBox Set value to

Use the drop-down list to select the default value for domain of the selected datatype.

CheckBox Not Null

If enabled, specifies that values of this domain are not allowed to be null.

Array

This area allows you to manage domain array, if necessary. Use the Lower Bound / Upper Bound spinner controls for setting array dimensions.

Right-click the area to display the context menu allowing you to add, insert, delete the selected array dimension, or move it up/down.

Array management tools are also available through the Navigation bar and toolbar of Domain Editor.

To compile a domain, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


Defining domain check

The Check tab allows you to set CHECK constraints, i.e. conditions that must be true for inserts and updates to the field, based on the current domain, e.g. VALUE>=10. The CHECK constraint cannot reference any domain or column.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.

The check definition can be loaded from, and saved to, a file with the help of the appropriate items of the Check group of the Navigation bar.

Domain Editor - Check

See Checks for details.


Tables

Relational databases store all their data in Tables. A table is a data structure consisting of an unordered set of horizontal rows, each containing the same number of vertical columns. The intersection of an individual row and column is a field that contains a specific piece of information. Much of the power of relational databases comes from defining the relations among the tables.

Creating Tables

  • select the Database | New Object... main menu item;
  • select Table in the Create New Object dialog;
  • define table properties and fields using the appropriate tabs of Table Editor.

Hint: To create a new table, you can also right-click the Tables node or any object within this node in the DB Explorer tree and select the New Table... item from the context menu.

To create a new table with the same properties as one of existing tables has:

  • select the Database | Duplicate Object... menu item;
  • follow the instructions of Duplicate Object Wizard.

Alternatively, you can right-click a table in the DB Explorer tree and select the Duplicate Table <table_name>... context menu item.

Duplicate Object Wizard allows you to select the database to create a new table in, and to view the result SQL statement for creating the table.

Editing Tables

To edit an existing table (manage its fields, indexes, data, etc.):

  • select the table for editing in the DB Explorer tree (type the first letters of the table name for quick search);
  • right-click the object and select the Edit Table <table_name> context menu item, or simply double-click the table;
  • edit table subobjects and data using the appropriate tabs of Table Editor.

Dropping Tables

  • select the table to drop in the DB Explorer tree;
  • right-click the object and select the Drop Table <table_name>... context menu item;
  • confirm dropping in the dialog window.

Note: If more convenient, you can also use the following shortcuts:

Ctrl+N to create a new table;

Ctrl+O to edit the selected table;

Shift+Del to drop the object from the database.


New Table

The New Table window is a mode of Table Editor that opens automatically when you create a new table (see Create table for details) and allows you to create a new table, set table properties, and specify table fields.

To call Table Editor for creating a new table, you can right-click the Tables node or any object within this node in the DB Explorer tree and use the Ctrl+N shortcut.

  • Using Navigation bar and Toolbar
  • Setting table properties
  • Specifying table fields


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Table Editor.

New table - Using Navigation bar

The Navigation bar of Table Editor (in the New table mode) allows you to:

Database

iconDB select a database to create a new table in

General

iconCompile compile the newly created table

iconRestoreDefaultSize restore the default size and position of the editor window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the table:

Fields

add a new field

edit selected field

drop selected field(s)

DDL

iconSaveToFile save DDL to file

open DDL in Query Editor

Items of the Navigation bar are also available on the ToolBar of Table Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Setting table properties

Use the Table tab of Table Editor to create a table and specify its properties.

Table name

Name of the table; must be unique among table and procedure names in the database.

New table - Setting table properties

Table type

This group allows you to specify the type of the table being created.

RadioButton Persistent table

Specifies a regular table with data stored in the database.

RadioButton External table

Specifies that data for the table under creation resides in a table or file outside the database.

File name

Type in or use the ExplorerButton button for complete file specification of the external file/table. The drop-down list contains the previously specified paths.

RadioButton Transaction GTT

If this option is selected then Global Temporary Table records are stored until any transaction is committed within this connection session.

RadioButton Connection GTT

This option indicates that Global Temporary Table records are stored up to the termination of the session during which the records were added. Stored records visibility is restricted with this connection.

Description

This field contains any optional description for the table.

To compile the table, use the iconCompile Compile item available within the Navigation bar or toolbar.


Specifying fields

The Fields tab is intended for setting up table fields. Double-click a field to open Field Editor for editing the field.

Right-click within the Table Fields area to display the context menu allowing you to insert, edit, delete, and reorder fields.

Fields management tools are also available through the Navigation bar of Table Editor.

New table - Specifying fields

The Table Fields list provides the following attributes of each field of the new table:

Key

Column Name

Data Type

Default Value

Not Null

Check

For details see Fields.

To compile the table, use the iconCompile Compile item available within the Navigation bar.


Table Editor

Table Editor is the basic SQL Manager tool for working with tables. It opens automatically in the New table mode when you create a new table and is available on editing an existing one (see Create table and Edit table for details).

Table Editor allows you to create, edit and drop table's fields, indexes, foreign keys and other table subobjects, manage table data, and much more.

To open a table in Table Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Managing fields
  • Managing indexes
  • Managing constraints
  • Managing triggers
  • Working with table data
  • Browsing object dependencies
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Table Editor.

Table Editor - Using Navigation bar

The Navigation bar of Table Editor (in the Edit table mode) allows you to:

Object

iconDB select a database

select a table for editing

General

iconRefresh refresh the content of the active tab

iconGrantsOnObject define grants on the table

iconPrint set printing options to print metadata of the table

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconShowSQLHelp show SQL help

iconOptions adjust Table Editor options

iconRestoreDefaultSize restore the default size and position of the editor window

iconCompile compile the table (if it is being modified)

Tools

view the dependency tree for the table

create a view based on the table

create a procedure based on the table

Explorer

iconDBExplorer browse the table subobjects using the Explorer tree

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the table:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

Fields

add a new field

edit selected field

drop selected field(s)

Constraints

add a new primary key

edit selected primary key

drop selected primary key

add a new foreign key

edit selected foreign key

drop selected foreign key(s)

add a new check

edit selected check

drop selected check(s)

add a new unique constraint

edit selected unique constraint

drop selected unique constraint(s)

Indexes

add a new index

edit selected index

drop selected index(-es)

Triggers

add a new trigger

edit selected trigger

drop selected trigger(s)

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export data from the table using Export Data Wizard

export data from the table as SQL script using Export as SQL Script Wizard

import data into the table using Import Data Wizard

Permissions

Grant

Grant with Grant Option

Revoke

Grant All

Grant All with Grant Option

Revoke All

Grant on All

Grant on All with Grant Option

Revoke on All

iconAddGranteeObject Add Grantee object

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of Table Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Managing fields

The Fields tab is intended for managing table fields.

Hint: This tab is selected by default upon opening Table Editor if the Always open the fields tab option is enabled on the Tools | Object Editors | Table Editor page of the Environment Options dialog.

Double-click a field to open Field Editor for editing the field.

Right-click a field to display the context menu allowing you to create new, edit, drop, rename, duplicate the selected field, or reorder fields of the table. Using the menu you can also copy to clipboard or export the list of the table fields to any of supported formats.

Fields management tools are also available through the Navigation bar and toolbar of Table Editor.

Table Editor - Managing fields

The Fields list provides the following attributes of each field of the table:

Field Name

Field Type

Domain

Not Null

Default Source

Computed Source

Description

For details see Fields.

If necessary, you can also use the Field Description area to supply a description for each field.


Changing fields order

The Reorder Fields dialog allows you to change the fields order in the table.

To open this dialog, open the table in Table Editor, proceed to the Fields tab there, right-click within the Fields list and select the Reorder Fields item from the context menu.

The fields are displayed in the Column name list in the current order.

To change the fields order, use the [image] [image] buttons or drag-and-drop operations within the list. Click the OK button and compile the table to view the modification script in the Compile window and apply changes.

Table Editor - Changing fields order


Managing constraints

The Constraints tab of Table Editor allows you to manage table data integrity constraints:

  • PRIMARY KEY
  • FOREIGN KEY
  • CHECK
  • UNIQUE


Primary keys

The Primary Key tab is provided for managing table PRIMARY KEY constraints. Double-click a primary key to open Constraints Editor for editing the primary key.

Right-click a primary key to display the context menu allowing you to create new, edit, rename, or drop the selected primary key. Using the menu you can also recompute the underlying index and export the list of keys to any of supported formats.

Keys management tools are also available through the Navigation bar of Table Editor.

Table Editor - Constraints - Primary keys

The Keys list provides the following attributes of primary key of the table:

Name

On Field(s)

Index Name

Sorting

For details see Primary keys.


Foreign keys

The Foreign Keys tab is provided for managing table FOREIGN KEY constraints. Double-click a foreign key to open Constraints Editor for editing the foreign key.

Right-click a Foreign key to display the context menu allowing you to create new, edit, rename, or drop the selected Foreign key. Using the menu you can also export the list of the table Foreign keys to any of supported formats.

Foreign keys management tools are also available through the Navigation bar of Table Editor.

Table Editor - Constraints - Foreign keys

The Foreign Keys list provides the following attributes of each Foreign key of the table:

Name

On Field(s)

Foreign Table

Foreign Field(s)

Index Name

Sorting

For details see Foreign keys.


Checks

The Checks tab is provided for managing table CHECK constraints. Double-click a check to open Constraints Editor for editing the check.

Right-click a check to display the context menu allowing you to create new, edit, rename, or drop the selected check. Using the menu you can also export the list of the table checks to any of supported formats.

Checks management tools are also available through the Navigation bar of Table Editor.

Table Editor - Constraints - Checks

The Checks list provides the following attributes of each check constraint of the table:

Name

Source

For details see Checks.


Unique constraints

The Uniques tab is provided for managing table UNIQUE constraints. Double-click a key to open Constraints Editor for editing the unique constraint.

Right-click a key to display the context menu allowing you to create new, edit, rename, or drop the selected unique key. Using the menu you can also recompute the underlying index and export the list of the table unique keys to any of supported formats.

Keys management tools are also available through the Navigation bar of Table Editor.

Table Editor - Constraints - Unique keys

The Uniques list provides the following attributes of each unique constraint of the table:

Name

On Field(s)

Index Name

Sorting

Description

For details see Unique constraints.

If necessary, you can also use the Constraint Description area to supply a description for each unique constraint.


Managing indices

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Managing indexes

The Indexes tab is provided for managing table indexes. Double-click an index to open Index Editor for editing the index.

Right-click an index to display the context menu allowing you to create new, edit, rename, or drop the selected index. Using the menu you can also recompute selected or all indexes, set the index active/inactive, and export the list of the table indexes to any of supported formats.

Indexes management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing indexes

The Indexes list provides the following attributes of each index of the table:

Index Name

On Field(s)

Sorting

Unique

Active

Statistics

Description

For details see Indexes.

If necessary, you can also use the Index Description area to supply a description for each index.


Managing triggers

The Triggers tab is provided for managing table triggers. Double-click a trigger to open Trigger Editor for editing the trigger.

Right-click the area to display the context menu allowing you to create new, edit, rename, or drop the selected trigger. Using the menu you can also set the trigger active/inactive, and open the selected trigger in a separate Trigger Editor.

Triggers management tools are also available through the Navigation bar of Table Editor.

Table Editor - Managing triggers

The Triggers list provides the following attributes of each trigger of the view:

Trigger Name

Position

Active

Description

On this tab all triggers are grouped into categories:

  • Before Insert
  • After Insert
  • Before Update
  • After Update
  • Before Delete
  • After Delete

The trigger definition is displayed in the Trigger DDL window.

Use the context menu or items on a toolbar to manage triggers:

add a new trigger

edit selected trigger

drop selected trigger(s)

iconSetTriggerInactive set trigger active/inactive

iconOpenInSeparateEditor open selected trigger in a Trigger Editor

For details see Triggers.


Working with table data

The Data tab displays the table data as a grid by default (see Data View for details). The context menu of this tab allows you to Export Data, Import Data, Export as SQL Script.

Data management tools are also available through the Navigation bar of Table Editor.

While working with data, you are provided with a number of filtering and grouping facilities.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Table Editor - Working with table data

See also:

Working with view data


Fields

Table fields are managed within the Fields tab of Table Editor.

Creating Fields

  • open the table in Table Editor;
  • proceed to the Fields tab there;
  • right-click the tab area and select the New Field... context menu item, or press the Ins key;
  • define the field properties using the Field Editor dialog.

Editing Fields

To edit an existing table field:

  • open the table in Table Editor;
  • proceed to the Fields tab there;
  • right-click the field and select the Edit Field <field_name>... context menu item, or simply double-click the field;
  • edit the field properties using the Field Editor dialog.

To change the name of a field:

  • open the table in Table Editor;
  • proceed to the Fields tab there;
  • right-click the field to rename and select the Rename Field <field_name>... item from the context menu;
  • edit the field name using the Rename Object... dialog.

To change the order of table fields:

  • open the table in Table Editor;
  • proceed to the Fields tab there;
  • right-click a field and select the Reorder Fields context menu item;
  • edit fields' order using the Reorder Fields dialog.

Dropping Fields

  • open the table in Table Editor;
  • proceed to the Fields tab there;
  • right-click the field and select the Drop Field <field_name> context menu item, or press the Del key;
  • confirm dropping in the dialog window.


Field Editor

Field Editor allows you to specify field definition and set field properties. It opens automatically when you create a new field and is available on editing an existing one (see Create field and Edit field for details).

To open a field in Field Editor, double-click it in the DB Explorer tree, or use the Edit Field... item of the context menu within the Fields tab of Table Editor.

  • Setting field name and type
  • Options for domain-based field
  • Options for field of standard data type
  • Defining array
  • Specifying 'COMPUTED BY' expression
  • Setting field defaults
  • Defining autoincrement
  • Setting field checks
  • Editing object description
  • Viewing DDL definition


Setting field name and type

Column

Enter a name for the new field, or modify the name of the field being edited. Note that the name of a field must be unique among all the field names in the table.

CheckBox Not Null

Check this option to specify that the values for the column should never contain a null value. NOT NULL affects all INSERT and UPDATE operations on a column.

CheckBox Add to primary key

Check this option to include the field into the primary key. Note that if a field is included into a primary key, it also gets the Not Null attribute enabled.

Tables - Field Editor

Field based on

This group allows you to select the source type for the field being created/edited. It can be one of existing domains, a standard (built-in) InterBase/Firebird data type (e.g. INTEGER, DATE or CHAR), or a 'COMPUTED BY' expression (if you want to calculate the field value using values of other fields).

RadioButton Domain

Specifies that the field is based on a domain previously created in the database.

If this option is selected, you should set options for domain-based field.

RadioButton Standard Data type

Specifies that the field is based on a standard data type.

If this option is selected, you should set options for field of standard data type.

RadioButton 'COMPUTED BY' expression

Specifies that the value of the field's data is calculated from an expression at runtime, and therefore storage space is not allocated in the database.

If this option is selected, you should specify 'COMPUTED BY' expression.

CheckBox Support IB6/FireBird syntax

This option is only available on editing an existing field. Select this option to enable support of InterBase 6.0 / FireBird syntax.


Options for domain-based field

If you select the RadioButton Domain option of the Field based on group indicating that the field being created/edited is based on a domain, you should specify domain-specific options.

Tables - Field Editor - Domain-based field options

Domain

Domain name

Use the drop-down list of existing domains to select the domain to be used for the field.

CheckBox Autoincrement value and CheckBox Identity

These options are only available if the selected domain is based on a numeric data type. For details see Defining autoincrement.

Collation

This setting is only available if the selected domain is based on a string data type. Use the drop-down list to select the collation order to be used for string data stored in the column.

To edit the selected domain using Domain Editor, click the Edit Domain button.

To create a new domain for the field using Domain Editor, click the New Domain button.

Domain info

This group allows you to view basic information on the selected domain.

CheckBox Use default value

Enable this option to specify the value this field will take by default. For details see Setting field defaults.


Options for field of standard data type

If you select the RadioButton Standard data type option of the Field based on group indicating that the field being created/edited is based on a standard InterBase/Firebird data type, you should specify options for the data type.

Tables - Field Editor - Standard data type options

Field type

Use the drop-down list of ANSI SQL data types to select the one to be applied for the field.

CheckBox Autoincrement value and CheckBox Identity

Use these options to setup autoincrement field properties.

Field dimension

For NUMERIC and DECIMAL data types set digit precision (digits of precision to store, 1 to 18) and scale (number of decimal places that can be stored, 1 to 18) in the appropriate boxes; for CHAR and VARCHAR set length (in characters), for BLOB data type set segment size and subtype.

Field character set

Use this group to set the column character set and collation order.

String (CHAR, VARCHAR, text Blob) columns of InterBase/Firebird can use different character sets. A character set defines the symbols that can be entered as text in a column, and it also defines the maximum number of bytes of storage necessary to represent each symbol. A number of character sets can be used to store InterBase/Firebird data, and the server allows comparisons according to a variety of collations.

The column character set and collation are treated by the server in the following way:

  • If both Character Set X and Collation Y are specified, then character set X and collation Y will be applied
  • If Character Set X is specified without Collation, then character set X and its default collation will be applied
  • Otherwise, the database character set (see the Connection section of the Database Registration Info dialog) and its default collation are used

Charset

Use the drop-down list to select the character set for the column.

Collation

Use the drop-down list to specify the collation order to be used for string data stored in the column.

CheckBox Use default value

Enable this option to specify the value this field will take by default. For details see Setting field defaults.


Defining array

A field can be an array of one of standard data types (except BLOB). To set array parameters, specify the data type and then select the Array tab of the dialog.

Tables - Field Editor - Array

To add/edit an array dimension, click the Add Dimension / Edit Dimension button to call the Dimension Editor dialog.

Use the spinner controls of the dialog to set the lower/upper bounds.

Tables - Field Editor - Array - Dimension Editor

To delete a dimension, select one in the list and click the Delete Dimension button.


Specifying 'COMPUTED BY' expression

If you select the RadioButton 'COMPUTED BY' expression option of the Field based on group indicating that values of the field being created/edited will be calculated according to an expression, you should specify the 'COMPUTED BY' expression in the editable area below.

Tables - Field Editor - Specifying COMPUTED BY expression

Set the expression to be used for calculation, e.g.

(OLD_SALARY + OLD_SALARY * PERCENT_CHANGE / 100)

Note the following:

  • the expression can be any arithmetic expression valid for the data types in the expression;
  • any columns referenced in the expression must exist before they can be used in expression;
  • the expression cannot reference BLOB columns;
  • the expression must return a single value, and cannot return an array.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


Setting field defaults

The Use default value group allows you to define the default value for the column, i.e. the value that is entered when no other entry is made

To activate the group, enable the CheckBox Use default value option.

Use the provided controls to specify the default field value.

Tables - Field Editor - Setting field defaults

Default value

Type in the preferable default value for a domain. The data type of the default expression must match the data type of the field:

  • for integral (SMALLINT, INTEGER) and floating-point (FLOAT, NUMERIC, DOUBLE PRECISION, DECIMAL) data types, use the spinner control to specify the necessary value;
  • for string data types (CHAR, VARCHAR), use the editable area to input the necessary text;
  • for temporal data types (DATE, TIME), type in or click the arrow-down button to call the Date editor popup window and set the required date value.

CheckBox Set value to

Use the drop-down list to select the default value for a field of the selected datatype.

Note that the default value set for the field based on a domain in the Field Default group of Field Editor will override the corresponding value set for the domain.


Defining autoincrement

For SMALLINT and INTEGER fields, Field Editor provides you with an ability to specify autoincrement. A generator, a trigger and/or a procedure wrapper can be created to implement the autoincrement property for the field being created/edited.

To enable the autoincrement property, select the CheckBox Autoincrement value option.

  • Defining generator
  • Defining trigger
  • Defining procedure

To disable the autoincrement property, deselect the CheckBox Autoincrement value option. The tree on the left will change - the Disable node will appear under the Autoincrement branch. Switch to the Disable page, and select the objects to be dropped with the help of the corresponding flags:

CheckBox Drop generator

CheckBox Drop trigger

CheckBox Drop procedure wrapper

Since Firebird 3.0 it is possible to define the IDENTITY field property to enable autoincrement abilities of the field. Select the CheckBox Identity option to switch on identity and set the initial sequence value in the Start with field. Please note that it is not possible to use Identity and Autoincrement value options at the same time because they provide with the same feature.


Defining generator

The Generator page allows you to specify properties of the generator to be created along with the autoincrement field.

Tables - Field Editor - Autoincrement - Generator

Generator name

Defines the name of the generator to be created.

Initial value

Sets the initial value for the generator.


Defining trigger

The Trigger page allows you to specify properties of the trigger to be created along with the autoincrement field.

Tables - Field Editor - Autoincrement - Trigger

Trigger definition

A block of statements in InterBase procedure and trigger language bracketed with BEGIN and END.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


Defining procedure

The Procedure page allows you to specify properties of the procedure wrapper to be created along with the autoincrement field.

Tables - Field Editor - Autoincrement - Procedure

CheckBox Create procedure wrapper

Enable the option to create a procedure wrapper. Procedure wrapper returns a new generator value and can be used instead of GEN_ID for a specific generator.

Procedure definition

A block of statements in InterBase procedure and trigger language bracketed with BEGIN and END.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


Setting field check

The Check page allows you to set CHECK constraints, i.e. conditions that must be true for inserts and updates to the field, e.g. VALUE>=10 or MIN_SALARY < MAX_SALARY. An attempt to enter a new value in the column fails if the value does not meet the specified check condition.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.

Note that the check value set for the field based on a domain in the Check section of Field Editor will override the corresponding value set for the domain.

Tables - Field Editor - Setting field checks

See Checks for details.


Table Constraints

Constraints let you define the way the server automatically enforces the integrity of a database. Constraints define rules regarding the values allowed in columns and are the standard mechanism for enforcing integrity.

A PRIMARY KEY constraint designates a column as the Primary key of a table. A composite primary key designates a combination of columns as the primary key.

Table primary keys are managed within the Constraints | Primary Key tab of Table Editor.

A FOREIGN KEY constraint (also called a referential integrity constraint) designates a column as the Foreign key and establishes a relationship between that foreign key and a specified Primary or Unique key called the referenced key. A composite Foreign key designates a combination of columns as the foreign key.

Table Foreign keys are managed within the Constraints | Foreign Keys tab of Table Editor.

A CHECK specifies an expression producing a Boolean result which new or updated rows must satisfy for an insert or update operation to succeed. Expressions evaluating to TRUE or UNKNOWN succeed. Should any row of an insert or update operation produce a FALSE result an error exception is raised and the insert or update does not alter the database. A check constraint specified as a column constraint should reference that column's value only, while an expression appearing in a table constraint may reference multiple columns.

Table checks are managed within the Constraints | Checks tab of Table Editor.

A UNIQUE constraint prevents insertion or updating of duplicate values into table columns.

Table unique keys are managed within the Constraints | Uniques tab of Table Editor.

Creating Primary Keys

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Primary Key tab there;
  • right-click the tab area and select the New Primary Key... context menu item, or press the Ins key;
  • define the primary key properties using the Constraints Editor dialog.

Editing Primary Keys

To edit an existing primary key:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Primary Key tab there;
  • right-click the primary key and select the Edit Primary Key <PK_name> context menu item, or simply double-click the primary key;
  • edit the primary key properties using the Constraints Editor dialog.

To change the name of a primary key:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Primary Key tab there;
  • right-click the primary key to rename and select the Rename Primary Key <PK_name>... item from the context menu;
  • edit the primary key name using the Rename Object... dialog.

Dropping Primary Keys

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Primary Key tab there;
  • right-click the primary key and select the Drop Primary Key <PK_name> context menu item, or press the Del key;
  • confirm dropping in the dialog window.

Creating Foreign Keys

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Foreign Keys tab there;
  • right-click the tab area and select the New Foreign Key... context menu item, or press the Ins key;
  • define the Foreign key properties using the Constraints Editor dialog.

Editing Foreign Keys

To edit an existing Foreign key:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Foreign Keys tab there;
  • right-click the Foreign key and select the Edit Foreign Key <FK_name>... context menu item, or simply double-click the Foreign key;
  • edit the Foreign key properties using the Constraints Editor dialog.

To change the name of a Foreign key:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Foreign Keys tab there;
  • right-click the Foreign key to rename and select the Rename Foreign Key <FK_name>... item from the context menu;
  • edit the Foreign key name using the Rename Object... dialog.

Dropping Foreign Keys

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Foreign Keys tab there;
  • right-click the Foreign key and select the Drop Foreign Key <FK_name> context menu item, or press the Del key;
  • confirm dropping in the dialog window.

Creating Checks

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Checks tab there;
  • right-click the tab area and select the New Check... context menu item, or press the Ins key;
  • define the check properties using the Constraints Editor dialog.

Editing Checks

To edit an existing check:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Checks tab there;
  • right-click the check and select the Edit Check <check_name>... context menu item, or simply double-click the check;
  • edit the check properties using the Constraints Editor dialog.

To change the name of a check:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Checks tab there;
  • right-click the check to rename and select the Rename Check <check_name>... item from the context menu;
  • edit the check name using the Rename Object... dialog.

Dropping Checks

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Checks tab there;
  • right-click the check and select the Drop Check <check_name> context menu item, or press the Del key;
  • confirm dropping in the dialog window.

Creating Unique Keys

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Uniques tab there;
  • right-click the tab area and select the New Unique... context menu item, or press the Ins key;
  • edit the unique key properties using the Constraints Editor dialog.

Editing Unique Keys

To edit an existing unique key:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Uniques tab there;
  • right-click the unique key and select the Edit Unique <unique_name>... context menu item, or simply double-click the unique key;
  • edit the unique key properties using the Constraints Editor dialog.

To change the name of a unique key:

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Uniques tab there;
  • right-click the unique key to rename and select the Rename Unique <unique_name>... item from the context menu;
  • edit the unique key name using the Rename Object... dialog.

Dropping Unique Keys

  • open the table in Table Editor;
  • proceed to the Constraints tab, and then to the Uniques tab there;
  • right-click the unique key and select the Drop Unique <unique_name> context menu item, or press the Del key;
  • confirm dropping in the dialog window.


Constraints Editor

Constraints Editor is a tool for working with table constraints. It opens automatically when you create a new constraint and is available on editing an existing one (see Create Primary Key, Edit Primary Key, Create Foreign Key, Edit Foreign Key, Create Unique Key, Edit Unique Key, Create Check, Edit Check for details).

To open Constraints Editor for viewing/editing primary key, foreign key, check, unique constraints of a table, open the table in Table Editor, proceed the Constraints tab, then to the sub-tab of the constraint you need, and double-click it in the list.

  • Creating/editing primary key
  • Creating/editing foreign key
  • Creating/editing check
  • Creating/editing unique key
  • Editing object description
  • Viewing DDL definition


Creating/editing primary key

The Primary Key section of the Constraints dialog allows you to specify PRIMARY KEY constraint definition.

Tables - Constraints Editor - Primary Key

Name

Name of the PRIMARY KEY constraint; the constraint name must be unique within the table.

Fields for primary key

To include field(s) in the primary key, you need to move it from the Available Fields list to the Included Fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.


Creating/editing foreign key

The Foreign Key section of the Constraints dialog allows you to specify FOREIGN KEY constraint definition.

Tables - Constraints Editor - Foreign Key

Name

Name of the FOREIGN KEY constraint; the constraint name must be unique within the table.

The Table Fields area allows you to select Foreign key field(s).

To select a field, you need to move it from the Available Fields list to the Included Fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Foreign Table

Use the drop-down list to select the foreign table.

The Foreign Table Fields area allows you to select the field(s) of the Foreign table.

To select a field, you need to move it from the Available Fields list to the Included Fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

If the referenced column(s) are changed frequently, it may be wise to add an index to the foreign key column so that referential actions associated with the foreign key column were performed more efficiently. See Indexes for details.

On Delete rule / On Update rule

Set rules to change a foreign key whenever the referenced primary key changes.

  • NO ACTION

Does not change the foreign key column(s); may cause the primary key update to fail due to referential integrity checks. This is the default action.

  • CASCADE

Delete any rows referencing the deleted row, or update the value of the referencing column to the new value of the referenced column, respectively.

  • SET NULL

Set the referencing column(s) to NULL.

  • SET DEFAULT

Set the referencing column(s) to their default values in effect when the referential integrity constraint is defined. When the default for a foreign column changes after the referential integrity constraint is defined, the change does not have an effect on the default value used in the referential integrity constraint.


Creating/editing check

The Check section of the Constraints dialog allows you to specify CHECK constraint definition.

Tables - Constraints Editor - Check

Name

Name of the CHECK constraint; the constraint name must be unique within the table.

Check Constraint Text

Set CHECK constraints, i.e. conditions that must be true for inserts and updates to the table, e.g.

PERCENT_CHANGE BETWEEN -50 AND 50

An attempt to enter a new value in the table fails if the value does not meet the specified check condition.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


Creating/editing unique key

The Unique section of the Constraints dialog allows you to specify UNIQUE constraint definition.

Tables - Constraints Editor - Unique

Name

Name of the UNIQUE constraint; the constraint name must be unique within the table.

Fields for unique key

To include field(s) in the unique key, you need to move it from the Available Fields list to the Included Fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.


Indexes

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Indices

Table indexes are managed within the Indices tab of Table Editor.

Creating Indices

  • open the table in Table Editor;
  • proceed to the Indices tab there;
  • right-click the tab area and select the New Index... context menu item, or press the Ins key;
  • define the index properties using the Index Editor dialog.

Editing Indices

To edit an existing table index:

  • open the table in Table Editor;
  • proceed to the Indices tab there;
  • right-click the index and select the Edit Index <index_name>... context menu item, or simply double-click the index;
  • edit the index properties using the Index Editor dialog.

To change the name of an index:

  • open the table in Table Editor;
  • proceed to the Indices tab there;
  • right-click the index to rename and select the Rename Index <index_name>... item from the context menu;
  • edit the index name using the Rename Object... dialog.

Dropping Indices

  • open the table in Table Editor;
  • proceed to the Indices tab there;
  • right-click the index and select the Drop Index <index_name> context menu item, or press the Del key;
  • confirm dropping in the dialog window.


Index Editor

Index Editor allows you to specify index definition and set index properties. It opens automatically when you create a new index and is available on editing an existing one (see Create Index and Edit Index for details).

To open an index in Index Editor, double-click it in the DB Explorer tree, or use the Edit Index... item of the context menu within the Indexes tab of Table Editor.

  • Specifying index properties
  • Selecting index fields
  • Editing index description
  • Viewing DDL definition


Specifying index properties

Use the Index page of the Index Editor dialog to specify common index properties.

Tables - Index Editor

Name

Specifies index name (if necessary, you can edit the one assigned by default).

Use the Index type section to define the created index type:

RadioButton Index

This option indicates that the index is defined by a field or a number of fields.

RadioButton Expression Index

This option indicates that index is defined by the expression from the Expression value tab.

CheckBox Index Active

Enables/disables the index immediately after it is created or changes applied.

Order

Use the drop-down list to select whether the ascending or descending sorting order should be used for index columns.


Selecting index fields

Use the Fields page of the Index Editor dialog to select the fields for the index.

Fields for index

To include field(s) in the index, you need to move it from the Available Fields list to the Selected Fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Tables - Index Editor - Fields

CheckBox Unique

Check this option to prevent inserting or updating duplicate values in indexed columns.

If the RadioButton Expression Index option was selected at the Index tab then you need to define the expression at the Expression Value tab.

Tables - Index Editor - Expression


Triggers

Table triggers are managed within the Triggers tab of the Table Editor.

Creating Triggers

  • open the table in Table Editor;
  • proceed to the Triggers tab there;
  • right-click the tab area and select the New Trigger... context menu item, or press the Ins key;
  • edit the trigger properties using the Trigger Editor dialog.

Editing Triggers

To edit an existing trigger:

  • open the table in Table Editor;
  • proceed to the Triggers tab there;
  • right-click the trigger and select the Edit Trigger <trigger_name>... context menu item, or simply double-click the trigger;
  • edit the trigger properties using the Trigger Editor dialog.

To change the name of a trigger:

  • open the table in Table Editor;
  • proceed to the Triggers tab there;
  • right-click the trigger to rename and select the Rename Trigger <trigger_name>... item from the context menu;
  • edit the trigger name using the Rename Object... dialog.

Dropping Triggers

  • open the table in Table Editor;
  • proceed to the Triggers tab there;
  • right-click the trigger and select the Drop Trigger <trigger_name> context menu item, or press the Del key;
  • confirm dropping in the dialog window.


Trigger Editor

Trigger Editor allows you to set properties for a new trigger or edit an existing trigger.

Tables - Trigger Editor

For details see Trigger Editor | Creating/editing trigger, Managing trigger messages.


View from Table

SQL Manager for InterBase/Firebird provides you with an ability to create an updatable view from a table and set its properties using the Create View from Table dialog.

To open the dialog, right-click the table in DB Explorer and select the Tasks | Create View... context menu item, or open the table in Table Editor and use the Create View item of the Navigation bar.

  • Options
  • View info
  • View triggers

See also:

SIUD Procedures from Table


Options

The Options section of the Create View from Table dialog allows you to specify common options for the view being created.

Tables - Create View from Table - Options

Triggers

Select trigger type(s) to be created for the view with the help of the corresponding flags:

CheckBox Before Insert

CheckBox Before Update

CheckBox Before Delete

CheckBox Grant privileges on view according to the privileges on the table

Enable the option grant the same privileges on the view as granted on the source table.


View info

The View info section of the Create View from Table dialog provides the definition of the view generated from the table.

Tables - Create View from Table - View info

Name

Specifies view name (if necessary, you can edit the one assigned by default).

The Fields list displays view fields as specified in the fields clause and the AS clause of the view definition.

The list provides the following attributes of each field:

Name

Type

To add/remove fields to/from the construction, check/uncheck flags available in the first column of the Fields list.

For your convenience the Select All, Deselect All and Invert Selection functions are implemented in the context menu of the fields list area.

The lower area represents the view definition as SQL statement. It is possible to edit the definition directly using the editor area to make appropriate changes.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


View triggers

The Before insert / Before update / Before delete pages allow you to specify definitions for corresponding triggers generated for the view. The set of available sections is determined by selection in the Triggers group of the Options page.

Tables - Create View from Table - View triggers

Edit the block of statements within the BEGIN / END pair according to your needs.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


Procedures from Table

SQL Manager for InterBase/Firebird provides you with an ability to create SELECT/INSERT/UPDATE/DELETE procedures from a table and set their properties using the Create Procedures from Table dialog.

To open the dialog, right-click the table in DB Explorer and select the Tasks | Create SIUD Procedures... context menu item, or open the table in Table Editor and use the Create Procedure item of the Navigation bar.

  • Options
  • SELECT procedure
  • INSERT procedure
  • UPDATE procedure
  • DELETE procedure

See also:

View from Table


Options

The Options section of the Create Procedures from Table dialog allows you to specify common options for the procedures being created.

Tables - Create Procedure from Table - Options

Procedure type

Select procedure type(s) to be created with the help of the corresponding flags:

CheckBox Create SELECT procedure

CheckBox Create INSERT procedure

CheckBox Create UPDATE procedure

CheckBox Create DELETE procedure

CheckBox Grant EXECUTE on procedures according to the privileges on the table

Enable the option to grant the EXECUTE privileges on the procedure(s) as it is granted on the source table.


SELECT procedure

The Select section of the Create Procedures from Table dialog provides the definition of the SELECT procedure generated from the table.

Tables - Create Procedure from Table - SELECT

Name

Specifies procedure name (if necessary, you can edit the one assigned by default).

The Fields list displays fields as specified in the fields clause of the procedure definition.

The list provides the following attributes of each field:

Name

Type

To add/remove fields to/from the construction, check/uncheck flags available in the first column of the Fields list.

For your convenience the Select All, Deselect All and Invert Selection functions are implemented in the context menu of the fields list area.

The lower area represents the SELECT procedure definition as SQL statement. It is possible to edit the definition directly using the editor area to make appropriate changes.

Edit the block of statements within the BEGIN / END pair according to your needs.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


INSERT procedure

The Insert section of the Create Procedures from Table dialog provides the definition of the INSERT procedure generated from the table.

Tables - Create Procedure from Table - INSERT

Name

Specifies procedure name (if necessary, you can edit the one assigned by default).

The Fields list displays fields as specified in the fields clause of the procedure definition.

The list provides the following attributes of each field:

Name

Type

To add/remove fields to/from the construction, check/uncheck flags available in the first column of the Fields list.

For your convenience the Select All, Deselect All and Invert Selection functions are implemented in the context menu of the fields list area.

The lower area represents the INSERT procedure definition as SQL statement. It is possible to edit the definition directly using the editor area to make appropriate changes.

Edit the block of statements within the BEGIN / END pair according to your needs.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


UPDATE procedure

The Update section of the Create Procedures from Table dialog provides the definition of the UPDATE procedure generated from the table.

Tables - Create Procedure from Table - UPDATE

Name

Specifies procedure name (if necessary, you can edit the one assigned by default).

The Fields list displays fields as specified in the fields clause of the procedure definition.

The list provides the following attributes of each field:

Name

Type

To add/remove fields to/from the construction, check/uncheck flags available in the first column of the Fields list.

For your convenience the Select All, Deselect All and Invert Selection functions are implemented in the context menu of the fields list area.

The lower area represents the UPDATE procedure definition as SQL statement. It is possible to edit the definition directly using the editor area to make appropriate changes.

Edit the block of statements within the BEGIN / END pair according to your needs.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


DELETE procedure

The Delete section of the Create Procedures from Table dialog provides the definition of the DELETE procedure generated from the table.

Tables - Create Procedure from Table - DELETE

Name

Specifies procedure name (if necessary, you can edit the one assigned by default).

The lower area represents the DELETE procedure definition as SQL statement. It is possible to edit the definition directly using the editor area to make appropriate changes.

Edit the block of statements within the BEGIN / END pair according to your needs.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


Views

A View is a logical table based on one or more tables or views. A view contains no data itself. The tables upon which a view is based are called base tables.

Views are useful for allowing users to access a set of relations (tables) as if it were a single table, and limiting their access to just that. Views can also be used to restrict access to rows (a subset of a particular table).

View Editor allows you to create new views and define their properties (view name and the SELECT statement it implements). It opens automatically when you create a new view and is available on editing an existing one.

To open a view in View Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing view
  • Managing common properties and fields
  • Managing triggers
  • View plan
  • Working with data
  • Editing object description
  • Browsing object dependencies
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in View Editor.

View Editor - Using Navigation bar

Object

iconDB select a database

select a view for editing

General

iconCompile compile the view (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the view

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconEditorMode toggle Text / Visual editor modes

iconRestoreDefaultSize restore the default size and position of the editor window

iconOptions adjust Visual Mode Editors options

Tools

view the dependency tree for the view

iconAutograntPrivileges set autogrant privileges for the view

iconGrantsOnObject define grants on the view

edit the view query using Query Designer

Explorer

iconDBExplorer browse the view subobjects using the Explorer tree

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the view:

Triggers

add a new trigger

edit selected trigger

drop selected trigger(s)

iconSetTriggerInactive set trigger active/inactive

iconOpenInSeparateEditor open selected trigger in a Trigger Editor

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export data from the view using Export Data Wizard

export data from the view as SQL script using Export as SQL Script Wizard

import data into the view using Import Data Wizard

Permissions

Grant

Grant with Grant Option

Revoke

Grant All

Grant All with Grant Option

Revoke All

Grant on All

Grant on All with Grant Option

Revoke on All

iconAddGranteeObject Add grantee object

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of View Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing view

Use the Object tab of View Editor to create/edit a view and specify its definition.

View Editor provides two modes: Text editor and Visual editor. To switch between these editor modes, use the corresponding items available in the General group of the Navigation bar and toolbar.

View Editor - Editing view definition

When in the Text editor mode, you can use the editor area to specify the view definition as SQL statement using a template, hence it is enough to simply edit the template using the editor area to make appropriate changes, and compile the view.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.

When in the Visual editor mode, you are provided with a set of widgets allowing you to benefit from graphical user interface while editing the object properties.

Name

Enter a name for the new view, or modify the name of the view being edited.

The Fields list provides the following attributes of each field of the view:

Name

Field Type

Domain

Description

If necessary, you can also use the Field Description area to supply a description for each field.

The lower area allows you to specify the AS clause of the view definition. When editing the view, you can edit the definition using the editor area to make appropriate changes, and recompile the view.

Note: When you edit the query of the AS clause, all the changes you make are processed by the View Editor precompiler, and the list of fields is formed automatically.

To compile a view, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


Managing fields

The Fields tab is provided for viewing fields represented in the view.

View Editor - Viewing fields

The Fields list provides the following attributes of each field of the view:

Name

Field Type

Domain

Description

If necessary, you can also use the Field Description area to supply a description for each field.


Managing triggers

The Triggers tab is provided for managing triggers represented in the view. Double-click a trigger to open Trigger Editor for editing the trigger.

Right-click the area to display the context menu allowing you to create new, edit, rename, or drop the selected trigger. Using the menu you can also set the trigger active/inactive, and open the selected trigger in a separate Trigger Editor.

View Editor - Managing triggers

The Triggers list provides the following attributes of each trigger of the view:

Trigger Name

Position

Active

Description

On this tab all triggers are grouped into categories:

  • Before Insert
  • After Insert
  • Before Update
  • After Update
  • Before Delete
  • After Delete

The trigger definition is displayed in the Trigger DDL window.

Use the context menu or items on a toolbar to manage triggers:

add a new trigger

edit selected trigger

drop selected trigger(s)

iconSetTriggerInactive set trigger active/inactive

iconOpenInSeparateEditor open selected trigger in a Trigger Editor

For details see Triggers.


View plan

The Plan tab is provided for your convenience to see the plan of the query implied by the view.

View Editor - View plan

See Query plan for details.


Working with data

The Results tab displays the view data as a grid by default (see Data View for details). The context menu of this tab and the Navigation bar allow you to Export Data, Import Data, Export as SQL Script.

While working with view data, you are provided with a number of filtering and grouping facilities.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Data management tools are also available through the Navigation bar and toolbar of View Editor.

View Editor - Working with data

In the bottom pane of this tab you can see brief statistics concerned query execution.

See also:

Data View


Procedures

A Procedure is a set of procedural constructs and embedded SQL statements that is stored in the database and can be called by name.

A Stored procedure is a self-contained program written in InterBase procedure and trigger language, and stored as part of a database's metadata. Stored procedures can be invoked directly from applications, or can be substituted for a table or view in a SELECT statement. Stored procedures can receive input parameters from and return values to applications and can execute on the server.

Creating Procedures

  • select the Database | New Object... main menu item;
  • select Procedure in the Create New Object dialog;
  • define procedure properties using the appropriate tabs of Procedure Editor.

Hint: To create a new procedure, you can also right-click the Procedures node or any object within this node in the DB Explorer tree and select the New Procedure... item from the context menu.

To create a new procedure with the same properties as one of existing procedures has:

  • select the Database | Duplicate Object... main menu item;
  • follow the instructions of Duplicate Object Wizard.

Alternatively, you can right-click a procedure in the DB Explorer tree and select the Duplicate Procedure <procedure_name>... context menu item.

Duplicate Object Wizard allows you to select the database to create a new procedure in, and to view the result SQL statement for creating the procedure.

Editing Procedures

To edit an existing procedure:

  • select the procedure for editing in the DB Explorer tree (type the first letters of the procedure name for quick search);
  • right-click the object and select the Edit Procedure <procedure_name> context menu item, or simply double-click the procedure;
  • edit procedure definition using the appropriate tabs of Procedure Editor.

To change the name of a procedure:

  • select the procedure to rename in the DB Explorer tree;
  • right-click the procedure alias and select the Rename Procedure <procedure_name>... item from the context menu;
  • edit the procedure name using the Rename Object... dialog.

Executing Procedures

  • select the procedure to execute in the DB Explorer tree (type the first letters of the procedure name for quick search);
  • right-click the object and select the Edit Procedure <procedure_name>... context menu item, or simply double-click the procedure;
  • execute the procedure using the Execute Procedure Navigation bar item of Procedure Editor.

Debugging Procedures

  • select the procedure to debug in the DB Explorer tree (type the first letters of the procedure name for quick search);
  • right-click the object and select the Tasks | Debug context menu item, or open the procedure in Procedure Editor and click the Debug procedure item on the Navigation bar or toolbar;
  • use tools provided by Procedure/Trigger Debugger to debug the procedure.

Dropping Procedures

  • select the procedure to drop in the DB Explorer tree;
  • right-click the object and select the Drop Procedure <procedure_name>... context menu item;
  • confirm dropping in the dialog window.

Note: If more convenient, you can also use the following shortcuts:

Ctrl+N to create a new procedure;

Ctrl+O to edit the selected procedure;

Ctrl+R to rename the procedure;

F9 to execute the procedure;

Shift+Ctrl+F9 to debug the procedure;

Shift+Del to drop the object from the database.


Procedure Editor

Procedure Editor allows you to create a new procedure, execute the existing procedure or edit its definition. It opens automatically when you create a new procedure and is available on editing an existing one (see Create procedure and Edit procedure for details).

To open a stored procedure in Procedure Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing procedure
  • Specifying input parameters
  • Executing procedure
  • Browsing object dependencies
  • Editing object description
  • Viewing object operations
  • Setting object permissions
  • Viewing DDL definition

See also:

Procedure/Trigger Debugger


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Procedure Editor.

Object

iconDB select a database

select a procedure for editing

General

iconCompile compile the procedure (if it is being created/modified)

iconExecute execute the procedure

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the procedure

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconEditorMode toggle Text / Visual editor modes

iconRestoreDefaultSize restore the default size and position of the editor window

iconOptions adjust Visual Mode Editors options

Tools

view the dependency tree for the procedure

iconGrantsOnObject define grants on the procedure

iconAutograntPrivileges set autogrant privileges for the procedure

iconDebugProcedure debug the procedure using Procedure/Trigger Debugger

Explorer

iconDBExplorer browse the procedure parameters and variables using the Explorer tree

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the procedure:

Input Parameters / Output Parameters / Variables / Cursors

iconPlus append a new input parameter / output parameter / variable / cursor

btnArrowRight insert a input parameter / output parameter / variable / cursor

iconMinus delete the selected input parameter / output parameter / variable / cursor

btnArrowUp move the selected input parameter / output parameter / variable / cursor up

btnArrowDown move the selected input parameter / output parameter / variable / cursor down

Permissions

Grant

Grant with Grant Option

Revoke

Grant All

Grant All with Grant Option

Revoke All

Grant on All

Grant on All with Grant Option

Revoke on All

iconAddGranteeObject Add grantee object

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of Procedure Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing procedure

Use the Stored Procedure tab of Procedure Editor to view and edit the stored procedure definition.

Procedure Editor provides two modes: Text editor and Visual editor. To switch between these editor modes, use the corresponding items available in the General group of the Navigation bar and toolbar.

Procedure Editor - Editing procedure definition

When in the Text editor mode, you can use the editor area to specify the procedure definition as SQL statement using a template, hence it is enough to simply edit the template using the editor area to make appropriate changes, and compile the procedure.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.

When in the Visual editor mode, you are provided with a set of widgets allowing you to benefit from graphical user interface while editing the object properties.

Name

Enter a name for the new procedure, or modify the name of the procedure being edited. Note that procedure name must be unique among procedure, table and view names in the database.

The Parameters and variables area allows you to manage input parameters, output parameters, variables and cursors at the corresponding tabs.

The lower area allows you to specify the procedure body, i.e. an optional list of local variables and their data types and a block of statements in InterBase procedure and trigger language, bracketed by BEGIN and END. When editing the procedure, you can edit its body using the editor area to make appropriate changes, and recompile the procedure.

To compile a procedure, you can use the iconCompile Compile item available within the Navigation bar or toolbar.

See also:

Managing parameters

Specifying input parameters


Executing procedure

Procedure Editor provides an ability to execute procedures. Click the btnExecuteQuery Execute item of the Navigation bar or use the corresponding toolbar button to execute the procedure.

If the procedure has input parameters, SQL Manager allows you to specify the values for these parameters in the Input Parameters dialog which appears just before execution.

The result of the successfully executed procedure, as well as the error message in case of execution failure, appears in the message panel at the bottom of the Procedure Editor window.

Procedure Editor - Executing procedure

Note: If any unsaved changes are applied to the stored procedure being currently edited, the execution of the procedure is impossible unless changes are saved through the Compile item of the Navigation bar.

See also:

Specifying input parameters

Procedure Editor


Working with data

The Data tab displays the procedure data as a grid by default (see Data View for details). The context menu of this tab and the Navigation bar allow you to Export Data, Import Data, Export as SQL Script.

While working with procedure data, you are provided with a number of filtering and grouping facilities.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Data management tools are also available through the Navigation bar and toolbar of Procedure Editor.

Procedure Editor - Results


Procedure/Trigger Debugger

To fix the errors in the procedure or trigger code and to optimize the procedure/trigger work, you can debug the procedure/trigger step-by-step before compilation, using the Procedure/Trigger Debugger.

To activate the debugger, open the procedure in Procedure Editor, or the trigger in Trigger Editor, then click the iconDebugProcedure Debug procedure / iconDebugProcedure Debug trigger button on the toolbar or use the corresponding item of the Navigation bar. You can also use the Shift+Ctrl+F9 shortcut for the same purpose.

  • Using Navigation bar and Toolbar
  • Debugging procedure/trigger
  • Browsing debug information

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Procedure Editor

Trigger Editor


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Procedure/Trigger Debugger.

Procedure Debugger - Using Navigation bar

General

iconShowSQLHelp show SQL help

iconRestoreDefaultSize restore the default size and position of the debugger window

Debug

iconExecute run the procedure/trigger

reset procedure/trigger execution

trace into a procedure that is called from the current procedure

step over the procedure that is called from the current procedure

run the procedure until return to the upper-level procedure

run the procedure/trigger to the cursor position

Tools

iconCommit commit retaining

open the I nput Parameters dialog

toggle breakpoint at the current statement

add watch at cursor

evaluate/modify a variable

toggle tracing embedded calls

Items of the Navigation bar are also available on the ToolBar of Procedure/Trigger Debugger. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Debugging procedure/trigger

The working area allows you to view the text of procedure/trigger definition.

The red spots ( [image]) at the left of the workspace and red highlight stand for enabled breakpoints;

the green spots ( [image]) and green highlight stand for disabled breakpoints;

the green arrow ( btnArrowRight) and blue highlight indicate the currently executed statement.

Procedure Debugger - Debugging procedure

For your convenience the following shortcuts are implemented:

  • To start executing the procedure step-by-step, press F8.
  • To trace into a procedure that is called from the current procedure, press F7.
  • To reset the procedure execution, press the Ctrl+F2 key combination.
  • To add/remove a breakpoint to/from the current statement, press the Ctrl+F8 key combination.
  • To run the procedure (to the end or to the next breakpoint), press F9.

Set mouse cursor over a parameter to see a hint with its current value.

Hint: Click an embedded procedure (or any other object) name with the Ctrl key pressed to open the object in its editor. For details see Using object links.

The lower area of the Procedure/Trigger Debugger window allows you to browse parameters and variables, watches, results, last statement, breakpoints, messages, call stack. For details see Browsing debug information.


Browsing debug information

Use tabs at the bottom of the debugger window to view miscellaneous debug information.

Parameters and Variables

This tab displays the list of procedure input and output parameters and variables (distinguished by respective icons) with their values and types.

Procedure Debugger - Debug info - Parameters and Variables

Double-click an item in the list to call the Modify Variable dialog allowing you to set the parameter/variable value.

Procedure Debugger - Debug info - Parameters and Variables - Modify Variable

Use the edit control to specify a value for the variable, or select the CheckBox Null option.

The controls vary according to the data type of the variable being edited:

  • for integral data types (SMALLINT, INTEGER), use the spinner control to specify the necessary value
  • for floating-point data types (FLOAT, NUMERIC, DOUBLE PRECISION, DECIMAL), type in or click the arrow-down button to call the Calculator popup window and set the necessary value
  • for string data types (CHAR, VARCHAR), use the editable area to input the necessary text
  • for temporal data types (DATE, TIME), type in or click the arrow-down button to call the Date editor popup window and set the required date value

Watches

Use this tab to manage watches for parameters and variables declared in the procedure being currently debugged.

Procedure Debugger - Debug info - Watches

The Watches list provides the following attributes of each parameter/variable of the procedure:

Name

Address (the name of the procedure to which the parameter or variable belongs)

Value

Type

Kind

Right-click an item in the list to call the context menu allowing you to select watches using the Add Watch dialog, to delete the selected watch, or to delete all watches.

The Add Watch dialog allows you to select the parameters and variables to add watch for.

Procedure Debugger - Debug info - Watches - Add Watch

To select a parameter/variable, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the parameters and variables from one list to another.

Results

If the procedure is supposed to return any results, this tab displays the intermediate execution results.

Procedure Debugger - Debug info - Results

Last Statement

This tab displays the last executed statement, the statement execution plan and other information such as execution time.

Procedure Debugger - Debug info - Last Statement

Breakpoints

This tab displays the breakpoints set in the procedure.

Procedure Debugger - Debug info - Breakpoints

The Breakpoints list provides the following attributes of each breakpoint of the procedure:

Address (the name of the procedure to which the breakpoint belongs)

Line (the line number where the breakpoint is set)

Condition

Eval expression

Passes (the number of times the execution has already passed through the breakpoint)

Right-click an item in the list to call the context menu allowing you to enable/disable, to specify properties using the Breakpoint Properties dialog, to delete the selected breakpoint, or to delete all breakpoints.

The Breakpoint Properties dialog allows you to view/edit properties for each breakpoint set in the procedure.

Procedure Debugger - Debug info - Breakpoints - Breakpoint Properties

Conditions

Condition

This field should contain the correct SQL statement returning a boolean value. The execution will stop at this breakpoint if the statement is true, and skip the breakpoint if it is false.

Pass count

Specify the number of passes for the breakpoint before the execution stops.

Actions

CheckBox Break

Enable the option to stop execution at this breakpoint.

Eval expression

Specify the correct SQL statement to evaluate some expression when passing through this point.

Messages

This tab displays various messages and errors received from the debugger after execution (if any).

Procedure Debugger - Debug info - Messages

Call Stack

Use this tab to see the stack (ordered log) of the procedure calls.

Procedure Debugger - Debug info - Call Stack

The parameters with which the procedure has been called are listed in the brackets after the procedure name.

A double-click on an item under the Breakpoints, Messages and Call Stack tabs leads to the corresponding call.


External Functions

An External function is a database function written entirely in a host language to perform data manipulation tasks not directly supported by InterBase/Firebird. It's executed on the server.

External functions give you the ability to create your own functions (like count) and integrate them in the database itself. Each external function is arranged as a function belonging to DLL. Thus, one dynamically loaded library consists of at least one function.

External Function Editor allows you to define user-defined function properties. It opens automatically when you declare a new user-defined function and is available on editing an existing one.

To open an external function External Function Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing external function
  • Browsing object dependencies
  • Editing object description
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in External function editor.

Object

iconDB select a database

iconSQLFunction select an external function for editing

General

iconCompile compile the external function (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the external function

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconOptions adjust Object Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

view the dependency tree for the external function

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the external function:

Input Arguments

iconPlus append a new input argument

btnArrowRight insert an input argument

iconMinus delete the selected input argument

btnArrowUp move the selected input argument up

btnArrowDown move the selected input argument down

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

NOTE: Items of the Navigation bar are also available on the ToolBar of UDF Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing external functions

Use the External Function tab of External Function Editor to view and edit external functions.

UDF Editor - Editing UDF definition

Name

Name of the external function to use in the SQL statements, or modify the name of the external function being edited (this name can be different from the name of the function specified as Entry point).

Entry point

Name of the external function in the source code as stored in the library that is referenced by the external function (ENTRY_POINT).

Library name

File name identifying the library that contains the external function (MODULE_NAME).

Input arguments

This group is provided for managing the list of input arguments passed to the external function.

Right-click the area to display the context menu allowing you to append, insert, delete the selected argument, or move it up/down.

Arguments management tools are also available through the Navigation bar and toolbar of External Function Editor.

Use the dropdown button to open Data Type Editor which allows you to define input argument data type properties.

Returns

This group allows you to select the data type / domain and set properties specific for this data type / domain. For details see Managing parameters.

By

Use the drop-down list to select the way to pass the return value – by value, by reference or by descriptor.

CheckBox Free it

This option frees memory of the return value after the external function finishes running (FREE_IT).

To compile an external function, you can use the iconCompile Compile item available within the Navigation bar or toolbar.

See also:

Managing parameters


SQL Functions

An SQL function is a program (the function body) that can be invoked by using zero or more input values (arguments) to a single value (the result). A Function can be stored as a database object providing reusable code.

SQL Function Editor allows you to define user-defined function properties. It opens automatically when you declare a new user-defined function and is available on editing an existing one.

To open an SQL Function Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing SQL function
  • Managing parameters\arguments\variables
  • Specifying input parameters
  • Browsing object dependencies
  • Setting object permissions
  • Editing object description
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in SQL Function editor.

Object

iconDB select a database

select an SQL function for editing

General

iconExecute execute the current SQL Function

iconCompile compile the SQL function (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the SQL function

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconVisualMode switches between Text and Visual editor modes

iconOptions adjust Object Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

view the dependency tree for the SQL function

iconGrantsOnObject define grants on the SQL Function

iconAutograntPrivileges set autogrant privileges for the SQL Function

iconDebugProcedure debug the SQL Function using Debugger

create a view based on the SQL Function

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the SQL function:

Input Arguments

iconPlus append a new input argument

btnArrowRight insert an input argument

iconMinus delete the selected input argument

btnArrowUp move the selected input argument up

btnArrowDown move the selected input argument down

Export list - use it to export the arguments list to the specified format

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

NOTE: Items of the Navigation bar are also available on the ToolBar of UDF Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing SQL Functions

Use the SQL Function tab of SQL Function Editor to view and edit SQL functions.

Name

Name of the SQL function.

SQL Function - Editing SQL Function

Input parameters

This group is provided for managing the list of input parameters passed to the SQL function.

The Input parameters list provides the following attributes of each input arguments of the SQL function:

Name, Default value, Parameter type, Not Null attribute and Description.

Click the arrow-down button to call Data Type Editor for setting properties of the parameter data type. It allows you to select the source type for the argument being created/edited. It can be one of existing domains, a standard InterBase/Firebird data type or a column.

Output parameters

This group is provided for managing the list of output parameters passed to the SQL function.

The Output parameters list provides the following attributes of each input arguments of the SQL function:

Name, Parameter type, Not Null attribute.

Click the arrow-down button to call Data Type Editor for setting properties of the parameter data type. It allows you to select the source type for the argument being created/edited. It can be one of existing domains, a standard InterBase/Firebird data type or a column.

Variables/Cursors

This group allows you to select the source type for the return parameter being created/edited. It can be one of existing domains or a standard InterBase/Firebird data type. For detailed information see Managing parameters.

The lower area allows you to specify the function body.

To compile an SQL Function use the iconCompile Compile item available within the Navigation bar or toolbar.

See also:

Managing parameters

Specifying input parameters


Triggers

A Trigger is an object in the database that is invoked when a particular SQL statement is run. In InterBase/Firebird, a trigger is a self-contained program associated with a table or view that automatically performs an action (fires) in response to a DML operation (when a row in the table or view is inserted, updated, or deleted).

Trigger Editor allows you to define trigger properties. It opens automatically when you create a new trigger and is available on editing an existing one.

To open a trigger in Trigger Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing trigger
  • Browsing object dependencies
  • Editing object description
  • Viewing object operations
  • Viewing DDL definition

See also:

Procedure/Trigger Debugger


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Trigger Editor.

Trigger Editor - Using Navigation bar

Object

iconDB select a database

select a trigger for editing

General

iconCompile compile the trigger (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the trigger

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconEditorMode toggle Text / Visual editor modes

iconOptions adjust Visual Mode Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

view the dependency tree for the trigger

iconAutograntPrivileges set autogrant privileges for the trigger

iconDebugProcedure debug the trigger using Procedure/Trigger Debugger

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the trigger:

Variable

iconPlus append a new variable

btnArrowRight insert a variable

iconMinus delete the selected variable

btnArrowUp move the selected variable up

btnArrowDown move the selected variable down

Message

iconPlus append a new message

btnArrowRight insert a message

iconMinus delete the selected message

btnArrowUp move the selected message up

btnArrowDown move the selected message down

Permissions

Grant

Grant with Grant Option

Revoke

Grant All

Grant All with Grant Option

Revoke All

Grant on All

Grant on All with Grant Option

Revoke on All

iconAddGranteeObject add a grantee object

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of Trigger Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing trigger

Use the Trigger tab of Trigger Editor to view and edit the trigger definition.

Trigger Editor provides two modes: Text editor and Visual editor. To switch between these editor modes, use the corresponding items available in the General group of the Navigation bar and toolbar.

Trigger Editor - Editing trigger definition

When in the Text editor mode, you can use the editor area to specify the trigger definition as SQL statement using a template, hence it is enough to simply edit the template using the editor area to make appropriate changes, and compile the trigger.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.

When in the Visual editor mode, you are provided with a set of widgets allowing you to benefit from graphical user interface while editing the object properties.

Name

Enter a name for the new trigger, or modify the name of the trigger being edited. Note that trigger name must be unique in the database.

For table

The drop-down list of tables and views allows you to select the table or view on which the trigger is executed.

Type

Select the trigger behavior type:

RadioButton Before

This selection specifies that the trigger is fired before the triggering SQL statement.

RadioButton After

This selection specifies that the trigger is fired only when all operations specified in the triggering SQL statement have executed successfully.

On event

Specify the data modification statement(s) that activate the trigger when it is tried against this table or view:

CheckBox Insert

CheckBox Update

CheckBox Delete

Position

Defines the order of firing triggers on the same event. Lower-number triggers fire first, thus trigger with the default position (0) will be the first trigger to fire.

CheckBox Is active

Activates/deactivates the trigger immediately after it is created. A disabled (inactive) trigger still exists as an object in the database, but does not fire.

Variables

This group is provided for managing the list of local variables declared and used only in the trigger.

The Variables list provides the following attributes of each variable used in the trigger:

Name (name of the variable, unique for variables within the trigger)

Default Value (a default value for the variable)

Variable Type (the data type of the variable, click the arrow-down button to call Data Type Editor for setting properties of the variable data type)

Description (description of the variable)

Right-click the area to display the context menu allowing you to append, insert, delete the selected variable, or move it up/down.

Variables management tools are also available through the Navigation bar and toolbar of Trigger Editor.

The Data Type Editor popup window allows you to define variable data type properties.

Parameter based on

This group allows you to select the source type for the variable being created/edited. It can be one of existing domains, a standard InterBase/Firebird data type or a column.

RadioButton Data type

Specifies that the parameter is based on a standard data type.

RadioButton Domain

Specifies that the parameter is based on a domain previously created in the database. Note that creating parameters based on a domain is only available for Firebird 2.1 and later.

RadioButton Column

Specifies that the parameter is based on a field.

Variable

This group allows you to select the data type / domain / column and set properties specific for this data type / domain / column. For details see Domain options, Options for standard data type.

Cursors

This group is provided for managing the list of cursors declared to define sets of rows that can be retrieved using the cursor.

The Cursors list provides the following attributes of each cursor used in the trigger:

Name (cursor name)

Query (the SELECT query that determines which rows to retrieve, click the arrow-down button to call Query Data editor for editing the query text)

Description (description of the cursor)

The Query Data popup window allows you to specify the SELECT query.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.

If more convenient, you can click the btnShowQueryBuilder button to call Query Designer for building the query visually.

The lower area allows you to specify the trigger body, i.e. an optional list of local variables and their data types and a block of statements in InterBase procedure and trigger language, bracketed by BEGIN and END. These statements are performed when the trigger fires. When editing the trigger, you can edit its body using the editor area to make appropriate changes, and recompile the trigger.

To compile a trigger, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


Managing trigger messages

The Messages tab is provided for displaying the list of trigger messages associated with the system trigger.

Trigger Editor - Managing trigger messages

See also:

System objects


Exceptions

Exceptions are user-defined errors and messages for use in stored procedures and triggers.

When raised by a trigger or a stored procedure, the exception:

  • terminates the trigger or procedure in which it was raised and undoes any actions performed (directly or indirectly) by it;
  • returns an error message to the calling application.

Exception Editor allows you to define exception properties. It opens automatically when you create a new exception and is available on editing an existing one.

To open an exception in Exception Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing exception
  • Browsing object dependencies
  • Editing object description
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Exception Editor.

Exception Editor - Using Navigation bar

The Navigation bar of Exception Editor allows you to:

Object

iconDB select a database

select an exception for editing

General

iconCompile compile the exception (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the exception

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconOptions adjust Object Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

view the dependency tree for the exception

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the exception:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of Exception Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing exception

Use the Exception tab of Exception Editor to view and edit the exception definition.

Exception Editor - Editing exception definition

Name

Enter a name for the new exception, or modify the name of the exception being edited. Note that exception name must be unique among exception names in the database.

Text

Text of the message displayed when the exception is raised. The maximum allowed string length is 78 characters.

To compile an exception, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


Generators

A Generator is a sequential number that can be automatically inserted in a column. A generator is often used to ensure a unique value in a PRIMARY KEY, such as an invoice number, that must uniquely identify the associated row.

Generator Editor allows you to define generator properties. It opens automatically when you create a new generator and is available on editing an existing one.

To open a generator in Generator Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing generator
  • Browsing object dependencies
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Generator Editor.

Generator Editor - Using Navigation bar

The Navigation bar of Generator Editor allows you to:

Object

iconDB select a database

select a generator for editing

General

iconCompile compile the generator (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the generator

iconRefresh refresh the content of the active tab

iconOptions adjust Object Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

view the dependency tree for the generator

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the generator:

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of Generator Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing generator

Use the Generator tab of Generator Editor to view and edit the generator definition.

Generator Editor - Editing generator definition

Name

Enter a name for the new generator, or modify the name of the generator being edited. Note that generator name must be unique among generator names in the database.

Value

Use the spinner control to set a starting value for the generator.

Initial value

Start value of the generator.

Increment

Allows to specify an increment for the next value.

To compile a generator, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


BLOB Filters

A Binary Large Object (or BLOB) is a collection of binary data stored as a single entity in a database management system. BLOBs are typically images, audio or other multimedia objects, though sometimes binary code is stored as a BLOB.

BLOB filters are routines for Blobs. They translate Blob data from one type to another, i.e. they allow the contents of Blob subtype X to be displayed as subtype Y, or vice versa. These filters are ideal tools for certain binary operations, such as the compression and translation of Blobs, depending upon the application requirements.

Blob filters are written in the same way that UDFs are written, and are generally part of standard libraries, just as UDFs are.

BLOB Filter Editor allows you to define BLOB filter properties. It opens automatically when you declare a new BLOB filter and is available on editing an existing one.

To open a BLOB filter in BLOB Filter Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing BLOB Filter
  • Browsing object dependencies
  • Editing object description
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in BLOB Filter Editor.

BLOB Filter Editor - Using Navigation bar

The Navigation bar of BLOB Filter Editor allows you to:

Object

iconDB select a database

select a BLOB filter for editing

General

iconCompile compile the BLOB filter (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the BLOB filter

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconOptions adjust Object Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

view the dependency tree for the filter

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the BLOB filter:

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of BLOB Filter Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing BLOB Filter

Use the BLOB Filter tab of BLOB Filter Editor to view and edit the BLOB filter definition.

BLOB Filter Editor - Editing BLOB Filter definition

Name

Enter a name for the new filter to use in the SQL statements, or modify the name of the filter being edited. Note that filter name must be unique among filter names in the database.

Entry point

Name of the BLOB filter in the source code as stored in a linked library (ENTRY_POINT).

Library name

File name identifying the object module in which the filter is stored (MODULE_NAME).

Each filter declared to the database should have a unique combination of input type and output type integer values. The server provides a built-in type of 1, for handling text. User-defined types are expressed as negative values.

From subtype

Indicates the Blob subtype from which data is to be converted (INPUT_TYPE).

To subtype

Indicates the Blob subtype into which data is to be converted (OUTPUT_TYPE).

To compile a BLOB filter, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


Journals

Database Journaling improves VLDB management and facilitates disaster recovery. When journaling is enabled, all transaction changes are safely recorded on durable storage before the transaction is committed. This guarantees the ACID properties of a transaction (the database industry standards for Atomicity, Consistency, Isolation, and Durability).

A Journal archive is the set of destination directories that will hold the current set of journal files for a particular database. The purpose of the journal archive is to support long-term database recovery.

Note that Journaling is only available on the Server Edition of InterBase 2009 and higher.

Creating Journal

To create a journal:

  • select the Database | New Object... main menu item;
  • select Journal in the Create New Object dialog;
  • define journal properties using the appropriate tabs of Journal Editor.

Hint: To create a journal, you can also right-click the Journal node in the DB Explorer tree and select the Create Journal item from the context menu.

After the journaling configuration is set, to archive a database or journal files to the archive:

  • select the Database | New Object... main menu item;
  • select Journal in the Create New Object dialog;
  • follow instructions of Backup Database wizard.

Hint: To archive a database or journal files, you can also right-click the Journal node in the DB Explorer tree and select the New Journal... item from the context menu.

Viewing Journal

To view journal configuration:

  • right-click the Journal node in the DB Explorer tree and select the View Journal context menu item, or simply double-click the node;
  • view journal journaling configuration using the appropriate tabs of Journal Editor.

Sweeping Journal

To sweep archives until the sequence number:

  • right-click the archive with the required sequence number within the Journal node in the DB Explorer tree and select the Tasks | Sweep Until... context menu item;
  • confirm sweeping in the dialog window.

Dropping Journal

To drop a journal:

  • right-click the Journal node in the DB Explorer tree and select the Drop Journal context menu item;
  • confirm dropping in the dialog window.

Note: If more convenient, you can also use the following shortcuts:

Ctrl+N to create a journal.


Journal Editor

Journal Editor allows you to define journal properties. It opens automatically when you create a new journal and is available on editing an existing one (see Create journal and Edit journal for details).

To open a journal in Journal Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/viewing journal
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Journal Editor.

Journal Editor - Using Navigation bar

The Navigation bar of Journal Editor allows you to:

General

iconCompile compile the journal configuration (if it is being initially set)

iconShowSQLHelp show SQL help

iconOptions adjust Object Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

iconCreateArchive create database backup

iconSweepUntil sweep backups until current sequence

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the journal:

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

Items of the Navigation bar are also available on the ToolBar of Journal Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/viewing journal

The Journal tab of Journal Editor allows you to set options that control the journaling configuration of the database.

Journal Editor - Setting journaling configuration options

Directory

Type in or use the ExplorerButton button to specify the full path to the journal file.

Base file name

Enter the base file name of the journal file.

Journal attributes

Length

Specifies the number of pages that will be written to the journal file before initiating a rollover to a new journal file. A single journal file is limited to 2GB in size.

Page size

Determines the size (in bytes) of a journal page. A journal page size must be at least twice the size of a database page size. If a journal page size of less is specified, it will be rounded up to twice the database page size and a warning will be returned.

Page cache

Determines the number of journal buffers that will be allocated. The size of each buffer is the same as the journal page size.

Checkpoint length

Determines the number of journal pages to be written before initiating a database checkpoint.

Checkpoint interval

Determines the number of seconds between database checkpoints.

Note: If both Checkpoint length and Checkpoint interval are specified, whichever event occurs first will initiate a database checkpoint.

CheckBox Preallocate

Use this option to reserve specified amount (in pages) of disk space for the journal.

CheckBox Use timestamp name

Determines whether or not the file creation timestamp will be appended to the base journal file name. If this option is enabled, the base journal file name will be appended with a timestamp of the form:

<YYYY>_<MM>_DD>T<hh>_<mm>_ss>Z.<sequence-number>.journal

To execute CREATE JOURNAL with the specified parameters and CREATE JOURNAL ARCHIVE, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


Journal management

All journal archive items within the Journals node are denoted by an archive sequence number that corresponds to the order in which the items were created in the archive.

Creating new backup archives

As the number of journal files grows in the archive, when you have not created more recent archived database dumps, the time that you will need to recover a database from the archive also grows. Therefore, it is a good practice to periodically create additional database dumps in the archive.

To create a new backup archive, right-click the Journal node and select the New Journal... item from the context menu. Backup Database wizard will guide you through the process of creating a new backup.

Journals - New archive

Sweeping

The archive may grow in storage size infinitely, as the database and the current journal files are continually archived. To garbage-collect archive items less than an archive sequence number, right-click the archive with the required sequence number within the Journal node in the DB Explorer tree and select the Tasks | Sweep Until... item from the context menu.

Journals - Sweep

Dropping journal

Dropping journal disables journal archiving for the database. It causes all journal files and database file dumps to be deleted in all journal archive directories. To drop the journal, right-click the Journal node and select the Drop Journal context menu item.

Journals - Drop

Viewing journal

Created journals can be opened to view. The appeared dialog allows all the operations described above except dropping journal. This how this dialog looks:

Journals - View

Table provides information about sequences. You can iconCreateArchive create new archive or iconSweepUntil sweep backups using corresponding context menu or navigation bar items.


Database Triggers

A Database trigger is a PSQL module that is executed when a connection-level or transaction-level event occurs.

Database triggers are used only for centralized, global operations that should be fired for the triggering statement, regardless of which user or database application issues the statement.

Note that Database triggers are only available on Firebird 2.1 and higher.

Database Trigger Editor allows you to define database trigger properties. It opens automatically when you create a new database trigger and is available on editing an existing one.

To open a database trigger in Database Trigger Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing DB Trigger
  • Browsing object dependencies
  • Editing object description
  • Viewing object operations
  • Setting object permissions
  • Viewing DDL definition


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Database Trigger Editor.

Object

iconDB select a database

select a database trigger for editing

General

iconCompile compile the database trigger (if it is being created/modified)

iconShowSQLHelp show SQL help

iconPrint set printing options to print metadata of the database trigger

iconQuickSave save the object using the Quick Save feature

iconQuickLoad load the object from buffers using the Quick Load feature

iconRefresh refresh the content of the active tab

iconEditorMode toggle Text / Visual editor modes

iconOptions adjust Visual Mode Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

Tools

view the dependency tree for the database trigger

iconGrantsOnObject define grants on the database trigger

iconAutograntPrivileges set autogrant privileges for the database trigger

iconDebug debug the database trigger using Procedure/Trigger Debugger

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the database trigger:

Variable

iconPlus append a new variable

btnArrowRight insert a variable

iconMinus delete the selected variable

btnArrowUp move the selected variable up

btnArrowDown move the selected variable down

Message

iconPlus append a new message

btnArrowRight insert a message

iconMinus delete the selected message

btnArrowUp move the selected message up

btnArrowDown move the selected message down

Permissions

iconAddGranteeObject add a grantee object

Description

iconSaveToFile save object description to file

iconCopyToClipboard copy description to clipboard

DDL

iconSaveToFile save DDL to file

open DDL in Execute Script

NOTE: Items of the Navigation bar are also available on the ToolBar of Database Trigger Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing DB Trigger

Use the Database Trigger tab of Database Trigger Editor to view and edit the database trigger definition.

Database Trigger Editor provides two modes: Text editor and Visual editor. To switch between these editor modes, use the corresponding items available in the General group of the Navigation bar and toolbar.

Database Trigger Editor - Editing DB Trigger definition

When in the iconVisualMode Text editor mode, you can use the editor area to specify the database trigger definition as SQL statement using a template, hence it is enough to simply edit the template using the editor area to make appropriate changes, and compile the database trigger.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and using the context menu.

When in the Visual editor mode, you are provided with a set of widgets allowing you to benefit from graphical user interface while editing the object properties.

Name

Enter a name for the new database trigger, or modify the name of the trigger being edited. Note that database trigger name must be unique in the database.

Trigger type

RadioButton Database

The trigger is created for the database event. Use the On event group to specify the triggering event

RadioButton DDL

The trigger is executed only when committing the transaction in which the affected DDL command runs. Check the required DDL statement(s) from the On event group.

On event

If the RadioButton Database trigger has been selected:

CheckBox Connect

  • Database connection established
  • A transaction is started
  • Triggers are fired - uncaught exceptions rollback the transaction, disconnect the attachment and are returned to the client
  • The transaction is committed

CheckBox Disconnect

  • A transaction is started
  • Triggers are fired - uncaught exceptions rollback the transaction, disconnect the attachment and are swallowed
  • The transaction is committed
  • The attachment is disconnected

CheckBox Transaction Start

  • Triggers are fired in the newly user created transaction - uncaught exceptions are returned to the client, and the transaction is rolled back

CheckBox Transaction Commit

  • Triggers are fired in the committing transaction - uncaught exceptions rollback the triggers savepoint, the commit command is aborted, and the exception is returned to the client

CheckBox Transaction Rollback

Triggers are fired in the rollback of the transaction - changes done will be rolled back together with the transaction; exceptions are swallowed.

If the RadioButton DDL trigger type has been selected the list of available DDL statements is displayed.

Position

Defines the order of firing database triggers on the same event. Lower-number triggers fire first, thus trigger with the default position (0) will be the first trigger to fire.

CheckBox Is active

Activates/deactivates the database trigger immediately after it is created. A disabled (inactive) trigger still exists as an object in the database, but does not fire.

Variables

This group is provided for managing the list of local variables declared and used only in the database trigger.

Parameter based on

This group allows you to select the source type for the variable being created/edited. It can be one of existing domains, a standard InterBase/Firebird data type or a column.

RadioButton Data type

Specifies that the parameter is based on a standard data type.

RadioButton Domain

Specifies that the parameter is based on a domain previously created in the database. Note that creating parameters based on a domain is only available for Firebird 2.1 and later.

RadioButton Column

Specifies that the parameter is based on a field.

Data type

Database Trigger Editor - Editing DB Trigger definition - Data Type

Variable

For NUMERIC and DECIMAL data types set digit precision (digits of precision to store, 1 to 18) and scale (number of decimal places that can be stored, 1 to 18) in the appropriate boxes; for CHAR and VARCHAR set length (in characters), for BLOB data type set segment size and subtype. You can also set the variable character set and collation order within this group.

Domain

Database Trigger Editor - Editing DB Trigger definition - Domain

Use the Domain drop-down list of existing domains to select the domain to be used for the variable. The collation drop-down list is only available if the selected domain is based on a string data type. Use this drop-down list to select the collation order to be used for string data stored in the variable.

To edit the selected domain using Domain Editor, click the Edit Domain button.

To create a new domain for the field using Domain Editor, click the New Domain button.

Column

Database Trigger Editor - Editing DB Trigger definition - Column

Column group contains Table name and Field name drop-down lists that can be used to define the the column variable should be based on. Within the Collation drop-down list you can set the collation order.

The Not NULL and Use default value options are common for all types.

CheckBox Not NULL

This option indicates if a variable can contain NULL values.

CheckBox Use default value

With this option you can set the default variable value.

Cursors

This group is provided for managing the list of cursors declared to define sets of rows that can be retrieved using the cursor.

Procedure Editor - Managing parameters - Cursors

For details refer to Creating/editing trigger.

The lower area allows you to specify the trigger body, i.e. an optional list of local variables and their data types and a block of statements in InterBase procedure and trigger language, bracketed by BEGIN and END. These statements are performed when the trigger fires. When editing the trigger, you can edit its body using the editor area to make appropriate changes, and recompile the trigger.

To compile a database trigger, you can use the iconCompile Compile item available within the Navigation bar or toolbar.


Collations

A Collation is an object in the database that set comparison rules for text data in the database. The collation must already be present on your system (typically in a library file) and must be properly registered in a .conf file in the intl subdirectory of your Firebird installation. You may also base the collation on one that is already present in the database.

Collation Editor allows you to define collation properties. It opens automatically when you create a new collation and is available on editing an existing one.

To open a collation in Collation Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing collation


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Database Trigger Editor.

Object

iconDB select a database

iconCollation select a collation for editing

General

iconCompile compile the collation (if it is being created/modified)

iconPrint set printing options to print metadata of the collation

iconRefresh refresh the content of the active tab

iconOptions adjust Visual Mode Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

NOTE: Items of the Navigation bar are also available on the ToolBar of Database Trigger Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing collation

Use the Collation tab of Collation Editor to view and edit the collation definition.

Collation Editor - Editting collation

Name

Enter a name for the new collation, or modify the name of the collation being edited.

For charset

Use the dropdown list to select the charset present in the database.

From

Select the collation from the existing ones in Base name, or check the CheckBox External option and specify the name manually. The name should strongly correspond to the collation existing in $fbroot/intl/fbintl.conf file.

Collation attributes

CheckBox Pad space

Set this option ON to exclude pad spaces.

CheckBox Case insensitive

Set this option ON not to consider case in collations.

CheckBox Accent insensitive

Set this option ON not to consider accents in collations.

Set the CheckBox Use special attributes flag to add specific attributes to the collation.

Specify the Collation locale manually. It required to specify the exact Version of ICU library to use, or switching on the CheckBox Use default option.

CheckBox Disable compression of certain character sequence

Use this option to disable compression of certain character sequence. Compressions cause certain character sequences to be sorted as atomic units.

CheckBox Disable expansions of certain characters into character sequences

Use this option to treat certain characters as a sequence of characters and sort accordingly.

CheckBox Use more than one ordering level

Use this option to enable multi-level sorting.

CheckBox Order special characters before alphanumeric characters

Use this option to sort special characters before alphanumeric ones.

CheckBox Sort numeric characters in numerical order

Use this option to enable natural sorting order.


Packages

A package is a group of procedures and functions managed as one entity.

Note that Packages are only available on Firebird 3.0 and higher.

Package Editor allows you to define package properties and content. It opens automatically when you create a new package and is available on editing an existing one.

To open a package in Package Editor, double-click it in the DB Explorer tree.

  • Using Navigation bar and Toolbar
  • Creating/editing package


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Package Editor.

Object

iconDB select a database

select a package for editing

General

iconCompile compile the package (if it is being created/modified)

iconPrint set printing options to print metadata of the package

iconRefresh refresh the content of the active tab

iconOptions adjust Visual Mode Editors options

iconRestoreDefaultSize restore the default size and position of the editor window

NOTE: Items of the Navigation bar are also available on the ToolBar of Package Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Creating/editing package

Use the Header and Body tabs of Package Editor to view and edit the package definition.

Package Editor - Editing package

Package name

Enter a name for the new package. The name of the existing package cannot be modified.

Specify the package header definition in the text editor area. The body of the package can be defined in the text area at the Body tab.


Query Tools

When using SQL Manager for InterBase/Firebird, you are provided with two basic tools you may need to manage your SQL queries: Query Data for editing SQL query text directly and Query Designer for building queries visually. Find the list of common SQL query management operations below.

Creating New Queries

In order to create a new query in Query Data:

  • select the Tools | Query Data main menu item or use the corresponding btnNewSQLEditor toolbar button;
  • click the Add new query item of the Navigation bar;
  • edit the query text within the Edit tab of Query Data.

In order to create a new query in Query Designer:

  • select the Tools | Query Designer main menu item or use the corresponding btnNewQueryBuilder toolbar button;
  • build the query visually within the Builder tab of Query Designer.

Editing Queries

In order to open a query in Query Data:

  • select the Tools | Query Data main menu item or use the corresponding btnShowSQLEditor toolbar button;
  • use the numbered tabs at the bottom of the editor window to switch between previously edited queries. The last edited query is displayed automatically on opening the editor;
  • edit the query text within the Edit tab of Query Data.

In order to open a query in Query Designer:

  • select the Tools | Query Designer main menu item or use the corresponding btnShowQueryBuilder toolbar button;
  • the last edited query is displayed automatically on opening Query Designer;
  • to load a previously saved diagram, click the Load diagram item of the Navigation bar;
  • to load a query from an *.sql file, open the Edit tab and click the Load SQL button of the Navigation bar;
  • edit the query visually within the Builder and/or the Edit tabs of Query Designer.

In order to load a query from an *.sql file:

  • select the Tools | Query Data main menu item or use the corresponding btnNewSQLEditor toolbar button;
  • click the Load from file item of the Navigation bar;
  • browse for the query file using the Open SQL File dialog;
  • edit the query text within the Edit tab of Query Data.

Executing Queries

In order to execute a query:

  • create a new query or open an existing one;
  • click the btnExecuteQuery Execute item of the Navigation bar or use the F9 hot-key to execute the query;
  • view/edit the returned data within the Results tab of Query Data.

Saving Queries

In order to save a query:

  • create a new query or open an existing one;
  • click the Save to file Navigation bar item (in Query Data) or the Save SQL Navigation bar item (in Query Designer), or use the Ctrl+S shortcut to save the query using the Save as... dialog;
  • click the Save diagram Navigation bar item in Query Designer to save the designed diagram;

or

  • use the Save all Navigation bar item in Query Data if you need to save all the queries to one file.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Data Management

Import/Export Tools

Database Tools

Services

Security management

Options

External Tools

How To...


Query Data

Query Data is the basic tool of SQL Manager for InterBase/Firebird for creating and executing queries. The tool allows you to create and edit the SQL text of a query, prepare and execute queries and view the results of query execution.

To open Query Data editor select the Tools | Query Data main menu items or use the corresponding btnShowSQLEditor toolbar button. You can also use F12 shortcut for the same purpose.

  • Using Navigation bar and Toolbar
  • Working with query
  • Using the context menu
  • Viewing query plan
  • Using object links
  • Executing queries and viewing results
  • Viewing query logs
  • Favorites editor
  • Viewing performance analysis

See also:

Query Designer

Query parameters

Execute Script Editor

Editor Options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Query Data.

Database

iconDB select a database for the query

General

iconAutoDDL toggle AutoDDL

iconExecute execute the current query

iconExecuteSelectedOnly execute selected code only

iconExecuteUnderCursor execute code under cursor

iconCompile prepare query for execution

view estimated query execution plan

run Query Designer to design the query as a diagram

iconOptions configure Query Data within the Tools | Query Data page of the Environment Options dialog

switch the results representation mode: on Edit tab or on separate tab

iconShowSQLHelp show SQL help

create a view based on the query

create a procedure based on the query

iconRestoreDefaultSize restore the default size and position of the editor window

Queries

add a new query (note that the current query text will not be lost)

rename the current query

remove the query

remove all queries from the editor

edit the query text using Favorites editor and add the query to the Favorite Queries list

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with queries:

Edit

iconFindText activate the Find Text dialog

iconLoadFromFile load a query from an *.sql file using the Open SQL File dialog

iconSaveToFile save the query to an *.sql file

iconSaveAll save all queries to an *.sql file

Logs

iconFindText activate the Find Text dialog

iconSaveToFile save the query log to a file

clear logs

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export the returned dataset using Export Data Wizard

export the returned dataset as SQL Script using the Export as SQL Script wizard

import data

Items of the Navigation bar are also available on the ToolBar of Query Data. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

See also:

Working with query

Viewing query plan

Executing queries

Viewing query logs

Favorites editor


Working with queries

The Editor area of Query Data is available within the Edit tab and is provided for working with SQL queries in text mode.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented:

  • using object links allowing you to open the object in the associated editor;
  • ability to display line numbers;
  • code folding for statements and clauses;
  • customizable margins and gutters;
  • formatting code for better representation

and more.

If necessary, you can enable/disable or customize most of Query Data features using the Editor Options dialog.

The example of code completion is illustrated in the picture below. You can set the delay within the Quick code section of the Editor Options dialog or activate the completion list manually by pressing the Ctrl+Space shortcut.

SQL Editor - Working with SQL Editor area

Hint: To use a keyboard template, type the template name and press the Ctrl+J shortcut: the text associated with the template will be inserted automatically.

If necessary, you can print the SQL text of your query using the corresponding item of the context menu.

See also:

Using Navigation bar and Toolbar

Using the context menu

Editor Options

Keyboard Templates

Favorites editor

Find Text dialog

Replace Text dialog


Using the context menu

The context menu of Query Data area contains execution commands, most of the standard text-processing functions (Cut, Copy, Paste, Select All) and functions for working with the query as a whole, e.g. you can move the cursor to a particular line, change the case of selected text, view the query properties or print the text of the query. Each of these operations can be also performed with the corresponding hot keys used.

Implementation of the Find Text / Replace Text dialogs and Incremental search bar contributes to more efficient work with the SQL code.

Find the complete list of Query Data context menu items below. The context menu allows you to:

  • add the selected text to dictionary or correct text (see Spell checking for details);
  • execute the query/selected text/text under cursor, and reset execution point (if necessary);
  • manage markers: Drop Marker, Collect Marker, Swap Marker;
  • toggle bookmarks allowing you to navigate through the query text and jump to a line with a particular number;
  • perform editing operations: Undo/Redo, Cut, Copy, Paste, Select all;
  • perform search and replace operations;
  • export data of selected query;
  • perform preview/print operations;
  • use the Quick code group allowing you to format the selected code using SQL Formatter to make the code easier to read, toggle comments for code fragments, change case of the selected text, indent/unindent code lines;
  • open the Editor Options dialog.

SQL Editor - Using the context menu

See also:

Working with query

Executing queries


Viewing query plan

Using SQL Manager for InterBase/Firebird, you can view the plan for each of the queries created and executed in the application. The query plan is available within the corresponding Plan tab.

To view the Plan of a query, open the query in Query Data and use the btnExplainQuery Explain query item of the Navigation bar or toolbar.

The Plan tab allows you to view the sequence of actions performed by the database server in the process of the query execution, and the amount of system resources used for the query execution.

SQL Editor - Viewing query plan

The Operation panel below displays the operations as a tree list with the following columns: Operation, Object type, Object name, Alias, Fields.

Right-click within the panel to display the context menu allowing you to configure the set of visible columns or export the plan to any of supported formats.

If necessary, you can specify that the Plan tab appears automatically upon query execution in Query Data: select the CheckBox Explain query on execution option available within the Tools | Query Data section of the Environment Options dialog.

See also:

Query Data options

Executing queries


Using object links

Objects that exist in the database are highlighted in the text as hyperlinks. You can open an object in the appropriate editor by clicking the object name in the text with the Ctrl key pressed.

SQL Editor - Using object links

Please note that you can change the way highlighted objects look in the editor: use the Display | Highlight section of the Editor Options dialog.

See also:

Working with query

Editor Options


Executing queries

When all the query parameters are set, you can immediately execute the query in Query Data.

To execute a query, click the btnExecuteQuery Execute item of the Navigation bar. You can also use the context menu or F9 hot key for the same purpose.

If the SQL syntax is correct, the query is executed and, in case the query statement is supposed to return data (e.g. as SELECT statement), the returned dataset appears within the Results tab. The position of the tab depends on the Results on Edit tab / Results on separate tab selection in the Navigation bar.

If SQL syntax of the query contains any errors, the query execution is stopped and the corresponding error message is displayed in the status bar area at the bottom of the editor window.

SQL Editor - Executing queries

By default, data returned by a query are displayed as a grid (see Data View for details). The context menu of the grid allows you to Export Data, Export as SQL Script.

SQL Editor - Viewing results

You can see brief statistics concerned query execution. Expand the bottom pane for this purpose.

SQL Editor - Brief performance statistics

See also:

Data View

Export Data

Export as SQL Script


Viewing query logs

This tab allows you to view the query log. The log is available within the Logs tab of Query Data.

Using this tab you can view log entries containing the following details:

  • date and time of the query execution;
  • text of the query;
  • number of rows fetched and fetch time, or the text of the error (if any).

Date/time and the execution result information are embedded as code comments conforming with the rules of SQL.

With the help of the context menu the log can be printed, saved to file or cleared. You can also use a number of Query Data context menu generic functions.

SQL Editor - Viewing query logs

See also:

Executing queries

Using the context menu


Favorites editor

For your convenience the Favorite Queries list is implemented in SQL Manager for InterBase/Firebird. This list is available within the iconFavoriteQueries Favorite Queries node of Database Explorer and allows you to store the most frequently used SQL queries in one location.

To add a query to the Favorite Queries list, use the [image] Add to Favorite Queries Navigation bar item in Query Data. The corresponding item is also available in the context menu of Query Data working area.

You can edit any of your Favorite Queries using Favorites editor.

SQL Editor - Favorites editor

Name

Set the name of the Favorite query.

Storage

Specify where the Favorite query will be stored: in Windows Registry or in the Database.

See also:

Managing Favorite queries

Working with query


Design Query

Query Designer is implemented in SQL Manager for InterBase/Firebird for building queries visually. The tool allows you to create and edit queries without deep knowledge of SQL. You can also prepare and execute queries, and view the results of their execution.

To open Query Designer select Tools | btnShowQueryBuilder Design Query main menu items or use the corresponding btnShowQueryBuilder toolbar buttons.

  • Using Navigation bar and Toolbar
  • Working with diagram area
  • Joining two database objects by fields
  • Setting the selection criteria
  • Setting output fields for selection
  • Setting the grouping criteria
  • Setting parameters of sorting
  • Working with editor area
  • Executing queries and viewing results
  • Viewing query plan
  • Viewing performance analysis

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Query Data

Query parameters


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Query Builder.

Query Builder - Using Navigation bar

The Navigation bar of Query Builder allows you to:

Database

iconDB select a database for the query

General

iconExecute execute the current query

view estimated query execution plan

clear the query

create a view based on the query

create a procedure based on the query

iconShowSQLHelp show SQL help

iconOptions configure Query Builder using the Query Builder Options page of the Environment Options dialog

iconRestoreDefaultSize restore the default size and position of the builder window

Objects

iconDBExplorer browse objects of the database; you can also add tables, views and procedures to the diagram using drag-and-drop operations

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with queries:

Visual Builder

iconLoadFromFile load a diagram from a *.vqb file using the Open diagram dialog

iconSaveToFile save the diagram to a *.vqb file using the Save diagram as... dialog

Edit

iconLoadFromFile load a query from an *.sql file using the Open SQL File dialog

iconSaveToFile save the query to an *.sql file

Data Management

iconCommit commit transaction

iconRollback rollback transaction

export the returned dataset using Export Data Wizard

export the returned dataset as SQL Script using the Export as SQL Script wizard

Items of the Navigation bar are also available on the ToolBar of Query Builder. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

See also:

Working with diagram area

Query execution


Working with diagram area

The main working area of Query Designer is the diagram area available within the Builder tab. Here you can create a query by placing the database tables and views onto the area, and edit it by selecting the required data fields and setting links between objects.

To add an object to the query, you can simply drag it from the DB Explorer tree to the diagram area.

To include a field in the query, check the corresponding box located to the left from the field name in the list, or just double-click it. To include all fields of the table/view, check the box located to the left of the table/view caption. If you do not check any fields, the SQL statement is generated as SELECT * FROM <table/view_name>, i.e. all the fields are included in the query.

To collapse/expand the list of table/view fields, click the minimize/maximize button at the object caption.

To exclude a field from the query, uncheck the respective box. In order to remove the entire table/view from the query, close it by clicking the corresponding cross-button at the object caption, or right-click the object and select Delete from the context menu. You can also select the object and press the Del key.

To edit the alias of a table/view, double-click the object caption and enter the new name, or right-click the object and select Rename from the context menu.

Query Builder - Working with diagram area

Query Designer allows you to create complex queries consisting of two or more queries combined in one with the UNION operator, or add nested queries. The panel to the left of the diagram area displays the tree of subqueries.

To add a query, right-click within the tree of subqueries area and select Add union from the context menu. A tab for the new query will appear in the diagram area.

To remove a query from the tree, right-click the query and select Delete union from the context menu.

To add the UNION ALL operator to the query, right-click the newly added query and select the corresponding context menu item.

Visual Query Builder - Union

Note: Depending on which query type you need to execute, you can select one from the drop-down list above the tree of subqueries: Select, Insert, Update, or Delete.

Visual Query Builder - Selecting query type

See also:

Joining two objects

Working with the editor area

Query execution


Joining two objects

The diagram area allows you to associate two objects by their fields: this operation is performed by dragging a field from one object list to another. This will set a link between these objects by the selected fields. It is indicated by a bidirectional arrow between the linked fields.

Note: Once two or more tables related by a foreign key are added to the diagram area, the corresponding visual joining of these tables appears at the Builder tab and the JOIN statement appears under the Edit tab.

Query Builder - Joining two objects

You can view the link properties of objects association: set the mouse cursor over the linking arrow, and a hint containing the association condition will popup after a short delay.

To edit the link properties, double-click the linking arrow or right-click it and select the Property popup menu item. The Link properties dialog allows you to change the association condition by choosing it from the drop-down list (=, >, <, >=, <=, <>).

Query Builder - Link properties

For your convenience the CheckBox Include all option is available for each object of the association:

if the option is enabled for the left table, the LEFT JOIN operator will be used for the association;

if the option is enabled for the right table, the RIGHT JOIN operator is used for the association;

if the option is enabled for neither of the tables, the INNER JOIN operator is used for the association.

Click OK to apply the changes you have made.

To remove a link between objects, right-click the linking arrow and select the Delete link popup menu item.

To add a point to the link line, right-click the linking arrow and select the Insert point popup menu item. Using the point you can move the link line easily. The point does not cause any changes to the query, it is only used for the diagram representation and makes visual building handy and more comprehensible.

Visual Query Builder - Link menu

See also:

Working with diagram area

Setting criteria


Setting criteria

Use the Criteria tab to set the selection conditions.

The way the conditions are used is set in the upper string of the area (All, Any, None or Not all of the following are met). Click the green link to change it.

Visual Query Builder - Criteria menu

To add a condition, click the ellipsis EllipsisButton button on the left, and select the Add condition popup menu item.

Edit the condition by clicking the elements of the condition pattern and setting the necessary values. Clicking the numbered button to the left of the condition string activates the popup menu which allows you to add a new condition at the same enclosure level, make composite condition by adding a new enclosure level, delete the current condition, expand or collapse enclosure levels of the condition (if the condition is composite).

Visual Query Builder - Condition menu

A simple condition pattern contains three elements: an argument, a condition operator and a second argument (if required for the condition).

Clicking each element field allows you to set its value. You can add a field by drag-and-dropping it from the working area to Criteria, Selection, Grouping criteria or Sorting tabs. When clicking an argument field, you can edit the argument as a text string: set an object name or a certain value in this field. Right-clicking the field in the edit mode activates the popup menu with the Insert field (also called by the Shift+Enter shortcut; this item allows you to select a field from the list of all the table fields) and Insert query (this item adds a nested query) items.

Query Builder - Setting criteria

Clicking the condition operator field activates the popup menu from which you can select the operator you need.

See also:

Setting output fields

Setting grouping criteria

Setting sorting parameters


Setting output fields

The Selection tab displays the output fields of the query as a grid.

The grid allows you to edit the names of the query output fields, specify their display order and set the aggregate functions for each field. To remove a field from the list, right-click the field row and select the Delete current row popup menu item.

Visual Query Builder - Selection field menu

The popup menu also allows you to insert a nested query and add a CASE clause. To edit the CASE clause, use the CASE END AS dialog.

Query Builder - Setting output fields - CASE

To change the input query field, click it and then type the field name or select it from the drop-down list.
To change the output query field name, set the cursor at the corresponding column and type the required field name.

To reorder fields in the list, use the [image] [image] buttons.

Query Builder - Setting output fields

To set an aggregate function for a field, click the field row within the Aggregate column, and then type in the function name or select one from the drop-down list (SUM, MIN, MAX, AVG, or COUNT).

The Grouping column displays the grouping state for each of the output fields.

CheckBox2 Select only unique records

If you check this option, the duplicate records (if any) are not included into the query result (i.e. the DISTINCT keyword is added to the SQL query text).

See also:

Setting criteria

Setting grouping criteria

Setting sorting parameters


Setting grouping criteria

The Grouping criteria tab allows you to set conditions for grouping query records.

The grouping condition pattern fields are set in the same way as those of the Criteria pattern.

Query Builder - Setting grouping criteria

These conditions will be included in the HAVING statement of the generated SQL query.

See also:

Setting criteria

Setting output fields

Setting sorting parameters


Setting sorting parameters

The Sorting tab allows you to set sorting parameters for the records returned by the query.

The working area contains the Output fields list (at the left) which represents all fields of the objects used in the query, and the Sorted fields list (at the right) which contains the fields to sort records by.

To move a field from one list to another, drag the selected field or use the Add and Remove buttons: Items - Move to Selected Items - Move all to Selected Items - Move to Available Items - Move all to Available.

To change the sorting order for a sorted field, select the field in the Sorted fields list and move it using the Up and Down buttons.

To change the sorting direction, select the field in the Sorted fields list and switch the direction (Ascending, Descending) using the corresponding A..Z/Z..A button.

Query Builder - Setting sorting parameters

See also:

Setting criteria

Setting output fields

Setting grouping criteria


Working with the editor area

The Editor area of Query Designer is available within the Edit tab and is provided for working directly with the SQL query text which is generated automatically while you build the query visually.

You can edit this text according to the rules of SQL, and all the changes will be displayed within the Builder tab respectively.

To learn more about the Query Data features available within the Edit tab, see Working with query.

Query Builder - Working with editor area

See also:

Working with diagram area

Query execution

Query Data


Query execution

When all the query parameters are set, you can immediately execute the query in Query Designer.

To execute a query, click the btnExecuteQuery Execute query item of the Navigation bar. You can also use the F9 hot key for the same purpose.

If the query parameters are specified correctly, the query is executed and, in case the query statement is supposed to return data (e.g. as SELECT statement), the returned dataset appears within the Result tab.

If SQL syntax of the query contains any errors, the query execution is stopped and the corresponding error message is displayed in the status bar area at the bottom of the Query Builder window.

Query Builder - Query execution

By default, data returned by a query are displayed as a grid (see Data View for details). The context menu of the grid allows you to Export Data, Export As SQL Script.

Query Builder - Viewing results

See also:

Working with diagram area

Working with the editor area

Data View


Viewing query plan

Using SQL Manager for InterBase/Firebird, you can view the plan for each of the queries created and executed in the application. The query plan is available within the corresponding Plan tab.

To view the Plan of a query, open Query Builder and use the btnExplainQuery Explain query item of the Navigation bar or toolbar.

The Plan tab allows you to view the sequence of actions performed by the database server in the process of the query execution, and the amount of system resources used for the query execution.

Query Builder - Viewing query plan

See also:

Query execution


Query parameters

Both Query Data and Query Designer support parameters usage inside the query text. A parameter is a kind of variable for which a value can be specified just before the query execution. In the query text the parameter should appear as an identifier with a colon (':') at the beginning, e.g.

SELECT * FROM MYTABLE WHERE ID = :param1;

Note: The Allow using of parameters in query text option should be checked on the Tools page of the Environment Options dialog for this feature to be enabled.

See also:

Query Data

Query Designer


Input parameters dialog

The Input Parameters dialog is used to specify the query parameters as well as values of the input parameters of the query before execution.

Appendix - Input Parameters

The edit field for input parameters varies according to the field data type. For your convenience the Calculator and Date editor are implemented for floating-point (FLOAT, NUMERIC, DOUBLE PRECISION, DECIMAL) and temporal (DATE, TIME) types respectively: click the arrow-down button to call the Calculator / Date editor popup window.

Also you can choose the recently used set of values in the table at the top of the window. To apply values from the table just double-click its row.

Click OK button to apply the values and execute the query or click Cancel button to abort execution.


Data Management

Table data and query results are displayed on the Data or Results tab of Table Editor, Query Data, Query Designer, etc.

Data can be displayed in one of the following modes: Grid View, Form View, Print Data, BLOB View. See Data View to learn more about these modes. You are also provided with a number of filtering tools when working with your data.

  • Data View
  • Custom Filter
  • Filter Builder dialog

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Import/Export Tools

Database Tools

Services

Security management

Options

External Tools

How To...


Data View

SQL Manager for InterBase/Firebird provides you with powerful tools for viewing, editing and printing data from tables and queries:

  • table / view data are available within the Data tab of Table Editor / View Editor correspondingly;
  • upon a query execution the returned dataset appears within the Result(s) tab of Query Data / Query Builder (in Query Data the position of the tab depends on the Results on Edit tab / Results on separate tab selection in the Navigation bar).

The data can be displayed in one of four available modes: Grid View, Form View, Print Data and BLOB View. The status bar at the bottom displays the number of records in the current dataset, the time the records were fetched by the application and the status of the records (whether the data are read-only or editable).

Please see the succeeding chapters to learn how to work with your data in the simplest and most efficient way.

  • Using Navigation bar and Toolbars
  • Grid View
  • Form View
  • Print Data
  • BLOB View
  • Applying changes

See also:

Custom Filter

Filter Builder dialog

Table Editor

View Editor


Using Navigation bar and Toolbars

Data Management

Data View - Using Navigation bar

iconCommit commit transaction

iconRollback rollback transaction

export data

export data as SQL script

import data (in Table Editor, View Editor only)

Tools

view the dependency tree for the table

iconGrantsOnObject define grants on the table

iconCreateView create a view on the table

iconPurgeTable purge table data

iconCreateProc create procedure based on the table

NOTE: Items of the Navigation bar are also available on the ToolBar. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

The Navigation pane contains toolbars allowing you to:

  • go to the first record of the dataset;
  • go to the previous page;
  • go to the previous record;
  • go to the next record;
  • go to the next page;
  • go to the last record of the dataset;
  • insert a new record (in Table Editor only);
  • delete the selected record (in Table Editor only);
  • edit the selected record (in Table Editor only);
  • post edit (in Table Editor only);
  • cancel edit (in Table Editor only);
  • refresh data;
  • set bookmark;
  • go to saved bookmark;
  • call the Filter Builder dialog;
  • search for a string in the currently selected column data;
  • enable multi-level mode to display data of the table(s) related by a foreign key (in Table Editor only).

Data View - Navigation pane

The Toolbar of the Print Data mode allows you to:

  • customize the report using Report Formatter and the Report Options dialog;
  • load a report from an external *.rps file;
  • save the current report to an external *.rps file;
  • print the report using the default printer;
  • set printing options using the standard Print dialog;
  • call the Page Setup dialog;
  • show/hide report thumbnails;
  • customize the Report Title;
  • add Date and Time, Page Numbering, show/hide empty pages;
  • shrink the report to the page;
  • specify background color;
  • zoom in/out, setup zoom, zoom page width, whole page, two/four/multiple pages;
  • select the active page of the report;
  • go to first/previous/next/last page of the report;
  • show linked details (automatically add grid levels on the basis of existing foreign keys).

Data View - Print Data - Toolbar

The Toolbar of the BLOB View mode allows you to:

  • select a BLOB column;
  • select encoding (ANSI, UTF-8, UNICODE-16);
  • load BLOB content from an external file;
  • save the BLOB column content to an external file;
  • cut/copy/paste selected text to/from clipboard (enabled for the Text and Rich Text tabs only);
  • undo changes;
  • print the text (enabled for the Text, Rich Text and HTML tabs only);
  • select font to be applied to the selected text (enabled for the Rich Text tab only);
  • select font size to be applied to the selected text (enabled for the Rich Text tab only);
  • make the selected text bold/italic/underlined (enabled for the Rich Text tab only);
  • align left/center/right (enabled for the Rich Text tab only);
  • add/remove list bullets (enabled for the Rich Text tab only).

Data View - BLOB View - Toolbar

See also:

Grid View

Form View

Print Data

BLOB View

Applying changes

Customize toolbars and menus


Grid View

By default, data returned by a query are displayed as a grid. It is indicated by the Grid View tab selected on the View mode panel at the bottom of the Results area of the window.

When in the Grid View mode, the columns correspond to the fields and the rows correspond to the records.

If more convenient, you can change the order of the columns by dragging their headers horizontally. Clicking the column caption sorts data by the values of this column in the ascending or the descending mode. The navigation pane at the top of the grid allows you to browse the data quickly, to insert, update and delete records, and to set a filter for the records using the Filter Builder dialog and other tools.

The Navigation bar of the parent window, toolbars and the context menu of the grid provide you with a number of data management functions: Export Data, Import Data, Export as SQL Script and more.

  • Customizing columns
  • Grouping data within the grid
  • Filtering records
  • Using the context menu
  • Working in multi-level mode
  • Browsing data in card view
  • Column Summary
  • Copying records

Data View - Grid View

See also:

Using Navigation bar and Toolbars

Form View

Print Data

BLOB View

Applying changes


Customizing columns

Selecting visible columns

When working in the Grid View mode, you can specify which columns of the current dataset will be visible. Click the btnSelectVisibleColumns button available in the top left corner of the data grid and select/deselect columns in the drop-down list to specify their visibility/invisibility.

Data View - Grid View - Selecting visible columns

Changing columns order

For your convenience the possibility to change the order of the columns in the data grid is available. To reorder columns, drag a column header horizontally to a place in between two other column headers indicated with green arrows.

Data View - Grid View - Changing columns order

See also:

Grouping data

Filtering records

Working in multi-level mode

Working in card view mode

Column Summary


Grouping and sorting data

In order to sort data, do the following:

open data at the Data or Results tab, choose the column by which you need to sort data and click the column title.

If the column was not sorted, the first click will sort it in the ascending order and the second one - in the descending order.

Clear Sorting

To cancel the sorting, open the context menu by right-clicking the necessary column and choose the Clear Sorting item, or press the Ctrl button and click the column title.

If necessary, you can group the data in grid by any of the columns.

This operation is performed by dragging the column header to the gray "Group by" box area at the top. In order to display this area, select the CheckBox Show "Group by" box option available in the Grid section of the Environment Options dialog.

When grouping by a column is applied to the grid, all the records are displayed as subnodes to the grouping row value as displayed in the screenshot below. The grouping row can contain the column summary information specified in the Group header group of the Column Summary dialog.

To reverse grouping, just drag the column header back.

Hint: While dragging the column header back, you can also change the column position.

Data View - Grid View - Grouping data

If necessary, you can group data by two or more columns. In this case column headers are displayed hierarchically, and data are grouped by these columns in the order the column headers appear in the "Group by" area.

Data View - Grid View - Grouping data by two columns

See also:

Customizing columns

Filtering records

Working in multi-level mode

Working in card view mode

Column Summary


Filtering records

A number of filtering facilities are implemented in the grid for your convenience. You can filter records in the grid in either of the following ways:

  • right-click a row and select the Quick Filter context menu item to filter records by the current value of the selected column;

Data View - Grid View - Quick Filter

  • click the Arrow-Down button next to the column caption to display the drop-down list and select any of the column values to filter records by this value of the selected column;

Data View - Grid View - Filtering records

or

  • click the Arrow-Down button next to the column caption to display the drop-down list, then select the Custom item and build a simple filter using the Custom Filter dialog;
  • use the Set filter btnSetFilter button on the navigation pane to invoke the Filter Builder dialog and create a composite filter using the dialog.

After the filter is set, the gray filtering panel becomes visible at the bottom of the grid. This panel allows you to see the active filtering condition and easily enable or disable it using the checkbox on the left. The Arrow-down button opens the drop-down menu which allows you to browse the filter history for this dataset.

If necessary, you can click the Customize... button on the right to customize your filter and add more complicated filtering conditions within the Filter Builder dialog.

Data View - Grid View - Filtering records - Filtering panel

To remove the current filter, click the Close btnClose button.

See also:

Customizing columns

Grouping data

Custom Filter

Filter Builder dialog


Using the context menu

The context menu of the grid is aimed at facilitating your work with data: you can perform a variety of operations using the context menu items:

  • copy the selected cell value to Windows clipboard;
  • paste the clipboard content to the currently selected cell;
  • copy/paste multiple records;
  • data manipulation: Export Data from the table, Import Data to the table, Export Data as SQL Script;
  • set/disable Quick Filter;
  • clear sorting;
  • set a value for the selected cell: NULL, Empty string (for string fields), Now (for TIME fields), "Zero" (for DATE fields);
  • edit the BLOB value or save the BLOB to file using BLOB viewer/editor;
  • show linked details (automatically add grid levels on the basis of existing foreign keys)
  • expand/collapse grid levels and navigate within the tabs;
  • manage grid levels: add a new grid level, delete the current grid level (this item is enabled only when the detail level exists and is currently focused);
  • switch to the Card View mode;
  • view Column Summary;
  • select visible/invisible columns of the dataset;
  • fit column width for better representation;
  • specify the grid mode: Load All Rows, Load Visible Rows, Default;
  • view/edit grid properties.

Data View - Grid View - Using the context menu

Note: If the CheckBox Show editor immediately and CheckBox Always show editor options on the Environment options | Grid tab are checked then the context menu of a grid can be evoked by selecting the necessary cell and right-clicking the table header. Otherwise, right-clicking the cell evokes the cell editing menu.


Working in multi-level mode

One of unique features of SQL Manager for InterBase/Firebird is the ability to work with data in multi-level mode to view and modify data in several related tables simultaneously.

To manage grid levels, right-click the grid and select the Grid Levels context menu group. Items of this group allow you to:

  • add a new grid level using Create Grid Level Wizard;
  • delete the current grid level;
  • switch between the ordinary Table View and the Card View modes.

Data View - Grid View - Working in multi-level mode

See also:

Using the context menu

Create Grid Level wizard


Create Grid Level wizard

Create Grid Level Wizard allows you to add a new detail level to the grid in order to get master-detail representation of your data.

To start the wizard, right-click the grid, select the Grid Levels context menu group and proceed to the Add Grid Level... item within this group.

  • Specifying master level
  • Selecting source table
  • Binding master and detail levels
  • Query parameterization
  • Setting additional parameters

Create Grid Level - Add Grid Level

See also:

Working in multi-level mode


Specifying master level

Use the drop-down list to select the table of the master level to which a new level will be added.

Source of new level data

Select the source type of the new level data: RadioButton Table or RadioButton Query.

Create Grid Level - Specifying master level

Click the Next button to proceed to the Defining source for detail level step to select a table for the detail level or input a query, depending on whether the RadioButton Table or the RadioButton Query option has been selected.


Defining source for detail level

If the RadioButton Table option has been selected at the previous step, you should now specify a table for the detail view using the Table name drop-down list. Set the CheckBox Show tables related by foreign keys only option to narrow the list of tables by including only tables linked by Foreign keys.

Create Grid Level - Defining source for detail level - Table

If the RadioButton Query option has been selected at the previous step, you should now enter a query that will be used as the source of the new grid level. If necessary, you can use Query Builder to build the SQL query visually.

Create Grid Level - Defining source for detail level - Query

Click the Next button to proceed to the Binding master and detail levels step of the wizard.


Binding master and detail levels

Define pairs of fields to link the Master Level and the Detail Level data sources:

  • select a field in the Master Level Key Fields list;
  • select a corresponding field in the Detail Level Key Fields list;
  • click Add to set correspondence between the selected fields.

The newly created correspondences are listed in the Links Between Master and Detail Levels area. If necessary, you can delete any correspondence using the the Remove button.

The From Foreign Key... menu is available if the CheckBox Show tables related by foreign keys only option has been selected at the previous step. This menu allows you to select the foreign key to be used for identifying master-detail levels (if the table has more than one foreign key relation).

Create Grid Level - Binding master and detail levels

Click the Next button to proceed to the Setting additional parameters step or to the Query parameterization step of the wizard if RadioButton Query was selected at the Specifying master level step of the wizard.


Query parameterization

If RadioButton Query was selected at the Specifying master level step of the wizard, you should now transform the query to a parameterized form that will be used in the 'Load visible rows' Grid Mode (see the Grid | Data Options section of the Environment Options dialog to get more information about grid modes offered by SQL Manager).

Create Grid Level - Query parameterization

Click the Next button to proceed to the Setting additional parameters step of the wizard.


Setting additional parameters

Level caption

Set the caption to be used for the new level in the grid.

Level type

Select the type of view you wish to be applied to the grid level: RadioButton Table view or RadioButton Card view.

Create Grid Level - Setting additional parameters

When you are done, click the Finish button to complete the operation.


Working in card view mode

Depending on your preferences, you can represent data in the Table View or in the Card View modes.

To switch to the Card View mode of data representation, right-click the grid, expand the Grid Levels context menu group and select the Card View item within this group.

Data View - Grid View - Working in card view mode

See also:

Using the context menu


Column Summary

If necessary, you can select the Column Summary... context menu item to open the Column Summary dialog which allows you to set the summary for each particular column that will be displayed in the grid footer, group header and group footer areas. Column Summary information displayed in the group footer and group header areas is available for grouped data.

Data View - Grid View - Column Summary

The Column list displays all columns of the dataset. Select a column and specify which information should be displayed in the grid as summary for this column:

RadioButton None

RadioButton Sum (for numeric types only)

RadioButton Minimum (for numeric and date/time types only)

RadioButton Maximum (for numeric and date/time types only)

RadioButton Count

RadioButton Average (for numeric types only)

Use the Number format edit boxes in each group to specify the preferable format for summary info representation.

See also:

Using the context menu


Copying records

When you copy several records to clipboard and paste them into the grid, you are offered to set correspondence between columns of the clipboard and fields of the target InterBase/Firebird table using the Associate Columns dialog.

Data View - Grid View - Associate columns

The Clipboard Columns and Grid Columns lists display the source and target dataset columns respectively. Set correspondence between the source clipboard columns and the table columns:

  • select a source clipboard column in the Clipboard Columns list;
  • select the corresponding field the target table in the Grid Columns list;
  • click the Add button to set correspondence between the selected columns;
  • the pair of columns appears in the Links between... list below;
  • repeat the operation for all the columns you need copy.

Use the Add All button to add all columns to the Links between... list on the basis of their order.

To remove a correspondence, select the pair of columns in the Links between... list and press the Remove button.

To remove all correspondences, press the Remove All button.

CheckBox First row is a header

This option specifies that the first row of the associated columns will be taken as the column header.


Form View

The Form View tab allows you to view data as a form. To activate this type of data view, select the Form View tab on the View mode panel at the bottom of the window.

The form displays the current record: field names on the left and the corresponding values on the right. If the fields are available for editing, you can edit the record directly on this form. The navigation pane at the top of the form allows you to browse the data quickly, to insert, update and delete records, and to set a filter for the records using the Filter Builder dialog.

Data View - Form View

Each field has a CheckBox Null checkbox which allows you to clear the field value and set it to NULL (if the field is nullable).

See also:

Using Navigation bar and Toolbars

Grid View

Print Data

BLOB View

Applying changes


Print Data

Using the Print Data tab you can view data in the way they are printed, in WYSIWYG mode.

When in Print Data mode, you are provided with a powerful context menu and toolbar allowing you to design a report, change the view scope, save reports and load previously saved ones, set report options, and specify a number of printing parameters using Report Formatter and the Page Setup dialog.

Data View - Print Data

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using Navigation bar and Toolbars

Grid View

Form View

BLOB View

Applying changes


Page Setup

The Page Setup dialog allows you to specify a number of settings pertaining to the report page.

To open the dialog, use the [image] Page Setup button available on the toolbar.

Use the following tabs of the Page Setup dialog:

  • Page
  • Margins
  • Header/Footer
  • Scaling

When you are done, you can click the Print... button at the bottom to call the Print dialog.

See also:

Report Formatter

Setting report options

Print dialog


Page

The Page tab of the Page Setup dialog allows you to specify the paper, page orientation, print order and shading settings.

Data View - Print Data - Page Setup - Page

Paper

Select one of the standard paper types in the Type list, or specify custom width and height using the Dimension group (in inches or millimeters, depending on the unit of measure specified in the Options dialog).

Use the Paper source drop-down list to select the paper feed type.

Orientation

Select the preferable page orientation (your selection is illustrated in the chart on the left):

RadioButton Portrait

RadioButton Landscape

Print Order

Select the preferable order for printing report pages (your selection is illustrated in the chart on the left):

RadioButton Down, then over

RadioButton Over, then down

Shading

CheckBox Print using gray shading

If this option is selected, gray shading (along with black and white) will be used for printing the report.


Margins

The Margins tab of the Page Setup dialog allows you to specify the size of the margins and running titles.

Data View - Print Data - Page Setup - Margins

Use the spinner controls to specify the size of top / bottom / left / right margins and header / footer (in inches or millimeters, depending on the unit of measure specified in the Options dialog). The Preview area on the right illustrates the changes you have made.

If you have specified an improper value, you can click the Fix button to correct it.

To restore the default size values, click the Restore Original button.

Center on page

This group allows you to specify whether the text should be centered horizontally and/or vertically on the page.


Header/Footer

The Header/Footer tab of the Page Setup dialog allows you to specify properties of the header and footer running titles.

Data View - Print Data - Page Setup - Header and Footer

Header / Footer

Click the Font... button to specify font properties using the standard Font dialog. The font name and size are displayed in the gray area next to the Font... button.

Use the Background drop-down list to select the background color that will be applied to the page header/footer, or to customize the color using the Color and Fill Effects dialogs.

For each of the running titles you are provided with three separate text editing fields. You can use any, all or none of the fields to enter the header and footer text.

The Vertical Alignment group allows you to specify vertical alignment for the header/footer text according to any of the three available patterns.

Predefined Functions

This group allows you to add the following standard functions to the header and footer:

[Machine Name]

[User Name]

[Time Printed]

[Date Printed]

[Date & Time Printed]

[Page # of Pages #]

[Total Pages]

[Page #]

CheckBox Reverse on even pages

If this option is selected, the header and footer text will be reversed on even pages of the printing report.


Scaling

The Scaling tab of the Page Setup dialog allows you to specify the page scaling options.

Data View - Print Data - Page Setup - Scaling

Select the preferable scaling mode:

RadioButton Adjust to ... % normal size

Use the spinner control to set the percentage of the regular page size to which the page size will be adjusted.

RadioButton Fit to ... page(s) wide by ... tall

Use the spinner controls to set the maximum number of pages (by width and by height) on one page to fit its size.


Report Formatter

Report Formatter allows you to specify a number of settings pertaining to the printing form of the report.

To open the tool, click the [image] Design Report button available on the toolbar, or use the Ctrl+D shortcut.

Use the following tabs of the Format Report dialog:

  • View
  • Behaviors
  • Formatting
  • Styles
  • Preview
  • Cards
  • Charts

The Title Properties... button allows you to customize the report title using the Report Title dialog.

See also:

Page Setup

Setting report options

Print dialog


View

The View tab of the Format Report dialog allows you to specify report elements to show in the report.

Data View - Print Data - Report Formatter - View

Tick off the elements to show in the report (caption, bands, headers, footers, group footers, expand buttons, filter bar) and on every page of the report (caption, bands, headers, footers, filter bar).

The Preview area on the right illustrates the changes you have made.


Behaviors

The Behaviors tab of the Format Report dialog allows you to specify the way (behavior) the report elements will appear on the printing form.

Data View - Print Data - Report Formatter - Behaviors

Selection

CheckBox Process selection / CheckBox Process exact selection

Specify whether the text selection should or should not be processed (precisely) for the printing form.

Expanding

Tick off the elements to expand in the report: groups, details, cards.

Size

CheckBox Auto Width

If this option is selected, the table will be resized automatically to fit the page by width.

The Preview area on the right illustrates the changes you have made.


Formatting

The Formatting tab of the Format Report dialog allows you to specify Look and Feel, Refinements and Pagination options.

Data View - Print Data - Report Formatter - Formatting

Look and Feel

This setting determines the manner in which the cells are painted. Use the drop-down list to select the painting style that will be applied to the cells on the printing form:

Flat

Standard

UltraFlat

Refinements

Options of this group allow you to reduce the report size.

CheckBox Transparent graphics

If this option is selected, the images will be drawn transparent in the report.

CheckBox Display graphic as text

If this option is selected, text will be displayed instead of the images.

CheckBox Flat CheckMarks

If this option is selected, the checkboxes will be drawn flat.

Pagination

Specify the way pagination will be performed for the report: By TopLevel groups or One group per page.

The Preview area on the right illustrates the changes you have made.


Styles

The Styles tab of the Format Report dialog allows you to specify styles to be applied to the report elements.

Data View - Print Data - Report Formatter - Styles

CheckBox Use native styles

This option determines whether the native Windows style will be applied to the report elements.

Note: The Native style option is currently supported for the Windows® XP operating system only.

The elements list displays the names of all report elements, with background color and font properties specified by default. You can Use native styles for them or customize them according to your preferences.

To edit an element, select it in the list and use the buttons to the right to edit the style for it.

Click the Font... button to specify font properties using the standard Font dialog.

Click the Color... button to customize the background color using the standard Color dialog.

Click the Texture... button to load an image that will be used as the texture for the element.

To rollback the changes, click the Clear button.

To restore the default stylesheet properties, click the Restore Defaults button.

If you need to save the current style sheet, you can click the Save as... button.

These items are also available through the context menu of the elements list.

Style Sheets

Use the drop-down menu to select the style sheet you need. To manage the style sheets, use the corresponding buttons below: New..., Copy..., Delete..., Rename...

The Preview area on the right illustrates the changes you have made.


Preview

The Preview tab of the Format Report dialog allows you to specify report preview options.

Data View - Print Data - Report Formatter - Preview

CheckBox Visible

This option specifies visibility of the grouping rows.

CheckBox Auto height

If this option is selected, the table will be resized automatically to fit the page by height.

Max line count

Use the spinner control to specify the maximum possible number of lines.

The Preview area on the right illustrates the changes you have made.


Cards

The Cards tab of the Format Report dialog allows you to specify properties for the card view.

Data View - Print Data - Report Formatter - Cards

Sizes

CheckBox Auto Width

If this option is selected, the cards will be resized automatically to fit the page by width.

CheckBox Keep same width

Select this option to keep the card width fixed.

CheckBox Keep same height

Select this option to keep the card height fixed.

Spacing

This group allows you to specify horizontal and vertical spacing between cards.

Framing

CheckBox Border

This option specifies visibility of the card borders.

CheckBox Horizontal lines

This option specifies visibility of the horizontal lines (row delimiters) within cards.

CheckBox Vertical lines

This option specifies visibility of the vertical lines (column delimiters) within cards.

Shadow

Use the Color drop-down list to select the color that will be applied to the card shadows. If necessary, specify the color depth using the corresponding spinner control.

The Preview area on the right illustrates the changes you have made.


Charts

The Charts tab of the Format Report dialog allows you to specify options for the charts used in the report.

Data View - Print Data - Report Formatter - Charts

CheckBox Transparent

If this option is selected, the charts will be drawn transparent in the report.

The Preview area on the right illustrates the changes you have made.


Setting report options

Options dialog

The Options dialog allows you to specify a number of settings pertaining to the printing report.

To open the dialog, open the Design Report [image] menu available on the toolbar and select the Preferences item.

Data View - Print Data - Report options

Show

Tick off the elements to show in the printing report (margins, margins hints, margins hints while dragging).

Use the Measurement Units drop-down list to select the unit of measure that will be used in report settings: default, inches, or millimeters.

Zoom Parameters

CheckBox Zoom on roll with IntelliMouse

If this option is selected, you can zoom in/out by scrolling up/down (with a Microsoft® mouse or a compatible mouse used).

Zoom Step

Use the spinner control to specify the percentage of the original page size to be considered as one zoom step.

Use the Margins Color drop-down list to select the color that will be applied to the report margins.

Report Title dialog

The Report Title dialog allows you to specify the report title text and properties.

To open the dialog, use the Title... button available on the toolbar.

Data View - Print Data - Report options - Title

Mode

Use the drop-down list to select where the report title should be displayed on the first page, on every top page, or not displayed at all.

Text

Use the edit box to enter the text of the report title.

Properties

CheckBox Transparent

If this option is selected, the report title will be drawn transparent.

Use the Color drop-down list to select the color that will be applied to the report title (enabled if the CheckBox Transparent option is not selected).

Click the Font... button to specify title font properties using the standard Font dialog. The font name and size are displayed in the gray area next to the Font... button.

CheckBox Adjust on scale

If this option is selected, the title can be adjusted on scale.

Alignment

Use the Horizontally drop-down list to select the type of horizontal alignment to be applied to the report title: Left, Center, or Right.

Use the Vertically drop-down list to select the type of vertical alignment to be applied to the report title: Top, Center, or Bottom.

To restore the default title properties, click the Restore Defaults button.

Date and Time dialog

The Date and Time dialog allows you to specify the date/time formats to be used in the report.

To open the dialog, open the Title... menu available on the toolbar and select the Date and Time... item.

Data View - Print Data - Report options - Date and Time

Select the preferable values from the Available Date Formats and the Available Time Formats lists. If necessary, you can specify that the date/time will be updated automatically.

To apply the default date/time format, click the Default... button.

Page Number Format dialog

The Page Number Format dialog allows you to specify the formats for page numbers to be used in the report.

To open the dialog, open the Title... menu available on the toolbar and select the Page Numbering... item.

Data View - Print Data - Report options - Page Number Format

Select the preferable number format from the Number Format drop-down list.

Use the Page Numbering section to specify whether page numbering should continue from the previous section (if any) or start at the specified number.

To set the default numbering values, click the Default... button.

Zoom dialog

The Zoom dialog allows you to zoom the report page more better representation.

To open the dialog, open the Zoom [image] menu available on the toolbar and select the Setup zoom... item.

Data View - Print Data - Report options - Zoom

Select the preferable percentage of zoom value (500%, 200%, 150%, 100%, 75%, 50%, 25%, 10%) or specify one of frequently used values:

RadioButton Page Width

RadioButton Whole Page

RadioButton Two Pages

RadioButton Four Pages

RadioButton Many Pages (click the chart below and select the item you need)

If necessary, you can set a custom percent value using the Percent spinner control below.

The Preview area on the right illustrates the changes you have made.

See also:

Page Setup

Report Formatter

Print dialog


Print dialog

The standard Print dialog allows you to specify printing settings for the report in groups: printer, page range, copies.

To open the dialog, click the Print dialog btnPrintSetup button available on the toolbar, or use the Ctrl+P shortcut.

Data View - Print Data - Print dialog

When you are done, click the Print button to start printing.

If you need to change any page settings before printing, you can click the Page Setup... button at the bottom to call the Page Setup dialog.

See also:

Page Setup

Report Formatter

Setting report options


BLOB View

SQL Manager for InterBase/Firebird provides BLOB Viewer/Editor to view and edit BLOB (Binary Large Object) fields content. The BLOB Viewer/Editor can be invoked from the data grid within Table Editor, Query Data, Query Designer, etc.

  • Navigation within the BLOB Viewer/Editor
  • Viewing/Editing BLOB field as Hexadecimal dump
  • Viewing/Editing BLOB field as plain Text
  • Viewing/Editing BLOB field as Rich Text (RTF)
  • Viewing/Editing BLOB field as Image
  • Viewing/Editing BLOB field as HTML

Data View - BLOB View

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using Navigation bar and Toolbars

Grid View

Form View

Print Data

Applying changes


Navigation within BLOB Editor

The BLOB Viewer/Editor provides an ability to navigate within the records using DB Navigation buttons on the navigation pane at the top of the viewer window.

Using items of the navigation pane and the drop-down menu you can browse the data quickly, insert, update and delete records, set a filter for the records using the Filter Builder dialog, load new BLOB content and save the current content to files.

The toolbar allows you to switch the fields and perform a number of editing operations. The set of toolbar items depends on the current selection and view mode.

Data View - BLOB View - Navigation within BLOB Editor

See also:

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as Image

Editing as HTML


Editing as Hexadecimal

The Hexadecimal tab allows you to view/edit the BLOB data as hexadecimal.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the btnSave Save to file and the iconLoadFromFile Load from file toolbar buttons to save the hexadecimal data to a file, or load data from a file.

Use the Ins key to switch between the Insert and Overwrite modes.

Data View - BLOB View - Hexadecimal

See also:

Navigation within BLOB Editor

Editing as Text

Editing as Rich Text

Editing as Image

Editing as HTML


Editing as Text

The Text tab allows you to view/edit the BLOB data as plain text.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the text to a *.txt file, or load text from a file. Additionally, you can use the Cut, Copy, Paste, Select All, Undo, Word Wrap context menu items for editing the text efficiently, and the Print context menu item to print the content of the Text tab.

Data View - BLOB View - Text

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Rich Text

Editing as Image

Editing as HTML


Editing as Rich Text

The Rich Text tab allows you to view/edit the BLOB data in Rich Text format (RTF).

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the Rich Text to a *.rtf file, or load text from a file. Additionally, you can use the Cut, Copy, Paste, Select All, Undo context menu items for editing the text efficiently, and the Print context menu item to print the content of the Rich Text tab.

Data View - BLOB View - Rich Text

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Image

Editing as HTML


Editing as Image

The Image tab allows you to view the BLOB data as image.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the Save to file btnSave and the Load from file iconLoadFromFile toolbar buttons to save the image to a *.png, *.wmf, *.ico or *.jpg file, or load an image from a file.

Data View - BLOB View

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as HTML


Editing as HTML

The HTML tab allows you to view the BLOB data as HTML (Hyper-Text Markup Language format) - in the way this data would be displayed by your Internet browser.

The toolbar provides additional functionality for BLOB Viewer/Editor: use the btnSave Save to file and the iconLoadFromFile Load from file toolbar buttons to save the content as a *.html, or *.htm file, or load content from a file.

Data View - BLOB View - HTML

See also:

Navigation within BLOB Editor

Editing as Hexadecimal

Editing as Text

Editing as Rich Text

Editing as Image


Applying changes

After changes are done, click the Post Edit btnPostEdit button on the navigation pane to apply the changes or the Cancel Edit btnCancelEdit button to discard the changes.

Data View - Applying changes

See also:

Using Navigation bar and Toolbars

Grid View

Form View

Print Data

BLOB View


Custom Filter

The Custom Filter dialog is one of the filtering facilities implemented in Data View for your convenience.

To open the dialog, click the Arrow-Down button next to the column caption, and select the Custom item from the drop-down list.

Select a logical operator for checking the column values (like, is less than, is greater than, etc.) and set a value to be checked by this operator in the corresponding box on the right.

Data management - Custom Filter

If necessary, you can set the second condition and specify the relation between the two conditions: whether both of them should be satisfied (AND) or just any of them (OR). Use the '_' character to represent any single symbol, and use the '%' character to represent any series of symbols in the condition string.

See also:

Data View

Filter Builder dialog


Filter Builder dialog

The Filter Builder dialog is a powerful filtering tool implemented in Data View for your convenience.

The dialog is aimed at facilitating the procedure of creating and applying complex filter criteria for data. In addition, the tool allows you to save filter criteria to an external *.flt file for future use.

To open the Filter Builder dialog, use the btnSetFilter Set filter button on the navigation pane available within the Data tab of Table Editor and the Result(s) tabs of Query Data and Query Builder.

  • Invoking the Filter Builder dialog
  • Adding a new condition to the filter
  • Setting filter criteria
  • Setting filter operator
  • Setting filter criteria values
  • Adding a new group
  • Setting group operator
  • Applying filter conditions

See also:

Data View

Custom Filter


Invoking the Filter Builder dialog

The Filter Builder dialog can be invoked in either of the following ways:

  • if a simple filter or the Custom Filter is being used, click the Customize... button on the gray filtering panel;

Filter Builder dialog - Invoking the Filter Builder dialog

  • use the Set filter btnSetFilter button on the navigation pane and create a composite filter using the dialog.

Data View - Navigation pane

The succeeding pages of this chapter are intended to illustrate usage of the Filter Builder dialog. Please see the instructions below to learn how to perform various operations in the easiest way.

See also:

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Adding a new condition

Suppose we need to select data from the sample table EMPLOYEE to view the list of IT specialists hired after 6/15/2009. These criteria are applied to the HIRE_DATE, the DEPT_ID and the POSITION fields.

Click press the button to add a new condition - this will add a new condition to the criteria. Alternatively, you can click the Filter button and select the Add Condition popup menu item.

Filter Builder dialog - Adding a new condition

See also:

Invoking the Filter Builder dialog

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Setting filter criteria

As we need to apply the filter criteria to the HIRE_DATE field, we click the column box (next to the ellipsis EllipsisButton button) to open the drop-down list displaying the available column names and select the HIRE_DATE item.

Filter Builder dialog - Setting filter criteria

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Setting filter operator

Since we need the list of employees hired after 6/15/2009, we need to select the IS GREATER THAN operator from the corresponding drop-down list.

Filter Builder dialog - Setting filter operator

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter criteria values

Adding a new group

Setting group operator

Applying filter conditions


Setting filter criteria values

Next, we need to specify value '6/15/2009' for the IS GREATER THAN operator.

Similarly, if, for example, we need to get the list of employees hired during the 6/15/2008 - 6/15/2009 term, we set the BETWEEN filter operator (this will add two empty value boxes to specify the inclusive range for the BETWEEN condition) and specify the range for the operator, i.e. the '6/15/2008' and the '6/15/2009' values in the corresponding value boxes.

It is possible to set the date value manually by typing it in, or via the date editor which is activated when you click the value box.

Filter Builder dialog - Setting filter criteria values

Editors used in value boxes are determined by the data type assigned to the corresponding columns.

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Adding a new group

Setting group operator

Applying filter conditions


Adding a new group

Since we also need to get the list of IT specialists (i.e. those registered in a department and having an IT-oriented job), we can add a complex filter condition combining simple conditions with the AND operator (however, in this particular case we can just add them on the same root level as for the existing condition).

If you need to add a group of conditions, click the ellipsis EllipsisButton button for the HIRE_DATE condition and select the Add Group popup menu item.

Filter Builder dialog - Adding a new group

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Setting group operator

Applying filter conditions


Setting group operator

Conditions of complex criteria can be combined with any of the four logical operators used: AND, OR, NOT AND, NOT OR.

In our case it is enough to click the group operator box and select the AND item from the drop-down menu.

Filter Builder dialog - Setting group operator

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Applying filter conditions


Applying filter conditions

Suppose we have created a condition within the new group. If we need, we can add more conditions at the same level and specify the required values using the value boxes. When the operation is completed, the Filter Builder dialog will look like in the screenshot below.

Click the Apply button to see the result of the filtering you have made, and click OK or Cancel to close the dialog with or without saving your filter conditions respectively.

Filter Builder dialog - Applying filter conditions

The Filter Builder dialog allows you to save filter criteria to and load them from external files. Clicking the Save As… or the Open… buttons activates the corresponding dialogs. Filter settings are stored in *.flt files.

Please be informed that a column in the file is referenced by its position within a view, hence filter settings cannot be correctly restored if columns have been deleted from the view after saving the filter to a file.

See also:

Invoking the Filter Builder dialog

Adding a new condition

Setting filter criteria

Setting filter operator

Setting filter criteria values

Adding a new group

Setting group operator


Import/Export Tools

Using SQL Manager for InterBase/Firebird you are provided with powerful tools to import and export data to/from your InterBase/Firebird database.

Export Data Wizard

Exports data to various supported formats including MS Excel, MS Access, RTF, HTML, PDF, CSV, XML, and more.

Import Data Wizard

Imports data from any of supported formats: MS Excel, MS Access, DBF, TXT, CSV, XML, and more.

Export Data as SQL Script

Exports data to an SQL script as a number of INSERT statements.

Using templates

Facilitates using import/export wizards.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Database Tools

Services

Security management

Options

External Tools

How To...


Export Data Wizard

Export Data Wizard allows you to export data from a table / view or from a query result to any of supported formats (MS Excel, MS Access, MS Word, RTF, HTML, PDF, TXT, CSV, XML, DBF, etc.). You can save your settings as a template any time for future use.

To start the wizard, right-click the object in DB Explorer, select the Data Manipulation context menu group and proceed to the Export Data... item within this group.

Alternatively, you can open the Data tab of Table Editor / View Editor or the Result(s) tab of Query Data / Query Builder, right-click the grid there, then select the Data Manipulation context menu group and proceed to the Export Data of <object_name>... item within this group, or use the Export Data item of the Navigation bar.

  • Setting name and format for the destination file
  • Selecting fields for export
  • Adjusting formats applied to exported data
  • Setting header and footer text for the destination file
  • Setting format-specific options
  • Setting common export options
  • Exporting data

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Import Data Wizard

Export as SQL Script

Using templates


Setting destination file name and format

This step of the wizard allows you to select the destination file format you need to export data into.

Destination file name

Type in or use the btnSaveAs button to specify the path to the file using the Save as... dialog. The file name extension changes automatically according to the selected Destination format.

Note: If the target file already exists, the application will show a warning dialog where you can choose the action you need.

Export Data - Setting destination file name and format

Destination format

Specify the format of the destination file. For details refer to Supported file formats.

Click the Next button to proceed to the Selecting fields for export step of the wizard.


Selecting fields for export

This step of the wizard allows you to select the table field(s) to be exported.

To select a field, you need to move it from the Available fields list to the Selected fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Export Data - Selecting fields for export

If you leave all the fields in the Available fields list, all fields of the table (except BLOBs) will be exported.

CheckBox Allow captions

Check this option if you need to export the field captions as well.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


Adjusting data formats

This step allows you to customize formats applied to exported data.

Data formats

Edit the format masks to adjust the result format in the way you need: Integer, Float, Date, Time, DateTime, Currency, Boolean True, Boolean False, NULL string, Decimal separator, Thousand separator, Date separator, Time separator.

Export Data - Adjusting data formats

Hint: The formats used by default are specified in the Data Export section of the Environment Options dialog.

For more details refer to Format specifiers.

Click the Next button to proceed to the Setting header and footer step of the wizard.


Setting header and footer

Set Header text and Footer text for the result file. This text will appear at the beginning and at the end of the result file respectively.

Export Data - Setting header and footer

Click the Next button to proceed to Setting format-specific options.


Setting format-specific options

This step of the wizard allows you to customize Format-specific options:

  • Excel 97-2003 options
  • Access 97-2003 options
  • Word 97-2003 / RTF options
  • HTML options
  • PDF options
  • TXT options
  • CSV options
  • XML options
  • MS Excel / ODS options
  • Access options
  • MS Word / ODT options

To get more information about the file formats, see the Supported file formats page.


Excel 97-2003 options

This step allows you to set options for the target MS Excel 97-2003 (*.xls) file.

You can customize Data format, Extensions and set Advanced options available within the corresponding tabs:

  • Data format
  • Extensions
  • Advanced

Export Data - Format-specific options - Excel

When you are done, click the Next button to proceed to Setting common export options.


Data format

The Data Format tab contains general options which allow you to adjust the format for each kind of Excel cells. This means that you can specify such parameters as font, borders, filling color and method, etc. for each entity (such as data field, header, footer, caption, data, hyperlink and so on) separately. Also it is possible to create styles to make the target Excel file striped by columns or rows.

  • Fields
  • Options
  • Styles

For your convenience the previews illustrating the changes are displayed in the Sample Group area on each page of Data Format tab.


Fields

Using the Fields tab you can set font options, border and fill options and aggregate functions for all the fields you want to export.

The Font tab allows you to specify properties of the font that will be used in the output Excel file cells.

Use the Font and Size drop-down lists to select the font and size to be applied to the output text.

Use the buttons below to set font color, make text bold, italicized, strikethrough text, set underline effects, specify text horizontal and vertical align.

Export Data - Format-specific options - Excel - Data Format - Fields

The Borders tab allows you to specify properties of the borders of the output Excel file cells.

Press the [image] [image] [image] [image] buttons on the left to show/hide the borders they indicate.

Use the drop-down list for each border to select the line type and the [image] button on the right to select the line color for each border.

Export Data - Format-specific options - Excel - Data Format - Fields - Borders

The Fill tab allows you to specify the fill pattern for the output Excel file cells.

Use the drop-down list to select the preferable fill pattern type.

Press the [image] button on the left to set the background color for the fill pattern.

Press the [image] button on the right to set the foreground color for the fill pattern.

Export Data - Format-specific options - Excel - Data Format - Fields - Fill

The Aggregate tab allows you to specify an aggregate function for the field in the output Excel file.

Select a function that will be applied to the field:

RadioButton None

RadioButton AVG

RadioButton MAX

RadioButton SUM

RadioButton MIN

Export Data - Format-specific options - Excel - Data Format - Fields - Aggregate

You can reset the changes any time using the Reset Item and the Reset All buttons.


Options

Using the Options tab you can set font options, border and fill options for all elements of the Excel sheet (header, caption, footer, aggregates and hyperlinks).

Export Data - Format-specific options - Excel - Data Format - Options

The font, borders and fill options are specified in the same way as for output Fields. For details refer to the Fields page.

You can reset the changes any time using the Reset Item and the Reset All buttons.


Styles

Using the Styles tab you can make a style template: set font options, border and fill options and save them.

To add a style template, click the Plus iconPlus button.

To delete a style template, select it and click the Minus iconMinus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Excel - Data Format - Styles

The font, borders and fill options are specified in the same way as for output Fields. For details refer to the Fields page.

You can reset the changes any time using the Reset Item and the Reset All buttons.


Extensions

The Extensions tab provides an ability to add hyperlinks and notes and to any cell of the target file, to specify a value of a cell, to create a chart and to merge cells.

Click the Plus iconPlus button to add an element;

click the Minus iconMinus button to delete an element.

  • Hyperlinks
  • Notes
  • Charts
  • Cells
  • Merged Cells


Hyperlinks

If you need to create a hyperlink:

  • set the cell coordinates (Col and Row);
  • specify whether this is a local link or URL;
  • enter the title of the hyperlink;
  • specify the target file location or address.

Export Data - Format-specific options - Excel - Extensions - Hyperlinks

Use the Col and Row spinner controls to specify the column and row for the hyperlink in the output file.

The Style group allows you to select the preferable hyperlink style:

RadioButton URL

RadioButton Local file (i.e. the file is located on your local machine or on a machine in the LAN)

Use the Title box to specify the hyperlink name.

The Target box lets you enter the path to the target file or URL. Use the [image] button to check whether the specified location is available.


Notes

If you need to create a note:

  • set the cell coordinates (Col and Row);
  • enter text of a note for the cell;
  • set the font and fill properties using the corresponding tabs.

The Base tab allows you to specify basic properties of the note to be added to the output Excel file.

Use the Col and Row spinner controls to specify the column and row for the note in the file.

Use the edit-box below to enter the text of the note.

Export Data - Format-specific options - Excel - Extensions - Notes - Base

The Font tab allows you to specify properties of the font that will be used for the note.

Use the Font and Size drop-down lists to select the font and size to be applied to the output text.

Use the buttons below to set font color, make text bold, italicized, strikethrough text, set underline effects, specify text horizontal and vertical align.

The Orientation group allows you to select the note text orientation:

RadioButton No rotation

RadioButton Top to bottom

RadioButton Counterclockwise

RadioButton Clockwise

Export Data - Format-specific options - Excel - Extensions - Notes - Font

The Fill tab allows you to specify the fill type and transparency for the note.

The Fill Type group allows you to select whether the fill color will be solid or gradient:

RadioButton Horizontal

RadioButton Vertical

RadioButton Diagonal up

RadioButton Diagonal down

RadioButton From corner

RadioButton From center

Press the [image] button to set the background color for the fill pattern.

Press the [image] button to set the foreground color for the fill pattern.

The Transparency control allows you to set the transparency degree for the note. Move the slider between the 0% and 100% threshold values to select the required transparency value within this scope.

Export Data - Format-specific options - Excel - Extensions - Notes - Fill


Charts

If you need to create a chart:

  • enter the chart title;
  • select the chart style;
  • set the legend position;
  • specify if you want to show the legend;
  • specify if you want to set the chart color automatically;
  • define the chart position and category labels using the corresponding tabs.

The Base tab allows you to specify basic properties of the chart to be added to the output Excel file.

Use the Title box to specify the chart name.

Use the Style drop-down list to select the preferable chart style (Column, Column 3D, Bar, Bar 3D, Line, Line Mark, Line 3D, etc.).

The Legend position group allows you to specify position of the chart legend:

RadioButton Bottom

RadioButton Top

RadioButton Left

RadioButton Corner

RadioButton Right

CheckBox Show legend

This options specifies whether the chart legend will be visible or not.

CheckBox Auto color

If this option is selected, each series will be automatically differentiated with different colors on the chart, otherwise one color will be applied for all series.

Export Data - Format-specific options - Excel - Extensions - Charts - Base

The Position tab allows you to specify properties pertaining to the chart position on the output file sheet.

RadioButton Auto

Specifies automatic position of the chart.

The Placement group allows you to specify the chart position relative to the data:

RadioButton Bottom

RadioButton Right

Use the Left and Top spinner controls to specify the spacing between the chart and data at the left and at the top respectively.

Use the Height and Width spinner controls to specify the chart height and width respectively.

RadioButton Custom

Specifies absolute position of the chart (irrelative to the data). Use the spinner controls to set the coordinates you need.

Export Data - Format-specific options - Excel - Extensions - Charts - Position

The Category Labels tab allows you to specify in which rows and columns the chart will be built.

RadioButton Column

Use the drop-down list to select the column that will be used to take values for x-axis.

RadioButton Custom

Specify the range of cells from which x-axis values will be taken. Use the spinner controls to set the range you need.

Export Data - Format-specific options - Excel - Extensions - Charts - Category Labels

To build a chart, you also need to create series that will be used to take values for y-axis. To add series for the chart:

  • add one or more series using the iconPlus button;
  • enter the titles;
  • set data ranges (select a column from the drop-down list or set the custom range);
  • define colors for all the graphs.

Use the Title box to specify the series name.

Data range

RadioButton Column

Use the drop-down list to select the column that will be used to take values for the series.

RadioButton Custom

Specify the range of cells from which the series will be formed. Use the spinner controls to set the range you need.

Press the [image] button to set the color for the series.

Export Data - Format-specific options - Excel - Extensions - Series


Cells

If you need to add a value in a specific cell:

  • set the cell coordinates (Col and Row);
  • select the cell type;
  • enter a value;
  • if you are adding a numeric or a date/time value, you can set the cell format;
  • set the font, borders and fill properties using the corresponding tabs.

Export Data - Format-specific options - Excel - Extensions - Cells

The Base tab allows you to specify basic properties of the cell.

Use the Col and Row spinner controls to specify the column and row denoting the cell.

Use the Cell type drop-down list to select the data type for the cell (Boolean, DateTime, Numeric or String).

Set the required value in the Value edit box.

The Formats group allows you to specify data format for numeric or a date/time types.

The font, borders and fill options are specified in the same way as for output Fields. For details refer to the Fields page.


Merged Cells

If you want to merge two or more cells, set the range of cell coordinates: First col, Last col, First row, Last row. Use the spinner controls to set the range you need.

Export Data - Format-specific options - Excel - Extensions - Merged Cells


Advanced

The Advanced tab allows you to set a number of advanced options to be applied to the result MS Excel file.

Page header

If necessary, enter some text for the page header.

Page footer

If necessary, enter some text for the page footer.

Hint: It is also possible to set macros in the Page header and Page footer fields:

&N stands for the quantity of pages;

&P - the number of the current page.

Sheet title

Specify the sheet title for the target file.

Page background

If necessary, use the Ellipsis EllipsisButton button to browse for a graphical file to be applied as the page background.

Export Data - Format-specific options - Excel - Advanced

CheckBox Calculate column width automatically

This option allows the wizard to determine column width in the target file automatically according to column size.


Access 97-2003 options

This step allows you to set options for the target MS Access (*.mdb) file.

Set the name for the target table and specify whether the wizard should create a new table in the MS Access database if it does not exist yet, or use the existing table to export data into.

Export Data - Format-specific options - Access

When you are done, click the Next button to proceed to Setting common export options.


Word 97-2003 / RTF options

This step allows you to set options for the target MS Word 97-2003 (*.doc) and Rich Text Format (*.rtf) files.

  • Base Styles
  • Strip Styles

For your convenience the previews illustrating the changes are displayed in the Sample Group area within the Base Styles and the Strip Styles tabs.

Export Data - Format-specific options - Word

When you are done, click the Next button to proceed to Setting common export options.


Base Styles

The Base Styles tab contains the list of target file entities: HEADER, CAPTION, DATA, FOOTER. You can customize style options, such as font and size, background and foreground colors, text alignment, etc. for each of them by clicking the corresponding item in the list and setting the options in the right-side panel. You can also switch page orientation for the target Word/RTF file using this tab.

Export Data - Format-specific options - Word - Base Styles

Use the Font and Size drop-down lists to select the font and size to be applied to the text.

Use the buttons below to set font color, make text bold, italicized, underlined, strikethrough text, specify horizontal align.

CheckBox Highlight

Enables/disables text highlight.

CheckBox Background

Enables/disables background for text.

Press the [image] button to set the background color for the text.

Press the [image] button to set the highlight color for the text.

You can reset the changes any time using the Reset Item and the Reset All buttons.


Strip Styles

Using the Strip Styles tab you can create a style template: set font, size, background and foreground colors, text alignment, highlight and save them.

To add a style template, click the Plus iconPlus button.

To delete a style template, select it and click the iconMinus Minus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Word - Strip Styles

You can reset the changes any time using the Reset Item and the Reset All buttons.


HTML options

This step allows you to set options for the target HTML (*.html) file.

  • Preview
  • Basic
  • Multi-file
  • Advanced

Export Data - Format-specific options - HTML

When you are done, click the Next button to proceed to Setting common export options.


Preview

The Preview tab allows you to customize the style that will be applied to the target HTML file using a number of built-in templates provided in the Templates drop-down list.

Export Data - Format-specific options - HTML - Preview

You can select any of the pre-defined templates and customize it by clicking objects in the preview panel, and save the settings as a custom template using the Save template... button. Use the Load template... button to load a previously saved custom template from your hard disk.

Click on an element of the table to select the color that will be applied for this element (background, font, header row, odd row, even row, non-visited link, visited link, active link).


Basic

The Basic tab allows you to specify the basic parameters of target HTML file:

  • specify the title of the result file;
  • select whether the cascade style sheet (CSS) should be internal or external (the Ellipsis EllipsisButton button to browse for a *.css file);
  • determine whether boolean fields of the table should be exported as HTML check boxes.

Export Data - Format-specific options - HTML - Basic


Multi-file

The Multi-file tab provides you with an ability to split the target HTML file into several separate files. This tab allows you to specify the record count for a single file, set an option to generate an index HTML file, and add an ability to navigate between the exported files.

Export Data - Format-specific options - HTML - Multi-file

Multi-file export

CheckBox Use multi-file export

Enables/disables the multi-file export feature.

Record(s) in a single file

Use the spinner control to specify the number of records to be exported into each of the files.

CheckBox Generate index

Specifies that an index file containing links to all the data files will be generated. Use the edit-box next to the checkbox to set a name for the index file.

Navigation

This group allows you to specify properties for navigation elements, i.e. the elements that provide quick access to pages of the multi-file document. Navigation is implemented as a set of hyperlinks.

CheckBox On top

Specifies that the hyperlinks will be placed at the top of the page.

CheckBox On bottom

Specifies that the hyperlinks will be placed at the bottom of the page.

Use the Index link, First link, Prior link, Next link and Last link boxes to specify captions for the corresponding navigation elements.


Advanced

The Advanced tab allows you to set a number of advanced options to be applied to the result HTML file.

Export Data - Format-specific options - HTML - Advanced

Body options

Default font

Use the drop-down list to select the font that will be used in the result file by default.

Background

If necessary, use the Ellipsis EllipsisButton button to browse for a graphical file to be applied as the page background.

Table options

Use the spinner controls to specify common table options: cell padding, cell spacing, border.

Background

If necessary, use the Ellipsis EllipsisButton button to browse for a graphical file to be applied as the table background.

It is also possible to define advanced attributes for both the HTML body and table.


PDF options

This step allows you to set options for the target PDF (*.pdf) file.

Fonts

This group of options allows you to customize fonts for the header, caption, data, footer of the result file.

Use the Base font name and Font encoding drop-down lists to select the preferable font (Helvetica, Courier, Times Roman, etc.) and encoding (Standard, WinANSI, MacRoman, PDFDoc) respectively, and the Font size spinner control to specify the font size.

Click the Font color... button to select the color to be applied to the font.

For your convenience the preview illustrating the changes is displayed in the Sample area.

Export Data - Format-specific options - PDF

Page options

Use the Page size drop-down list to select one of the standard page formats (Letter, Legal, A3, A4, etc.).

Use the Width and Height spinner controls to specify the page width and height respectively.

Use the Units drop-down list to select the unit of measure that will be used in report settings: inches, millimeters, or dots.

Use the Orientation drop-down list to select the preferable page orientation: portrait or landscape.

Margins

Use the Left, Right, Top, Bottom spinner controls to specify the corresponding page margins for the output PDF file.

Grid options

Use the Col spacing, Row spacing, Line width spinner controls to specify spacing for grid columns, rows, and grid line width respectively.

When you are done, click the Next button to proceed to Setting common export options.


TXT options

This step allows you to set options for the target text (*.txt) file.

Set the Calculate column width option on if you want each column of the target file to be adjusted to the maximum number of characters in it. The Spacing option specifies the number of spaces between columns in the target file.

Export Data - Format-specific options - TXT

When you are done, click the Next button to proceed to Setting common export options.


CSV options

This step allows you to set options for the target CSV (*.csv) file.

CheckBox Quote strings

Check this option to apply quoting for string values in the target file.

CheckBox Quote captions

Check this option to apply quoting for captions in the target file.

Specify the column separator using the Comma drop-down list and the preferable quote character using the Quote drop-down list.

Export Data - Format-specific options - CSV

When you are done, click the Next button to proceed to Setting common export options.


XML options

This step allows you to set options for the target XML (*.xml) file.

Specify XML document encoding in the Encoding edit box and set the Standalone option on if you intend to create a standalone XML document (standalone="yes").

XML type

Select the type of the result XML document: Datapacket 2.0 or Access.

Conversion between generic XML documents and documents of the XML-Datapacket (CDS) format can be performed with the help of XML Mapper by Borland®.

Export Data - Format-specific options - XML

When you are done, click the Next button to proceed to Setting common export options.


MS Excel / ODS options

This step allows you to set options for the target MS Excel (*.xlsx) or ODF Spreadsheets (*.ods) file.

Using the Base Styles tab you can set font and border options for all elements of the Excel 2007 / ODS sheet (HEADER, CAPTION, DATA, FOOTER). You can customize style options, such as font and size, background and foreground colors, text alignment, etc. for each of them by clicking the corresponding item in the list and setting the options in the right-side panel.

If necessary, you can also specify the sheet name for the target Excel 2007 / ODS file.

Use the Font and Size drop-down lists to select the font and size to be applied to the text.

Use the buttons below to set font color, make text bold, italicized, underlined, specify horizontal and vertical align.

CheckBox Background

Enables/disables background for text.

Press the [image] button to set the background color for the text.

CheckBox The Wrap Text button enables/disables the text wrapping feature.

For your convenience the previews illustrating the changes are displayed in the Sample Group area within the Base Styles and the Strip Styles tabs.

Export Data - Format-specific options - Excel 2007 - Base Styles

Using the Strip Styles tab you can create a style template: set font, size, background color, text alignment, wrap text options and save them.

To add a style template, click the Plus iconPlus button.

To delete a style template, select it and click the Minus iconMinus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Excel 2007 - Strip Styles

You can reset the changes any time using the Reset Item and the Reset All buttons.

CheckBox Use border

Enables/disables borders in the output file.

Press the [image] button to set the color to be applied to the borders.

Use the Border Style drop-down list to select the preferable style that will be used for borders (thin, dashed, dashdot, dotted, etc.).

When you are done, click the Next button to proceed to Setting common export options.


Access options

This step allows you to set options for the target MS Access (*.accdb) file.

Set the name for the target table and specify whether the wizard should create a new table in the MS Access database if it does not exist yet, or use the existing table to export data into.

Export Data - Format-specific options - Access 2007

When you are done, click the Next button to proceed to Setting common export options.


MS Word / ODT options

This step allows you to set options for the target MS Word (*.docx) or ODF text (*.odt) file.

Using the Base Styles tab you can set font options for all elements of the Word 2007 / ODT document (HEADER, CAPTION, DATA, FOOTER). You can customize style options, such as font and size, background and foreground colors, text alignment, text highlight, etc. for each of them by clicking the corresponding item in the list and setting the options in the right-side panel.

Use the Font and Size drop-down lists to select the font and size to be applied to the text.

Use the buttons below to set font color, make text bold, italicized, underlined, strikethrough text, specify horizontal align.

CheckBox Background

Enables/disables background for text.

Press the [image] button to set the background color for the text.

CheckBox Highlight

Enables/disables text highlight.

If this option is enabled, you should select the preferable highlight color from the drop-down list.

For your convenience the previews illustrating the changes are displayed in the Sample Group area within the Base Styles and the Strip Styles tabs.

Export Data - Format-specific options - Word 2007 - Base Styles

Using the Strip Styles tab you can create a style template: set font, size, background color, text alignment, highlight options and save them.

To add a style template, click the Plus iconPlus button.

To delete a style template, select it and click the Minus iconMinus button.

To reorder style templates in the list, use the btnMoveItemUp btnMoveItemDown buttons.

To load a style template, click the iconLoadFromFile button.

To save the current style template, click the btnSave button.

If you have created or loaded more than one style template, they can be ignored, or used column-by-column or row-by-row (it depends on the Strip type selection).

Export Data - Format-specific options - Word 2007 - Strip Styles

You can reset the changes any time using the Reset Item and the Reset All buttons.

Using the Border tab you can enable borders in the result Word 2007 / ODT document and customize them.

CheckBox Use border

Enables/disables borders in the output file.

Press the [image] button to set the color to be applied to the borders.

Use the Border Style drop-down list to select the preferable style that will be used for borders (single, thick, double, hairline, etc.).

Export Data - Format-specific options - Word 2007 - Border

When you are done, click the Next button to proceed to Setting common export options.


Setting common export options

Use this step of the wizard to set common export options. The detailed description of these options is given below.

Export Data - Setting common export options

CheckBox Export empty tables

If checked, you can export the table even if it does not contain any data.

Skip ... record(s)

Specifies the number of records to be skipped before export starts.

RadioButton Export all records

Specifies that all records of the table will be exported.

RadioButton Export only ... record(s)

Specifies the number of records to be exported.

CheckBox Open files after export

If this option is checked, the result file will be opened with the currently associated program after the export operation is completed.

CheckBox Print files after export

If this option is checked, the result file will be sent to the default printer after the export operation is completed.

When you are done, click the Next button to proceed to the last step of the wizard.


Exporting data

This step of the wizard is intended to inform you that all export options have been set, and you can start the export process.

The log area allows you to view the log of operations and errors (if any).

Export Data - Exporting data

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the export process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the export process.

After the operation is completed, you can view the number of exported records, elapsed time, estimated export speed, and the log of operations and errors (if any).


Import Data Wizard

Import Data Wizard allows you to import data to a table / view from any of supported formats (MS Excel, MS Access, DBF, XML, TXT, CSV, HTML, MS Excel 2007, MS Word 2007, ODF). You can save your settings as a template any time for future use.

To start the wizard, right-click the table/view in DB Explorer, select the Data Manipulation context menu group and proceed to the Import Data... item within this group.

Alternatively, you can open the Data tab of Table Editor / View Editor, right-click the grid there, then select the Data Manipulation context menu group and proceed to the Import Data to <object_name>... item within this group, or use the Import Data item of the Navigation bar.

  • Setting source file name and format
  • Selecting the source to import data from
  • Setting correspondence between the source and target fields
  • Adjusting common data formats
  • Setting advanced field formats
  • Setting import mode and data write type
  • Customizing common import options
  • Importing data

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Export Data Wizard

Export as SQL Script

Using templates


Selecting source file name and format

This step of the wizard allows you to select the source file format you need to import data from.

Source file name

Type in or use the ExplorerButton button to specify the path to the file using the Open file... dialog. The file name extension changes automatically according to the selected Import Type.

Import Data - Selecting source file name and format

Import Type

Specify the format of the source file. For details refer to Supported file formats.

CSV format parameters

For CSV import you should define Delimiter and Quote settings using the corresponding drop-down lists.

Click the Next button to proceed to the Setting fields correspondence step or to the Selecting data source step of the wizard if you have selected MS Access as the source file format.


Selecting data source

This step of the wizard is only available when you are importing data from MS Access. Select a table from the table list or input a query in the corresponding text boxes to specify the data source.

If you choose a query as the data source, you also can load a SQL query from a *.sql file or save the current query text to a file using the Load from File... and the Save to File... buttons correspondingly.

Import Data - Selecting data source

Click the Next button to proceed to the Setting fields correspondence step of the wizard.


Setting fields correspondence

This step of the wizard allows you to set correspondence between columns of the source file and fields of the target InterBase/Firebird table.

  • MS Excel 97-2003
  • MS Access / DBF / XML Datapacket
  • TXT
  • CSV
  • HTML
  • XML Generic
  • MS Excel / Word, ODF

To get more information about the file formats, see the Supported file formats page.


Excel 97-2003

Specify ranges in the grid for the target and source fields:

  • select a field of the target InterBase/Firebird table in the Fields list;
  • proceed to the Sheet grid: click a column caption to select the whole column or click the row number to select the whole row;
  • the selected column/row of the source file gets green highlight, and a new range indicating the source and target fields correspondence appears in the Ranges list;
  • repeat the operation for all the fields you need to be included in the import process.

If the source Excel file and the destination InterBase/Firebird table have the same order of columns or rows, you can use the iconAutoFillColumns Auto Fill Cols or the iconAutoFillRows Auto Fill Rows buttons to set correspondence between them automatically.

If necessary, you can choose to skip a defined number of the source file columns and/or rows using the Col(s) and Row(s) spinner controls of the Skip group (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - Excel

To clear ranges for a field, select the field in the Fields list and press the iconCross Clear Ranges button.

To clear all ranges specified for the target table fields, press the iconClearAllRanges Clear All button.

Right-click a range in the Ranges list to call its popup menu. Using the popup menu you can add or edit ranges manually, remove them or change their order.

Import Data - Setting fields correspondence - Excel - Popup menu

The Range dialog allows you to edit the data range for import manually.

Range Type

Use the drop-down list to select whether a column, a row, or a cell of the source Excel file will be mapped to the target table field.

Depending on the selected range type you should specify the column (e.g. B), the row (e.g. 2) or the cell (e.g. A2).

Start / Finish

These groups allow you to set the precise data range for import: select Where data started / finished or use the spinner control to specify the start/finish row (or start/finish column).

Direction

Use this group to select the direction for importing data of the specified range: Down or Up.

Sheet

Use this group to define whether the specified range will be taken from the default Excel sheet or from a custom sheet (select sheet number or sheet name using the corresponding drop-down lists).

Import Data - Setting fields correspondence - Excel - Range

Click the Next button to proceed to the Adjusting data formats step of the wizard.


Access/DBF/XML Datapacket

Set correspondence between the source MS Access fields and the target InterBase/Firebird table fields:

  • select a field of the target InterBase/Firebird table in the Destination Fields list;
  • select the corresponding field of the source MS Access table in the Source Fields list;
  • click the iconPlus Add button to set correspondence between the selected fields;
  • the pair of fields appears in the list below;
  • repeat the operation for all the fields you need to be included in the import process.

Use the iconAutoFillColumns Auto Fill button to set correspondence between the source and target fields automatically on the basis of their order.

When importing data from a DBF file, the additional Skip deleted records option appears. Selecting this checkbox allows you to skip records marked for deletion.

Import Data - Setting fields correspondence - Access

To remove a correspondence, select the pair of fields in the list below and press the iconMinus Remove button.

To remove all correspondences, press the iconCross Clear button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


TXT

Set correspondence between the source text file columns and the target InterBase/Firebird table fields:

  • select a field of the target InterBase/Firebird table in the Fields list;
  • double-click in the text viewer area to add vertical separators delimiting the source column bounds;
  • click the area between the separators to assign the column to the selected target table field - the selected source column gets black highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If necessary, you can choose to skip a defined number of the source file lines using the Skip Lines spinner control (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - TXT

To clear all correspondences, press the iconCross Clear button.

Note: if you cannot see the content of the source text file properly, you should select the appropriate Charset to be used for processing data.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


CSV

Set correspondence between the target table fields and the source CSV file columns:

  • select a field of the target InterBase/Firebird table in the Fields list;
  • proceed to the source grid viewer area: click a caption to assign the column to the selected target table field;
  • the selected column of the source file gets gray highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If the source CSV file and the destination InterBase/Firebird table have the same order of columns, you can use the iconAutoFillColumns Auto Fill button to set correspondence between them automatically.

Note that the CSV delimiter is specified at the Selecting source file name and format step of the wizard.

The Col(s) control indicates the currently selected source file column. You can also use this spinner control for quick column selection.

If necessary, you can choose to skip a defined number of the source file rows using the Row(s) spinner control of the Skip group (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - CSV

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

Note: if you cannot see the content of the source text file properly, you should select the appropriate Charset to be used for processing data.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


HTML

Set correspondence between the target table fields and the source HTML file columns:

  • select a field of the target InterBase/Firebird table in the Fields list;
  • proceed to the source grid viewer area: select the Table from which you intend to import data and click a column to assign the column to the selected target table field;
  • the selected column of the source file gets green highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If the source HTML file and the destination InterBase/Firebird table have the same order of columns, you can use the iconAutoFillColumns Auto Fill button to set correspondence between them automatically.

The Col control indicates the currently selected source file column. You can also use this spinner control for quick column selection.

If necessary, you can choose to skip a defined number of the source file rows using the Row spinner control of the Skip group (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - HTML

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

To remove all correspondences, press the iconClearAllRanges Clear All button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


XML Generic

In order to set mapping of a Generic XML document, you should enter the relative XPath (the path must be specified in the XPath format). Press the iconAutoFillColumns Fill Grid button to get the grid filled with text and attribute values of the selected node.

Note: if the source XML document contains huge amount of data, building the tree may take a long time.

Set correspondence between the source XML file columns and the target InterBase/Firebird table fields:

  • select a field of the target InterBase/Firebird table in the Fields list;
  • proceed to the source grid viewer area: click a column to assign the column to the selected target table field;
  • the selected column of the source file gets gray highlight;
  • repeat the operation for all the fields you need to be included in the import process.

You can use the iconAutoFillColumns Auto Fill button to set correspondence between the source and target fields automatically according to their order (mapping is started from the first attribute value in this case).

The Col(s) control indicates the currently selected source file column. You can also use this spinner control for quick column selection.

If necessary, you can choose to skip a defined number of the source file lines using the Row(s) spinner control of the Skip group (e.g. if you need to exclude node headers from the imported data range).

Import Data - Setting fields correspondence - XML Document

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

To remove all correspondences, press the iconClearAllRanges Clear All button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


MS Excel/Word, ODF

Specify ranges in the grid for the target and source fields:

  • select a field of the target InterBase/Firebird table in the Fields list;
  • proceed to the Sheet grid: click a column to assign the column to the selected target table field;
  • the selected column of the source file gets green highlight;
  • repeat the operation for all the fields you need to be included in the import process.

If the source file and the destination InterBase/Firebird table have the same order of columns, you can use the iconAutoFillColumns Auto Fill button to set correspondence between them automatically.

The Col control indicates the currently selected source file column. You can also use this control for quick column selection.

If necessary, you can choose to skip a defined number of the source file rows using the Skip spinner control (e.g. if you need to exclude column headers from the imported data range).

Import Data - Setting fields correspondence - MS Excel and Word 2007, ODF

To remove a correspondence, select the field in the Fields list and press the iconCross Clear button.

To remove all correspondences, press the iconClearAllRanges Clear All button.

Click the Next button to proceed to the Adjusting data formats step of the wizard.


Adjusting data formats

This step of the wizard provides a number of options for setting common formats for all imported data:

Date & Time formats: Short date, Long date, Short time, Long time;

Separators: Decimal, Thousand, Date, Time;

Boolean True (specify the text that will be displayed for the boolean TRUE values);

Boolean False (specify the text that will be displayed for the boolean FALSE values);

NULL values (specify the text that will be displayed for the NULL values).

For more information refer to the Format specifiers page.

Import Data - Adjusting data formats

Click the Next button to proceed to the Setting advanced field formats step of the wizard.


Setting advanced field formats

This step of the wizard allows you to set formats each field separately.

Select a field in the list and adjust format options that will be applied to this field only.

Import Data - Setting advanced field formats

Specify Generator value and Generator step for incremental data generation into the specified field, or enter a Constant value which will be set for all records in the field.

Specify the NULL value which will be used for the records where the value is NULL.

If necessary, specify the default value.

Use the Left / Right quotation edit boxes to specify left/right quotation marks.

Use the Quotation action drop-down list to select whether the quotation marks should be added, removed, or left 'As is'.

Use the Character case drop-down list to select the case that will be used for string values of the field: Upper, Lower, UpperFirst, UpperFirstWord, or 'As is'.

Use the Character set drop-down list to select which charset will be used for string data in the field: ANSI, OEM, or As is.

The Replacements area allows you to set the text you need to be replaced during data import into the selected field. Press the Plus iconPlus button to specify a new replacement options using the Add Replacement dialog.

Import Data - Setting advanced field formats - Add Replacement

To edit a replacement, click the [image] Edit button.

To remove a replacement, click the iconMinus Minus button.

When you are done, click the Next button to proceed to the Setting import mode step of the wizard.


Setting import mode

This step of the wizard allows you to define the records processing mode as Insert All, Insert New, Update, Update or Insert, Delete, Delete or Insert mode:

  • Insert all: all records from the source file are inserted into the tables irrespective of whether any records exist in the destination table or not
  • Insert new: already existing records are skipped, and new records are inserted into the destination table
  • Update: all existing records are updated from the source file
  • Update or insert: already existing records are updated and new records are inserted into the destination table
  • Delete: already existing records are deleted
  • Delete or insert: existing records are deleted and new records are inserted into the destination table

Import Data - Setting import mode

Here is an example of some import modes offered by Import Data Wizard:

All import modes (except for the Insert All mode) are based on key values information. In order to perform import operations with these modes used, you need to have matches between the source file key column(s) and the destination table key field(s).

For example, your source file contains three rows with the key values 1, 2, 3, and your destination table contains three rows with the key values 1, 2, 4.

Destination table | Source file data
Import Data - Setting import mode - Destination Table | Import Data - Setting import mode - Source Table

If you use the Insert new import mode, in this case only the row with key value 3 will be inserted into the destination table.

If you use the Update import mode, then the rows with key values 1, 2 will be updated.

If you use the Update or insert import mode, then rows 1, 2 will be updated and the row with key value 3 will be inserted.

It is applied to all other import modes, except for the Insert all mode. For all these modes (except for the Insert all mode) it is obligatory to select the primary key fields. This field (or fields) is used as key field to identify specific data in the target database.

Insert new | Update | Update or insert | Delete | Delete or insert
Import Data - Setting import mode - Result - Insert new | Import Data - Setting import mode - Result - Update | Import Data - Setting import mode - Result - Update or insert | Import Data - Setting import mode - Result - Delete | Import Data - Setting import mode - Result - Delete or insert

The key columns for these operations are defined in the Key columns area.

Use Import mode to select whether to insert all records, or to update/delete existing ones. Note that for updating/deleting existing records in the target table you should move its key columns from the Available columns list to the Selected columns list.

The Key columns area allows you to select the fields of the table to be used as the key fields for the import process.

To select a field, you need to move it from the Available columns list to the Selected columns list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

When you are done, click the Next button to proceed to the Customizing common options step of the wizard.


Customizing common options

Use this step of the wizard to set common import options. The detailed description of these options is given below.

Import Data - Customizing common options

Commit

RadioButton Commit when done

Commits the transaction when all records are imported.

RadioButton Commit after each block

Inserts the COMMIT statement after a defined number of records.

RadioButton Commit changes manually

Select this option if you intend to commit the transaction manually.

Block size

Use the spinner control to define the number of records in each committed block.

Record count

RadioButton Import all records

Specifies that all records of the source file will be imported.

RadioButton Import only ... record(s)

Specifies the number of records to be imported.

When you are done, click the Next button to proceed to the last step of the wizard.


Importing data

This step of the wizard is intended to inform you that all import options have been set, and you can start the import process.

The log area allows you to view the log of operations and errors (if any).

Import Data - Importing data

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the import process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the import process.

After the operation is completed, you can view the total number of processed records, the number of inserted/updated/deleted records, the number of committed records, the number of errors, elapsed time, and the log of operations and errors (if any).


Export as SQL Script

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Export as SQL Script Wizard

Export as SQL Script Wizard allows you to export data from a table / view or from a query result to SQL script as a number of INSERT statements. You can save your settings as a template any time for future use.

To start the wizard, right-click the object in DB Explorer, select the Data Manipulation context menu group and proceed to the Export Data as SQL Script... item within this group.

Alternatively, you can open the Data tab of Table Editor / View Editor or the Result(s) tab of Query Data / Query Builder, right-click the grid there, then select the Data Manipulation context menu group and proceed to the Export <object_name> as SQL Script... item within this group, or use the Export as SQL Script item of the Navigation bar.

  • Selecting destination DBMS
  • Setting destination file name
  • Setting BLOB options
  • Selecting field to export
  • Editing the result table definition
  • Setting export options
  • Exporting as SQL Script

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Export Data Wizard

Import Data Wizard

Using templates


Selecting destination DBMS

This step of the wizard allows you to define the destination server you need to export data for. The result script will be generated in compliance with the specifications of the selected DBMS:

RadioButton DB2

RadioButton InterBase/Firebird

RadioButton Microsoft® SQL Server™

RadioButton MySQL

RadioButton Oracle

RadioButton PostgreSQL

Export as SQL Script - Defining type of destination server

CheckBox Add CREATE TABLE statement

Check this option to add the CREATE TABLE statement to the result script.

CheckBox Selected records only

This option is visible if the Export as SQL Script wizard is opened from the Data/Results grid view. If the option is checked only selected rows will be exported.

Click the Next button to proceed to the Setting destination file name step of the wizard.


Setting destination file name

Specify whether the result script will be loaded to Execute Script Editor or saved to a file.

File name

Type in or use the btnSaveAs button to specify the path to the file and the file name.

If necessary, select the File charset using the corresponding drop-down list.

Compression options

CheckBox Compress file

Check this option if you wish to compress the output file.

Compression

Define the desired compression level to be applied for the file: None, Fastest, Default, Best.

Split file every ... Mb

Specify the size (in megabytes) of each part the output file will be split into.

Enter the Table name and the Schema name to be included in the result SQL script. Schema name should only be specified for the DBMS in which this object is implemented.

Export as SQL Script - Setting destination file name

Click the Next button to proceed to the Setting BLOB options step of the wizard.


Setting BLOB options

BLOB and arrays options

In this group of options you can determine whether BLOB fields are not to be extracted, extracted as strings, or extracted into a separate file (available for DB2, InterBase/Firebird, MS SQL, Oracle destination servers). If the latter is selected, you also need to specify the File name (the *.blo file where the BLOB data will be stored) and the location of the file on your local machine using the btnSaveAs button.

CheckBox Compress file

Check this option if you wish to compress the file containing BLOB data.

CheckBox Extract array type fields into file

Check this option if you wish fields of array type to be dumped into the file.

Compression

Define the desired compression level to be applied for the file: None, Fastest, Default, Best.

Export as SQL Script - Setting BLOB options

Click the Next button to proceed to the Selecting fields to export step of the wizard.


Selecting fields to export

This step of the wizard allows you to select the table field(s) to be exported to SQL script.

To select a field, you need to move it from the Available fields list to the Selected fields list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Export as SQL Script - Selecting fields to export

Click the Next button to proceed to the Editing table definition step of the wizard.


Editing table definition

This step is available only if the Add CREATE TABLE statement option was checked on the Selecting destination DBMS step of the wizard. It allows you to view/edit the SQL script for creating the table.

For your convenience the syntax highlight, code folding and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.

Export as SQL Script - Editing table definition

Click the Next button to proceed to the Setting export options step of the wizard.


Setting export options

Specify common export options according to your needs.

If necessary, you can choose to replace non-print characters in strings with spaces.

Data options

Records in block

Use the spinner control to define the number of records in each committed block.

CheckBox Insert COMMIT after each block

Check this option to add the COMMIT statement after a defined number of records.

Export as SQL Script - Setting export options

CheckBox Quote identifiers

Quotes will be added to the script, if you enable this option.

CheckBox Use multi insert statements

Enable to generate multiple rows in a single command.

Click the Next button to proceed to Exporting as SQL Script.


Exporting as SQL Script

This step of the wizard is intended to inform you that all export options have been set, and you can start the export as SQL script process.

The log area allows you to view the log of operations and errors (if any).

Export as SQL Script - Exporting as SQL Script

CheckBox Load generated script into Script Editor

Check this option to load the result script to Execute Script Editor.

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the export process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the export as SQL script process.


Database Tools

SQL Manager for InterBase/Firebird provides graphical interface for a number of database maintenance operations. The following services are available in SQL Manager:

Dependency Tree

Allows you to view all the object dependencies in one diagram.

SQL Monitor

Displays all the SQL statements executed while working in SQL Manager for InterBase/Firebird.

Execute Script Editor

Executes SQL scripts in the database.

Extract Database Wizard

Extracts the table metadata and/or data to an SQL script which can be executed later on another machine to restore the database structure and/or data.

Compare Databases

Compares databases metedata and generates SQL script which can be executed later on another machine to synchronize the databases structure.

Print Metadata

Creates powerful metadata reports in the WYSIWYG mode ready for printing.

HTML Report

Creates powerful metadata reports in the HTML format.

Reports management

Tools for efficient management of reports: creating, editing, viewing, printing.

Search in Metadata

Provides quick search for a string within the scope of database metadata.

Database Monitor

Displays various statistics on database in general and database activities.

Event monitor

Allows you to view event notifications.

Table Altering Monitor

Allows you to view the number of changes in table and view metadata.

Server Messages Editor

Allows you to view and edit server messages.

Database Designer

Allows you to lay out your database schema visually.

Using templates

Facilitates using SQL Manager wizards.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Services

Security management

Options

External Tools

How To...


Dependency Tree

The Dependency Tree tool allows you to view all the object dependencies in one diagram.

To call the Dependency Tree window, select the Tools | btnDependencyTree Dependency Tree main menu item, or use the Dependency Tree btnDependencyTree button on the main toolbar.

  • Using Navigation bar and Toolbar
  • Viewing dependency tree

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Dependency Tree.

Dependency Tree - Using Navigation bar

Database

iconDB select a database for browsing object dependencies

General

iconRefresh refresh the currently displayed dependency tree

iconPrint print the diagram

iconPrintSetup set printing options using the Print Setup dialog

iconSaveAsPicture save the current diagram as a picture

iconOptions edit dependency tree options

iconRestoreDefaultSize restore the default size and position of the window

Object

navigate by switching to the previous object

navigate by switching to the next object

show/hide subobjects

show/hide domains

select a root object

Diagram Layout

show all objects

show objects depending on the Root object

show objects the Root object depends on

Items of the Navigation bar are also available on the ToolBar of the Dependency Tree window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

Hint: Items of the Object pane of the Navigation bar are also available in the context menu of the Dependency Tree area.


Viewing dependency tree

To view dependencies of an object, click the Select object Navigation bar item. Then select the required object in the Select Object dialog window. The dependency tree will appear in the main area of the window.

Dependency Tree - Select object

While the tree of dependencies is being built, the progress bar is displayed in the status area at the bottom of the window.

The root object is marked out in blue.

The objects that the root object depends on are located to the left of the root object.

The objects that depend on the root object are located to the right of the root object.

Object dependencies are denoted as regular arrows from the left to the right (->).

A cyclic dependency (i.e. when the object already has some other depending object(s)) is denoted as a line ending with a cross (-x).

You can switch between objects by selecting them in the diagram. The selected object becomes the root object. To make an object root, you can also right-click it in the diagram area and select Set as Root from the context menu. The context menu of an object also allows you to edit it using the corresponding editor.

The history of selected root objects is also available: you can move back and forward through this history using the Previous object and the Next object links on the Navigation bar or toolbar.

Hint: To show/hide subobjects (e.g. table triggers, foreign keys), click the Show subobjects / Hide subobjects item on the Navigation bar.

See also:

Select Object dialog


SQL Monitor

SQL Monitor allows you to view the log of all operations performed over databases and database objects in SQL Manager for InterBase/Firebird. The content of the window is read-only.

To open the SQL Monitor window, select the Tools | [image] SQL Monitor main menu item, or use the Shift+Ctrl+M shortcut.

  • Using Navigation bar and Toolbar
  • Working with SQL Monitor

See also:

SQL Monitor options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in SQL Monitor.

SQL Monitor - Using Navigation bar

General

clear the content of the window

save the content to a *.txt file using the Save as... dialog

iconFindText search for a string using the Find Text dialog

iconSearchAgain search again

iconOptions configure SQL Monitor using the SQL Monitor section of the Environment Options dialog

iconRestoreDefaultSize restore the default size and position of the window

iconAlwaysOnTop specify that the window is displayed on top of other child windows

Items of the Navigation bar are also available on the ToolBar of SQL Monitor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Working with SQL Monitor

The working area of SQL Monitor lists the log of database operations and SQL queries as items, each consisting of 3 parts: Executed (the date and time of the operation), Operation (SQL statement sent to the server), Result (the result of the operation).

Items of the context menu of SQL Monitor area provide access to various functions for working with the window content. The context menu contains standard text-processing functions (Copy, Select All), spelling checking and functions for working with the content as a whole, e.g. you can set markers, move the cursor to a particular line, save the content to a file or as a favorite query, configure the editor using the properties item or preview/print the content. Most of these operations can be also performed with the corresponding hot keys used.

Implementation of the Find Text dialog and Incremental search bar contributes to more efficient work with the content of SQL Monitor.

SQL Monitor - Working with SQL Monitor


Execute Script

Using Execute Script Editor you can view, edit and execute SQL scripts.

To open Execute Script Editor, select the Tools | btnShowSQLScript Execute Script main menu items or use the corresponding btnShowSQLScript toolbar button. You can also use the Shift+Ctrl+S shortcut for the same purpose.

In the script area you can view and edit the SQL script text. For your convenience syntax highlight and code completion features are implemented.

  • Using Navigation bar and Toolbar
  • Working with Execute Script editor area
  • Using Script Explorer
  • Script execution

Note: SQL Script editor does not show results returned upon SELECT queries execution. Please use Query Data for that purpose instead.

See also:

Query Data

SQL Script options

Editor Options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in SQL Script Editor.

SQL Script Editor - Using Navigation bar

Destination

iconHost select a host

iconDB select a database for the script

General

iconAutoDDL toggle AutoDDL

iconExecute execute the current script

iconExecuteSelectedOnly execute selected code only

iconExecuteUnderCursor execute code under cursor

iconCompile execute a script from file

iconNew create a new script

iconLoadFromFile load a script from an *.sql file using the Open SQL Script dialog

iconSaveToFile save the current script

iconSaveToFileAs save the script to an *.sql file using the Save as... dialog

iconDBExplorer enable/disable parsing of SQL code

enable/disable result log

iconOptions configure SQL Script Editor within the Script Options section of the Environment Options dialog

iconShowSQLHelp show SQL help

iconRestoreDefaultSize restore the default size and position of the editor window

Explorer

iconDBExplorer browse the tree objects used in the script using the Script Explorer pane

Items of the Navigation bar are also available on the ToolBar of SQL Script Editor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

See also:

Working with Execute Script editor area

Using Script Explorer

Script execution


Working with SQL Script editor area

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Working with Execute Script editor area

The Editor area of SQL Script is provided for efficient working with SQL scripts in text mode.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented:

  • using object links allowing you to open the object in the associated editor;
  • ability to display line numbers;
  • code folding for statements and clauses;
  • customizable margins and gutters;
  • formatting code for better representation

and more.

The context menu of Execute Script Editor area contains execution commands, most of the standard text-processing functions (Cut, Copy, Paste, Select All), spelling checking and functions for working with the script as a whole, e.g. you can enable/disable parsing, toggle bookmarks and comments, move the cursor to a particular line, change the case of selected text, load/save the content from/to a file or save as a favorite query, configure the editor using the Properties item or preview/print the text of the script. Most of these operations can be also performed with the corresponding hot keys used.

Implementation of the Find Text / Replace Text dialogs and Incremental search bar contributes to more efficient work with the SQL code.

SQL Script Editor - Working with SQL Script editor area

See also:

Using Navigation bar and Toolbar

Using Script Explorer

Script execution

Managing Favorite queries

Execute Script options


Using Script Explorer

The Explorer group on the Navigation bar displays the tree of objects, used in the current script and allows you to get to the required script fragment quickly by clicking the object in the tree.

SQL Script Editor - Using Script Explorer

Hint: When you click a node in the Script Explorer tree, the corresponding SQL statement is highlighted in the editor area. If you double-click a node, the corresponding SQL statement is highlighted, and the current focus is switched to the editor area (the cursor appears after the highlighted statement).

See also:

Using Navigation bar and Toolbar

Working with Execute Script editor area

Database Objects Management


Script execution

When all the script parameters are set, you can immediately execute the script in Execute Script Editor.

To execute a script, click the btnExecuteQuery Execute script item of the Navigation bar or toolbar. You can also use the context menu or F9 hot key for the same purpose.

SQL Script Editor - Script execution

Note: If the CheckBox Execute selected text separately option (see the Tools | Execute Script section of the Environment Options dialog) is enabled (by default) and a text fragment is currently selected, only this fragment is executed when you click Execute script on the Navigation bar or press F9. If this option is disabled, the whole script is executed, but you can still execute the selected fragment using the corresponding Execute Selected Only item of the context menu or by pressing Ctrl+F9.

If the SQL syntax is correct, the script is executed and the 'Done!' information message appears.

SQL Script Editor - Script execution - Done

If the syntax contains errors or script cannot be executed, the corresponding error message is displayed in the status bar area at the bottom of the editor window.

Hint: When you select an item from the error list (in the status bar area), the corresponding SQL statement is highlighted in the editor area. If you double-click an item, the corresponding SQL statement is highlighted, and the current focus is switched to the editor area (the cursor appears after the highlighted statement).

Note: Execute Script Editor does not show results returned upon SELECT queries execution. Please execute such queries in Query Data to see the result dataset.

See also:

Using Navigation bar and Toolbar

Working with Execute Script editor area

Using Script Explorer


Extract Database Wizard

Extract Database Wizard allows you to extract database objects and/or data to an SQL script, e.g. for backup purposes.

To start the wizard, select the Tools | btnExtractDB Extract Database... main menu item, or right-click the database alias in the DB Explorer tree and select the Tasks | btnExtractDB Extract Database... item from the context menu.

  • Selecting a database for extraction
  • Specifying destination file name
  • Setting extraction mode
  • Setting BLOB options
  • Selecting objects for metadata extraction
  • Selecting objects for data extraction
  • Customizing script options
  • Start of extraction process
  • Using templates

See also:

Execute Script Editor

Database Objects Management

Using templates


Selecting source database

This step of the wizard allows you to select the source database from which metadata and/or data are to be extracted.

If necessary, check the CheckBox Extract all metadata and data of the database option to simplify the wizard.

Extract Database - Selecting source database

Click the Next button to proceed to the Specifying destination file name step of the wizard.


Specifying destination file name

Script destination

This group of options allows you to specify whether the result SQL script will be automatically loaded to Execute Script Editor or saved into a file.

File name

Set a name for the result *.sql file and type in or use the Save as... btnSaveAs button to specify the path to this file on your local machine or on a machine in the LAN.

File charset

If necessary, use the drop-down list to select the character set to be applied to the output file.

Compression options

CheckBox Compress file

Check this option if you wish to compress the output file.

Compression

Define the desired compression level to be applied for the file: None, Fastest, Default, Best.

Split file every ... Mb

Specify the size (in megabytes) of each part the output file will be split into.

Extract Database - Specifying destination file name

Depending on whether you have checked the CheckBox Extract all metadata and data of the database option at the Selecting source database step, upon pressing the Next button you will either proceed to the next step of the wizard, or you will be immediately forwarded to the Setting BLOB options step, and then to the Customizing script options step of the wizard.


Setting extraction mode

This step allows you to specify the extraction mode: choose whether structure only, data only or both are to be extracted.

Extract Database - Setting extraction mode

Click the Next button to proceed to the Setting BLOB options step of the wizard.


Setting BLOB options

BLOB and arrays options

In this group of options you can determine whether BLOB fields are not to be extracted, extracted as strings (should be used in case BLOB fields contain only text data), or extracted into a separate file. If the latter is selected, you also need to specify the File name (the *.blo file where the BLOB data are to be stored) and the location of the file on your local machine using the Save as... btnSaveAs button.

Note: Extracting BLOB fields as strings can lead to the inability to execute an SQL query because the query length is limited to 64K.

CheckBox Compress file

Check this option if you wish to compress the file containing BLOB data.

CheckBox Extract array type fields into file

Check this option if you wish fields of array type to be dumped into the file.

Compression

Define the desired compression level to be applied for the file: None, Fastest, Default, Best.

Extract Database - Setting BLOB options

Note: If you choose to RadioButton Extract BLOB fields into file then afterwards the result SQL file can be restored only by using the SQL Manager for InterBase/Firebird Execute Script tool.

Click the Next button to proceed to Selecting objects for structure extraction.


Selecting objects for structure extraction

This step of the wizard allows you to select objects for metadata extraction.

Note that this step is only available if the CheckBox Extract all metadata and data of the database option was unchecked when selecting the source database.

RadioButton Extract all objects

Adds all objects of the database to structure extraction process.

RadioButton Extract selected objects

Adds only selected objects to structure extraction process.

Objects to copy

Use the drop-down list to select the type of objects to be extracted.

To select an object, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Extract Database - Selecting objects for structure extraction

Click the Next button to proceed to Selecting objects for data extraction.


Selecting objects for data extraction

This step of the wizard allows you to select tables for data extraction.

Note that this step is only available if the CheckBox Extract all metadata and data of the database option was unchecked when selecting the source database.

RadioButton Extract data of the selected tables

Adds only selected tables to data extraction process.

To select a table, you need to move it from the Available list to the Selected list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the tables from one list to another.

RadioButton Extract data of all tables

Adds all tables of the database to data extraction process.

RadioButton Extract data of tables selected on the previous step

Adds only the tables selected for metadata extraction.

Extract Database - Selecting objects for data extraction

Click the Next button to proceed to the Customizing script options step of the wizard.


Customizing script options

This step allows you to customize common script options and data options for the extraction process.

Script options

CheckBox Generate "CREATE DATABASE" statement

Check this option to add the CREATE DATABASE statement to the result script.

CheckBox Generate "CONNECT DATABASE" statement

Check this option to add the CONNECT DATABASE statement to the result script.

CheckBox Include Password in "CONNECT" and "CREATE DATABASE" statements

Check this option to add the PASSWORD clause to the CONNECT / CREATE DATABASE statements in the result script.

CheckBox Generate "CREATE JOURNAL" statement

When this option is enabled, the CREATE JOURNAL statement will be created in the script.

CheckBox Generate "DROP" statements for objects

Check the option to add the DROP statements for the extracted objects in the result script.

CheckBox Generate "SET AUTO DDL" statement

Check this option to add the SET AUTO DDL statement, and select whether SET AUTO DDL ON or SET AUTO DDL OFF is to be used in the result script.

CheckBox Set generators

Check this option to add the SET GENERATOR statements to the result script.

CheckBox Include object descriptions

This option specifies whether object descriptions will be included in the result script or not.

CheckBox Include trigger messages

This option specifies whether trigger messages will be included in the result script or not.

CheckBox Include privileges

This option specifies whether granted privileges will be included in the result script or not.

CheckBox Use dependencies

This option determines objects' dependencies usage in the extraction process. Check the option to extract all objects that the selected objects depend on.

Extract Database - Customizing script options

Data options

Records in a block / CheckBox Insert "COMMIT" statement after each block

These controls allow you to define whether the COMMIT statement is added to the script or not, and to specify the number of records in each block to be supplemented with this statement.

CheckBox Abort extraction on error

This option determines whether the extraction process should be stopped or forced to continue if an error occurs.

Click the Next button to proceed to the last step of the wizard.


Start of extraction process

This step of the wizard is intended to inform you that all extraction options have been set, and you can start the extraction process.

The log area allows you to view the log of operations and errors (if any).

Extract Database - Start of extraction process

CheckBox Load script to Script Editor

Check this option to load the result script to Execute Script Editor.

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the extraction process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the extraction process.


Compare Databases

Compare Databases Wizard creates an SQL script that provides database structure synchronization. To launch the wizard use the Tools | iconCompare Compare Databases... item of the main menu.

Selecting source database

Selecting target database

Selecting type of synchronization script

Selecting additional options

Comparing databases

See also:

Execute Script Editor

Database Objects Management

Using templates


Selecting source database

Use this step to define source database for comparing.

Compare Database - Selecting source database

Source host

Defines host where source database is located.

Source database

Select source database from the drop-down list.

Click the Next button to proceed to the Selecting target database step of the wizard.


Selecting target database

Use this step to define target database for comparing.

Compare Database - Selecting target database

Target host

Defines host where target database is located.

Target database

Select target database from the drop-down list.

Click the Next button to proceed to the Selecting type of synchronization script step of the wizard.


Selecting type of synchronization script

Specify the direction of comparing selected database.

Compare Database - Selecting script type

RadioButton Target database into source database

Enables reverse comparing: the synchronization script will contain statements which make the target database identical to the source one.

RadioButton Source database into target database.

Enables direct comparing: the synchronization script will contain statements which make the source database identical to the target one.

Click the Next button to proceed to the Selecting additional options step of the wizard.

Use the templates button to save current settings to template or to restore settings from an existing template.


Selecting additional options

Script destination

This group of options allows you to specify whether the result SQL script will be automatically loaded to Execute Script Editor or saved into a file.

File name

Set a name for the result *.sql file and type in or use the Save as... btnSaveAs button to specify the path to this file on your local machine or on a machine in the LAN.

File charset

If necessary, use the drop-down list to select the character set to be applied to the output file.

Compare Database - Selecting additional options

Click the Next button to proceed to the last step of the wizard.


Comparing databases

This step of the wizard is intended to inform you that all extraction options have been set, and you can start the extraction process.

The log area allows you to view the log of operations and errors (if any).

Compare Database - Start of comparizon process

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the extraction process is completed.

If necessary, you can save a template for future use.

Click the Run button to run the extraction process.


Print Metadata

Print Metadata allows you to generate and print metadata reports of any database object(s).

To open the window, select the Tools | btnPrintMetadata Print Metadata main menu item, or use the Print Metadata btnPrintMetadata button on the main toolbar.

  • Using Navigation bar and Toolbar
  • Selecting objects
  • Printing options
  • Print Preview

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management

Print Metadata options


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Print Metadata.

Print Metadata - Using Navigation bar

Database

iconDB select a database for the printing report

General

iconPrint print metadata of the selected object(s)

iconPreview preview the printing report

iconRestoreDefaultSize restore the default size and position of the window

Show

Tick filter database objects available in the Available Objects list by type

Items of the Navigation bar are also available on the ToolBar of the Print Metadata window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Selecting objects

The Print Metadata window allows you to select the database objects for printing metadata.

To select an object, you need to move it from the Available Objects list to the Objects for Printing list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

Print Metadata - Selecting objects

After you select one or several objects, the Printing Options pane appears at the bottom. Select an object in the Objects for Printing list and specify items to be included into the printing report. For details see Printing options.

Note: You can btnPrintPreview preview the printing report and btnPrintMetadata print metadata for objects of the selected type using the corresponding items of the Navigation bar (or toolbar). For details see Report Viewer.


Printing options

The Printing Options area is available in the bottom right corner of the Print Metadata window. It is also available within a separate Printing options dialog when called from a Navigation bar or toolbar of an object editor.

Print Metadata - Printing options

Categories for printing

Use this group to specify items to be included into the printing report: Fields/Params, Indexes, Foreign keys, Checks, DDL, Description, Triggers (availability of the items depends on the object).

Click the Print button to call the standard Print dialog to set printer configuration and start printing the report.

Click the Preview button to call the Report Viewer dialog to preview the report.

Click the Design button to call Report Designer to edit the report.


HTML Report Wizard

HTML Report wizard allows you to generate a detailed HTML report of the selected database objects.

To start HTML Report Wizard, select the Tools | [image] HTML Report main menu item, or use the HTML Report [image] button on the main toolbar. Alternatively, you can right-click the database alias in the DB Explorer tree and select the Tasks | HTML Report... item from the context menu.

  • Selecting database and directory
  • Selecting object types
  • Specifying CSS for HTML report
  • Setting additional report options
  • Creating HTML report
  • Using templates

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management

Using templates


Selecting database and directory

At this step of the wizard you should select the source database and output directory for the HTML report.

Source database

Use the drop-down list of registered and connected databases to select the source database for the report.

Output directory

Type in or use the ExplorerButton button to specify the path to the output directory for the result HTML files using the Browse for Folder dialog.

HTML Report - Selecting database and directory

Click the Next button to proceed to the Selecting object types step of the wizard.


Selecting object types

Use this step of the wizard to select the types of objects to be included in the result HTML report.

HTML Report - Selecting object types

For your convenience the Check All and Unckeck All buttons are implemented at the bottom of the objects list area.

Click the Next button to proceed to the Specifying CSS step of the wizard.


Specifying CSS

This step of the wizard allows you to edit the CSS (Cascading Style Sheet) file that will be used by the result HTML report.

HTML Report - Specifying CSS

Click the Next button to proceed to the Setting additional report options step of the wizard.


Setting additional report options

Use this step of the wizard to set additional HTML report options.

HTML Report - Setting additional report options

If necessary, you can set optional text to Report header and Report footer of the result HTML report. For your convenience the default header and footer text is already available. If necessary, you can edit this text according to your needs.

Click the Next button to proceed to Creating HTML report.


Creating HTML report

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

HTML Report - Creating HTML report

CheckBox Show report after generating

This option opens the result report in your default browser after generating.

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the creating HTML report process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process.


Reports management

SQL Manager for InterBase/Firebird provides several tools for efficient reports management:

Create Report Wizard

This tool is used to simplify the process of creating reports.

Report Designer

It is a basic tool for creating powerful reports.

Report Editor

Allows you to manage created reports.

Report Viewer

Allows you to preview reports before printing and export them to other formats.

Reports can be stored either in the database (table IFM$REPORTS will be created to store them) or in a directory on your hard drive specified on the Directories page of the Database Registration Info dialog.


Create Report Wizard

Using Create Report Wizard you can create a report containing required datasets, bands and fields on them, with a definite report style applied.

To start the wizard, select the Database | New Object... main menu item, then select Report in the Create New Object dialog. Alternatively, you can right-click the Reports node of the DB Explorer tree and select the New Report... item from the context menu.

  • Specifying report name and options
  • Selecting report bands
  • Selecting report style
  • Specifying paper settings
  • Specifying margins
  • Specifying other page settings

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Report Designer

Report Editor

Report Viewer


Specifying database name and report options

Select the source database for adding a report and choose the action you need to perform: either create a new report or import an existing report from file.

Set the name for the new report and specify the save options for it: .

RadioButton Save to database

The report will be created on the server inside the database.

RadioButton Save to file

If this option is selected, the report will be saved as a *.fr3 file to the directory specified on the Directories page of the Database Registration Info dialog.

Create Report - Specifying database name and report options

Click the Next button to proceed to the Selecting report bands step of the wizard.


Selecting report bands

This step of the wizard allows you to select the bands to be included in the report.

To select a band, you need to move it from the Available Bands list to the Report Bands list. Use the Items - Move to Selected Items - Move all to Selected Items - Move to Available Items - Move all to Available buttons or drag-and-drop operations to move the fields from one list to another.

Use the Edit [image] button to create datasets for 'data' bands using Query Builder.

Create Report - Selecting report bands

Brief information about bands functionality is listed below. See FastReport Help for more information.

Name | Functionality
Report title | Prints once at the beginning of report
Report summary | Prints once at the end of report
Page header | Prints at the top of each page
Page footer | Prints at the bottom of each page
Master header | Prints at the beginning of master list
Master data | Data rows of master list
Master footer | Prints at the end of master list
Detail header | Prints at the beginning of detail list
Detail data | Data rows of detail list
Detail footer | Prints at the end of detail list
Subdetail header | Prints at the beginning of subdetail list
Subdetail data | Data rows of subdetail list
Subdetail footer | Prints at the end of subdetail list
Group header | Prints at the beginning of each group
Group footer | Prints at the end of each group

Click the Next button to proceed to the Selecting report style step of the wizard.


Selecting report style

Select the report style by clicking one of the images illustrating the styles available for the report.

Create Report - Selecting report style

Click the Next button to proceed to the Specifying paper settings step of the wizard.


Specifying paper settings

Specify report options: paper size and orientation, page margins, other settings. For details see Page settings.

Create Report - Specifying paper settings

Use the Margins tab to specify margins for the result report.

CheckBox Open the report after the wizard has finished

If this option is checked, the report will be opened in Report Designer after generating.

When you are done, click the Finish button to run the report generation process.


Specifying margins

Page margins

CheckBox Stretch to print area

If this option is checked, the size of report is adjusted to the print area. If this option is unchecked, you can specify the left, right, top and bottom margins (in millimeters).

Create Report - Specifying margins

Use the Other tab to specify other page settings for the result report.

CheckBox Open the report after the wizard has finished

If this option is checked, the report will be opened in Report Designer after generating.

When you are done, click the Finish button to run the report generation process.


Specifying other page settings

Options

CheckBox Print to previous page

This option allows to use white space on a previous page. This option can be used in case when a report template consists of several pages or when printing batch (composite) reports.

CheckBox Two-pass report

If this option is selected, report's formation will be performed in two steps. During the first pass, a report is formed, and is divided into pages, but the result is not saved anywhere. During the second pass a standard report formation with saving a result in the stream is performed.

CheckBox Page numbering

This option allows to print a page numbers.

Columns

Number

This parameter specifies the number of columns for multi-column reports' printing.

Gap, mm

This parameter specifies the width of the gap between columns.

Create Report - Specifying other page settings

CheckBox Open the report after the wizard has finished

If this option is checked, the report will be opened in Report Designer after generating.

When you are done, click the Finish button to run the report generation process.


Report Designer

Report Designer allows you to create and edit reports. This tool can be opened after completion of Create Report Wizard to design a new report.

To edit an already existing project, use the appropriate Navigation bar item of Report Editor.

This module is provided by Fast Reports, Inc. (http://www.fast-report.com) and has its own help system. Press F1 key in the Report Designer to call the FastReport help.

Please find the instructions on how to create a simple report in the Report Designer below:

  • Adding dialog form
  • Adding database and query components
  • Adding report data
  • Report Preview
  • Saving the report

Note: The Object Inspector which allows you to edit report object properties, can be shown/hidden by pressing the F11 key.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Create Report Wizard

Report Editor

Report Viewer


Adding dialog form

To add a dialog form, select the File | New Dialog main menu item in Report Designer.

The new dialog appears within the DialogPage1 tab of the designer. Use the available RAD tools to add necessary interface elements to the dialog.

Report Designer - Adding dialog form

To call the dialog, proceed to the Code tab and supply the corresponding statement (PascalScript), e.g.

begin

DialogPage1.ShowModal;

end.

Using the Language drop-down list you can select the script language to be used for the event handler: PascalScript (by default), C++Script, BasicScript, JScript.

For instance, the following C++ Script code can be used as the handler for the OnClick event of the 'Show' button to open FIBQuery:

{

FIBQuery1.Active = true;

}

See also:

Adding database and query components

Adding report data

Saving the report


Adding database and query components

Adding database component

In order to add the Database component:

  • proceed to the Data tab of Report Designer;
  • pick the [image] Database component on the toolbar (on the left);
  • click within the working area - the corresponding FIBDatabase1 icon appears in the area;
  • set the database name and authorization parameters within the Properties Inspector.

Report Designer - Adding database component

Adding query component

In order to add the Query component:

  • proceed to the Data tab of Report Designer;
  • pick the [image] Query component on the toolbar (on the left);
  • click within the working area - the corresponding FIBQuery1 icon appears in the area;
  • set the database name and authorization parameters within the Properties Inspector;
  • double-click the FIBQuery1 icon to open the SQL window;
  • input the SQL query that returns the required dataset and click the btnPostEdit button;
  • repeat the operation if you wish to add other query components to the report.

Report Designer - Adding query component

Note: The Properties Inspector panel which allows you to edit report object properties can be shown/hidden by pressing the F11 key.

Using the above given steps you can create as many queries as you need. In order to select a dataset returned by a query, select the Report | Data... main menu item of Report Designer to call the Select Report Datasets dialog. Pick the required query within the dialog and press OK.

Report Designer - Selecting datasets

See also:

Adding dialog form

Adding report data

Saving the report


Adding report data

Adding bands

In order to add a band to the report:

  • proceed to the Page1 tab of Report Designer;
  • pick the [image] Insert Band component on the toolbar (on the left);
  • select the band to be added to the report;
  • click within the working area - the corresponding element appears in the area;
  • set element properties within the Properties Inspector.

Report Designer - Adding bands

Adding report data

In order to add data to the report:

  • proceed to the Data tab within the panel on the right side of the window;
  • pick a field within the [image] Data tree and drag it to the working area;
  • add all necessary elements one by one using drag-and-drop operation for each of them.

Report Designer - Adding report data

Note: The Properties Inspector panel which allows you to edit report object properties can be shown/hidden by pressing the F11 key.

Note: To preview the newly created report, select the File | Preview main menu item or use the corresponding btnPrintPreview Preview toolbar button. You can also use the Ctrl+P shortcut for the same purpose. For details see Report Viewer.

See also:

Adding dialog form

Adding database and query components

Saving the report


Saving the report

When all report parameters are set, you can save the report to an external *.fr3 file on your local machine or on a machine in the LAN.

To save the report, select the File | btnSave Save main menu item or use the corresponding btnSave Save Report toolbar button. You can also use the Ctrl+S shortcut for the same purpose.

If necessary, you can add the report to the database using Create Report Wizard and perform preview/print operations using Report Editor.

See also:

Adding dialog form

Adding database and query components

Adding report data


Report Editor

Report Editor allows you to view, edit, save and print reports.

To open a report in Report Editor, double-click it in the DB Explorer tree, or right-click it and select the Edit Report <report_name>... item from the context menu.

  • Using Navigation bar and Toolbar
  • Viewing Report

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Create Report Wizard

Report Designer

Report Viewer


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Report Editor.

Report Editor - Using Navigation bar

The Navigation bar of Report Editor allows you to:

Object

iconDB select a database

select a report

General

iconRefresh refresh the content of the window

edit report using Report Designer

iconSaveToFile save the current report

iconSaveToFileAs save the report to a *.fr3 file using the Save as... dialog

iconPrint print the report

iconRestoreDefaultSize restore the default size and position of the viewer window

Items of the Navigation bar are also available on the ToolBar of the Report Editor window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Viewing Report

The main window of Report Editor allows you to view the specified report.

Possible report operations are available through the Navigation bar and toolbar of the editor window.

Report Editor - Viewing Report


Report Viewer

Report Viewer allows you to preview reports generated in SQL Manager before printing and export them to other formats.

This module is provided by Fast Reports, Inc. (http://www.fast-report.com) and has its own help system. For more information refer to the Fast Report User Manual (FRUserManual.chm) distributed with the program.

The tool opens automatically when a btnPrintPreview Preview item is used in Print Metadata or Report Designer.

  • Using Toolbar and context menu
  • Working with Report Viewer
  • Page settings
  • Sending Report by E-mail

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Create Report Wizard

Report Designer

Report Editor


Using Toolbar and context menu

The Toolbar and context menu provide quick access to tools implemented in Report Viewer.

Report Viewer - Using Toolbar

The Toolbar of Report Viewer allows you to:

btnPrint print the report

iconSaveToFile save the current report to an external *.fp3 file

call a menu allowing you to export the preview content to any of the available formats: PDF file, HTML file, RTF file, Excel table (OLE), Excel table (XML), BMP image, JPEG image, TIFF image, GIF image, E-mail, CSV file, Text file, Open Document Spreadsheet, Open Document Text, Text (matrix printer)

specify Export to PDF options

specify Send by E-mail options

search for text within the report content

zoom in

zoom out

enable/disable full screen view

enable/disable report outline

enable/disable report thumbnails

specify page settings

navigate to the first page of the report

navigate to the previous page of the report

navigate to the next page of the report

navigate to the last page of the report

Items of the Toolbar are also available in the context menu of the Report Viewer window. To open the menu, right-click in the working area of the viewer.


Working with Report Viewer

Report Viewer provides a quick preview of data and metadata reports generated in SQL Manager:

  • Viewing data report
  • Viewing metadata report

Data Report

The screenshot below illustrates viewing data reports generated with the Report Designer tool.

Report Viewer - Data

Metadata Report

The screenshot below illustrates viewing metadata reports generated with the Print Metadata tool.

Report Viewer - Metadata

Note: Report Viewer tools are available through the toolbar and context menu of the preview area.


Page settings

The Page Settings dialog allows you to configure page size, orientation, margins, and other settings.

Report Viewer - Page Settings

Size

Select one of the standard paper types from the drop-down list, or specify custom width and height using the corresponding controls below (in centimeters).

Orientation

Select the preferable page orientation (your selection is illustrated in the chart on the right):

RadioButton Portrait

RadioButton Landscape

Margins

Use this group to specify the left, right, top and bottom margins (in centimeters).

Other

Select the scope the settings are to be applied to:

RadioButton Apply to the current page

RadioButton Apply to all pages

For more information refer to the Fast Report User Manual distributed with the program.


Exporting report content

The Export dialog allows you to configure page range and a number of output format settings.

Report Viewer - Export to PDF

Page range

This group allows you to specify which report pages are to be exported:

RadioButton All

RadioButton Current page

RadioButton Specified pages (you should input page number(s) and/or page range(s) in the edit box)

Format-specific settings

These settings vary according to the specified output format: PDF file, HTML file, RTF file, Excel table (OLE), Excel table (XML), BMP image, JPEG image, TIFF image, GIF image, E-mail, CSV file, Text file, Open Document Spreadsheet, Open Document Text, Text (matrix printer).

For more information refer to the Fast Report User Manual distributed with the program.


Sending by E-mail

The Send by E-mail dialog allows you to send a report by e-mail in any supported format.

Report Viewer - Sending by E-mail

For more information refer to the Fast Report User Manual distributed with the program.


Search in Metadata

The Search in Metadata tool is implemented for quick search within the scope of database metadata. The tools allows you to set various search conditions and view the results.

To launch the Search in Metadata tool, select the Tools | iconSearchInMetadata Search in Metadata main menu item, or use the Ctrl+Alt+F shortcut.

  • Using Navigation bar and Toolbar
  • Setting search conditions
  • Viewing search results

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Search in Metadata.

Search in Metadata - Using Navigation bar

The Navigation bar of the Search in Metadata tool allows you to:

Database

iconDB select a database for searching

General

iconSearchInMetadata set search conditions

iconRestoreDefaultSize restore the default size and position of the window

Explorer

iconDBExplorer browse the tree of found database objects

Items of the Navigation bar are also available on the ToolBar of the Search in Metadata tool. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Setting search conditions

The Find in metadata dialog allows you to set search conditions. It opens each time the Search in Metadata tool is launched.

Search in Metadata - Setting search conditions

Text to find

Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Database

Use the drop-down list to select a database for the search operation.

Options

Available search options are similar to those provided by the Find Text dialog. For detailed description of the search options refer to the Find Text dialog page.

When all the options are set, click OK. The Search in Metadata [search string] report window will display the search progress and results.

See also:

Find Text dialog


Viewing search results

The Search in Metadata window allows you to view the search progress and results fetched from the database.

Search in Metadata - Viewing search results

After the search is complete, the Explorer group on the Navigation bar displays the tree of database objects in which the search string is found, and allows you to view metadata of the required object or its fragment quickly by clicking enclosed object branches in the tree.

The Object <object_name> area is provided for viewing metadata of the objects, with the search string highlighted.

For your convenience the syntax highlight, code completion and a number of other features for efficient SQL editing are implemented. For details see Working with query and Using the context menu.


Database Monitor

Database Monitor allows you to get actual information about the database and its activities.

Use Database Monitor to monitor database activities in real-time and to terminate/shutdown processes (when possible) to troubleshoot related issues. Collected information is arranged by sections available within the corresponding tabs.

This feature is available only for InterBase 7 (and higher) and Firebird 2.1 (in ODS 11.1 and higher) InterBase/Firebird versions.

To launch the tool, select the Tools | iconDatabaseMonitor Database Monitor main menu item, or right-click the database alias in the DB Explorer tree and select the Tasks | iconDatabaseMonitor Database Monitor item from the context menu.

  • Using Navigation bar and Toolbar
  • Database overview
  • Viewing transactions
  • Viewing statements
  • Viewing users
  • Viewing call stack (Firebird only)
  • Viewing procedures (InterBase only)
  • Viewing relations (InterBase only)
  • Viewing triggers (InterBase only)
  • Memory usage (InterBase only)

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Database Monitor.

Database Monitor - Using Navigation bar

The Navigation bar of the Database Monitor window allows you to:

Database

iconDB select a database for monitoring

General

iconOptions edit database monitor options

iconExecute start/resume monitoring

iconPause pause monitoring

iconRestoreDefaultSize restore the default size and position of the window

Depending on the current tab selection, the Navigation bar expands to one or more additional panes with tab-specific actions that can be useful for working with the tool:

Remote Control

iconCommit commit transaction (at the Transactions tab)

iconRollback rollback transaction (at the Transactions tab)

iconRollback cancel statement (at the Statements tab)

iconDeleteRole shutdown user (at the Users tab)

iconRollback cancel current operation (at the Users tab)

Items of the Navigation bar are also available on the ToolBar of the Database Monitor window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Database overview

The Database tab of Database Monitor allows you to get the general overview of the database.

Database Monitor - Database overview

The working area consists of the following sections:

Database parameters (database path, database ID, sweep interval, sweep active, sweep relation, sweep records, state, page reads, page writes, page fetches, page marks)

Transaction parameters (transactions, transaction commits, transaction rollbacks, transaction prepares, transaction deadlocks, transaction conflicts, transaction waits, next transaction, oldest interesting, oldest active, oldest snapshot, cache buffers, cache free writes, cache precedence, cache free waits, cache latch waits)

Objects (attachments, statements, pools, procedures, relations, triggers, active threads, allocated pages)

Memory (sort memory, current memory, maximum memory, permanent pool memory, cache pool memory)

Records (record selects, record inserts, record updates, record deletes, record purges, record expunges, record blackouts)


Viewing transactions

The Transactions tab of Database Monitor allows you to view the list of transactions in the database (currently active or in limbo).

Database Monitor - Viewing transactions

The list displays the transactions as a grid with the following columns:

ID, User, State, Start time, Commit retaining, Isolation level, Read only, Write, No wait, Snapshot, Pool memory, Quantum, Savepoint records, Page reads, Page writes, Page fetches, Page marks, Record selects, Record inserts, Record updates, Record deletes, Record purges, Record expunges, Record backouts (for InterBase);

ID, User, State, Start time, Protocol, Remote address, Isolation mode, Lock timeout, Read only, Auto commit, Auto undo (for Firebird).

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.


Viewing statements

The Statements tab of Database Monitor allows you to view the list of statements being currently executed in the database.

Database Monitor - Viewing statements

The window consists of two basic areas: Statement List and Statement Text.

The Statement List area displays the statements as a grid with the following columns:

ID, User, State, Start time, Protocol, Remote address.

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

The Statement Text area displays the corresponding SELECT statement used to get data from system tables.

Statements management tools are available through the Navigation bar and toolbar of Database Monitor.


Viewing users

The Users tab of Database Monitor allows you to view the list of users logged in since the current connection was opened.

Database Monitor - Viewing users

The list displays the users as a grid with the following columns:

ID, User, State, Login time, Pool memory, Host, IP address, Process ID, Quantum, Priority, Compiled statements, Active transactions, Active sorts, DB key ID, Page reads, Page writes, Page fetches, Page marks, Record selects, Record inserts, Record updates, Record deletes, Record purges, Record expunges, Record backouts (for InterBase);

ID, User, Role, State, Login time, Server PID, Remote PID, State, Remote protocol, Remote address, Charset ID, Garbage collection, Compiled statements, Active transactions, Active sorts, DB key ID, Page reads, Page writes, Page fetches, Page marks, Record selects, Record inserts, Record updates, Record deletes, Record purges, Record expunges, Record backouts (for Firebird).

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.

Users management tools are available through the Navigation bar and toolbar of Database Monitor.


Viewing call stack

The Call stack tab of Database Monitor allows you to view the call stack for the database.

Note: This tab is available for Firebird databases only.

Database Monitor - Viewing call stack

The list displays the call stack as a grid with the following columns:

ID, User, Caller ID, Object name, Object type, Start time, Source line, Source column.

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.


Viewing procedures

The Procedures tab of Database Monitor allows you to view the procedures executed in the database since the current connection was opened.

Note: This tab is available for InterBase databases only.

Database Monitor - Viewing procedures

The list displays the procedures as a grid with the following columns:

ID, Procedure name, Pool memory, Clone no., Start time, Use count, Quantum.

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.


Viewing relations

The Relations tab of Database Monitor allows you to view some of the characteristics of tables and views in the database.

Note: This tab is available for InterBase databases only.

Database Monitor - Viewing relations

The list displays the relations as a grid with the following columns:

ID, Relation name, Use count, Sweep count, Scan count, Formats, Pointer pages, Data pages, Garbage collect pages, Page reads, Page writes, Page fetches, Page marks, Indexed selects, Sequential selects, Record inserts, Record updates, Record deletes, Record purges, Record expunges, Record backouts.

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.


Viewing triggers

The Triggers tab of Database Monitor allows you to view the triggers defined in the database.

Note: This tab is available for InterBase databases only.

Database Monitor - Viewing triggers

The list displays the triggers as a grid with the following columns:

ID, Relation name, Trigger name, Trigger type, Start time, Trigger sequence, Order, Operation, Clone no., Quantum, Invocations, Pool memory, Page reads, Page writes, Page fetches, Page marks, Record inserts, Record updates, Record deletes, Record purges, Record expunges, Record backouts.

If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

If necessary, you can group the data in grid by any of the columns. This operation is performed by dragging the column header to the gray "Group by" box area at the top. When grouping by a column is applied to the grid, all the rows are displayed as subnodes to the grouping row value. To reverse grouping, just drag the column header back.


Memory usage

The Memory usage tab of Database Monitor provides information on memory usage in the database.

Note: This tab is available for InterBase databases only.

Database Monitor - Memory usage

The diagram area provides visual representation of memory usage.

The pie diagram in the upper area represents the percentage of memory pool allocated for each of the following:

TRA (Transaction manager)

DYN

SQL (SQL statements)

REQ (User queries)

IRQ (Int. metadata queries)

TRG (Trigger requests)

PRM (Metadata structures)

SRT (Sort memory blocks)

CCH (Cache mgr/page buffers)

The chart in the lower area represents the memory pool usage history in progress:

the ordinate defines memory amount (in KB);

the abscissa defines time intervals.


Event Monitor

Event Monitor allows you to see the notifications made by event alerters. Event alerters are messages passed from the database to an application; enables applications to receive asynchronous notification of database changes.

To launch the tool, select the Tools | iconEventMonitor Event Monitor item from the main menu.

  • Using Navigation bar and Toolbar
  • Working with Event Monitor

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Events


Using Navigation bar and toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Event Monitor.

Event Monitor - Using Navigation bar

General

clear the list of events

export the list of events to a *.txt file

iconRestoreDefaultSize restore the default size and position of the window

Items of the Navigation bar are also available on the ToolBar of Event Monitor. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Working with Event Monitor

The working area of Event Monitor lists the events that were defined for the database and then posted.

Event Monitor - Working with Event Monitor

The list displays the events as a grid with the following columns: Database, Time, Event, Count.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Right-click an item within the list to call the context menu allowing you to clear the list of events, or export the list to a *.txt file. These operations can also be performed with the corresponding hot keys used.

Event management tools are also available through the Navigation bar of Event Monitor.


Table Altering Monitor

Table Altering Monitor allows you to view the number of metadata changes in tables and views of the database. InterBase/Firebird allows editing a table or a view metadata up to 255 times, after reaching this limit backup and restore are recommended for the database.

To launch the tool, select the Tools | iconTableAlteringMonitor Table Altering Monitor main menu item, or right-click the database alias in the DB Explorer tree and select the Tasks | iconTableAlteringMonitor Table Altering Monitor item from the context menu.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Tables


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Table Altering Monitor.

Tables Altering Monitor - Using Navigation bar

The Navigation bar of the Table Altering Monitor window allows you to:

Database

iconDB select a database for browsing table and view metadata changes

General

iconRefresh refresh the currently displayed list

iconRestoreDefaultSize restore the default size and position of the window

Items of the Navigation bar are also available on the ToolBar of the Table Altering Monitor window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Working with Table Altering Monitor

The working area of the Table Altering Monitor window lists all tables and views of the database and the number of changes made to them.

Tables Altering Monitor

See also:

Using Navigation bar and Toolbar


Server Messages Editor

Server Messages Editor allows you to view and edit system messages of InterBase/Firebird server.

It may be useful when there is a need to find a certain message, edit a standard server message according to your preferences, or translate messages into your native language.

To launch the tool, select the Tools | btnDBRegInfo Server Messages Editor item from the main menu.

  • Using Navigation bar and Toolbar
  • Working with server messages
  • Go to Message Number dialog
  • Editing Server Messages

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Server Messages Editor.

Server Messages Editor - Using Navigation bar

The Navigation bar of the Server Messages Editor window allows you to:

General

iconLoadFromFile load server messages from a *.msg file using the Open dialog

iconFindText search for a string using the Find Text dialog

iconSearchAgain search again

iconGoToMessage open the Go to Message Number dialog

export the list of messages to a *.txt file

import the list of messages from a *.txt file

iconRestoreDefaultSize restore the default size and position of the window

Items of the Navigation bar are also available on the ToolBar of the Server Messages Editor window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Working with server messages

The working area of Server Messages Editor lists InterBase/Firebird server messages.

Server Messages Editor

The list displays the server messages as a grid with the following columns: Number, Text, Original Text. If more convenient, you can change the order of the columns by dragging their headers horizontally.

Click the Number column caption to toggle the DEC/HEX notation-specific representation modes.

Double-click an idem in the list to edit the underlying message.

Right-click an item within the list to call the context menu allowing you to open a *.msg file, save current changes, find text / search again using the Find Text dialog, go to a message with specified number, and export/import the list of messages to/from a *.txt file, revert the selected message to original (i.e. undo changes).

Server message management tools are also available through the Navigation bar of Server Messages Editor.

The status bar area displays the total messages count loaded from the file.


Go to Message Number dialog

The Go to Message Number dialog allows you to jump to the message with a certain number.

To call this dialog, select the corresponding items on the Navigation bar, toolbar, or context menu of the working area of Server Messages Editor.

Server Messages Editor - Go To Message

Message number

Input the number of the message you need. The drop-down list contains the previously specified values.

Search type

Select a number notation to be used in the message search operation:

RadioButton Hexadecimal

RadioButton Decimal


Editing Server Messages

The Message #<message_no> dialog allows you to view and edit message text.

To call this dialog, double-click the message you need in the working area of Server Messages Editor.

Server Messages Editor - Editing message

The New text area displays the message text with currently made changes. The content of this area is editable.

The Original text area displays the original message text. The content of this area is read-only.

The Total chars value at the bottom stands for the total characters count in the New text area.


Database Designer

Database Designer is provided for visual presentation of databases, database objects and relations between objects. It also allows you to create, edit and drop tables and table fields, set relations between tables and perform other operations you may need to achieve your purpose.

To open the designer, select the Tools | btnVDBD Database Designer main menu item, or use the VDBD btnVDBD button on the main toolbar.

  • Using Navigation bar and Toolbars
  • Using Diagram Navigator and DB Objects pane
  • Using context menus
  • Adding/removing objects to/from diagram
  • Creating new objects
  • Creating relations
  • Working with diagram pages
  • Reverse engineering
  • Printing diagram
  • Saving/loading diagram
  • Setting diagram options

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Database Objects Management

Database Designer options


Using Navigation bar and Toolbars

The Navigation bar and Toolbars provide quick access to tools implemented in Database Designer.

VDBD - Using Navigation bar

The Navigation bar of Database Designer allows you to:

Database

iconDB select a database for building the diagram

General

iconOptions edit diagram options

iconRestoreDefaultSize restore the default size and position of the window

iconRefresh refresh objects in the diagram

add a new page

delete the current page

delete all pages

iconPrintSetup set printing options using the Print Setup dialog

iconPreview preview the diagram

iconPrint print the diagram

Navigator

Tick use Diagram Navigator

Database Objects

iconFindText search for objects in the diagram using the Database Objects pane

iconPlus add objects to the diagram using the Database Objects pane

The Toolbars of Database Designer provide quick access to most tools for working with diagrams.

To enable the toolbars, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbars only) or RadioButton Both (if you need both the toolbars and the Navigation bar) in the Bar style for child forms group.

The main toolbar (by default, the toolbar is located at the top of the diagram area) contains a number of tools (including items of the Navigation bar, context menu, tools for printing diagram, etc.) allowing you to:

  • select the database for building the diagram;
  • create a new diagram;
  • open an existing diagram;
  • save the current diagram to a *.ibd file;
  • save the current diagram as an image;
  • adjust diagram zoom for optimal representation: zoom in, zoom out;
  • open the Print Setup dialog;
  • print the diagram;
  • show Print Preview;
  • arrange objects in the diagram;
  • extract metadata of all objects in the diagram and load the script to Execute Script Editor;
  • perform Reverse Engineering;
  • refresh objects in the diagram;
  • view/edit diagram options;
  • specify a predefined zoom value;
  • restore the default size and position of the window.

VDBD - Toolbars - Main

The Pages toolbar (by default, the toolbar is located at the top of the diagram area) contains tools for working with diagram pages allowing you to:

  • add a new page;
  • delete the current page;
  • delete all pages.

VDBD - Toolbars - Pages

The Alignment Palette (by default, the toolbar is located on the left side of the diagram area) allows you to:

  • align left/right edges of selected objects;
  • align tops/bottoms of selected objects;
  • align horizontal/vertical centers of selected objects;
  • space selected objects equally horizontal/vertical.

VDBD - Toolbars - Alignment Palette

The New object toolbar (by default, the toolbar is located on the left side of the diagram area) allows you to:

  • set the cursor mode to Select;
  • create a new object (a table, a view, or a comment);
  • create a new relation.

VDBD - Toolbars - New object

See also:

Using Diagram Navigator and DB Objects pane

Using context menus

Adding/removing objects to/from diagram

Creating new objects

Creating relations

Working with diagram pages

Reverse engineering

Printing diagram

Saving/loading diagram

Setting diagram options


Using Diagram Navigator and DB Objects pane

To navigate within the large diagram, use the Navigator tool available on the Navigation bar. It allows you to see the whole diagram in a reduced scale and to perform a number of operations over the diagram objects.

VDBD - Diagram navigator

A mouse click in the Navigator area sets the center of the visible diagram area. The area currently visible in the main diagram area is outlined in a red bounding rectangle.

Using the Navigator you can work with the diagram objects in the same way as in the main diagram area: add/remove, create new objects, move objects within the diagram and perform other operations.

The Database Objects pane available on the Navigation bar allows you to browse the list of available database objects that can be added to the diagram.

VDBD - Database Objects pane

Select and drag an object to the diagram area or double-click it to add the object to the diagram.

Right-click an item within the list to call the context menu allowing you to:

iconFindText find the selected object in the diagram (if the object is found, it will be highlighted in the diagram area);

iconPlus add new objects to the diagram by Reverse engineering;

Tick specify whether tables are to be displayed;

Tick specify whether views are to be displayed;

Tick specify whether procedures are to be displayed;

Tick toggle objects representation mode: as a tree / as a list;

Tick select the sorting mode applied to the objects in the list: by name / by type, name;

iconRefresh refresh the list.

See also:

Using Navigation bar and Toolbars

Adding/removing objects to/from diagram

Creating new objects

Creating relations

Working with diagram pages


Using context menus

The context menu of the diagram area contains a number of items available in the Navigation bar and toolbars and allows you to:

  • select all objects in the diagram area;
  • adjust diagram zoom for optimal representation: zoom in, zoom out, select rectangle to fit, fit model, specify a predefined zoom value;
  • set the cursor mode to Select or create a new table, relation, or comment;
  • configure the grid: draw grid, snap to grid;
  • adjust the diagram style: draw primary key fields separately, draw entities icons, draw attributes icons, draw only names of entities, draw foreign key names;
  • perform Reverse Engineering;
  • extract metadata of the diagram objects to Execute Script Editor;
  • view/edit diagram options.

VDBD - Using context menu

The context menu of an entity contains items for working with the object and allows you to:

  • edit the object using its editor (Table Editor, View Editor);
  • create a new object using its editor (New table, View Editor);
  • drop the object from the database;
  • show/hide object subitems;
  • remove the object from the diagram.

VDBD - Using entity context menu

The context menu of a field contains items for working with the object and its fields and allows you to:

  • edit the selected field using its editor (Field Editor);
  • create a new field;
  • drop the selected field;
  • edit the object using its editor (Table Editor, View Editor);
  • create a new object using its editor (New table, View Editor);
  • drop the object from the database;
  • show/hide object subitems;
  • remove the object from the diagram.

VDBD - Using field context menu

See also:

Using Navigation bar and Toolbars

Adding/removing objects to/from diagram

Creating new objects

Creating relations


Adding/removing objects to/from diagram

To add an object to the diagram:

  • drag it from the Database Explorer tree to the diagram area

or

  • drag it from the Database Objects pane (available on the Navigation bar) to the diagram area or simply double-click this object in the list.

To add objects by Reverse engineering, you can right-click within the Database Objects list and select the iconPlus Add new objects... context menu item.

To remove an object from the diagram, select it in the diagram area, then right-click its title and choose the Remove <object_name> item from the context menu, or just press the Del key.

VDBD - Removing objects from diagram

See also:

Using Navigation bar and Toolbars

Using Diagram Navigator and DB Objects pane

Using context menus

Creating new objects

Creating relations

Reverse engineering

Database Objects Management


Creating objects

To create a new object using Database Designer:

  • press the Create table button on the New object toolbar;
  • click the desired point on the diagram to place the new object at;
  • specify object properties using its editor (New table, View Editor).

VDBD - Creating new table

Hint: To create a new object, you can also select the corresponding item from the context menu. The context menus also allow you to edit and drop database objects.

See also:

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram

Creating relations


Creating relations

To establish a new relation (which is the foreign key in terms of database management):

  • press the Create relation button on the New object toolbar;
  • click the entity where the referential constraint should be created;
  • click the referred entity;
  • specify new foreign key properties using Foreign key Editor.

VDBD - Creating relations

Hint: To create a relation, you can also use the corresponding item of the context menu.

Once the relation is created, it is displayed as a line between two entities in the diagram area. The style the line is drawn is determined by the diagram notation.

The context menu of this line allows you to edit the foreign key using Foreign key Editor or drop the foreign key from the database.

VDBD - Creating relations - Context menu

See also:

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram

Creating new objects


Working with diagram pages

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Working with multiple diagram pages

You can create several pages in one diagram to split the model into several subject groups, e.g. for better comprehension.

To manage diagram pages, right-click on the tabs at the bottom of the diagram area and select the required popup menu items for adding, deleting and renaming pages.

VDBD - Working with diagram pages

Hint: Page management items are also available on the Pages toolbar of Database Designer.

See also:

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram


Reverse engineering

The reverse engineering operation builds relationship diagram on the basis of the current database's structure. The objects are arranged automatically within the diagram model.

To start the reverse engineering process, press the btnReverseEngineer Reverse Engineerbutton on the main toolbar, or use the corresponding item of the context menu.

VDBD - Reverse engineering

See also:

Using Navigation bar and Toolbars

Using Diagram Navigator and DB Objects pane

Adding/removing objects to/from diagram


Printing diagram

Database Designer allows you to print and preview the diagram.

To preview the diagram:

  • press the btnPrintPreview Print Preview button on the toolbar;
  • preview the diagram using the Print Preview window.

To setup print options:

  • press the btnPrintSetup Print Setup button on the toolbar, or use the corresponding link on the Navigation bar;
  • set printing options using the Print Setup dialog and press OK.

To print the diagram:

  • press the btnPrintMetadata Print button on the toolbar;
  • set printing options using the Print Setup dialog and press the Print button.


Print Preview

The Print Preview dialog allows you to see the diagram layout in WYCIWYG mode before it will be printed.

Use the navigation buttons or the spinner control to navigate within the preview pages.

Click the Print options... button to call the Print Setup dialog.

If necessary, specify the preview zoom according to your preferences.

Click the Print all button to start printing.

VDBD - Printing diagram - Print Preview

See also:

Print Setup dialog


Print Setup dialog

The Print Setup dialog of Database Designer provides two tabs for setting printing options: Printer and Page options.

The Printer tab of the Print Setup dialog allows you to:

  • specify the printer (use the Choose printer button to select a printer which is not set by default on your system; the name, driver, port fields display the selected printer details);
  • specify print layout: print using a defined scale factor or arrange diagram at a defined number of pages horizontally and vertically;
  • set other print options.

Database tools - VDBD - Print Setup - Printer

The Page options tab of the Print Setup dialog allows you to:

  • specify page margins (in millimeters): Top margin, Bottom margin, Left margin, Right margin;
  • specify Page header and Page footer: enter the header/footer running titles text, set left/center/right align.

Database tools - VDBD - Print Setup - Page options

Hint: It is also possible to set macros in the Page header and Page footer fields:

#PCOUNT stands for the quantity of pages;

#PAGE - the number of the current page;

#DATE denotes the current date;

#TIME denotes the current time.

See also:

Print Preview


Saving/loading diagram

Use the btnSave Save Diagram and the ExplorerButton Open Diagram buttons on the main toolbar to save the diagram as a *.ibd file for future use or to load the previously saved diagram.

VDBD - Saving and Loading diagram

If necessary, you can save the diagram as an image: click the btnSaveAsPicture Save as Picture button on the on the main toolbar.

See also:

Using Navigation bar and Toolbars

Using Diagram Navigator and DB Objects pane

Using context menus

Adding/removing objects to/from diagram


Setting diagram options

Using the Diagram Options dialog you can setup the behavior and look of each diagram page.

To open this dialog, use the btnEnvironmentOptions Diagram options item of the Navigation bar or on the main toolbar, or select the corresponding item from the context menu.

See detailed description of each option on the Database Designer page of the Environment Options dialog.

VDBD - Setting diagram options

CheckBox Apply changes to all new pages

If this option is selected, the current settings will be applied to all newly created pages of Database Designer.

See also:

Using Diagram Navigator and DB Objects pane

Database Designer options


Services

SQL Manager for InterBase/Firebird provides graphical interface for a number of database maintenance operations. The following specific database tools are available in SQL Manager for InterBase/Firebird:

Backup Database Wizard

Creates backup copies of databases.

Restore Database Wizard

Restores databases from previously created backups.

Database Validation

Validates the database, verifies the integrity of data structures.

Database Statistics

Collects statistics on a specified database.

Start/Stop database

Provides the ability to turn a database to a single-user mode (shutdown) and bring a database back online.

Rebuild Database Indexes

Recomputes or rebuilds database indexes.

Purge Database

Clears the data of the selected tables.

To obtain detailed information concerning specific InterBase/Firebird database maintenance services, refer to the official server documentation.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Security management

Options

External Tools

How To...


Backup Database

Backup Database Wizard allows you to perform the database backup operation on your InterBase/Firebird system.

This operation is used to create a full backup copy of a database, an archive backup, or an incremental backup (online dump for InterBase 2009 and higher) of a database.

To run the wizard, select the Services | [image] Backup Database main menu item, or right-click the database alias in the DB Explorer tree and select the Tasks | [image] Backup Database context menu item.

  • Selecting database and backup type
  • Full Backup options
  • Archive Backup options
  • Incremental Backup options
  • Setting general backup options
  • Running backup

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Restore Database

Using templates


Selecting database and backup type

This step of the wizard allows you to specify the database name, backup type, backup file, user name / password, and options specific for the selected backup type.

Backup Database - Selecting database and backup type

Database

Use the drop-down list to select the database to backup.

Backup type

RadioButton Full backup

Specifies that all the data of the database are copied. For details see Full Backup options.

RadioButton Archive backup

This type is available only in InterBase. Use this type to backup the database journals. For details see Archive Backup options.

RadioButton Incremental backup

This is a physical backup mechanism. It backs up the physical pages of the database to "dump" files. The incremental backup feature ensures that the output dump files represent the on-disk state of the database as of the instant the online dump was started, so transaction and page consistency are maintained in the process. For details see Incremental Backup options.

Note that the archive backup and incremental backup types are only available in InterBase 2009 and Firebird 2.0 and higher versions.

Backup File

Backup file name

Specify the path and name of the output backup file. It is possible to insert date and time variables in this field. This is helpful if unique backup name required. You can save template with backup file name containing variables to ease further backup operations. The following variables can be used: [Timestamp], [Date], [Time].

Usage example: 'C:\Backups\my_database[Timestamp].GBK'.

Note: Variables value format is defined by system settings.

You must also specify User name and Password in the corresponding boxes. This user name and password will be needed afterwards to access the backup file.

Click the Next button to proceed to the Setting backup options step (for Full Backup), or to Running backup (for Archive Backup, Incremental Backup).


Full Backup options

If RadioButton Full backup is specified as the backup type, you need to set full backup options.

Backup Database - Backup type - Full Backup options

CheckBox Shutdown database before service start

Select this option to shutdown the database before running backup. For details see Start/Stop Database.

CheckBox Bring database online after service finished

Select this option to bring the database online after running backup. For details see Start/Stop Database.

CheckBox Compression

If this option is selected, the backup file will be compressed by the application. This option is available only if the backup file is located on the local computer.

Note: You can use compressed backup files as the source in Restore Database Wizard.

Execution mode

RadioButton Use local utilities

Select this option to backup the database using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog, and gbak.exe and nbackup.exe (for Firebird multi-level backup) files must exist in this directory.

RadioButton Use services

Select this option to use the server services for the backup operation.

Note: Backup of a database located on the Embedded host is only possible with local tools used. You need icudt30.dll, icuin30.dll, icuuc30.dll and fbembed.dll (fbembed.dll must be renamed to fbclient.dll) to be located along with gbak.exe file inside the directory specified in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

Store mode

RadioButton Local

Select this option to store the backup file on the local machine. This mode is available only when you select Use local utilities in the Execution mode group.

RadioButton Server

Select this option to store the backup file on the server machine.

See also:

Archive Backup options

Incremental Backup options


Archive Backup options

If RadioButton Archive Backup is specified as the backup type, you need to set specific archive backup options.

Backup Database - Backup type - Archive Backup options

Execution mode

RadioButton Use local utilities

Select this option to backup the database using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog, and gbak.exe and nbackup.exe (for Firebird multi-level backup) files must exist in this directory.

RadioButton Use services

Select this option to use the server services for the backup operation.

Archive Backup Type

RadioButton Database backup

Select this option to backup the database.

RadioButton Journals backup

Select this option to backup the journal archive.

See also:

Full Backup options

Incremental Backup options


Incremental Backup options

If RadioButton Incremental backup is specified as the backup type, you need to set specific incremental backup (Online Dump) options.

Backup Database - Backup type - Incremental Backup options

Execution mode

RadioButton Use local utilities

Select this option to backup the database using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog, and gbak.exe and nbackup.exe (for Firebird multi-level backup) files must exist in this directory.

RadioButton Use services

Select this option to use the server services for the backup operation.

CheckBox Overwrite old file

This option is available only for Interbase 2009 or higher. If you enable this option, the utility will completely overwrite the old backup file. Otherwise the new backup file will contain only changes relatively to the previous backup.

CheckBox Generate backup name

Check this option if you need backup file name to be generated automatically.

Backup level

Specify the level of the backup. Note that you cannot make a level n backup if level n-1 backup of this database does not exist in backup history. Only level 0 backup can be created without any restrictions.

Note: This option is only available for Firebird 2.0 or higher. The option is available if the location of the utilities is specified in the Path to database utilities field on the Connection page of the Host Registration Info dialog, and nbackup.exe file exists in this directory. Moreover, the server must be registered locally.

See also:

Full Backup options

Archive Backup options


Setting backup options

This step of the wizard allows you to set the general backup options.

Note: This step is only available if RadioButton Full backup is specified as the backup type.

Backup Database - Setting backup options

General

CheckBox Ignore check sum

If this option is selected, wrong check sums of the database header pages where the database connection properties are stored, are ignored in the backup operation.

CheckBox Ignore transaction in Limbo

If this option is selected, transactions in limbo, i.e. transactions that cannot be defined as executed or aborted, are ignored in the backup operation.

CheckBox Backup metadata only

If this option is selected, only database metadata are saved in the backup file.

CheckBox Garbage collection

If this option is selected, garbage collection is executed in the backup operation.

CheckBox Old metadata description

If this option is selected, old metadata descriptions are included into the reserve database.

CheckBox Convert to tables

This option converts the database data to tables in the backup operation.

Format

Select the data format for the reserve database: Transportable (the database can be then moved from one platform to another) or Non-Transportable.

Shutdown Mode

This group appears if the CheckBox Shutdown database before service start option has been enabled at the first step. The following shutdown modes are available:

RadioButton Forced

RadioButton Deny new transactions

RadioButton Deny new attachments

For details see Setting shutdown options.

Click the Next button to proceed to Running backup.


Running backup

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

Backup Database - Running backup

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the backup process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process.


Restore Database

Restore Database Wizard allows you to perform the database restore operation on your InterBase/Firebird system.

This operation is used to rebuild a damaged or corrupted database that has been backed up using Backup Database Wizard. The restored database is in the same state it was in when the backup copy was made. A database can be overwritten with a different image, and a backup image can be restored to a new database.

To run the wizard, select the Services | [image] Restore Database main menu item, or right-click the database alias in the DB Explorer tree and select the Database Operations | [image] Restore Database context menu item.

  • Selecting restore type
  • Restore from Full Backup
  • Restore from Incremental Backup
  • Restore from Journal Archive
  • Restore Online Dump
  • Setting general restore options
  • Running restore

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Backup Database

Using templates


Selecting restore type

This step of the wizard allows you to specify the restore type.

Restore Database - Selecting restore type

Restore type

RadioButton Restore from full backup

Specifies that the database will be restored from a full backup.

RadioButton Restore from incremental backup (Firebird only)

Specifies that the database will be restored from an incremental backup.

RadioButton Restore from Journal Archive (InterBase only)

Specifies that the database will be restored from a journal archive backup.

RadioButton Restore from Online Dump (InterBase only)

Specifies that the database will be restored from an online dump.

Note: You can restore the database from a backup copy, located on the Embedded server, only with the help of local utilities. The 'fbembed.dll' library of the embedded server must be renamed to 'fbclient.dll' and located in the directory with the gbak.exe utility. The icudt30.dll, icuin30.dll and icuuc30.dll libraries must be also located in this directory.

You can specify the directory with the gbak.exe utility in the Path to database utilities field on the Connection tab in the Host Registration Info dialog.

Click the Next button to proceed to the next step which varies depending on the selected restore type:

  • Restore from Full Backup
  • Restore from Incremental Backup
  • Restore from Journal Archive
  • Restore Online Dump


Restore from Full Backup

If RadioButton Restore from full backup is specified as the restore type, you need to set restore from full backup options.

Restore Database - Restore from Full Backup

Source file

Type in or use the ExplorerButton button to specify the backup file from which the restore operation should be performed.

Restore into

Specify the database into which you want to restore one from the source file.

RadioButton New database (into database file)

Select this option to create a new database to restore the backup into.

Host

This group allows you to define the host on which the new database will be located.

RadioButton Existing host

Specifies that the database to be created will reside on an existing (already registered) host. Use the Host name drop-down list to select the host for the new database.

RadioButton New host

Specifies that the database to be created will reside on a new host. If this option is selected, you will need to specify new host options at the next step. For details see Setting connection parameters, SSH tunneling parameters.

RadioButton Existing database (into database)

Select this option to restore the backup into an existing (already registered) database. Select the necessary database from the drop-down list, and use the Login as group to specify the User name and Password to access the database.

CheckBox Shutdown database before service start

Select this option to shutdown the database before running restore. For details see Start/Stop Database.

CheckBox Bring database online after service finished

Select this option to bring the database online after running restore. For details see Start/Stop Database.

Execution mode

RadioButton Use local utilities

Select this option to restore the database using local utilities.

RadioButton Use services

Select this option to use the server services for the restore operation.

Note: Restore of a database located on the Embedded host is only possible with local tools used. You need icudt30.dll, icuin30.dll, icuuc30.dll and fbembed.dll (fbembed.dll must be renamed to fbclient.dll) to be located along with gbak.exe file inside the directory specified in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

Restore mode

RadioButton Local

Select this option to store the restore file on the local machine. This mode is available only when you select Use local utilities in the Execution mode group.

RadioButton Server

Select this option to store the restore file on the server machine.

See also:

Restore from Incremental Backup

Restore from Journal Archive

Restore Online Dump


Restore from Incremental Backup

If RadioButton Restore from incremental backup is specified as the restore type, you need to set restore from incremental backup options.

Note: This restore type is only available for Firebird version 2.0 or higher.

Restore Database - Restore from Incremental Backup

Restore into

This group allows you to define the target host onto which the incremental backup will be restored.

RadioButton Existing host

Specifies that the database will be restored onto an existing (already registered) host. Use the Host name drop-down list to select the host for the restored database.

RadioButton New host

Specifies that the database will be restored onto a new host. If this option is selected, you will need to specify new host options at the next step. For details see Setting connection parameters.

File name

Type in or use the btnSaveAs button to specify the database location and name (*.FDB).

Restore source

This group allows you to select the restore source file(s) from the backup history or specify them manually.

RadioButton Select entry from backup history

Indicates that the backup file(s) will be selected from the the backup history.

Restore Database - Restore from Incremental Backup - Backup history

Select the Source database from the drop-down list to get its backup history that will be displayed in list below.

Note: Only local Firebird databases can be found in the drop-down list.

The list displays the backup history items as a grid with the following columns: Level, Timestamp, Filename.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Check/uncheck the boxes in the first column to select/deselect items.

Note: Levels of the selected backups must form a continuous range with 0 and n as boundaries with step 1 (0,1,2,3...n-1,n).

RadioButton Specify backup files manually

Indicates that the backup file(s) will be specified manually.

Restore Database - Restore from Incremental Backup - Backup files

The area below allows you to select source files for incremental restore manually. Use the btnAddItem btnRemoveItem buttons to add and remove files. Type in or use the ExplorerButton button to specify file location and name.

See also:

Restore from Full Backup

Restore from Journal Archive

Restore Online Dump


Restore from Journal Archive

If RadioButton Restore from Journal Archive is specified as the restore type, you need to set restore from journal archive backup options.

Note: This restore type is only available for InterBase 2009 or higher.

Restore Database - Restore from Journal Archive

Database archive file name

Type in or use the ExplorerButton button to specify the database archive file (*.DATABASE) from which the restore operation should be performed.

Login information

Specify the User name and Password to access the backup archive file.

Restore into

Specify the database into which you want to restore one from the source file.

RadioButton New database (into database file)

Select this option to create a new database to restore the backup into.

Host

This group allows you to define the host on which the new database will be located.

RadioButton Existing host

Specifies that the database to be created will reside on an existing (already registered) host. Use the Host name drop-down list to select the host for the new database.

RadioButton New host

Specifies that the database to be created will reside on a new host. If this option is selected, you will need to specify new host options at the next step. For details see Setting connection parameters.

RadioButton Existing database (into database)

Select this option to restore the backup into an existing (already registered) database. Select the necessary database from the drop-down list.

CheckBox Use until option

Select this option to set the date and time before which the database with changes done is to be restored.

For your convenience the Date editor is implemented for inputting the timestamp: click the arrow-down button to call the Date editor popup window.

See also:

Restore from Full Backup

Restore from Incremental Backup

Restore Online Dump


Restore Online Dump

If RadioButton Restore from Online Dump is specified as the restore type, you need to set restore from incremental backup (online dump) options.

Note: This restore type is only available for InterBase 2009 or higher.

Restore Database - Restore Online Dump

Online Dump source file

Type in or use the ExplorerButton button to specify the Online Dump file (*.GBK) from which the restore operation should be performed.

Login information

Specify the User name and Password to access the source file.

Path to database utilities

Type in or use the ExplorerButton button to specify the path to the database utilities.

CheckBox Rename result database file

If the option is disabled, the database will be restored into the original one. Enable this option to restore the backup into a new database.

New database file name field

Type in or use the btnSaveAs button to specify the database location and name (*.GDB).

CheckBox Register after restore

If this option is selected, the newly restored database will be registered in the application.

Host

This group allows you to define the host where the database will be located.

RadioButton Existing host

Specifies that the database will reside on an existing (already registered) host. Use the Host name drop-down list to select the host for the restored database.

RadioButton New host

Specifies that the database will reside on a new host. If this option is selected, you will need to specify new host options at the next step. For details see Setting connection parameters.

See also:

Restore from Full Backup

Restore from Incremental Backup

Restore from Journal Archive


Setting restore options

This step of the wizard allows you to set the general restore options.

Note: This step is only available if RadioButton Restore from full backup is specified as the restore type.

Restore Database - Setting restore options

CheckBox Deactivate indexes

If this option is selected, database indexes are deactivated while restoring.

CheckBox Don't recreate shadow files

If this option is selected, shadow files are not recreated while restoring.

CheckBox Don't enforce validity conditions

If this option is selected, database validity conditions are not restored.

CheckBox Commit after each table

If this option is selected, SQL Manager commits work after restoring each table.

CheckBox Replace existing database

If this option is selected, the restored database replaces an existing one.

CheckBox Use all space

Restores database with 100 per cent fill ratio on each data page, instead of the default 80 per cent fill ratio.

Page size

Use the drop-down list to specify the database page size (in bytes). Possible values are: 1024, 2048, 4096, 8192, 16384.

Click the Next button to proceed to Running restore.


Running restore

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

Restore Database - Running restore

CheckBox Register the database after restoring

If this option is selected, the newly restored database will be registered in SQL Manager automatically.

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the restore process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process.


Database Validation

Database Validation Wizard allows you to validate databases for verifying the integrity of data structures.

A database should be validated:

  • whenever a database backup is unsuccessful;
  • whenever an application receives a "corrupt database" error;
  • periodically, to monitor for corrupt data structures or misallocated space;
  • any time when data corruption is suspected.

To run the wizard, select the Services | iconDatabaseValidation Database Validation... main menu item, or right-click the database alias in the DB Explorer tree and select the Tasks | iconDatabaseValidation Database Validation... context menu item.

  • Selecting database and execution mode
  • Setting validation options
  • Running database validation

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Start/Stop Database

Using templates


Selecting database and execution mode

This step of the wizard allows you to specify the database name, shutdown / bring online options, and execution mode.

Database Validation - Selecting database and execution mode

Database

Use the drop-down list to select the database to be validated.

CheckBox Shutdown database before service start

Select this option to shutdown the database before Running database validation. For details see Start/Stop Database.

CheckBox Bring database online after service finished

Select this option to bring the database online after Running database validation. For details see Start/Stop Database.

Execution mode

RadioButton Use local utilities

Select this option to validate the database using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

RadioButton Use services

Select this option to use the server services for the database validation operation.

Click the Next button to proceed to the Setting validation options step of the wizard.


Setting validation options

This step of the wizard allows you to set the general validation options.

Database Validation - Setting validation options

Options

CheckBox Return a list of limbo transactions

If this option is selected, the database is checked on transactions in limbo, i.e. the transactions that cannot be defined as executed or aborted.

CheckBox Validate the database, but don't repair it

Enables the "Read Only" mode of validation. By default, validating a database updates it, if necessary. Check this option to prevent updating.

CheckBox Ignore all checksum errors

If this option is selected, all checksum errors are ignored.

A checksum is a page-by-page analysis of data to verify its integrity. A bad checksum means that a database page has been randomly overwritten (e.g. due to a system crash).

CheckBox Kill all unavailable shadow files

If this option is selected, server drops the shadows which cannot be used.

CheckBox Prepare a corrupt database for backup

Performs total cleaning of the corrupt database, preparing the database for backup.

CheckBox Perform a database sweep

Removes all outdated records.

CheckBox Validate the database structure

Repairs corrupt or misallocated structures.

CheckBox Validate record fragments

Releases unassigned record fragments.

Log file options

CheckBox Write log information to file

Check this option if you wish to log validation process to an external file.

File name

This field is enabled if the Write log information to file option is selected. Type in or use the btnSaveAs Save as button to specify the path to the *.log file to store the database validation logs.

Click the Next button to proceed to Running database validation.


Running database validation

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

Database Validation - Running database validation

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the validation process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process.


Database Statistics

Database Statistics Wizard allows you to retrieve database statistics.

To run the wizard, select the Services | iconDatabaseStatistics Database Statistics... main menu item, or right-click a table in the DB Explorer tree and select the Table Services | iconDatabaseStatistics Database Statistics... context menu item.

  • Selecting database and execution mode
  • Setting statistics options
  • Running statistics collection

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Start/Stop Database

Using templates


Selecting database and execution mode

This step of the wizard allows you to specify the database name, shutdown / bring online options, and execution mode.

Database Statistics - Selecting database for statistics

Database

Use the drop-down list to select the database for collecting statistics.

CheckBox Shutdown database before service start

Select this option to shutdown the database before Running statistics collection. For details see Start/Stop Database.

CheckBox Bring database online after service finished

Select this option to bring the database online after Running statistics collection. For details see Start/Stop Database.

Execution mode

RadioButton Use local utilities

Select this option to collect database statistics using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

RadioButton Use services

Select this option to use the server services for the database statistics operation.

Click the Next button to proceed to the Setting statistics options step of the wizard.


Setting statistics options

This step of the wizard allows you to set the general statistics collection options.

Database Statistics - Setting statistics options

Options

This group allows you to select what kind of statistics is to be collected:

RadioButton Retrieve all statistics

RadioButton Stop retrieving after header page statistics

RadioButton Stop retrieving after log pages statistics

RadioButton Stop retrieving after user indexes statistics

RadioButton Stop retrieving after data tables statistics

RadioButton Stop retrieving after system tables and indexes statistics

Log file options

CheckBox Write log information to file

Check this option if you wish to log statistics collection to an external file.

File name

This field is enabled if the Write log information to file option is selected. Type in or use the Save as btnSaveAs button to specify the path to the *.log file to store the database statistics collection logs.

Click the Next button to proceed to Running statistics collection.


Running statistics collection

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

Database Statistics - Running database statistics

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the statistics collection process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process.


Start/Stop Database

Start/Stop Database Wizard allows you to shutdown (to switch to the one-user database connection mode) and to bring database online back again.

Maintaining a database often involves shutting it down. The user who shuts down the database then has exclusive access to the database.

After a database is shut down, it must be restarted (brought back online) before users can access it.

To run the wizard, select the Services | iconStartDatabase Start/Stop Database... main menu item, or right-click a table in the DB Explorer tree and select the Table Services | iconStartDatabase Start/Stop Database... context menu item.

  • Selecting database and execution mode
  • Setting shutdown options
  • Running Bring Online / Shutdown Database

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Using templates


Selecting database and execution mode

This step of the wizard allows you to specify the operation, database name, and execution mode.

Start-Stop Database - Selecting database and execution mode

Operations

RadioButton Bring database online

Specifies that the specified database will be brought online (restarted).

RadioButton Shutdown database

Specifies that the specified database will be shut down (switched to the one-user database connection mode).

Database

Use the drop-down list to select the database to shut down / bring online.

Execution mode

RadioButton Use local utilities

Select this option to shut down / bring database online using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

RadioButton Use services

Select this option to use the server services for the shutdown / bring online operation.

Click the Next button to proceed to the Shutdown database options step (for the Shutdown database mode), or to Running Bring Online / Shutdown Database (for the Bring database online mode).


Setting shutdown options

This step of the wizard allows you to set the general shutdown database options.

Start-Stop Database - Shutdown database options

Shutdown Mode

RadioButton Forced

In this mode all the transactions, still active by the stated time, are forcedly aborted and all the users are forcedly disconnected.

RadioButton Deny new transactions

In this mode all the transactions must be executed by the stated time. Starting of any new transactions is blocked. If there are some transactions still active by the stated time, database shutdown is not executed.

RadioButton Deny new attachments

In this mode all the active user attachments must finish their work by the stated time. If there are some attachments still active by the stated time, database shutdown is not executed.

Wait (seconds)

Time to wait for the shutdown to execute (in seconds).

Click the Next button to proceed to Running Bring Online / Shutdown Database.


Running Bring Online / Shutdown Database

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

Start-Stop Database - Running Bring Online or Shutdown Database

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the bring online / shutdown process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process.


Rebuild Database Indices

Rebuild Indexes Wizard allows you to recompute or rebuild indexes.

To improve index performance, one should consider recomputing or rebuilding database indexes.

Recomputing index selectivity is performed through SET STATISTICS. Index selectivity is a calculation, based on the number of distinct rows in a table, that is made by the optimizer when a table is accessed. It is cached in memory, where the optimizer can access it to calculate the optimal retrieval plan for a given query.

Rebuilding an index consists in making it inactive, then active with sequential calls to ALTER INDEX. Deactivating an index is exactly like dropping it, except that the index definition remains in the database. Activating an index creates a new index structure.

To run the wizard, select the Services | iconRecomputeIndices Rebuild Database Indexes... main menu item, or right-click a table in the DB Explorer tree and select the Table Services | iconRecomputeIndices Rebuild All Indexes of Database context menu item.

  • Selecting database and execution mode
  • Selecting action for indexes
  • Selecting indexes
  • Recomputing/rebuilding indexes

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Start/Stop Database

Indices

Using templates


Selecting database and execution mode

This step of the wizard allows you to specify the database name, shutdown / bring online options, and execution mode.

Rebuild Indices - Selecting database and execution mode

Database

Use the drop-down list to select the database for recomputing/rebuilding indexes.

CheckBox Shutdown database before service start

Select this option to shutdown the database before Recomputing/rebuilding indexes. For details see Start/Stop Database.

CheckBox Bring database online after service finished

Select this option to bring the database online after Recomputing/rebuilding indexes. For details see Start/Stop Database.

Execution mode

RadioButton Use local utilities

Select this option to recompute/rebuild indexes using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

CheckBox Use service manager (use files on server)

If this option is selected, the recomputing/rebuilding indexes will be performed with the service manager used.

RadioButton Use services

Select this option to use the server services for the recomputing/rebuilding indexes operation.

Click the Next button to proceed to the Selecting action for indexes step of the wizard.


Selecting action for indexes

This step of the wizard allows you to select the action for database indexes and set the action-specific options.

Rebuild Indices - Selecting action for indices

Options

RadioButton Recompute indexes

Specifies SET STATISTICS to be executed for recomputing database indexes.

CheckBox Include system indexes

If this option is selected, system indexes will be recomputed as well.

RadioButton Rebuild indexes

Specifies deactivating/activating database indexes through ALTER INDEX.

CheckBox Deactivate indexes

If this option is selected, database indexes will be deactivated (ALTER INDEX ... INACTIVE)

CheckBox Activate indexes

If this option is selected, database indexes will be activated (ALTER INDEX ... ACTIVE).

Click the Next button to proceed to the Selecting indexes step of the wizard.


Selecting indexes

This step of the wizard allows you to select indexes for management.

To select an index, you need to move it from the Available Indexes list to the Selected Indexes list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the indexes from one list to another.

Rebuild Indices - Selecting indexes

Click the Next button to proceed to Recomputing/rebuilding indexes.


Recomputing/rebuilding indexes

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

Rebuild Indices - Rebuilding indexes

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the backup process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process.


Purge Database

Purge Database Wizard allows you to delete data from the selected tables.

To run the wizard

select Services | iconPurgeDatabase Purge database... from the main menu

or right-click a table in the DB Explorer tree and select the Tasks | iconPurgeTable Purge table... context menu item.

  • Selecting database and execution mode
  • Selecting options for data deleting
  • Selecting tables to purge data
  • Running purging operation

Availability:
Full version | Yes
Lite version | No
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.


Selecting database and execution mode

This step of the wizard allows you to specify the database name and set execution mode.

Purge Database - Selecting database and execution mode

Database

Use the drop-down list to select the database for purging data.

Execution mode

RadioButton Use local utilities

Select this option to purge tables using local utilities.

Note: To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

RadioButton Use services

Select this option to use the server services for database purging.

Click Next > to proceed to the Selecting options for data deleting step.


Selecting options for data deleting

This step of the wizard allows you to select the options and rules for deleting data.

Purge Database - Selecting options for data deleting

CheckBox Temporarily deactivate table triggers before data deletion

Use this option to disable triggers before deleting data. After the data has been deleted, the trigger will be automatically activated.

CheckBox Recompute statistics of table indices after data deletion

Use this option to recompute statistics after deleting data.

CheckBox Sweep database after data deletion

Use this option to sweep the database after deleting data.

CheckBox Temporarily change delete rules of foreign keys referring to the purging table

Use this option to change delete rules for foreign keys linked to the selected tables. You can choose the new rule: SET NULL, SET DEFAULT or CASCADE.

Click < Back to go back to Selecting database and execution mode step or Next > to proceed to the Selecting tables to purge data step.


Selecting tables to purge data

This step of the wizard allows you to select tables for purging data.

To select a table, you need to move it from the Available tables list to the Selected tables list using the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations.

Purge Database - Selecting tables to purge data

Click < Back to go back to Selecting options for data deleting step or Next > to proceed to the Running purging operation step.


Running purging operation

This step of the wizard is intended to inform you that all necessary options have been set, and you can start the process.

The log area allows you to view the log of operations and errors (if any).

Purge Database - Running purging operation

CheckBox Close the wizard after successful completion

If this option is selected, the wizard is closed automatically when the backup process is completed.

If necessary, you can save a template for future use.

Click the Finish button to run the process or click < Back to go back to Selecting tables to purge data step.


Security management

Security for InterBase/Firebird relies on a central security database for each server host. This database contains a record for each legitimate user who has permission to connect to databases and services on that host. Each record includes the user login name and the associated encrypted password. The entries in this security database apply to all databases on the server host.

InterBase/Firebird manages database access permissions using the concept of users:

  • SYSDBA (a special user account that can bypass normal SQL security and perform tasks such as database backups and shutdowns; this is the only authorized user initially; the default password for the user is masterkey);
  • other users (other users on a per-server basis created by SYSDBA)

Embedded Database User Authentication is supported by InterBase 7.5 and later versions of InterBase.

Embedded User Authentication stores user name / password accounts in the database. This overrides the server-wide security database for user authentication. Only the database owner is allowed to administer embedded user authentication against a database. A normal user may alter the password for their user account.

Note: There are issues related to database backup/restore performed under embedded users. For details refer to the official InterBase documentation.

InterBase/Firebird implements features for assigning SQL privileges to groups of users. SQL roles are implemented on a per-database basis, and the implementation includes the following:

  • a role is declared;
  • privileges on database objects are assigned to the role with the help of Grant Manager;
  • role members are defined;
  • the role name is specified on the Connection page of the Database Registration Info dialog.

A user can belong to only one role per connection to the database and cannot change role while connected. To change role, the user must disconnect and reconnect, specifying a different role name.

SQL Manager for InterBase/Firebird provides tools for efficient management of InterBase/Firebird users and SQL roles:

User Manager

A tool for managing InterBase/Firebird server users.

User Editor

A tool for editing InterBase/Firebird server users.

Role Manager

A tool for managing InterBase/Firebird database roles.

Members of Role

A tool for defining InterBase/Firebird database role members.

Grant Manager

Allows you to manage grants on your InterBase/Firebird database objects.

Adding Users

  • select the Tools | User Manager main menu item or use the corresponding btnUserManager toolbar button to open User Manager;
  • select the Add User... item from the context menu or within the Navigation bar;
  • define user properties and membership using User Editor.

Editing Users

  • select the Tools | User Manager main menu item or use the corresponding btnUserManager toolbar button to open User Manager;
  • right-click and select the Edit User... item from the context menu or within the Navigation bar;
  • edit the user properties and membership using User Editor.

Deleting Users

  • select the Tools | User Manager main menu item or use the corresponding btnUserManager toolbar button to open User Manager;
  • right-click the user to delete and select the Delete User item from the context menu or within the Navigation bar;
  • confirm deleting in the dialog window.

Adding Roles

  • select the Database | New Object... main menu item;
  • select Role in the Create New Object dialog;
  • define role name and confirm new role declaration in the dialog window

or

  • select the Tools | Role Manager main menu item to open Role Manager;
  • right-click and select the Add Role... item from the context menu or within the Navigation bar;
  • define role name and confirm new role declaration in the dialog window.

Hint: To create a new role, you can also right-click the Roles node or any object within this node in the DB Explorer tree and select the New Role... item from the context menu.

To create a new role with the same properties as one of existing roles has:

  • select the Database | Duplicate Object... main menu item;
  • follow the instructions of Duplicate Object Wizard.

Alternatively, you can right-click a role in the DB Explorer tree and select the Duplicate Role 'role_name'... context menu item.

Duplicate Object Wizard allows you to select the database to create a new role in, and to view the result SQL statement for creating the role.

Editing Role Members

  • select the Tools | Role Manager main menu item to open Role Manager;
  • select the Edit role members item within the Navigation bar, or double-click a role in the list;
  • edit the role members using the Members of Role dialog.

Deleting Roles

  • select the Tools | Role Manager main menu item to open Role Manager;
  • right-click the role to delete and select the Delete Role item from the context menu or within the Navigation bar;
  • confirm deleting in the dialog window.

Managing Privileges

  • select the Tools | Grant Manager main menu item, or use the corresponding btnGrantManager toolbar button to open Grant Manager;
  • select the object type using the drop-down list on the toolbar;
  • select a user, a role, a view, a trigger, or a procedure from the Privileges for list available within the Navigation bar;
  • edit the grantee's privileges using Grant Manager

or

  • right-click an object in DB Explorer and select the Tasks | Grants for <object_name> item from the context menu;
  • edit privileges using Grant Manager.


User Manager

User Manager allows you to browse the list of existing InterBase/Firebird users, and manage them efficiently.

To launch the tool, select the Tools | iconUserManager User Manager main menu item, or right-click the host alias in the DB Explorer tree and select the Tasks | iconUserManager User Manager item from the context menu.

Note: You should register the server host with Register Host Wizard before using this tool.

See also:

Grant Manager

Role Manager

Embedded User Editor


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in User Manager.

User Manager - Using Navigation bar

The Navigation bar of the User Manager window allows you to:

Servers

iconHost select a server host for managing users

iconDB select a database on the host for managing embedded users (if Embedded User Authentication is enabled for the server)

General

iconRefresh refresh the currently displayed list of users

iconAddUser add a new user

iconEditUser edit the selected user

iconDeleteUser delete the selected user

iconRestoreDefaultSize restore the default size and position of the window

Items of the Navigation bar are also available on the ToolBar of the User Manager window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Managing users

If you are not connected to the database server yet, select the server host from the Servers drop-down list on the Navigation bar and you will be prompted for connection confirmation.

The list displays the existing users as a grid with the following columns: User Name, First Name, Middle Name, Last Name.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Right-click an item within the list to call the context menu allowing you to add a new user and specify its properties using User Editor, edit, delete the selected user, or show/hide columns of the list. Using the context menu you can also export the list of users to any of supported output file formats.

Users management tools are also available through the Navigation bar and toolbar of User Manager.


User Editor

The User Editor dialog window allows you to view/edit users.

To open the dialog, click Add User / Edit User on the Navigation bar or toolbar of User Manager, or right-click and select the Add User... / Edit User... item from the context menu. Alternatively, you can just double-click the user for editing.

User

This page allows you to specify user name, password and personal info for the user being created/edited.

User Editor - User

Name

Enter a name for the new user, or view the name of the user being edited.

Note: User name is significant to 31 characters and is not case sensitive.

Password / Confirm password

Set a password by which the user will be identified in the server.

Note: Password is significant to 8 characters and is case sensitive.

First name / Middle name / Last name

Specify user's real name (as opposed to login name): first name, middle name, last name.

Roles

This page allows you to select the role the user being created/edited will have privileges of.

User Editor - Roles

To select a role, you need to move it from the Available Roles list to the Selected Roles list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.


Embedded User Editor

The Embedded User Editor dialog window allows you to view/edit embedded users.

To open an embedded user in Embedded User Editor, double-click it in the DB Explorer tree.

User

This page allows you to specify embedded user name, password, personal info, default role and specific settings for the embedded user being created/edited.

Embedded User Editor - User

Name

Enter a name for the new embedded user, or view the name of the embedded user being edited.

Note: Embedded user name is significant to 31 characters and is not case sensitive.

Password / Confirm password

Set a password by which the embedded user will be identified in the database.

Note: Password is significant to 8 characters and is case sensitive.

First name / Middle name / Last name

Specify embedded user's real name (as opposed to login name): first name, middle name, last name.

Default role

Use the drop-down list to select the role the embedded user being created/edited will have privileges of (by default).

System user name

Enter the name of the system user.

Group name

Enter the name of the group the embedded user will belong to.

GID

Optional GroupID. Currently not used by InterBase.

UID

Optional UserID. Currently not used by InterBase.

CheckBox Active

This option activates/deactivates the embedded user.

CheckBox Database Owner

If this option is selected, the embedded user is the database owner (rdb$user_privilege = 1).

Roles

This page allows you to select the role the embedded user being created/edited will have privileges of.

Embedded User Editor - Roles

To select a role, you need to move it from the Available Roles list to the Selected Roles list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the objects from one list to another.

See also:

User Manager

Role Manager

Grant Manager


Role Manager

Role Manager allows you to browse the list of existing SQL roles, and manage them efficiently.

To launch the tool, select the Tools | btnGroupManager Role Manager main menu item, or right-click the database alias in the DB Explorer tree and select the Tasks | btnGroupManager Role Manager item from the context menu.

See also:

User Manager

Embedded User Editor

Grant Manager


Using Navigation bar and Toolbar

The Navigation bar and Toolbar provide quick access to tools implemented in Role Manager.

Role Manager - Using Navigation bar

The Navigation bar of the Role Manager window allows you to:

Database

iconDB select a database for managing roles

General

iconRefresh refresh the currently displayed list of roles

iconShowSQLHelp show SQL help

iconRestoreDefaultSize restore the default size and position of the window

Tools

iconAddUser add a new role

iconEditUser edit the selected role members

iconDeleteUser delete the selected role

Items of the Navigation bar are also available on the ToolBar of the Role Manager window. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.


Managing roles

To browse the list of roles, select the database from the Database drop-down list on the Navigation bar.

The list displays the existing roles as a grid with the following columns: Role Name, Owner, Members.

Click a column caption to sort items by values of this column in the ascending or the descending mode.

Right-click an item within the list to call the context menu allowing you to add a new role, delete the selected role, or refresh the list.

Roles management tools are also available through the Navigation bar and toolbar of Role Manager.


Defining role members

The Members of Role dialog allows you to select the users to which the role will be assigned, i.e. the existing users to be added as members of the role being edited.

To open the dialog, click Edit role members within the Navigation bar or toolbar of Role Manager, or double-click a role in the list.

Role Editor - Members of Role

To select a user, you need to move it from the Available Users list to the Selected Users list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the users from one list to another.


Grant Manager

Grant Manager allows you to set the user access grants on certain database objects: tables, views, procedures, etc. Granting privileges on the selected database objects allows a user to perform the defined operation over the objects.

Connecting to a database does not automatically include privileges to modify or even view data stored within that database. Privileges must be granted explicitly; users cannot access any database objects until they have been granted privileges.

To open Grant Manager, select the Tools | btnGrantManager Grant Manager main menu item.

  • Using Navigation bar, Toolbar and context menu
  • Managing database-specific privileges
  • Managing DDL grants
  • Managing column permissions
  • Filtering objects in list

See also:

User Manager

Embedded User Editor

Role Manager


Using Navigation bar, Toolbar and context menu

The Navigation bar, Toolbar and context menu provide quick access to tools implemented in Grant Manager.

Database

iconDB select a database for grants management

General

iconCompile compile changes in privileges

iconRefresh refresh the content of the window

iconRestoreDefaultSize restore the default size and position of the window

Tools

Grant - grant a permission on an object to the selected grantee (user/role/view/trigger/procedure);

Revoke - revoke a previously granted permission;

Grant with GRANT Option -grant a permission (with GRANT Option) on an object to the selected grantee (user/role/view/trigger/procedure);

Grant All -grant all permissions on an object to the selected grantee (user/role/view/trigger/procedure);

Revoke All -revoke all previously granted permissions on an object;

Grant All with GRANT Option - grant all permissions (with GRANT Option) on an object to the selected grantee (user/role/view/trigger/procedure);

Grant on All - grant a permission (with GRANT Option) on all objects to the selected grantee (user/role/view/trigger/procedure);

Revoke on All - revoke a previously granted permission on all objects;

Grant on All with GRANT Option

Grant All on All - grant all permissions (with GRANT Option) on all objects to the selected grantee (user/role/view/trigger/procedure)

Revoke All on All -revoke all previously granted permissions on all objects;

Privileges for

btnGroupManager select an existing database user/role/view/trigger/procedure to grant privileges to

Legend

Tick view the legend

NOTE:Items of the Navigation bar are also available on the ToolBar of Grant Manager. To enable the toolbar, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

See also:

Managing database-specific privileges

Managing DDL grants

Managing column permissions

Filtering objects in list


Managing database-specific privileges

This window allows you to define privileges on database objects and grant privileges to a user, role, view, trigger, or procedure.

To edit the privileges of a user/role/view/trigger/procedure on an object of a database, select the database using the Database pane of the Navigation bar, then select a user, a role, a view, a trigger, or a procedure from the Privileges for list available within the Navigation bar. Then select the type of objects to be displayed in the main working window using the drop-down list at the top.

The Object Name column contains the list of objects of the selected type; each subsequent column corresponds to the permission which can be granted on the selected object:

SEL, INS, UPD, DEL, References (for tables, views);

Execute (for procedures);

Usage (for exceptions and generators).

Grant Manager - Managing database-specific privileges

The list of objects can be configured in several ways: you can specify that only granted objects are displayed in the grid, or define an object name to filter the objects by that name.

Right-click a cell to grant a specific permission on a certain object. To grant a permission on an object, you should find the object in the Object Name list and the column with the corresponding permission. The context menu of a cell contains possible permissions that can be granted:

Grant

Revoke (removes a previously granted permission)

Grant with GRANT Option

Grant All

Revoke All

Grant All with GRANT Option

Grant on All

Revoke on All

Grant on All with GRANT Option

Grant All on All

Revoke All on All

See also:

Using Navigation bar and context menu

Managing column permissions

Filtering objects in list


Managing DDL grants

This tab allows you to define DDL grants (Create, Alter, Drop) for different object types to a user, role, view, trigger, or procedure.

Grant Manager - Managing DDL grants

Right-click a cell to grant a specific permission on a certain object type. The context menu of a cell contains possible permissions that can be granted:

Grant

Revoke (removes a previously granted permission)

Grant with GRANT Option

Grant All

Revoke All

Grant All with GRANT Option

Grant on All

Revoke on All

Grant on All with GRANT Option

Grant All on All

Revoke All on All


Managing column permissions

The Column permissions of <grantee_name> on <object_name> area displays the grid with table/view columns and the privileges that can be granted to the selected user, role, view, trigger, or procedure.

Use items of the context menu to grant/revoke permissions on columns.

Grant Manager - Managing column permissions

If permissions on a column have been defined (for a table or view), the corresponding permission cell of the table/view contains a specific icon.

See also:

Using Navigation bar, Toolbar and context menu

Managing database-specific privileges

Filtering objects in list


Filtering objects in list

In large databases with huge amount of objects it may be difficult to find the required object. For this purpose you are provided with several tools for filtering objects in list:

  • the Object type control: select the required object type from the drop-down list (e.g. Tables);
  • the Filter panel: enter a character string to filter the object names by that string;
  • the CheckBox Granted only option: check this option to display objects with at least one granted operation.

Grant Manager - Filtering objects in list

See also:

Using Navigation bar, Toolbar and context menu

Managing database-specific privileges

Managing column permissions


Options

SQL Manager for InterBase/Firebird provides you with capabilities for flexible personalization of the application.

Please see the chapters below to learn how to use personalization tools effectively.

  • Environment Options
  • Editor Options
  • Save Settings
  • Localization
  • Keyboard Templates
  • Object Templates

The Options menu allows you to export all program settings to a *.reg file for future use, e.g. when you need to move the settings to another machine (see Save Settings for details).

Hint: Each of the SQL Manager Options dialogs is provided with the Reset to defaults button. You can use it either to Reset current category or to Reset all categories.

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Security management

External Tools

How To...


Environment Options

Environment Options allow you to customize general options of the SQL Manager application.

To open the Environment Options window, select the Options | btnEnvironmentOptions Environment Options... main menu item, or use the Environment Options btnEnvironmentOptions button on the main toolbar.

Preferences

Full mode activation

Confirmations

Appearance

DB Explorer

Search

SQL Assistant

Tools

Query Data

SQL Monitor

Execute Script

Design Query

Style & Color

Database Designer

Extract Database

Print Metadata

Database Monitor

Dependencies

Data Export

Object Editors

Table Editor

Visual Mode Editors

Fonts

Grid

Data Options

Print Data

Color & Formats

Advanced

Column Options

Localization

Global Shortcuts

Find Option

See also:

Editor Options


Preferences

CheckBox Restore desktop on connect

This option determines whether the previously opened windows and their positions should be restored upon connection to the database.

CheckBox Show desktop panel (for MDI Environment style only)

Displays Desktop Panel when no child windows are open.

CheckBox Show Full Version features

This option is available in the Lite version of SQL Manager. When selected, a 30-day period of fully-functional usage is activated.

Environment Options - Preferences

If necessary, you can reset all toolbars and menus of the application using the corresponding button.

Hint: The Reset to Defaults button which is common for all sections of the Environment Options dialog opens a menu with items allowing you to discard all changes and reset options of the current category or of all categories to their defaults.

See also:

Confirmations

Tools

Fonts

Grid

Localization

Find Option


Full mode activation

Note that when using the FREE Lite version of SQL Manager for InterBase/Firebird (which contains functional limitations) you can activate a 30-day period of fully-functional usage. During this period you will get the splash screen displaying the number of days left every time you start the application. After the period expires, you will be able to continue using the Lite version.

Environment Options - Full mode activation

To activate the 30-day Full version mode, please enable the CheckBox Show Full Version features option available on the Preferences page of the Environment Options dialog (note that this option is only available in the Lite version of SQL Manager).


Confirmations

CheckBox Confirm saving the object (or document) upon closing the editor

If this option is selected, the program requires confirmation each time you want to save changes in a database object or document.

CheckBox Confirm dropping of object

If this option is selected, the program requires confirmation of dropping a database object.

CheckBox Confirm exit from SQL Manager

If this option is selected, you are prompted for confirmation each time when you exit the application.

Environment Options - Confirmations

CheckBox Confirm transaction commit

If this option is checked, the program requires confirmation on attempt to commit a transaction.

CheckBox Confirm transaction rollback

If this option is checked, the program requires confirmation on attempt to rollback a transaction.

CheckBox Confirm deleting records

This option enables/disables a confirmation dialog for deleting records.

CheckBox Confirm addition into spell checking dictionary

Enable this option if you wish to be prompted for adding a word to the dictionary which is used for checking words spelling (see Spell Checking).

CheckBox Confirm transformation of misprint into substitution

If this option is selected, you need to confirm replacing a misprinted word with a corresponding substitution word (see Spell Checking).

CheckBox Show client library warnings

If this option is selected, the application displays warnings returned by the client library used for connection.

CheckBox Show refresh database warnings

If this option is selected, the application displays warnings received upon refreshing a database.

CheckBox Show NONE charset connection warnings

If this option is selected, the application displays warnings upon connection with NONE charset specified.

CheckBox Confirm successful compilation

This option enables/disables the Compile window.


Windows

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Appearance

Theme

Select the main color theme for the application: Light, Blue or Dark.

Environment style

This group allows you to define the basic window environment - RadioButton MDI (like Microsoft® Office) or RadioButton Floating windows (like Borland® Delphi IDE).

Windows restrictions

This option allows you to set the number of editors (Table Editor, Query Data, etc.) that can be opened simultaneously.

Zoom options

This group of options is only available if Environment Style is set to Floating windows environment. It allows you to set maximization size for child windows:

RadioButton Full screen

RadioButton Restricted by Main Form

RadioButton Restricted by Main Form and DB Explorer

RadioButton Justified my Main Form and DB Explorer

Environment Options - Windows

Bar style for child forms

Here you can define the location of action buttons: RadioButton within the Navigation bar (on the left) and/or RadioButton on the Toolbar.

If necessary, you can also CheckBox Enable floating toolbars for your application.


DB Explorer

General options

CheckBox Show hosts in DB Explorer

Shows/hides hosts in the DB Explorer tree.

CheckBox Show table subobjects

Shows/hides table subobjects (fields, indexes, etc.) in the DB Explorer tree.

CheckBox Show procedure subobjects

Toggles displaying stored procedure subobjects (input/output parameters) in the DB Explorer tree.

CheckBox Show UDF subobjects

Toggles displaying UDF subobjects in the DB Explorer tree.

CheckBox Ping hosts

Checking the host for availability.

CheckBox Sort by aliases

Use this option to apply sorting registered databases by their aliases in the DB Explorer tree.

CheckBox Rename objects by editing in place

Allows you to edit object names in DB Explorer by selecting any object and clicking its alias one more time.

CheckBox Auto expand navigation pane

If this option is checked, the list of navigation tabs in DB Explorer is expanded automatically on program launch.

CheckBox Show hints

The option enables/disables hints for objects in the DB Explorer tree.

Select colors for system objects / erroneous objects from the System object color / Erroneous object color drop-down lists. If you select the Default item, the default color will be applied.

Note: When setting colors, select an item from the drop-down list or click the ellipsis EllipsisButton button to select a color using the Color dialog where you can specify the required color from the palette.

Recent objects count

Defines the number of objects displayed within the Recent menu of the DB Explorer.

Environment Options - Tools - DB Explorer

CheckBox Show system objects

Shows/hides system objects (having names starting with RDB$) in the DB Explorer tree.

CheckBox Detect erroneous objects

Enables/disables displaying the objects with "broken" DDL with different icons in the tree.

CheckBox Show view subobjects

Toggles displaying view subobjects in the DB Explorer tree.


Search

Use these options to adjust search settings for the search string in DB Explorer.

Environment Options - Tools - DB Explorer - Search

CheckBox Search by categories

Enable this option to only search in category names. Use this option to quickly access the object node. You can use the corresponding [image] button on the Search toolbar in DB Explorer to quickly toggle the option.

CheckBox Use case sensitive search

Enable this option to differentiate uppercase characters from lowercase ones using the Search Panel.

CheckBox Don't search in collapsed nodes

Enable this option to restrict searching in the collapsed nodes in DB Explorer.

CheckBox Start-with search

Enable this option to search for the names starting with the specified text only.


SQL Assistant

Table / View / Procedure / UDF / Exception / Generator details in SQL Assistant

These options switch the SQL Assistant mode for displaying details for InterBase/Firebird objects selected in the DB Explorer tree:

for tables: fields, primary keys, uniques, Foreign keys, checks, indexes, triggers, description or definition;

for views: fields, triggers, description or definition;

for procedures: parameters, description or definition;

for UDFs: arguments, description or definition;

for exceptions: message text, description or definition;

for generators: value or definition.

If necessary, you can specify to CheckBox Show error messages for erroneous objects (triggers, stored procedures) in SQL Assistant.

Environment Options - Tools - DB Explorer - SQL Assistant


Tools

CheckBox Show only connected databases in drop-down menu

If this option is checked, only connected databases are displayed in drop-down menus of such tools as Query Builder, Script editor, etc.

CheckBox Allow using parameters in query text

This feature allows you to specify different values within a query in a popup dialog just before the query execution. Use the colon (':') character before an identifier (e.g. :P1) to specify a parameter within the query.

Environment Options - Tools

New tool form should be opened for

Use this group to specify the database to open new editors for:

RadioButton Database currently selected in DB Explorer

RadioButton Database selected in currently focused form

CheckBox Show only connected databases for services

If this option is checked, only connected databases are displayed in services such as Backup Database, Restore Database, etc.


Query Data

CheckBox Explain query on execution

If this option is checked, the query plan is displayed automatically upon query execution in Query Data.

CheckBox Show result for each query

With this option checked, when you execute two or more queries, the result of each query will be displayed one by one. Otherwise, only the result of the last query will be displayed.

CheckBox Execute selected text separately

Check this option to allow execution of the selected statement separately.

CheckBox Write only successfully executed queries to database SQL log file

If this option is checked, unsuccessful queries will not be saved to the Query Data log file (see Setting log options in the Database Registration Info dialog).

CheckBox Show results on Query tab

If this option is checked, the Results tab is displayed as a separate tab.

CheckBox Don't save queries automatically for the next session

If this option is checked, the SQL query text will not be saved. Otherwise, it will be saved in Windows registry and will be therefore available in the next sessions of application.

CheckBox Always save changes in Favorite Queries before closing

This option enables/disables saving changes in SQL queries marked as Favorite automatically upon closing the editor.

Environment Options - Tools - SQL Editor

CheckBox Same queries for all databases

With this option enabled, Query Data stores all queries in a shared repository, so that switching to another database does not cause loading queries of that database (applying this option does not affect currently opened copies of Query Data). The value of the option can be changed freely without any risk to lose the query repository content.

CheckBox Refresh DB Explorer upon successful DDL statement execution

If this option is selected, the content of DB Explorer is refreshed each time a DDL statement is executed successfully in Query Data.

Transaction confirmation

CheckBox Disable transaction confirmation

If this option is checked, no transaction confirmation will be required on closing Query Designer and Query Data. Specify the default action (Commit or Rollback) and this action will be performed automatically each time when you close the editor.

CheckBox Substitute constraints in query plan

If this option is checked, natively used constraints are substituted with indexes in the query plan.

CheckBox Toggle AutoDDL off by default

Toggles the default mode (on/off) for automatic committing of each statement.

See also:

Query Data


SQL Monitor

Operations

This group allows you to specify which operations will be monitored by the application: connect, disconnect, start of transaction, commit, commit retaining, service operations, rollback, rollback retaining, execute query, prepare query, fetch record.

SQL log

This group of options allows you to enable logging of all SQL Monitor events to a file. Check the Log SQL Monitor events to file option, specify the path to the log file using the btnSaveAs button, and enter a name for the *.sql file. To clear the log file after it reaches some definite size, check the Clear log file when it is greater than... option and set the maximum file size (in Kilobytes).

Environment Options - Tools - SQL Monitor

CheckBox Show time of operation

If this option is checked, the execution time of logged operations is added.

CheckBox Always show on top

Select this option if you want to display the SQL Monitor window in the foreground permanently.

See also:

SQL Monitor


Execute Script

CheckBox Abort script on error

If this option is checked, script execution is aborted if an error occurs.

Note: Errors of CONNECT and CREATE DATABASE statements abort script execution anyway.

CheckBox Show statements explorer

With this option checked, Execute Script Editor parses the loaded script to enable fast navigation in the Script Explorer tree.

CheckBox Show message when done

Displays a message box on finishing script execution.

CheckBox Execute selected text separately

Check this option to allow execution of the selected statement separately.

CheckBox Don't clear error list on selected text execution

If this option is checked, the error list is not cleared upon execution of the selected statement.

CheckBox Skip unknown statements

Skips unknown statements on script execution.

CheckBox Disable all code features in Execute Script

Disables syntax highlighting and code folding to speed up processing of script.

Environment Options - Tools - SQL Script

Database options

CheckBox Register databases if needed

If the option is enabled, the Database Registration Info dialog will be displayed automatically after successful CREATE DATABASE or CONNECT script execution.

Note: Unregistered databases mentioned in the CONNECT and CREATE DATABASE statements will be prompted for registration.

CheckBox Connect automatically to just created database

Enable this option to automatically connect to just created database in DB Explorer.

Transaction options

CheckBox Rollback current transaction on abort

This option evokes automatic rollback of the current transaction when script execution is aborted (due to an error or if interrupted by user).

CheckBox Start transaction automatically if needed

Enable this option to automatically start transaction on execution.

CheckBox Toggle AutoDDL off by default

Toggles the default mode (on/off) for automatic committing of each statement.

Script finalization

RadioButton Commit all active transactions automatically

All transactions are committed automatically after the script has been executed.

RadioButton Ask user to select required action

The user is prompted to commit or abort transaction after the script has been executed.

See also:

Execute Script Editor


Design Query

General options

CheckBox Allow SELECT queries only

When this option is checked, the INSERT, UPDATE and DELETE statements are not allowed in Query Builder.

CheckBox Select condition row

Displays the selected condition in different rows on the Criteria and Grouping Criteria tabs of Query Builder.

CheckBox Drag field name

Displays the dragged field name in the Builder area.

CheckBox Hide selection when inactive

Hides the selection when the Query Builder window is inactive.

CheckBox Show field types

Displays the field data type next to the field name in the table box.

CheckBox Union all by default

Check this option to use the UNION ALL expression in Query Builder by default.

The UNION keyword allows you to include the results of two SELECT statements in one resulting table.

The ALL parameter incorporates all rows into the results, including duplicates. If not specified, duplicate rows are removed.

Environment Options - Tools - Query Builder

Visible tabs

These options specify which Query Builder tabs are available and which are not. Use the check boxes to make the corresponding tabs visible/invisible.

Script format

These options specify case formatting of keywords and functions in query text within the Edit tab: As is keeps the original case, Uppercase sets all the keywords/functions to the upper case, Lowercase sets all the keywords/functions to the lower case, and First upper sets the first letters of all keywords/functions to the upper case.

Additionally, you can set styles and color for all Query Builder objects by using Style & Color.

See also:

Query Builder


Style & Color

Style
These options specify the way various Query Builder elements look: the Condition button: Flat, 3DLook, Raised; object borders: Bump, Etched, Raised, Sunken.

CheckBox Flat objects

This option sets the flat appearance of objects in Design Query.

CheckBox Windows style of tables

This option determines the appearance of tables in the Builder tab.

CheckBox Show icons on tabs

With this option selected, you can see icons next to the tab names in Design Query.

Environment Options - Tools - Query Builder - Style & Color

Color palette

These options define the colors of various Query Builder elements.

Active condition row (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Active condition row

Condition text (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Condition text

Condition item text (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Condition item text

Table client area (in the diagram area):

Environment Options - Tools - QB - Style & Color - Table client area

Active table caption (in the diagram area):

Environment Options - Tools - QB - Style & Color - Active table caption

Inactive table caption (in the diagram area):

Environment Options - Tools - QB - Style & Color - Inactive table caption

Field text (in the diagram area):

Environment Options - Tools - QB - Style & Color - Field text

Selected field text (in the diagram area):

Environment Options - Tools - QB - Style & Color - Selected field text

Work space (in the diagram area):

Environment Options - Tools - QB - Style & Color - Work space

Field (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Field

Operation (at the Criteria and Grouping criteria tabs):

Environment Options - Tools - QB - Style & Color - Operation

Group (at the Grouping criteria tab):

Environment Options - Tools - QB - Style & Color - Group

Predicate (at the Criteria and Grouping criteria tabs when a subquery is used):

Environment Options - Tools - QB - Style & Color - Predicate

Subquery (at the Criteria and Grouping criteria tabs when a subquery is used):

Environment Options - Tools - QB - Style & Color - Subquery

Click an item to select a color for the corresponding element using the Color dialog where you can specify the required color from the palette.


Database Designer

CheckBox Automatically open last diagram file

Enable this option to load the last opened diagram file on starting the Database Designer.

Visual settings

Model notation

When you work in Database Designer, you can choose one of the following modeling notations:

  • Integration DEFinition for Information Modeling (IDEF1X);
  • Information Engineering (IE).

The IDEF1X and IE notations use different symbols to represent relationships between entities (and tables).

Environment Options - Tools - VDBD

CheckBox Draw PRIMARY KEY fields separately

Separates Primary key fields from other fields with a horizontal line.

Environment Options - Tools - VDBD - Draw PRIMARY KEY fields separately

CheckBox Draw entities icons

Displays icons at the left of each entity header according to its type.

Environment Options - Tools - VDBD - Draw entities icons

CheckBox Draw attributes icons

Displays icons at the left of each attribute according to its type (Primary key, Foreign key, ordinary field).

Environment Options - Tools - VDBD - Draw attributes icons

CheckBox Draw only names of entities

Displays only entity headers, fields are hidden.

Environment Options - Tools - VDBD - Draw only names of entities

CheckBox Draw FOREIGN KEY name

Displays foreign key names for the corresponding relations.

Environment Options - Tools - VDBD - Draw FOREIGN KEY name

CheckBox Draw page borders

Displays borders of the page on the diagram.

If y

Grid options

CheckBox Show grid

Displays dots in the diagram area to make the grid visible.

CheckBox Snap to grid

Automatically aligns entities on the form with the nearest grid line. You cannot place an entity in between grid lines.

Grid size

Sets grid spacing in pixels along the x- and y-axes. Specify a higher number to increase grid spacing.

Style & Color

This section helps you to customize the default view of the diagram objects.

Select the Element type from the list: Workspace, Selected item, Table, Relation, Field, Comment and set the required options for it, including color or font properties. Use the Apply to all button to apply the changes to all elements.

See also:

Database Designer


Extract Database

This page allows you to customize settings of the Extract Database wizard.

CheckBox Automatically load template on run

Check this option to specify that a template file will be automatically loaded on running the Extract Database wizard.

Type in or use the ExplorerButton button to specify the path to the *.emt file to be used by the wizard.

Environment Options - Tools - Extract database

See also:

Extract Database


Print Metadata

Default paper size

Define the default paper size for reports created with the Print Metadata tool used:

RadioButton A4 (210 x 297 mm)

RadioButton Letter (8 1/2 x 11 ")

Environment Options - Tools - Print Metadata

See also:

Print Metadata


Database Monitor

This section allows you to set preferences pertaining to the Database Monitor tool.

Environment Options - Tools - DB Monitor

Refresh interval in seconds

Set the refresh interval (in seconds) for collecting information by Database Monitor.

See also:

Database Monitor


Dependencies

This section allows you to set preferences pertaining to the Dependencies tab of object editors and the Dependency Tree tool.

Environment Options - Tools - Dependencies

CheckBox Automatically expand dependencies

Set this option to expand the tree of dependent objects automatically on opening the Dependencies tab of an object editor.

CheckBox Don't show empty object categories in dependencies

Set this option to hide empty objects categories in the trees of dependent objects.

CheckBox Show subobjects in dependencies

Set this option to show subobjects of dependent objects.

CheckBox Scroll current object into visible area of Dependency Tree

Set this option to scroll the Root (currently selected) object to the visible area of the Dependency Tree working area.

CheckBox Show domains in dependencies

Set this option to show domains in Dependency Tree.

CheckBox Use simplified resolving of object dependencies

Set this option to disable parsing while fetching object dependencies.

Dependency Tree diagram layout

This group allows you to specify which objects are to be displayed in Dependency Tree:

RadioButton Show all objects

RadioButton Show only objects that depend on the Root object

RadioButton Show only objects that the Root object depends on

Max number of history items in Dependency Tree

Set the maximum number of history items to be saved in Dependency Tree tool.

Note: Navigation through history items is performed by using the Previous object / Next object items of the Navigation bar.

See also:

Dependency Tree


Data Export

This page allows you to customize formats applied to exported data.

Environment Options - Tools - Data Export

Data formats

Edit the format masks to adjust the result format in the way you need: Integer format, Float format, Date format, Time format, DateTime format, Currency format, Boolean True, Boolean False, Null string.

CheckBox Auto save format strings

Select this option to save specified format strings automatically.

If more convenient, you can click the Set defaults button to apply default data formats.

These settings can also be specified at the Adjusting data formats step of Export Data Wizard.

Fore more details see Format specifiers.

See also:

Export Data Wizard


Object Editors

CheckBox Show privileges in objects DDL

Toggles displaying the script fragment for setting grants at the DDL tab of object editors.

CheckBox Show description in objects DDL

Toggles displaying the script fragment for setting description at the DDL tab of object editors.

CheckBox Automatically show Object Explorer*

Enables/disables the Object Explorer panel within the Navigation bar of Table Editor and Procedure Editor.

CheckBox Restore the object changes after abnormal closure of editor

Select this option if you wish changes made to an object in its editor to be restored from internal buffers unexpected interruption of the editor occurs.

CheckBox Keep layout for each editor separately

If the option is enabled, layout (mode) is kept for each editor separately.

CheckBox Always open the Edit tab

If this option is checked, the Edit tab is activated by default on opening an object in its editor.

CheckBox Search subobjects by double click in Object Explorer*

If this option is checked, you may open subobjects on the appropriate tab by double click in the Object Explorer panel within the Navigation bar of Table Editor and Procedure Editor.

Environment Options - Tools - Object Editors

* Regarding table, view, stored procedure, trigger and DB trigger editors.


Table Editor

CheckBox Show Autoincrement objects in DDL

If this option is selected, definition of objects used for the Autoincrement property implementation will be displayed in table DDL.

CheckBox Open separate editor for trigger at Triggers tab with a double-click

If this option is selected, a separate Trigger Editor will be opened when a trigger is double-clicked under the Triggers tab of Table Editor.

Environment Options - Tools - Object Editors - Table Editor

See also:

Table Editor


Visual Mode Editors

CheckBox Recompile dependencies

If the option is selected, the objects that refer to the current object are recompiled.

CheckBox Set grants when compiling

This option allows you to set grants on the object automatically when compiling the object.

CheckBox Show Trigger Messages in DDL

Toggles displaying the script fragment for setting trigger messages at the DDL tab of the trigger editors.

Environment Options - Tools - Object Editors - Visual Mode Editors

CheckBox Force applying of visual mode for all editors

Enables visual mode for all editors. This option is unavailable if Keep layout for each editor separately option is ON at Object Editors options.

CheckBox Show descriptions as comments in script

Toggles displaying object descriptions as comments in scripts generated for the objects.

CheckBox Quote local variable names in visual mode automatically if needed.

If this option is enabled, the local variable names are quoted automatically if they are entered in lowercase. This option is working correctly if the CheckBox Always capitalize database objects names option on the Common options tab in the Database Registration Info dialog is not enabled.


Fonts

This section of the Environment Options dialog allows you to specify fonts used in the application.

Environment Options - Fonts

System font name
Defines the font used by SQL Manager for InterBase/Firebird. Select the font name from the drop-down list of available system fonts.

Environment Options - Fonts - System font name

System font size
Select the required size for the system font.

The box below displays the sample text with the selected font applied.

Grid font name
Defines the font used in the Data grid. Select the font name from the drop-down list of available fonts.

System font size
Select the required size for the grid font.

The grid below displays the sample grid with the selected font applied.


Grid

General options

CheckBox Striped grids

Displays the odd grid rows in a different color defined by the Strip option available on the Color & Formats page.

CheckBox Show editor immediately

Allows editing the cell value right after the cell is clicked.

CheckBox Always show editor

Set this option to make the cell editors always active.

CheckBox Enable auto-search in grid

If this option is checked, the cursor is automatically forwarded to the closest match when you start typing.

CheckBox Column auto-width

With this option set, column widths are changed in order to display all columns without using the horizontal scroll bar. If the content a column is still too large to display without a need to resize the grid, then the column values are truncated and the hidden characters are replaced with an ellipsis at the end.

CheckBox Cell auto-height

If the widths of the columns are insufficient to display the full content, then text clipping occurs. Set this option to prevent this. If this option is set, the cell content is displayed in multiple lines where necessary. You can set the number of lines to display using the Cell max line count option.

Environment Options - Grid

Root level options

These options are applied to the main view of the grid. See Grid View for details. The options are described in the Detail level options list below.

Detail level options

These options are applied to the detail view of the grid. See Grid View for details.

CheckBox Show "Group by" box

Displays the gray area above the column caption allowing one to group data in the grid.

CheckBox Show indicator

Activates/deactivates the row indicator pane at the left.

Environment Options - Grid - Show indicator

CheckBox Show navigator

Activates/deactivates the data navigator similar to the navigation pane at the top of the grid. The navigator is available at the bottom of detail level view.

Environment Options - Grid - Show navigator

CheckBox Show "New item row"

Displays an empty row at the bottom of a view which is a convenient way for adding data to the grid.

CheckBox Hide tabs for single detail

This option is useful when only one view is present on the detail level. When the option is enabled, the view tab is hidden.

Selection

If the RadioButton Row selection is selected then the whole record in the table is selected in the table on clicking the cell. Otherwise, only the clicked cell is selected ( RadioButton Cell selection option).

Check the CheckBox Row/cell multi-selection option to enable the selection of multiple cells or rows in the grid with the Shift button.

See also:

Grid View


Data Options

Advanced

CheckBox Use separate connections for each data view within a database

Select this option to use a separate connection for each data view within a database. Disabling this option is recommended if maximum allowed number of connections is too low.

CheckBox Asynchronous query execution

Check this option to allow executing queries in background mode (asynchronously). Note that this option is only available when the Use separate connections for each data view within a database option is enabled.

CheckBox Perform data sorting on client in data view

If enabled, the data are sorted by SQL Manager for InterBase/Firebird (on the client side). If this option is disabled, the data are sorted on InterBase/Firebird server with the help of the ORDER BY clause used in SQL query.

CheckBox Perform data filtration on client in data view

If enabled, the data are filtered by SQL Manager for InterBase/Firebird (on the client side).

If disabled, SQL filter is used in data view. In this case filtering is performed on the InterBase/Firebird server with the help of the WHERE clause used in SQL query.

With the Perform data sorting on client in data view option enabled, sorting is performed by means of the grid. Otherwise a click on the column header for sorting causes reloading all table data with the selected field in the ORDER BY expression of the SELECT statement.

If the table contains a huge amount of records and the Select only N records mode (see the Default limit options in table and view editors group) is used, this mode is more preferable (e.g. all the records having values starting with "A" will be displayed, and not those which were in originally opened N records).

All above-mentioned is related to the Perform data filtration on client in data view option as well. If the filter is applied to a table containing a great number of records, it is strongly recommended to enable this option - in this case the filter will be applied to all table/view records, not only to those which are displayed at the present moment.

Load visible rows mode if records more than...*

Set this option to switch to the Load visible rows mode when the number of records in the dataset exceeds the specified value.

String fields width (chars)

Using this option you can limit string fields width that may improve performance on large datasets.

CheckBox Sort by primary key

When enabled, the option allows sorting data by the primary key on opening the data grid.

Environment Options - Grid - Data Options

Default grid mode

RadioButton Load all rows*

The grid loads all records from a dataset. This option increases the grid performance by reloading only changed dataset records when updating. In this mode all features (automatic sorting, filtering and summary calculations) are available.

RadioButton Load visible rows*

The grid loads only a fixed number of dataset records into memory. This option minimizes dataset loading time. Automatic sorting, filtering, summary calculations are not available in this mode.

The Default grid mode options allow you to define the grid mode which will be used by default.

With the Load all rows option enabled, when loading data, all the records are loaded into grid buffers. In this mode opening the tables with many records may take a considerable amount of time. But in this case you can make use of some advantages: in the filter drop-down list the column headers are displayed with the values for quick filtering; it is possible to open several sub-levels at the same time when viewing data in master-detail view, etc.

In case opening and other operations with an object consisting of many records takes sufficient time, the Load visible rows mode should be used instead. It can be set individually for each table and saved between sessions (can be set through the context menu of the grid).

Default records count retrieving mode

RadioButton Always retrieve

Use this mode to get record count always.

RadioButton Never retrieve

This mode disables retrieving record counting.

RadioButton Retrieve for quick queries

Use this mode to retrieve records count if it takes less time than specified at the Quick query latency field below.

Note: Changing the options marked with the asterisk (*) sign does not affect the way data are viewed in currently opened windows. These options are used as default values for Data Options parameters for newly registered databases. To change the options for registered databases, please use the Database Registration Info dialog.


Print Data

Save/restore following print data properties

These options specify which Print Data properties will be saved between work sessions (e.g. if you tick off the Page settings item, those settings will be saved and stored between the sessions).

You can save/restore the following Print Data properties: Card view representation, Detail view representation, Expanding, Formatting, Level options, "On every page" options, Pagination, Preview options, Image options, Selection options, Report size options, Showing grid elements, Page number format, Page settings, Report title.

Environment Options - Grid - print Data Options


Color & Formats

Display formats

Integer fields

Defines the format for displaying SMALLINT, INTEGER and BIGINT fields.

Float fields

Defines the format for displaying FLOAT, DOUBLE PRECISION and DECIMAL fields.

Datetime fields

Defines the format for displaying TIMESTAMP fields.

Date fields

Defines the format for displaying DATE fields.

Time fields

Defines the format for displaying TIME fields.

For more information refer to the Format specifiers page.

Environment Options - Grid - Color & Formats

Colors

Options of this group allow you to set colors for basic grid elements. Use the ellipsis EllipsisButton button to open the Color dialog allowing you to select the required color from the palette.

Grid
Defines the background color of the data grid.

Row
Defines the color of the selected row in the data grid.

Strip
Defines the color of the odd rows (applied if the Striped grids option is set on the Grid page).

NULL values
Text
Defines the text that stands for NULL values in grid.

Font color
Defines the font color for displaying NULL values in the grid. Use the ellipsis EllipsisButton button to open the Color dialog allowing you to select the required color from the palette.


Advanced

Advanced options

CheckBox Cell hints for clipped text

Indicates whether a hint box is displayed when hovering over a cell containing clipped text.

CheckBox Focus cell on cycle

Determines whether the focus moves to the next row after it reaches the right-most cell within the current row.

CheckBox Focus first cell on new record

Determines whether the focus moves to the first cell of a newly created row.

CheckBox Next cell on pressing Enter

Determines whether the current view columns can be navigated by using the Enter key.

CheckBox Show navigator hints

Indicates whether a hint box is displayed when hovering over navigation buttons.

CheckBox MRU list in column filter

Enables showing of Most Recently Used items when filtering columns.

Card width

Defines the width of the card used in Card View mode.

Environment Options - Grid - Advanced

Form view

CheckBox Large memo editor

Enables large editors on the Form view. Set the number of lines for text-typed fields.

CheckBox Word wrap in memo editor

Determines whether long strings are wrapped within the memo editor area.

CheckBox Word wrap in string editor

Determines whether long strings are wrapped within the string editor area.

Grid lines

Determines whether to display vertical and horizontal lines between cells.

Detail tabs position

Specifies the position of the tabs in detail level views: top or left.

Card layout direction

Specifies the direction of cards in Card View mode: horizontal or vertical.

Show edit buttons

Indicates when the edit buttons are displayed: never, for focused record or always.


Column Options

Common options

CheckBox Auto-select text

Determines whether all text within an editor is automatically selected when the editor gets focus.

CheckBox Hide selection on losing focus

Determines whether the visual indication of the selected text remains when the editor loses focus.

Memo editor options

CheckBox Inserting Return characters

Specifies whether a user can insert return characters into text.

CheckBox Inserting Tab characters

Specifies whether a user can insert tab characters into text.

CheckBox Word wrap in grid

Determines whether long strings are wrapped in grid.

CheckBox Popup memo editors

Turns on popup memo editors for text BLOB type fields.

Environment Options - Grid - Column Options

Spin editor options

CheckBox Use Ctrl+Up instead of Up to increase value

Allows you to use Ctrl+Up and Ctrl+Down key combinations for editing spinner values (for INTEGER field values).

CheckBox Show large increment buttons

Determines whether fast buttons (for large increment) are visible within the editor.

Increment

Specifies the increment value for the spin editor (spinner control).

Large increment

Specifies the large increment value for the spin editor (spinner control).

Spin editor buttons' position

Specifies the position of spin editor (spinner control) buttons: vertical, horizontal / left and right or horizontal / right.


Localization

The Localization section of the Environment Options dialog is provided for managing the localization files of SQL Manager for InterBase/Firebird.

You can create your own *.lng files similar to those available in the %program_directory%\Languages folder, add them to the list of available languages and set the new language as the program interface language.

Default directory

Use the Explorer ExplorerButton button to specify the directory where the *.lng files are to be stored by default.

Choose program language

Use the drop-down list of available languages to select the interface language to be applied to the application.

CheckBox Auto scan languages on startup

When checked, the directory with localization files will be scanned automatically at the application startup; all the languages found will be added to the list of available languages.

Available Languages

Lists all the languages available for localization and the corresponding *.lng files. Double-click a language in the list to edit its name or the *.lng file.

Environment Options - Localization

Add Defaults

This button is used to search for *.lng files in the Default directory and add all of them to the Available Languages list.

Add

Opens the Add language dialog where you can specify your own localization file and set the language name.

Edit

Opens the Edit language dialog where you can change the language name or select another localization file for the specified language.

Delete

Removes the selected language from the Available languages list (without confirmation).

See also:

Localization


Global Shortcuts

This section allows you to view/edit shortcuts for most needed actions when working with SQL Manager for InterBase/Firebird.

Environment Options - Global Shortcuts

To edit a shortcut, select the required action click the ellipsis button and press the preferred key combination to assign it with the action.

See also:

Key Mapping

Keyboard Templates


Find Option

The Find Option section allows you to search for options available within the Environment Options dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within SQL Manager Environment Options.

Environment Options - Find Option

The Available options area lists all options of the Environment Options category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


Editor Options

Editor Options allow you to set the parameters of viewing and editing SQL statements within Query Data and other SQL editing tools of the SQL Manager application.

To open the Editor Options window, select the Options | Editor Options... main menu item, or use the Editor Options btnEditorOptions button on the main toolbar.

General

Display

SQL Formatter

Key Mapping

Spell Checking

Find Option

See also:

Environment Options


General

Editor options

CheckBox Auto indent

If this option is checked, each new indention is the same as the previous one when editing SQL text.

Indents and outdents are used in the process of text editing to make the source code easier to read.

CheckBox Insert mode

If this option is checked, the insert symbols mode is on by default.

CheckBox Find text at cursor

If this option is checked, the Text to find field in the Find Text dialog is automatically filled with the text on which the cursor is set.

CheckBox Always show hyperlinks

If this option is checked, hyperlinks are displayed in the editor window. To open a link, click it with the Ctrl key pressed.

CheckBox Double click line

If this option is checked, double-clicking the line on which the cursor is set selects the whole line.

CheckBox Trim trailing spaces

If this option is checked, all spaces after the last symbol in line will be trimmed.

CheckBox Fixed line height

Prevents line height calculation. If this option is checked, the default line height is taken.

CheckBox Persistent blocks

Keeps marked blocks selected even when the cursor is moved with the arrow keys used, unless a new block is selected.

CheckBox Fixed column move

If this option is checked, the caret keeps its horizontal position when moved between lines.

CheckBox Optimal fill

Check this option to enable optimal algorithm of filling text content in the working area of the editor.

CheckBox Unindent keep align

Keeps align for the lines that are not indented.

CheckBox Smart caret

This option determines the caret movement (up, down, line start, line end). The caret is moved to the nearest position on the screen.

CheckBox Resolve aliases

Enables/disables the syntax highlight and code completion features for aliases.

Editor Options - General

CheckBox Overwrite blocks

Replaces a marked block of text with whatever is typed next. If Persistent Blocks is also selected, the text you enter is appended to the currently selected block.

CheckBox Show caret in read only mode

Displays/hides the caret in read-only mode.

CheckBox Copy to clipboard as RTF

If this option is checked, the selected text is copied in Rich Text format.

CheckBox Drag and drop text

This option allows to drag and drop selected text.

CheckBox Group undo

This option allows you to undo multiple actions of the same kind.

CheckBox Group redo

This option allows you to redo multiple actions of the same kind.

CheckBox Keep caret horizontal position (Cursor beyond EOL)

If this option is checked, the horizontal position of a cursor is kept. If you move the cursor (using the Up and Down arrow keys) onto a line having length less than the current cursor horizontal position, it will be positioned after the last symbol of the line.

CheckBox Enable column selection

Enables/disables column selection mode.

CheckBox Hide cursor on type

Hides/displays mouse cursor within the working area while a user is typing some text.

CheckBox Hide dynamic (no focus)

Hides dynamic highlights when an editor is not focused.

CheckBox Collapse empty lines

Collapses empty lines after a text range when this range has been collapsed.

CheckBox Scroll to past line (Scroll to the last line only)

When the option is enabled, you can scroll to the last line of the text only, otherwise you can scroll to the end of the page.

CheckBox Word wrap

When on, text is wrapped at the right margin of the editor area to fit in the visible area.

CheckBox Variable horizontal scrollbar

If this option is checked, the horizontal scrollbar varies according to the current content of the editor.

CheckBox Float markers

When enabled, markers are linked to the text, and they will move with the text while the text is being edited; otherwise the markers are linked to the caret position, and stay unchanged while the text is being edited.

CheckBox Undo after save

Keeps undo buffer unchanged after saving.

CheckBox Disable selection

Disables any selection when editing.

CheckBox Draw current line focus

Draws the focus rectangle around the current line when the editor has focus.

CheckBox Hide selection (no focus)

Hides the selection when the editor loses focus.

CheckBox Greedy selection

Selects an extra column/line in column/line selection modes.

CheckBox Keep selection mode

Enables selection for caret movement commands (like in BRIEF).

CheckBox Select search result

Determines whether the search result should be selected.

CheckBox Smart paste

When this option is enabled, the editor gets both Unicode and ANSI content from the clipboard, converts them using the selected character set and selects the best text to be pasted. This allows getting correct text copied from both ANSI and Unicode applications disregarding the currently selected keyboard language.

CheckBox Disable all code features

This option disables code completion, code folding, highlight and all options that are set on the Code Completion page. For options that are set on the Highlight page, the defaults will be applied.

Collapse level

Specifies the level of text ranges that will be affected by the "Collapse all" command.

Undo limit

Defines the maximum number of changes possible to be undone.

Tab mode

Specifies the way the TAB key is processed. Possible values are: Use tab character (inserts a tab character); Insert spaces (inserts space characters); Dialog behaviour (when the edit control is in a dialog, the focus is switched to the next control); Smart tab (tabs to the first non-white space character in the preceding line).

Tab stops

Defines the tab length used when editing a text.

Comment symbols

Defines the symbols which will be used to comment code fragments.

Block indent

Specify the number of spaces to indent a marked block.

Hint: The Reset to Defaults button which is common for all sections of the Editor Options dialog opens a menu with items allowing you to discard all changes and reset options of the current category or of all categories to their defaults.


Display

Default editor fonts

Use these options to set the font and size used in the editor.

CheckBox Show only fixed-width fonts

Use this option to display only fonts with fixed width in the Font dialog.

Gutter

CheckBox Show line numbers

If this option is checked, line numbers are displayed in the SQL text editor window.

CheckBox Gutter auto width

Enable this option to specify that the gutter width will be adjusted automatically.

CheckBox Display line state

If this option is checked, a colored line indicating the state of all altered lines in the text is displayed at the gutter of the editor window.

CheckBox Use code folding

Check this option to enable to code folding feature of Query data.

Width

Defines the gutter width in the editor window.

Use these options to set the Font, Size and Numbering style used in the gutter.

CheckBox Show only fixed-width fonts

Use this option to display only fonts with fixed width in the Font dialog.

Editor Options - Display

Right margin

CheckBox Visible

Makes the right text margin visible.

CheckBox Word break

Allows breaking the words at the right margin.

Position

Defines the position of the right text margin in the editor window.

Color

Defines the color of the right margin in the editor window. Select an item from the drop-down list or click the ellipsis EllipsisButton button to select a color using the Color dialog where you can specify the required color from the palette.

Code staples

CheckBox Visible

Makes the code staples visible in the editor window.

CheckBox Single color

Check the option to apply a single color for code staples.

CheckBox Offset

Specify the offset value for code staples.


Color Scheme

Scheme

Select the default color scheme for all editors: Default (Light) or Dark.

Editor Options - Display - Highlight

The Element list contains all elements available in SQL editors of the program. For your convenience the preview area (located below the Element list) illustrates the changes being made to each of the elements

Controls for changing the properties of the item selected in the Element list are located on the right. Use the following instructions for each of the elements.

CheckBox Bold

Highlights the element with bold.

CheckBox Italic

Makes the element text cursive.

CheckBox Foreground

Select the foreground color for the element.

CheckBox Background

Select the background color for the element.

CheckBox Effects

Enables additional effects for the element text.

See also:

Code Completion


Code Completion

The Code Completion section of the Editor Options dialog allows you to specify the automatic features, fonts, styles, foreground and background colors, borders and other attributes of the text used by the editor to display objects for 'quick code': tables, indices, fields, foreign keys, procedures, functions, views, etc.

Automatic features

CheckBox Code completion

If this option is checked, then on typing the first word characters in the SQL text editor you will be offered some variants for the word completion in a popup list (an analogue of the Code Insight feature in Delphi IDE). The popup list will appear after a period of time defined by the Delay option.

Delay

Using this option you can change the time after which completion variants popup.

Sensitivity

This option allows you to set the number of characters to be typed before code completion is activated.

CheckBox Parameters completion

If this option is checked, the Delphi-like hint for key words is enabled.

CheckBox Group by type

If enabled, the items in the code completion list are sorted by type, otherwise they are sorted by name.

CheckBox Sort column names

Enable this option to force sorting for field names.

CheckBox Show information hints

This option enables/disables information hints for variants offered by code completion feature.

CheckBox Auto launch keyboard templates

Allows you to use keyboard templates for faster typing frequently used expressions (see Keyboard Templates).

CheckBox Accept by Space key too

Enables selecting the completion item with Space key.

Editor Options - Display - Quick Code

Completion list object

The list contains all objects for which you can set quick code parameters. For your convenience the preview area (located to the right of the Completion list object list) illustrates the changes being made to each of the objects.

If you press the Disable element button, the standard settings will be applied to this object; the button text will change to Enable element. If you press this button, you will be able to change font and color attributes for this object.

Controls for changing the properties of the item selected in the Completion list object list are located on the right.

See also:

Highlight


SQL Formatter

SQL Formatter is a feature implemented in SQL Manager for InterBase/Firebird and is a useful tool for formatting SQL queries and scripts, making SQL statements easy to read. SQL Formatter is introduced in Query Data, Execute Script and some object editors.

The Settings tab of the SQL Formatter section allows you to enable this feature and apply SQL formatting to subqueries, if necessary.

CheckBox Format SQL query

Check this option to enable SQL formatting.

CheckBox Format subquery

Enables SQL formatting for subqueries.

Editor Options - SQL Formatter

See also:

Query Data


SQL Words

The SQL words page of the SQL Formatter section allows you to select the key words for each action of SQL formatter and to set formatting parameters.

Wrap first element

Wraps the selected text at a specific column. Select the SQL key words after which formatting should be applied.

Params in line/list

Allows you to display the parameters followed by the defined key words in list or in line.

Editor Options - SQL Formatter - SQL Words

OR - AND

Set the placement of the AND an OR operators according to the operands followed by them. See the example below.

RadioButton Left

WHERE

AND ...

AND ...

AND ...

RadioButton Separate

WHERE

...

AND

...

AND

RadioButton Right

WHERE

... AND

... AND

... AND

The Keywords case / Identifiers case options allow you to define the case of the corresponding items.

You can choose UPPER, lower, Capitalize.

Default case means that the name of the identifier/keyword remains "AS IS".

CheckBox Space before bracket

Adds a "space" character before the opening bracket and after the closing one.

CheckBox Space into brackets

Adds a "space" character after the opening bracket and before the closing one.

CheckBox Wrap element after opening bracket

Transfer to a new line after opening the bracket.

Indent in list

Sets the size of indent relatively to the previous string.


Find Option

The Find Option section allows you to search for options available within the Visual Options dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within SQL Manager Visual Options.

Visual Options - Find Option

The Available options area lists all options of the Visual Options category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


Key Mapping

For your convenience key mapping is provided in SQL Manager for InterBase/Firebird. On this page you can set the shortcuts for various commands/operations according to your needs.

Use the Commands list on the right to select the command for which you need to make a shortcut, then place cursor into the Key editor and press the key combination you find useful (use Ctrl Alt Shift buttons). After setting the shortcut, press the New button to add it to the list of existing Key combinations. If the specified shortcut is already assigned to another command/operation, an error message with the command/operation will be returned.

Editor Options - Key Mapping

Note: It is possible to set more than one key combination for the same command/operation (e.g. Ctrl-K, Ctrl-H) using the Add button.

If necessary, you can export the current Key mapping list to an external file by pressing the Export button.

Manage the shortcuts within the Key combinations list using the Delete (to remove the selected item) and the Clear (to remove all shortcuts for this command/operation) buttons.

It is also possible to save a custom key mapping scheme, if necessary:

  • set the shortcuts for the appropriate commands/operations;
  • click the Save As... button;
  • input the new scheme name in the corresponding dialog.

To delete a scheme, select it in the Scheme name drop-down list and press the Delete button.

See also:

Query Data

SQL Manager shortcuts


Spell Checking

Spell checking is a new feature implemented in SQL Manager for InterBase/Firebird for your convenience.

Set the necessary Spell checker mode:

RadioButton Highlighting

In this mode incorrectly spelled and misprinted words are highlighted in the editor.

RadioButton Autocorrection

In this mode incorrectly spelled and misprinted words are replaced with the corresponding words from the Substitutions list automatically.

RadioButton None

In this mode the spelling checker is disabled.

Use the Add... button to add a new item to the Substitutions list, the Edit... button to alter the selected substitution, and the Delete button to remove the selected substitution from the spelling checker vocabulary.

Editor Options - Spell Checking

Case sensitivity

CheckBox Support case consistency with substitution

If this option is selected, the spelling checker uses the case of words-substitutions when performing a replacement.

CheckBox Ignore case while spell checking

Check this option to disable case checking.

CheckBox Keep the misprint case when replacing

Check this option if you do not wish to change the case of the replaced word.

Misprints

Controls of this group allow you to manage the spelling checker vocabulary: use the Add... button to add a new misprint to the vocabulary, the Auto button to use the default list of misprints, the Edit... button to change the selected misprint, the Delete button to remove the selected misprint from the vocabulary, and the Clear button to empty the list of misprints for the currently selected substitution.

It is also possible to exclude a misprint from spell checking without deleting the misprint. This misprint will therefore remain in the vocabulary, but it will be ignored by the spelling checker.

To mark a misprint as excluded, you need to move it from the Check list to the Ignore list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the misprints from one list to another.


Find Option

The Find Option section allows you to search for options available within the Editor Options dialog easily and quickly.

Option

In this field you can enter the name of the option to search for within SQL Manager Editor Options.

Editor Options - Find Option

The Available options area lists all options of the Editor Options category according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding section where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


Bars and menus

Use the Bars and menus section of the Visual options dialog to customize SQL Manager bars style, menus animation and a number of general options concerning toolbars and menus usage.

Visual Options - Bars and menus

Bar style

Use the drop-down list to select the painting style that will be applied to the bars:

Standard

Enhanced

Flat

XP native

Office 11

Note: If the XP native style is selected, bars use the currently applied XP theme to paint themselves. However, if the currently installed operating system is not Windows XP or the Windows Classic theme is currently applied, bars will be painted using the Enhanced style.

Menu animation

Use the drop-down list to specify the menu animation effects:

None (no animation)

Random (random choice: Unfold, Slide, Fade)

Unfold (unfolding menus)

Slide (sliding drop-down and popup menus)

Fade (menus fade in when appearing)

CheckBox Sunken border

If this option is enabled, the border of each dockable bar is drawn using sunken borders. Otherwise, no border is drawn around the dockable bar.

CheckBox Use F10 for menu

If this option is disabled, the application does not respond to the F10 key press events and the main menu will not will be called.

CheckBox Menu shows recent commands first

This option determines whether the most frequently used items will be placed in menus at first position.

If this option is enabled, frequently used menu items are "promoted" and displayed higher on the list. Unused and infrequently used menu items are visually suppressed and appear "collapsed".

Hint: If you wish to disable this feature, you can also right-click the toolbar and select the Customize... popup menu item to call the Customize dialog, then proceed to the Options tab within the dialog, and deselect the Menus show recently used commands first option.

CheckBox Show full menus after delay

This option is available only if the Menu shows recent commands first option is selected.

If this option is enabled, infrequently used menu items (if they appear "collapsed") will be automatically expanded after a delay upon setting mouse cursor (or upon selection with the Up/Down keys) on the bottom of the menu. Otherwise, the menu expands only after clicking its bottom-most button (or using the Ctrl+Down shortcut).

CheckBox Flat close buttons

This option determines the border style of the Close buttons.

If this option is enabled, the Close button is drawn flat. Otherwise, it has a 3D look.

CheckBox Gray-scale disabled images

This option specifies whether default images must be painted faded.

By default, images within disabled links are painted grayscale when the XP native or Office11 bar style is used. For other bar styles, such images are painted grayed out.

If this option is enabled, images of disabled links will be painted grayscale independently of the selected bar style.

Hint: The Reset to Defaults button which is common for all sections of the Visual Options dialog allows you to discard all changes and reset options to their defaults.


Trees and lists

Use the Trees and lists section of the Visual options dialog to view and edit the corresponding options.

Visual Options - Trees and lists

Look & feel

This setting determines the manner in which tree and list elements are painted. Use the drop-down list to select the painting style that will be applied to the trees and lists:

Standard

Flat

UltraFlat

CheckBox Hide selection

This option specifies how selected tree nodes and list items are displayed when focus leaves the tree or list control.

If this option is enabled, selected nodes look like other nodes. Otherwise, selected nodes/items are highlighted within the tree/list.

CheckBox Hide focus rectangle

This option determines whether a focus rectangle is displayed around the focused tree node or list item within the tree or list control.

If this option is disabled, the focused node/item is not highlighted but the focus rectangle is displayed around it.

CheckBox Native style

This option determines whether the native Windows style will be applied to the trees and lists.

The option has the highest priority for trees and lists. If this option is selected, the tree nodes and list items are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Edit controls

Use the Edit controls section of the Visual options dialog to customize the appearance of various SQL Manager for InterBase/Firebird edit controls: Border style, Button style, Button transparency, etc.

Visual Options - Edit controls

Border style / Button style

Use these drop-down lists to specify the style around an editor (the edit control borders) and select the painting style that will be applied to the edit control buttons (ellipsis button, arrow-down combo-box button, etc.) respectively:

None

Single

Thick

Flat

3D

UltraFlat

Button transparency

Represents the button transparency mode within an editor. Use the drop-down list to specify the transparency that will be applied to the edit control buttons (ellipsis button, arrow-down combo-box button, etc.):

None (a button is always displayed in a non-transparent fashion)

Inactive (a button is drawn when the editor has focus or when the mouse cursor is positioned over the button; otherwise, the button is transparent)

Always (a button is always transparent)

Hide inactive (a button is drawn only when the editor has focus; otherwise, the button is invisible)

Hide unselected (a button is drawn when the editor has focus or when the mouse cursor is positioned over the editor region; otherwise, the button is invisible).

Edges

This group defines which edges are displayed within an editor. Check/uncheck the boxes to hide/show individual edges of the edit controls:

CheckBox Left (if unchecked, the left border edge is invisible)

CheckBox Right (if unchecked, the right border edge is invisible)

CheckBox Top (if unchecked, the top border edge is invisible)

CheckBox Bottom (if unchecked, the bottom border edge is invisible)

CheckBox Hot track

This option specifies whether editor items are highlighted when the mouse cursor is positioned over an edit control. Select this option to highlight an edit control in response to mouse movements.

CheckBox Shadow

If this option is selected, a shadow is displayed for the edit controls.

CheckBox Native style

This option determines whether the native Windows style will be applied to the edit controls.

The option has the highest priority for edit controls. If this option is selected, the edit controls are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.

CheckBox Autosize

This option specifies whether an editing field is resized to entirely display its contents.


Check boxes

Use the Check boxes section of the Visual options dialog to customize the border style and the appearance of check boxes and radio buttons.

Visual Options - Check boxes

Border style

This setting determines the manner in which check box and radio group borders are painted. Use the drop-down list to select the painting style that will be applied to the check boxes and radio groups:

None

Single

Thick

Flat

3D

UltraFlat

CheckBox Shadow

If this option is selected, a shadow is displayed for the check boxes and radio groups.

CheckBox Native style

This option determines whether the native Windows style will be applied to the check boxes and radio buttons.

The option has the highest priority for check boxes and radio buttons. If this option is selected, the check boxes and radio buttons are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Buttons

Use the Buttons section of the Visual options dialog to customize SQL Manager buttons.

Visual Options - Buttons

Button kind

This setting determines the manner in which a button is painted. Use the drop-down list to select the painting style that will be applied to buttons:

Standard

Flat

UltraFlat

CheckBox Native style

This option determines whether the native Windows style will be applied to the buttons.

The option has a higher priority than the Button kind setting. If this option is selected, the buttons are painted according to the native Windows style, otherwise the Button kind selection is applied.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Page controls

Use the Page controls section of the Visual options dialog to customize the style of all SQL Manager page controls.

Visual Options - Page controls

Tabs are visual elements of tab controls. Their purpose is to identify pages and switch between them. Once a tab is clicked, the corresponding page is selected.

Pages are container controls that represent the contents of tab controls. Tab controls contain a single page, whose context is to be updated each time the selected tab changes. Page controls contain the number of pages equal to the number of tabs.

Tab style

Use the drop-down list to select the painting style that will be applied to the tab controls:

Tabs (tabs are painted as notebook tabs)

Buttons (the selected tab is painted as a pressed button, other tabs are painted as released buttons)

Flat (tabs are painted as notebook tabs, but appear lowered slightly)

CheckBox Hot track

This option specifies whether tab captions are highlighted when the mouse pointer hovers over tabs. Select this option to enable tab highlighting.

CheckBox Multiline pages

This option specifies whether tabs are arranged across several rows.

If this option is enabled, tabs are automatically arranged into the minimum number of rows required to fit all of them. If this option is disabled, tabs are displayed within a single row.

CheckBox Native style

This option determines whether the native Windows style will be applied to the tab controls.

The option has the highest priority for the tab controls. If this option is selected, the tabs are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.

Options of the Slants group allow you to apply the Slanted painting style to tabs and specify the appearance aspects (positions) of tab slants.

CheckBox Slants

If this option is enabled, the Slanted painting style is applied to a tab control: all tabs appear slanted, and the selected tab's top edge is highlighted.

Slants kind

Specify the positions (sides) at which the tabs are bent by slants.

RadioButton Cut corner (top right/left corners of tabs are cut)

RadioButton Slant (right/left sides of tabs are slanted)

Slants position

Specify the positions (sides) at which the tabs are bent by slants.

CheckBox Left (slants bend left sides of the tabs)

CheckBox Right (slants bend right sides of the tabs)


Group boxes

Use the Group boxes section of the Visual options dialog to customize all SQL Manager group boxes to your liking.

Visual Options - Group boxes

Border style

This setting determines the manner in which group box borders are painted. Use the drop-down list to select the painting style that will be applied to the group box borders:

None

Single

Thick

Flat

3D

UltraFlat

Look & feel

This setting determines the manner in which group boxes are painted. Use the drop-down list to select the painting style that will be applied to the group boxes:

Standard

Flat

UltraFlat

Office11

CheckBox Shadow

If this option is selected, a shadow is displayed for the group boxes.

CheckBox Native style

This option determines whether the native Windows style will be applied to the group boxes.

The option has the highest priority for the group boxes. If this option is selected, the group boxes are painted according to the native Windows style, regardless of other painting settings.

Note: The Native style option is currently supported for the Windows® XP operating system only.


Splitters

Use the Splitters section of the Visual options dialog to customize all SQL Manager splitters to your liking.

Visual Options - Splitters

Hot zone style

This setting determines the manner in which splitter hot zones are painted. Use the drop-down list to select the hot zone style that will be applied to the splitters:

Windows XP task bar

Media Player 8

Media Player 9

Simple

None (hot zone is disabled)

CheckBox Hot zone drags a splitter

This option is applied when the Hot zone style value is different from None, and specifies whether the splitter can be dragged by its hot zone.

If this option is enabled, you can drag the splitter by its hot zone (i.e. use any part of the splitter's area for dragging). Otherwise, attempts to drag the splitter by the hot zone will have no effect.


Navigation bar

Use the Navigation bar section of the Visual options dialog to customize the Navigation bars of all SQL Manager tools according to your preferences.

Visual Options - Navigation bar

View style

Several types of control representations (views) are available for Navigation bars. View styles define the appearance of Navigation bar elements (background, scroll buttons, group headers, links/items and hint boxes). Use the drop-down list to select the view style that will be applied to the Navigation bars:

Office 11

XP

Simple

Advanced

CheckBox Border

This option specifies whether a border style will be applied to the Navigation bars.

If this option is enabled, the Navigation bars have thin borders. Otherwise, no borders are drawn around the Navigation bars.


Save Settings

Save Settings Wizard allows you to export the settings of SQL Manager for InterBase/Firebird - wholly or partially - to a single *.reg file which can be applied afterwards to SQL Manager for InterBase/Firebird installed on another machine, or it can be used to backup previous settings.

To start the wizard, select the Options | Save Settings main menu item.

  • Specifying destination file
  • Selecting settings
  • Selecting databases
  • Saving settings

To apply saved settings you need to open the created *.reg file, then press the OK button in the window appeared. All settings will be applied automatically (they will be added in the Windows Registry).


Specifying destination file

This step of the wizard allows you to specify the location of the destination file.

Filename

Use the btnSaveAs button to set the path to the *.reg file where the application settings are to be saved.

Note: If the target file already exists, the application will show a warning dialog where you can choose the action you need.

Save Settings - Specifying destination file

Press the Next button to proceed to the next step of the wizard.


Selecting settings

This step of the wizard allows you to specify the information you need to be saved to the result file: Database registration info, Favorite objects, Tabs, Environment options, Editor options, Keyboard templates, Object templates, External tools list, Form placements, MRU lists, Favorite queries.

Save Settings - Selecting settings

Press the Next button to proceed to the next step of the wizard.


Selecting databases

This step of the wizard allows you to select the database(s) to save the registration settings.

To select a database, you need to move its alias from the Available Databases list to the Selected Databases list. Use the Move all to Selected Move to Selected Move to Available Move all to Available buttons or drag-and-drop operations to move the databases from one list to another.

Save Settings - Selecting databases

Press the Next button to proceed to the last step of the wizard.


Saving settings

This step of the wizard is intended to inform you that the saving settings operation has been configured, and the wizard is ready to save the application settings to the specified file.

The log area allows you to view the log of operations and errors (if any).

Save Settings - Saving settings

CheckBox Close the Wizard after successful completion

If this option is selected, the wizard is closed automatically when the export process is completed.

If necessary, you can save a template for future use.

Click the Finish button to start saving settings.


Localization

When using SQL Manager for InterBase/Firebird, your are provided with multi-language interface support. You can change the program language, specify the directories for your localization files easily, edit existing localizations and create your own localization files.

Changing Program Language

  • select the Options | Select Program Language... main menu item;
  • select the interface language in the Select Language dialog;
  • click OK to apply the language and close the dialog.

Editing Program Localization

  • open one of the program windows (e.g. Table Editor, Query Data) where you wish to edit the localization of captions and hints;
  • use the Shift+Ctrl+L keyboard shortcut to open the Localization Editor window;
  • edit window captions and hints as necessary;
  • click the Save btnSave button on the toolbar.

Note: The Localization Editor window is only available if the currently selected language is different from the default.

Creating New Localization Files

  • create a new localization file similar to those located in the %program_directory%\Languages folder;
  • select the Options | Environment Options main menu item;
  • proceed to the Localization section of the Environment Options dialog;
  • click the Add button;
  • set the language name and the path to the new *.lng file within the Language Info Editor dialog.

The new language is added to the list of available languages. Now you can set it as the interface language using the Select Program Language dialog or the Localization section of the Environment Options dialog.

See also:

Localization

Language Info Editor


Localization Editor

The Localization Editor window allows you to edit the captions and hints of any SQL Manager window, if the selected program language is different from the default one.

To call this window, use the Shift+Ctrl+L shortcut in any child window of SQL Manager for InterBase/Firebird.

The working area of the window contains the element names and the corresponding strings divided by the "=" character. These strings are what you see in the program as menu items, window captions, button hints, etc. Edit them to change the program appearance. Be careful and do not edit the identifiers that stand before the "=" character - this will not produce any effect.

For your convenience the Find and Replace features are provided - the corresponding btnFindText btnReplaceText toolbar buttons are used to call the Find Text dialog or the Replace Text dialog respectively. The Search Again btnSearchAgain button enables the repeated search for the text that was last searched.

Localization - Localization Editor

When you are done with editing, click the Save btnSave button on the toolbar to apply the changes you have made.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | Yes
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Select Program Language

Localization


Select Program Language

The Select Language dialog allows you to select a language for SQL Manager for InterBase/Firebird localization.

To open this dialog, select the Options | iconSelectLanguage Select Program Language... main menu item.

The dialog displays the list of available languages configured on the Environment Options | Localization page. Select a language from the list and click OK to confirm your choice and close the dialog.

Localization - Select Program Language

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | Yes
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

Localization Editor

Localization


Keyboard Templates

The Keyboard Templates window allows you to create new keyboard templates for quicker typing regularly used expressions and to edit the existing ones.

To open this window, select the Options | iconKeyboardTemplate Keyboard Templates... main menu item.

To add a new keyboard template, click the Add Template... button, set the template name and define the template expression. In the upper right area of the window you can change the case of the template expression (As is, Uppercase, Lowercase, First upper).

You can deactivate an existing template by selecting it from the list on the left and removing the Active flag of the template.

If necessary, you can also edit the template name using the Edit Template... button, delete the template using the Delete Template button or edit the template expression within the Expansion area of the window. For faster editing you can use the Cursor, Author, Time, Date, Clipboard, Marker buttons.

Hint: Add/edit/delete template items are also available in the context menu of the template list on the right.

CheckBox Old style

This option specifies whether the selected keyboard template expansion should conform to the template specifications used in the earlier versions of SQL Manager for InterBase/Firebird.

Once you have defined the templates, you can use them in Query Data. First of all, make sure that the CheckBox Auto launch keyboard templates option is selected on the Code Completion page of the Editor Options dialog. When editing SQL text in Query Data, type a template name and use the Ctrl+J shortcut: the text associated with the template (Expansion) will be inserted automatically.

Hint: The Reset to defaults button which is available at the bottom of the Keyboard Templates dialog allows you to discard all changes and restore the settings to their defaults.

See also:

Code Completion

SQL Manager shortcuts


Object Templates

The Object Templates window allows you to preset the definition template for the name and/or body of an object to be created.

To open this window, select the Options | iconObjectTemplates Object Templates... main menu item.

Select an object in the tree (Domain, Table, View, Procedure, DB Trigger, UDF, Exception, Generator, BLOB Filter, User, Embedded User, Role, Report, Favorite Query, Project) and set its template using the editor area.

See also:

Database Objects Management


Find Option dialog

The Find Option dialog allows you to search for SQL Manager options easily.

To open this dialog, select the Options | iconFindOption Find Option main menu item.

Option

In this field you can enter the name of the option to search for within the entire set of SQL Manager options.

Find Option dialog

The Available options area lists all options by categories according to the specified name. The Option Kind, Category and Group columns specify option type and location.

Select the required option in the list and click iconFindText Show Option to open the corresponding dialog where you can view/edit the value of this option. For your convenience the required option is marked with an animated iconFindOption icon.


External Tools

When using SQL Manager for InterBase/Firebird, you can add external Windows applications to make your work more efficient.

  • External Tools dialog
  • External Tool Info editor

Adding External Tools

  • select the Options | External Tools... main menu item;
  • click the Add... button in the External Tools dialog;
  • specify parameters of the new external tool within the External Tool Info editor;
  • confirm adding the new external tool by clicking OK in the External Tool Info editor and the External Tools dialog.

This adds the icon and the title of the application you have selected to the Tools | External Tools submenu. Now you can run this tool quickly without closing SQL Manager.

Removing External Tools

  • select the Options | External Tools... main menu item;
  • select the tool to be removed in the Tools list of the External Tools dialog;
  • press the Del key or click the Delete button within the dialog;
  • click OK to confirm removing the tool and closing the dialog.

The selected tool has been removed and is no longer accessible from the Tools | External Tools submenu.


External Tools dialog

The External Tools dialog allows you to manage the list of external applications which can be easily run from within SQL Manager environment.

To open this dialog, select the Options | iconExternalTools External Tools... main menu item.

Tools

Lists all added external applications.

Add...

Opens the External Tool Info editor for adding a new tool to the Tools | External Tools submenu.

Edit...

Opens the External Tool Info editor for editing the title, the hot key, the path to the executable file, the working directory and execution parameters of the tool currently selected in the Tools list.

Delete

Removes the selected tool from the list of SQL Manager for InterBase/Firebird external tools.

External tools - External Tools dialog

To change the order of tools in the list, use the [image] [image] arrow buttons at the bottom area of the dialog, or use the Ctrl+Shift+Up / Ctrl+Shift+Down shortcuts. You can also drag-and-drop items within the list box to change their positions.

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | Yes
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

External Tool Info editor


External Tool Info editor

The External Tool Info editor allows you to set common parameters of running added external programs from within SQL Manager environment. This dialog is used both when adding external tools and editing their parameters (see Add External Tool and External Tools).

Title

Enter the title to be displayed in the Tools | External Tools submenu of SQL Manager.

Hot Key

Press a key or a key combination to set it as a hot key for running the tool.

Program

Use the ExplorerButton Explorer button to specify the path to the *.exe file of the external program.

Working Dir

Set the default working directory of the program.

Parameters

This box stores parameters for the program execution (if required).

External tools - External Tool Info editor

Availability:
Full version (for Windows) | Yes
Lite version (for Windows) | Yes
Note: To compare all features of the Full and the Lite versions of SQL Manager, refer to the Feature Matrix page.

See also:

External Tools dialog


Installed plugins

The Plugins tab of the SQL Manager Plugins dialog allows you to view the list of currently installed plugins and manage this list efficiently.

Plugins - Installed plugins

The plugins are generally subdivided into Common tools which are plugins intended for working with the program as a whole, and Tools for objects used for working with database objects. Plugins of each group are listed under the respective tabs (Common tools, Tools for objects).

The area located at the bottom displays the path to the *.dll file and the description of the selected plugin.

Add plugin

Use this button to call the Open... dialog which allows you to specify the *.dll file location and install the plugin.

Remove plugin

Use this button to uninstall a plugin selected in the Common Tools or Tools for objects lists.

New submenu

This button can be used to add a sub-node to the node selected in the Common Tools list. A plugin can be placed into the submenu and will be then available within the Plugins | <submenu_name> program menu. Therefore it might be reasonable to define a submenu name that will indicate the plugin category (e.g. Testing or Data Management).

Rename

This button allows you to change the selected submenu name.

Delete

This button removes the selected submenu.

Note: To change the position of the plugins and submenus in the list, use the [image] [image] buttons or drag-and-drop operations.

See also:

Plugin Options

Data Generator plugin


Plugin options

The Plugin Options tab of the SQL Manager Plugins dialog allows you to view and edit the selected plugin properties.

Plugins - Plugin options

Information

CheckBox Plugin is a common tool

Indicates that the selected plugin is performed for working with the program as a whole.

CheckBox Plugin is built in object editor

Indicates that the selected plugin is built-in to a database object editor.

CheckBox Plugin has options dialog

Indicates that the selected plugin has options available for customizing.

CheckBox Unload plugin after executing

Indicates that the selected plugin is automatically unloaded after execution.

Object editors

This group lists the database objects that can be used by the plugin: table, function, column, index, foreign key. The plugin is available in the editor(s) of the selected object(s).

Options

Menu caption

These boxes allows you to specify the plugin menu caption and a shortcut for the plugin.

Options menu caption

These boxes display the caption of the Options menu item and the shortcut for faster accessing plugin options. These boxes are available only if the plugin has options.

CheckBox Place button on toolbar

Check this option to place a button for the plugin to the main program toolbar.

See also:

Installed plugins

Data Generator plugin


Data Generator plugin

Data Generator Plugin is a useful tool for populating tables fields with random values. This tool is available in the Plugins menu after it has been installed (see Install Plugin for details). By default the DataGenerator.dll file is located in the %program_directory%\Plugins directory.

To call the tool, select the Plugins | <plugin_category> | Data Generator menu item.

Database

Use the drop-down list to select the database to generate data to.

Table

Use the drop-down list to select the table to populate with data.

Plugins - Data Generator plugin

The <table_name> list box at the left displays names and types of all the fields from the table selected in the drop-down list above. Tick off a box to the left of the field name to select this field for generation. Select a field in the list to set its generation options in the <field_name> area at the right.

Data Generation Type

RadioButton Generate randomly

Generates data for the field selected in the list box, within the given range specified by the data type constraints:

Min Value, Max Value (for Integer fields);

Digits, Precision (for Float/Double/Decimal fields);

Min Date/Time, Max Date/Time (for Date/Time fields);

Min Length, Max Length, Start Char, End Char (for Char/Varchar fields).

RadioButton Get from list

Fills the field with values taken randomly from the specified list of values. You can set the list of possible values in the edit-box below, delimiting values with line breaks.

See also:

Installed plugins

Plugin Options


How To...

The succeeding pages of this chapter are intended to provide you with brief instructions on how to perform this or that operation correctly using SQL Manager for InterBase/Firebird.

Work with Databases

Connect to a database

Create a database

Edit database connection parameters

Backup a database

Restore a database from a backup

Make work with a database faster

Create a database copy

Document a database

Save metadata reports to file

Log database changes

Design a visual database structure

View an ER diagram

Get an SQL dump

Work with Database Objects

Group objects

Find objects

View dependecies

Get an object DDL

Work with Data

Export/import data

Export data as SQL Script

Set data filter

View tables with many records

Export filtered data

Edit data of master-detail tables

Sort and group data

Create an autoincrement field

Add image to table

Set data display format

Work with Queries and Scripts

Export query results into file

Work with several queries at once

Save most frequently used queries

Execute queries with parameters

Create SQL statements rapidly

Execute scripts

Execute a large SQL script

Make SQL script work faster

Customize work with Query/Script text

View executed queries and scripts

Create a simple report in Report Designer

Transfer program settings

Update SQL Manager

Report bugs and suggestions

See also:

Getting Started

Database Explorer

Database Management

Database Objects Management

Query Management Tools

Data Management

Import/Export Tools

Database Tools

Services

Security management

Personalization

External Tools


Database Management_10

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Connect to a database

If a host and a database are not registered yet or you have launched SQL Manager for InterBase/Firebird for the first time and you want to connect to a database then you should do the following:

  1. Launch the Register Database wizard by selecting the Database | btnRegisterDB Register Database... main menu item.
  2. On the first step choose RadioButton Database is located on a new host item.
  3. On the second step set connection parameters for the new database.
  4. On the third step set options of a newly registered database: Database name, Database alias and Charset. Click Test Connection to check availability of the database at the moment. Then set common and log options for the database on the General and Logs tabs correspondingly.
  5. The registered database is now displayed in the DB Explorer. To connect to the database double-click its alias or select the btnConnectToDB Connect to Database item of the database context menu.

To connect to a new database on a registered host perform the following operations:

  1. Launch the Register Database wizard by selecting the Database | btnRegisterDB Register Database... main menu item.
  2. On the first step choose RadioButton Database is located on the host already registered in SQL Manager.
  3. On the second step set the necessary parameters to connect to the already registered server: User name, Password and Role.

Then follow points 4 and 5 from the instruction above.


Database Management_4

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Create a database

If you want to create a database, please, make sure that the host for this database has been already registered. For more details see the Register Host wizard.

To create a database on the registered server perform the following operations:

  1. Launch the Create Database wizard by selecting Database | btnCreateDB Create Database main menu item.
  2. On the first step select the host where the new database will reside.
  3. On the second step define the path to the database file in the Fully qualified database file path field, login parameters - in the User name and the Password fields. If you want to store your new database in several files, uncheck the CheckBox Single database file option. In this case you will proceed to the Defining database files step of the wizard where you are to add secondary file by inputting its name in the File name field (type in or use the btnSaveAs button to specify the path to the database file), then setting its length (secondary file length indicates where the next file will be started) and clicking the Add button.
  4. On the final step check the CheckBox Register after creating option in order to open the Database Registration Info dialog after database creation.


Database Management_12

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Edit database connection parameters

If you have made a mistake when creating and registering a database or the information provided is incomplete then it can be edited using the Database Registration Info dialog. You can view this information both for connected or disconnected database.

To open the dialog, select the database right-click the database alias in DB Explorer and use the btnDBRegistrationInfo Database Registration Info... context menu item.

The connection parameters can be changed on the Connections tab of the dialog. Here you can define or redefine the following properties in the corresponding boxes: User name, Password, Role, Database name, Database alias, Charset, Font charset.


Make work with a database faster

If your database contains too many objects or if a connection to the database is slow you can increase work speed by uncheking the CheckBox Refresh objects on connection option when registering database or editing the Database Registration Info.


Design a visual database structure

To design your database visually you may use the Database Designer. It allows you to create, edit and drop tables and table fields, set relations between tables and perform other operations you may need to achieve your purpose.

To create a new object right-click within the Database Designer area and then choose the Create item of the context menu. After that a new object will appear on a diagram.

After you have finished designing your diagram you can click a Compile button to create this structure physically.


View an ER diagram

The relationship diagram is built using the reverse engineering operation.

To view an ER diagram of a scheme you should follow the steps:

  1. Run Database Designer;
  2. Click the btnReverseEngineer Reverse Engineer button on the main toolbar or use the corresponding item of the context menu.
  3. Choose schemas to reverse engineer from.

The created diagram can be saved as a *.ibd file ( btnSave Save Diagram button) or as an image ( btnSaveAsPicture Save as Picture button).


Backup a database

A database backup is created by means of the Backup Database Wizard. To launch it and set necessary backup options choose Services | [image] Backup Database main menu item.

Backup Database Wizard allows you to make a backup on the local or remote host.

To create a local database backup:

  1. Select the RadioButton Use local utilities option in the Execution mode group. To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog, and gbak.exe and nbackup.exe (for Firebird multi-level backup) files must exist in this directory.
  2. Select the RadioButton Local option in the Store mode group to store the backup file on the local machine.

Note: Backup of a database located on the Embedded host is only possible with local tools used. You need icudt30.dll, icuin30.dll, icuuc30.dll and fbembed.dll (fbembed.dll must be renamed to fbclient.dll) to be located along with gbak.exe file inside the directory specified in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

To create a database backup on the remote host:

  1. Select the RadioButton Use services option in the Execution mode group to use the server services for the backup operation.
  2. Select the RadioButton Server option in the Store mode group to store the backup file on the server machine.


Restore a database from a backup

Use the Restore Database Wizard to restore a database from a backup. To launch the wizard and set restore options choose Services | [image] Restore Database main menu item.

Restore Database Wizard allows you to restore a database from a backup that resides on a local or remote server.

To restore a database from a local host:

  1. Select the RadioButton Use local utilities option in the Execution mode group. To enable this mode, you need to specify the location of the utilities in the Path to database utilities field on the Connection page of the Host Registration Info dialog, and gbak.exe and nbackup.exe (for Firebird multi-level backup) files must exist in this directory.
  2. Choose the RadioButton Local option in the Restore mode group to store the restore file on the local machine.

Note: Restore of a database located on the Embedded host is only possible with local tools used. You need icudt30.dll, icuin30.dll, icuuc30.dll and fbembed.dll (fbembed.dll must be renamed to fbclient.dll) to be located along with gbak.exe file inside the directory specified in the Path to database utilities field on the Connection page of the Host Registration Info dialog.

To restore a database from a remote host:

  1. Select the RadioButton Use services option in the Execution mode group to use the server services for the restore operation.
  2. Choose the RadioButton Server option in the Restore mode group to store the restore file on the server machine.


Create a database copy

In order to create a copy of the whole database or of separate objects you can:

  1. Extract DB objects structure and data into SQL script using the Extract Database Wizard. The result script can be used to copy or restore your database.
  2. Create database backups with the help of the Backup Database Wizard.
  3. Create copies of separate database objects by using the Duplicate Object Wizard.


Document a database

There are several ways to document a database:

  1. You can generate a detailed HTML report of the selected database objects using HTML Report Wizard.
  2. You can generate and print metadata reports of any database object(s). Generated reports can be exported to any of the available formats: HTML file, Excel file, Text file, RTF file, CSV file, HTML file, BMP image, Excel table (OLE), JPEG image, TIFF image.
  3. You can save the Database Designer diagram as a *.ibd file for future use. A diagram is saved with the objects XML files. If necessary, you can also save the diagram as an image.


Save metadata reports to file

To save a metadata report in a file of any supported format (*.txt, *.csv, *.pdf, *.html) you should do the following:

  1. Open the Print Metadata window by selecting the Tools | iconPrint Print Metadata item of the main menu.
  2. Mark the needed objects and define printing settings and click the btnPrintPreview Preview button on the navigation bar or toolbar.
  3. In the opened Preview window click btnPreviewExport Export and select from the drop-down list the needed file format for report saving. When done, specify file name and location.


Log database changes

If you want to perform metadata changes logging and SQL query logging you need to:

  1. Check the CheckBox Enable log of metadata changes and specify the path to the *.sql file to store the metadata logs.
  2. Check the CheckBox Enable log of Query Data queries and specify the path to the *.sql file to store the logs of SQL queries: date/time of query execution, SQL text, execution result or errors (if any).

This can be done in the Database Registration Info | Logs window.

You can also allow automatic saving the DDL and location of database objects after the specified time interval by checking CheckBox Enable QuickSave every ... Minute(s) option.


Get an SQL dump

To get an SQL dump (an *.sql file) of your database use the Extract Database Wizard that will extract database objects and/or data to an SQL script, e.g. for backup purposes.


Group objects

If you want to group objects you can do it in one of the following ways:

Using Favorite objects (situated in the DB Explorer tree):

  1. Click create New Sub Folder in the Favorite Objects folder using the corresponding item of the context menu
  2. Define its name and drag-and-drop necessary objects there or use the Add Object item of the created folder context menu. Pick the objects to add to folder from the appeared dialog.

Using DB Explorer tabs:

  1. Right-click the necessary object in the DB Explorer.
  2. Choose the btnNewTabFromHere New Tab from Here item of the object context menu and define the name of the tab.
  3. Now your objects are stored on the separate tab of a DB Explorer.

Note: If object is not a tree node, it cannot be placed on separate tab.


Find objects

In order to search for objects you need you can:

  1. Call the Find Object dialog by right-clicking the Database alias, any database object group nodes or objects in the DB Explorer tree and select the Find Object... context menu item.
  2. Call the Find Object dialog by using the Ctrl+F shortcut.
  3. Type in the first letters in the edit-box of the Search Panel, and the corresponding object will be highlighted in the tree, as displayed in the picture below.

Note: Objects among which the search is performed should be updated and the object node should be expanded.

  4. Launch the Search in Metadata tool by selecting the Tools | iconSearchInMetadata Search in Metadata main menu item, or using the Ctrl+Alt+F shortcut. After the search is complete, the Explorer group on the Navigation bar displays the tree of database objects in which the search string is found, and allows you to view metadata of the required object or its fragment.


View dependecies

If you want to view all the object dependencies then:

  1. Use a dependencies tab in the Table Editor.
  2. Use the Dependency Tree tool.

These tools may be useful when you can't find an object that prevents your from dropping a table.


Get an object DDL

In order to get an object DDL you can:

  1. Right-click the object in the DB explorer tree and select the Script to New Query Data | Create context menu item.
  2. Right-click the object and select the Edit Table <table_name>... context menu item or double-click the table and then proceed to the DDL tab in the opened table editor window.
  3. Right-click the object in the DB explorer tree and select the Data Manipulation | Export Data as SQL Script context menu item.


View tables with many records

If your table contains a lot of records you can minimize dataset loading time by:

  1. Setting the number of records to be selected;
  2. Enabling RadioButton Load visible records in order to load only a fixed number of dataset records into memory;
  3. Checking the RadioButton Never retrieve option to disable retrieving record count for tables.

These options can be set only for the selected database on the Data Options page of the Database Registration Info.

Default settings for newly registered databases can be defined on the Grid | Data Options page of the Environment Options dialog.


Set data filter

Quick Filtering (by the current value in a cell)

Open the context menu of the needed column and choose the Quick Filter item. Then choose a filter condition in the opened submenu.

Filtering by Column

HowTo - Grid View - Quick Filter

Open the drop-down list on the column title and choose a filter condition from the list.

You can set advanced conditions by using the Custom... menu item.

When choosing this item, the special window for setting filter conditions opens.

Advanced Filtering

You can set advanced filter options by pressing the button btnSetFilter on the toolbar of the Data View and set filter parameters in the Filter Builder. Apply the set conditions by pressing the Apply button.

If a filter is set for a table, the special bar appears in the lower part of the table where you can see filter conditions and the history of filter changes opened by pressing the drop-down list.

Data View - Grid View - Filtering records - Filtering panel

Disable Filtering

To cancel filtering, open the context menu of the column and choose the Disable filter item.

Or press the btnClose button on the filter toolbar.


Sort and group data

In order to sort data, do the following:

  1. Open data at the Data or Results tab.
  2. Choose the column by which you need to sort data and click the column title.
  3. If the column was not sorted, the first click will sort it in the ascending order and the second one - in the descending order.

Note: To cancel the sorting, open the context menu by right-clicking the necessary column and choose the Clear Sorting item, or press the Ctrl button and click the column title.

To enable grouping, drag the column title to the special grouping car above the table.

HowTo - Data View - Grid View - Grouping data by two columns_Small

Note: To disable grouping, drag the column title from the group bar back to the table.


Export/import data

You can export data from a database table into an external file of any supported format by means of the Export Data Wizard.

There are several ways to launch Export Data Wizard:

  1. Open the Data or Results tab, press [image] Export Data on one of the Data View toolbars.
  2. Open the Data or Results tab, choose Data Manipulation | Export Data in the Data Grid context menu.
  3. Open the table context menu in the DB Explorer, choose the Data Manipulation | Export Data item.
  4. Open the Data or Results tab and use the shortcut Shift+Ctrl+E.

You can import data from external sources into a table or view using Import Data Wizard:

  1. Open the Data tab, press the Import Data button on one of the Data View toolbar.
  2. Open the Data tab, choose Data Manipulation | Import Data in the Data Grid context menu.
  3. Open the table context menu in the DB Explorer, choose the Import Data item.
  4. Open the Data tab and use the shortcut Ctrl+I.

Note: Export and import data tolls are available in full version of SQL Manager for InterBase/Firebird only.


Export data as SQL Script

You can export data from a database table into SQL script with INSERT INTO statements in one of the following ways:

  1. Open the Data or Results tab, press the [image] Export Data as SQL Script on one of the Data View toolbars and set export parameters in the opened Export as SQL Script Wizard.
  2. Open the Data or Results tab, choose Data Manipulation | [image] Export Data as SQL Script in the Data Grid context menu and set export parameters in the opened Export as SQL Script Wizard.
  3. Open the table context menu in the DB Explorer, choose the [image] Export Data as SQL Script item and set export parameters in the opened Export as SQL Script Wizard.

Note: In order to extract table DDL (CREATE TABLE statement), check the CheckBox Add CREATE TABLE statement box at the Step 1.


Export filtered data

If you have set a filter in a Data View and want to export only this data then you need to uncheck CheckBox Perform data filtration on client in data view option on the Database Registration Info | Data Options tab. In this case all the changes made by applying filters are performed on the InterBase/Firebird server with the help of the WHERE clause used in SQL query. Otherwise your changes will just be displayed on your client machine but data will be exported into a file without applied filters.


Create an autoincrement field

To create an autoincrement field you need to check CheckBox Autoincrement value option when specifying options for domain-based fields. If the option is enabled, the autoincrement property is specified for the domain. For details see Defining autoincrement.


Edit data of master-detail tables

You can work with data in multi-level mode, that is you can view and modify it in several related tables simultaneously.

To manage grid levels, right-click the grid and select the Grid Levels context menu group. Click Add Grid Level in the menu to run the Create Grid Level wizard. After the level is added you can edit data of the related tables.


Add image to table

If you want to add an image to a table then do the following:

  1. Open the table on the Data tab.
  2. Go to the BLOB View section (the navigation buttons are located in the bottom part of the window) and then proceed to the Image tab.
  3. If there are several BLOB fields, choose the required field from the Select BLOB Column drop-down list on the toolbar of the Blob View tab and press the iconLoadFromFile Load from File button on the same toolbar.
  4. Choose the needed image file in the appeared dialog.

HowTo - Grid View - BLOBView - Select BLOB Column

Note: Adding images to table is possible only if table contains at least one BLOB field.


Set data display format

To set the format for displaying data open the Options | btnEnvironmentOptions Environment Options dialog from the main program menu, proceed to the Color & Formats tab and define or choose the display format for some data types in the Display formats section.


Create SQL statements rapidly

There are two options for creating SQL queries rapidly:

In the DB Explorer

  1. Right-click a table in the DB Explorer
  2. Choose Script to New Query Data context menu item.
  3. Select the necessary query type.

In the Query Designer

  1. Open Query Designer.
  2. On the Builder tab drag an object from the DB Explorer tree to the diagram area.
  3. Choose necessary fields to include in the query by checking the corresponding box located to the left from the field name in the list, or just by double-clicking it. To include all fields of the table/view, check the box located to the left of the table/view caption.
  4. Associate two objects by their fields.Drag a field from one object list to another. This will set a link between these objects by the selected fields. It is indicated by a bidirectional arrow between the linked fields.
  5. Edit link properties. Double-click the linking arrow or right-click it and select the Property popup menu item. The Link properties dialog allows you to change the association condition by choosing it from the drop-down list.
  6. You can view and edit your SQL statement on the Edit tab of the Query Designer.


Work with several queries at once

Query Data provides a possibility to open and edit several queries. You can create tabs in the lower part of the Query Data, each tab may contain a separate query. There are several ways for creating tabs:

  1. Open btnShowSQLEditor Query Data and choose btnNewSQLEditor Add New Query on one of the toolbars.
  2. Open btnShowSQLEditor Query Data and choose btnNewSQLEditor Add New Query in the context menu of the existing tab. HowTo - WorkWithQueries - AddNewQuery
  3. Use the shortcut Ctrl + N.

Note: Each tab can be renamed and any query can be added to Favorite Queries.


Save most frequently used queries

Use the Favorite Queries feature to store your most frequently used SQL queries. To access the list of your favorite queries you can use the Favorite Queries node of DB Explorer or create a separate tab for your Favorite queries.

Using the context menu you can create a new Favorite query or edit an existing one using Favorites editor, open any of the existing queries in Query Data or remove a query if you don't need it any longer.


Execute queries with parameters

If you want to use queries with parameters then you should check CheckBox Allow using parameters in query text option in the Environment Options | Tools.

This feature allows you to specify different values within a query in a popup dialog just before the query execution. Use the colon (':') character before an identifier (e.g. :P1) to specify a parameter within the query.


Export query results into file

When executing queries, their results can be displayed on the Edit or Results tab in the Data View.

You can copy data from database tables into an external file of any supported format in one of the following ways:

  1. Open the Data or Results tab, press [image] Export Data on one of the Data View toolbars and define export parameters in the opened Data Export Wizard.
  2. Open the Data or Results tab, choose Data Manipulation | [image] Export Data in the Data Grid context menu and define export parameters in the opened Data Export Wizard.
  3. Open the table context menu in the DB Explorer, choose the [image] Export Data item and define export parameters in the opened Data Export Wizard.
  4. Open the Data or Results tab and use the shortcut Ctrl+E.


Execute scripts

Execute Script allows you to create, view, edit and execute SQL scripts. To open Execute Script Editor select the Tools | btnShowSQLScript Execute Script... main menu item. This tool is intended for work with a great number of SQL statements and with scripts that are stored in files. For instance, you can execute a script directly from a file without loading it to the Editor window. This reduces memory usage. However Execute Script allows just to estimate whether the execution of script statements will be successful, but it does not return query result.

Note: To execute SQL scripts you should use Execute Script, not Query Data. The latter is intended for creating, editing and executing SQL statements. It also provides a possibility to view query result, perform various operations with it (data import, data export, etc.) and manage transactions.


Execute a large SQL script

If you need to execute a large SQL script it's not necessary to load it from file to the Execute Script Editor window as it can take a lot of time. Instead you can execute script directly from *.sql, *.zsql or *.txt file. In order to do this click the iconCompile Execute script from file button of the Navigation bar and Toolbar in Execute Script editor.


Make SQL script work faster

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Make Execute Script work faster

In order to make the Execute Script work faster, you can disable some functions.

Parsing

Choose and disable the iconDBExplorer Disable Parsing item on one of Execute Script Editor toolbars.

Automatic Creation of Hierarchical Text Structure

Uncheck the CheckBox Use code folding box at Options | Editor options in the main program menu.

Syntax Highlight and Code Completion for Aliases

Choose Options | Editor options in the main program menu, proceed to the General tab and uncheck the CheckBox Resolve aliases box - the syntax highlight and Code Completion for aliases will be disabled.


Customize work with query/script text

To customize work with a query/script text you may:

Use Internal Link

This means that the name of the object existing on a database is highlighted in a query/script text. Such an object can be opened by holding the Ctrl key and clicking the object with a mouse.

Add Text Template

Keyboard templates allow you to type regularly used expressions and edit the existing ones quicker. Once you have defined the templates, you can use them in Query Data. When editing SQL text in Query Data, type a template name and use the Ctrl+J shortcut: the text associated with the template will be inserted automatically.

Use Automatic Completion (Object List)

You can call the autocompletion list by starting entering the first characters of the text and using the shortcut Ctrl + Space.

Customize Autocompletion List

Choose Options | Editor options in the main program menu, proceed to the Code Completion tab and define the list and quick code parameters.

Apply Automatic Formatting of Query/Script

Choose Quick Code | Format in the Query Data/Execute Script context menu or the Shift+Ctrl+F shortcut to apply automatic formatting.

Set Font and Query/Script Format at the Display tab

Choose Options | Editor options in the main program menu, proceed to the Display tab and define common font and format parameters for Query Data/Execute Script.

Set Font and Query/Script Format at the Highlight tab

Choose Options | Editor options in the main program menu, proceed to the Highlight tab and define font options for each element.

Note: If some font parameters are defined on the Highlight tab, they will be applied to the query/script text and not the ones defined on the Display tab.


View executed queries and scripts

To view all queries and scripts sent to the server you need to launch SQL Monitor. It will show you the log of database operations and SQL queries as items, each consisting of 3 parts: Executed (the date and time of the operation), Operation (SQL statement sent to the server), Result (the result of the operation).

Note: SQL Monitor only displays scripts and queries executed in SQL Manager for InterBase/Firebird during current session.


Create a simple report in Report Designer

SQL Manager for InterBase/Firebird
  • Index
  • « Prev
  • Next »

Create simple report in the report designer

To create a report using Report Designer:

  1. Select the Tools | [image] Report Designer main menu item.
  2. In the opened Report Designer select the File | [image] New Report main menu item, or click the [image] New Report item of the navigation bar. The following objects will be added to the newly created report: ReportTitle, MasterData and PageFooter.
  3. Connect to data source.
  4. Add ADOTable or ADOQuery object.
  5. Link ADOTable or ADOQuery with ADODatabase.
  6. Place database fields on the Page1. Move the required fields from Data Tree to Band MasterData.


Transfer program settings

If you want to apply current program settings (wholly or partially) to SQL Manager for InterBase/Firebird installed on another machine you can save them into a single *.reg file. This can be done by means of the Save Settings Wizard.

Note that Favorite Queries are not saved in this case. To get access to your queries from another machine please store them in the database.


Update SQL Manager

SQL Manager for InterBase/Firebird can be updated in the following ways:

  1. Download the SQL Manager for InterBase/Firebird distribution package from the download page, then extract archive to the preferable directory (e.g. c:\unzipped). Close SQL Manager for InterBase/Firebird if it's opened and run IbManagerFullSetup.exe or IbManagerLiteSetup.exe.
  2. Select the Help | SQL Manager Direct, then press the Update button. If new SQL Manager for InterBase/Firebird version is released it will be offered for downloading. Click Yes in the dialog window to update SQL Manager for InterBase/Firebird automatically.


Report bugs and suggestions

  1. Before reporting bugs and suggestions make sure you are using the latest version of the SQL Manager for InterBase/Firebird.
  2. If so then you may contact us via Members Area on http://www.sqlmanager.net/, via Help main menu or by sending an email to support@sqlmanager.net.
  3. Please, don't forget to mention your OS version, InterBase/Firebird version and program version.
  4. Describe the steps to reproduce the bug in detail and illustrate them with screenshots.


Program interface

Main menu

The main menu allows you to perform various Database operations, open To-Do List and activate/deactivate Database Explorer, SQL Assistant and various toolbars within the View menu, manage your databases using items of the Tools and Services menus, customize the application using the Options menu, manage SQL Manager Windows using Window List and other tools, and access Registration information and product documentation, update the product to the latest version using the corresponding items available within the Help menu.

Appendix - Program interface - MainMenu

Note: To learn how to configure SQL Manager menus, refer to the Customize toolbars and menus page.

Navigation bars in object editors and program tools

Navigation bars are interface elements that enable users to quickly locate tools they need. Navigation bar items are displayed within a group with the help of links. A typical Navigation bar of SQL Manager contains links to commonly accessed tools (refresh, print, restore default size of the window), options pertaining to the editor or tool, and specific tools.

Appendix - Program interface - NavBar - Expanded

Navigation bar panes (groups) can be expanded/collapsed. When expanded, a pane provides access to its links; when collapsed, panes are displayed as headers only.

To expand/collapse a pane, click the pane header. The [image] [image] icons indicate the current pane state (collapsed/expanded respectively).

Appendix - Program interface - NavBar - Collapsed

Note: Depending on the current tab selection, Navigation bars in most of the program tools expand to one or more additional panes with tab-specific actions that can be useful for working with the object or service.

Hint: Most items of the Navigation bars are also available on the Toolbars.

Toolbars in the main program window, object editors and program tools

A toolbar is a horizontal row or vertical column of selectable image buttons that give the user a constantly visible reminder of and an easy way to select certain application functions. Most SQL Manager editors and tools are supplemented with toolbars.

Appendix - Program interface - Toolbar

To enable the toolbars in SQL Manager for InterBase/Firebird, open the Environment Options dialog, proceed to the Windows section there and select RadioButton Toolbar (if you need the toolbar only) or RadioButton Both (if you need both the toolbar and the Navigation bar) in the Bar style for child forms group.

Hint: Most SQL Manager toolbars are dockable, i.e. you can place a toolbar to any available location within the parent window.

To learn how to configure toolbar items, refer to the Customize toolbars and menus page.

Progress bars

A progress bar is an interface element that conveys the progress of a task or service. Several SQL Manager editors (e.g. Execute Script),tools (e.g. Dependency Tree) and wizards (e.g. Import Data Wizard) are supplemented with progress bars indicating the progress of lengthy operations.

The graphic of SQL Manager progress bars is accompanied by a textual representation of the progress in the percent format.

Splitters

Splitter controls are used to resize docked controls at run time. In SQL Manager for InterBase/Firebird the splitter controls are used on the main form, DB Explorer, and in program tools and editors as a separator between the working area and Navigation bars, status bars, etc.

Incremental Search bar

Incremental search bar is the tool which is available in the status bar area of some SQL Manager tools. The bar is normally called through the Ctrl+I shortcut. Type in the first letters of the search string, and the corresponding string will be highlighted in the search scope.


Viewing object DDL structure

The DDL (Data Definition Language) tab displays the SQL statement for creating the object with all its subobjects, if any. This text is read-only. If you want to change the object definition, use the appropriate editor tabs instead, or copy the text to the Windows Clipboard to paste it in the Query Data or Execute Script Editor.

Appendix - Viewing DDL structure

Hint: If more convenient, you can use the Save DDL to file and Open DDL in Query Data items available on the DDL pane within the Navigation bar of object editors.


Editing object description

The Description tab allows you to view and edit the comment for the object (optional).

Appendix - Editing object description

You can save changes made in this area by clicking the Save Description item on the Navigation bar.


Browsing object dependencies

The Dependencies tab allows you to view objects that depend on the object being edited, and the objects that the edited object depends on.

While the tree of dependencies is built, the progress bar is displayed in the status area of the editor window.

Appendix - Browsing object dependencies

Hint: To open a dependent object or a depending object in its editor, you can simply double-click the object alias in the Objects that <object_name> depends on and Objects that depend on <object_name> lists.

See also:

Dependency Tree


Setting object permissions

The Permissions tab allows you to view the permissions currently allocated for this object, and to grant permissions on the object to any of the existing grantees.

Privileges on object can be assigned for procedures and views.

Managing column permissions is available for tables and views.

Appendix - Setting object permissions

For details see Grant Manager.


Managing parameter properties

Select the object to create the field type on.

RadioButton Data type

Specifies that the parameter is based on a standard data type.

Appendix - Managing parameters - Data type

Type

Use the drop-down list of SQL data types to select the one to be applied for the parameter type.

For NUMERIC and DECIMAL data types set digit precision (digits of precision to store, 1 to 18) and scale (number of decimal places that can be stored, 1 to 18) in the appropriate boxes; for CHAR and VARCHAR set length (in characters), for BLOB data type set segment size and subtype.

Charset

Use the drop-down list to select the character set for the parameter type.

Collation

Use the drop-down list to specify the collation order to be used for string data.

CheckBox Not NULL

Enable this option to add the Not NULL attribute to the parameter.

CheckBox Use default value

Enable this option to specify the value this field will take by default. For details see Setting field defaults.

RadioButton Domain

Specifies that the parameter is based on a domain previously created in the database. Note that creating parameters based on a domain is only available for Firebird 2.1 and later.

Appendix - Managing parameters - Domain

Domain name

Select the domain name from the list of existing domains.

Collation

Use the drop-down list to specify the collation order to be used for string data.

Use Edit Domain button to edit the domain selected in Domain name or New Domain button to open Domain editor for creating the new domain.

CheckBox Full inheritance of domain attributes

If this option is set, the TYPE OF <domain_name> clause is generated, and data type of the domain is used.

CheckBox Not NULL

Enable this option to add the Not NULL attribute to the parameter.

Domain info displays the summary of the domain-based parameter: data type and size.

CheckBox Use default value

Enable this option to specify the value this data type will take by default. For details see Setting field defaults.

RadioButton Column

Specifies that the parameter is based on a field.

Appendix - Managing parameters - Column

-

Table name

Select the table to use field type from the dropdown list.

Field name

Select the filed name from the list of table fields to create the parameter type on.

CheckBox Not NULL

Enable this option to add the Not NULL attribute to the parameter.

Collation

Use the drop-down list to specify the collation order to be used for the parameter.

Column info displays the summary of the column-based parameter: data type and size.

CheckBox Use default value

Enable this option to specify the value this data type will take by default. For details see Setting field defaults.


Specifying input parameters

If the stored procedure (or function) has parameters, the Input Parameter dialog appears before the execution. It allows you to specify the values for all parameters. After changes are done, click the OK button to execute the stored procedure\function, or the Cancel button to abort the execution.

Appendix - Input Parameters

Also you can choose the recently used set of values in the table at the top of the window. To apply values from the table just double-click its row.


Viewing object operations

The Operations tab of Procedure Editor, Trigger Editor, Database Trigger Editor displays DML operations performed by the current procedure / trigger / database trigger respectively. On clicking an operation in the list you get the corresponding SELECT, INSERT, UPDATE or DELETE statement displayed in the Statement area below.

Appendix - Viewing object operations


Viewing performance analysis

The Performance Analysis tab of View Editor, Data Editor, Design Query editors displays the performance analysis for the query.

At the Reads sub-tab you can see the result of query execution. Visual comparison of indexed and with non-indexed reads is displayed on a diagram.

Appendix - Viewing performance analysis

At the Updates, Deletes and Inserts sub-tabs you can find statistics on the corresponding UPDATE/DELETE/INSERT operations.

Appendix - Viewing performance analysis - Updates

At the Summary sub-tab you can view full execution statistics for the query:

Appendix - Viewing performance analysis - Summary

The Query time, Memory and Operations sections display summary analysis of the query execution and can be copied to clipboard by pressing the corresponding button.

Statistics on indexed reads (IR), non-indexed reads (NIR), updates (UPD), deletes (DEL) and inserts (INS) are presented as a table.


Compile window

The Compile window is used to trace the errors and edit SQL statements during their compilation. The compilation window appears each time metadata is changed, both when the compilation is successful and when there are compilation errors.

Statement sequence

This area contains the list of operations and the result of their parsing (successful or error).

Selected statement

This area displays the SQL statement pending to be executed to perform metadata changing. In this area you can view and edit the SQL statement.

In case of a compilation error the Error tab also becomes visible - here you can view the error description returned by the server.

Commit

This button starts execution of the statement(s). Click it to commit the current transaction. This button is available only if there were no errors in compilation.

Rollback

This button cancels the script execution and allows you to return to the previous stage (editor window or DB Explorer).

Rollback and Recompile

This button calls for recompilation with the changes you made in the Selected statement editing area. Use this button after correcting the SQL statement.

Appendix - Changing Metadata window

If necessary, you can copy information to clipboard and save it in a text editor afterwards (the button is only enabled when a compilation error occurs).

If you want this window to appear only in case of an error, uncheck the CheckBox Confirm successful compilation option (checked by default) available within the Confirmations section of the Environment Options dialog.

If object compilation requires recompilation of its dependencies, the Compile window looks like in the screenshot below.

Appendix - Dependent Objects


Find Text dialog

The Find Text dialog is provided for quick and flexible searching for specified text within the working area of SQL Manager editors.

Text to find
Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Options

CheckBox Search in DDL

This option includes object definition in search scope.

CheckBox Case sensitive
This option can be used to differentiate uppercase characters from lowercase ones during the search process.

CheckBox Whole words only
Use this option to search for words only (with this option off, the search string might be found within longer words.)

CheckBox Regular expressions
Recognizes regular expressions in the Text to find field.

For example, you can type "empl*" to search for metadata containing the "empl" substring; enter "^emp" to search for words starting with "emp" or "^emp|emp$" to search for the string "emp" at the beginning or at the end of the string.

Note: The syntax of regular expressions that can be used in the Text to find field is similar to that used in Perl regular expressions. Comprehensive information about it can be found at http://perldoc.perl.org/perlre.html#Regular-Expressions.

Direction

RadioButton Forward

Searches from the current position to the end of the working area.

RadioButton Backward

Searches from the current position to the beginning of the working area.

Scope

RadioButton Global

Searches within the entire working area, in the direction specified by the Direction setting.

RadioButton Selected text

Searches only within the currently selected text, in the direction specified by the Direction setting. You can use the mouse or block commands to select a block of text.

Origin

RadioButton From cursor

The search starts at the cursor's current position, and then proceeds either forward to the end of the scope, or backward to the beginning of the scope depending on the Direction setting.

RadioButton Entire scope

The search covers either the entire block of selected text or the entire script (no matter where the cursor is in the Editor area) depending upon the Scope options.

CheckBox Mark search result with stack marker

The option toggles marking search results. If this option is selected, stack markers are set at all search positions - this makes it possible to jump from one marker (search result) to another within the text.

Click the Show All button to highlight every occurrence of the search string.


Replace Text dialog

The Replace Text dialog is provided for searching and replacing text within the working area of SQL Manager editors.

Text to find
Enter a search string in this box. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered search strings.

Text to replace
This box allows you to enter a string to replace the search string. The Arrow-Down button which can be found next to the input box allows you to select any of the previously entered strings. To replace the search string with an empty string, leave this input box blank.

Options

CheckBox Case sensitive
This option can be used to differentiate uppercase characters from lowercase ones during the search process.

CheckBox Whole words only
Use this option to search for words only (with this option off, the search string might be found within longer words.)

CheckBox Regular expressions
Recognizes regular expressions in the Text to find field.

CheckBox Replace with template
This option requires the Regular expressions option selection.

Enable this option to use regular expressions in the Text to replace field. Expression used in this field will be applied to each string that matches the Text to find expression.

Note: The syntax of regular expressions that can be used in the Text to find and the Text to replace fields is similar to that used in Perl regular expressions. Comprehensive information about it can be found at http://perldoc.perl.org/perlre.html#Regular-Expressions.

CheckBox Prompt on replace
Check this option if you wish to be prompted before replacing upon each occurrence of the search string. When this option is off, the search string is replaced automatically.

Direction

RadioButton Forward
Searches and replaces from the current position to the end of the working area.

RadioButton Backward
Searches and replaces from the current position to the beginning of the working area.

Scope

RadioButton Global
Searches and replaces within the entire working area, in the direction specified by the Direction setting.

RadioButton Selected text
Searches and replaces only within the currently selected text, in the direction specified by the Direction setting. You can use the mouse or block commands to select a block of text.

Origin

RadioButton From cursor
The search and replace process starts at the cursor's current position, and then proceeds either forward to the end of the scope, or backward to the beginning of the scope depending on the Direction setting.

RadioButton Entire scope
The search and replace process covers either the entire block of selected text or the entire script (no matter where the cursor is in the Editor area) depending upon the Scope options.

CheckBox Mark search result with stack marker
The option toggles marking search results. If this option is selected, stack markers are set at all search positions - this makes it possible to jump from one marker (search result) to another within the text.

Click the Replace All button to replace every occurrence of the search string. If you have checked the Prompt on replace option, the confirmation dialog box appears upon each occurrence of the search string.


Format specifiers

The following format specifiers are supported in the format string:

Float/Integer format

0

Digit place holder. If the value being formatted has a digit in the position where the '0' appears in the format string, then that digit is copied to the output string. Otherwise, a '0' is stored in that position in the output string.

#

Digit placeholder. If the value being formatted has a digit in the position where the '#' appears in the format string, then that digit is copied to the output string. Otherwise, nothing is stored in that position in the output string.

.

Decimal point. The first '.' character in the format string determines the location of the decimal separator in the formatted value; any additional '.' characters are ignored.

,

Thousand separator. If the format string contains one or more ',' characters, the output will have thousand separators inserted between each group of three digits to the left of the decimal point. The placement and number of ',' characters in the format string does not affect the output, except to indicate that thousand separators are wanted.

E+

Scientific notation. If any of the strings 'E+', 'E-', 'e+', or 'e-' are contained in the format string, the number is formatted using scientific notation. A group of up to four '0' characters can immediately follow the 'E+', 'E-', 'e+', or 'e-' to determine the minimum number of digits in the exponent. The 'E+' and 'e+' formats cause a plus sign to be output for positive exponents and a minus sign to be output for negative exponents. The 'E-' and 'e-' formats output a sign character only for negative exponents.

Date/Time format

c

Displays the date using the format using the Short Date Format, followed by the time using the Long Time Format. The time is not displayed if the date-time value indicates midnight precisely.

d

Displays the day as a number without a leading zero (1-31).

dd

Displays the day as a number with a leading zero (01-31).

ddd

Displays the day as an abbreviation (Sun-Sat) using the strings of the Short Day Names.

dddd

Displays the day as a full name (Sunday-Saturday) using the strings of the Long Day Names.

ddddd

Displays the date using the Short Date Format.

dddddd

Displays the date using the Long Date Format.

e

Displays the year in the current period/era as a number without a leading zero (Japanese, Korean and Taiwanese locales only).

ee

Displays the year in the current period/era as a number with a leading zero (Japanese, Korean and Taiwanese locales only).

g

Displays the period/era as an abbreviation (Japanese and Taiwanese locales only).

gg

Displays the period/era as a full name. (Japanese and Taiwanese locales only).

m

Displays the month as a number without a leading zero (1-12). If the m specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.

mm

Displays the month as a number with a leading zero (01-12). If the mm specifier immediately follows an h or hh specifier, the minute rather than the month is displayed.

mmm

Displays the month as an abbreviation (Jan-Dec) using the strings given of the Short Month Names.

mmmm

Displays the month as a full name (January-December) using the strings of the Long Month Names.

yy

Displays the year as a two-digit number (00-99).

yyyy

Displays the year as a four-digit number (0000-9999).

h

Displays the hour without a leading zero (0-23).

hh

Displays the hour with a leading zero (00-23).

n

Displays the minute without a leading zero (0-59).

nn

Displays the minute with a leading zero (00-59).

s

Displays the second without a leading zero (0-59).

ss

Displays the second with a leading zero (00-59).

z

Displays the millisecond without a leading zero (0-999).

zzz

Displays the millisecond with a leading zero (000-999).

t

Displays the time using the Short Time Format.

tt

Displays the time using the Long Time Format.

am/pm

Uses the 12-hour clock for the preceding h or hh specifier, and displays 'am' for any hour before noon, and 'pm' for any hour after noon. The am/pm specifier can use lower, upper, or mixed case, and the result is displayed accordingly.

a/p

Uses the 12-hour clock for the preceding h or hh specifier, and displays 'a' for any hour before noon, and 'p' for any hour after noon. The a/p specifier can use lower, upper, or mixed case, and the result is displayed accordingly.

ampm

Uses the 12-hour clock for the preceding h or hh specifier, and displays the contents of the TimeAMString global variable for any hour before noon, and the contents of the TimePMString global variable for any hour after noon.

/

Displays the date separator character using the Date Separator.

:

Displays the time separator character using the Time Separator.

'xx'/"xx"

Characters enclosed in single or double quotes are displayed as-is, and do not affect formatting.


Language Info Editor

The Language Info Editor dialog allows you to set the language name and specify the corresponding *.lng localization file. This dialog is opened when you add or edit a language (see Environment Options | Localization).

Language Name

The name of the language that is displayed in the Select Program Language dialog and within the Available Languages list of the Environment Options | Localization section.

Language File

The *.lng file containing the translated string resources. See the %program_directory%\Languages folder to find already existing localization files.

Adding a language

The Add language dialog allows you to specify your own localization file and set the language name.

Editing a language

The Edit language dialog allows you to change the language name or select another localization file for the specified language.


Using templates

For your convenience the ability to use templates is provided by SQL Manager for InterBase/Firebird. A template is a named collection of wizard options stored in a file.

Instead of performing a long chain of routine steps all the time you can save all the options of the wizard for future use as a template file. Select the Templates | Save Template drop-down menu item, specify the template file name and set an optional comment for the template file.

When starting the wizard next time, you can load the template by selecting the Templates | Load Template drop-down menu item.

Note that saving/loading of templates is possible at any step of the wizard.


Supported file formats

RadioButton MS Excel 97-2003

The most popular e-table format used by Microsoft® Excel (*.xls). The result files are fully compatible with Microsoft® Excel versions 97-2000, 2003 and XP.

RadioButton MS Access 97-2003

File of Microsoft® Access 97-2003 format (*.mdb) with an ADO connection used.

RadioButton MS Word 97-2003

One of the most popular text processing formats used by Microsoft® Word (*.doc). The result files are fully compatible with Microsoft® Word versions 97-2000, 2003 and XP.

RadioButton RTF

Rich Text Format (*.rtf) supported by many text processing programs (e.g. WordPad).

RadioButton HTML

Hyper Text Markup Language file format (*.html, *.htm), complete compatibility with HTML 4.0 specification.

RadioButton PDF

A standard format in electronic publishing (*.pdf).

RadioButton Text file

Plain text file format (*.txt).

RadioButton CSV file

Comma-Separated Value file format (*.csv).

RadioButton DIF file

Data Interchange File (*.dif) format.

RadioButton SYLK

Symbolic Links (*.slk) file format.

Note: all the text formats including Text file, CSV, DIF, SYLK are usually used as working or interchange formats.

RadioButton LaTeX

A specific file format (*.tex) which is a popular (especially among mathematicians and physicists) macroextension of TeX pack developed by D.Knut.

RadioButton XML

A markup language for documents containing structured information (*.xml).

RadioButton DBF

Database file format (*.dbf) used by dBASE and a number of xBASE applications.

RadioButton MS Excel

The contemporary e-table format used by Microsoft® Excel (*.xlsx). The result files are fully compatible with Microsoft® Excel 2007.

RadioButton MS Access

File of Microsoft® Access 2007 format (*.accdb) with an ADO connection used.

RadioButton MS Word

The contemporary text processing format used by Microsoft® Word (*.docx). The result files are fully compatible with Microsoft® Word 2007.

RadioButton ODF Spreadsheets

OASIS Open Document Format for Office Applications - open document file format for spreadsheets (*.ods) used by a number of applications including OpenOffice.org and KOffice.

RadioButton ODF text

OASIS Open Document Format for Office Applications - open document file format for word processing (*.odt) documents used by a number of applications including OpenOffice.org and KOffice.


To-Do List

The To-Do List window allows you to make up a list of tasks for the database.

To call this window, select the View | To-Do List main menu item, or use the Shift+Ctrl+T shortcut.

The task list is displayed in a form of a grid. Its columns (Action, Priority, User, Category) correspond to the task parameters. Click the column caption to sort the task list by the current parameter or change the sorting direction. Use the Navigation bar and context menu to add, edit, and delete to-do items.

Appendix - To-Do List

Database

Select the database to apply the task list to. When switching between the databases you can view different task lists.

To add a task to this list, click the Add Item link on the Navigation bar, or select Add Item from the context menu. You can also use the Ins key for the same purpose. Define the task parameters and click OK to add the new task to the list.

Appendix - To-Do List - Edit To-Do item

Text

Optional text to describe the task.

Priority

Set a numeric value to indicate the priority of the task.

User Name

The database User name this task is applied to.

Category

Set a category for the task. Using categories may be useful for grouping tasks.

To modify a task, select the task in the list and click the Edit Item link of the Navigation bar, or select Edit Item in the context menu. You can also use the Enter key for the same purpose.

To remove a task, select the task in the list and click the Delete Item link of the Navigation bar, or select Delete Item in the context menu. You can also use the Del key for the same purpose.

To remove all tasks from To-Do List, click the Delete all link of the Navigation bar, or select Delete all in the context menu. You can also use the Ctrl+Del shortcut for the same purpose.


Windows List

The Windows List panel allows you to browse the list of windows that are currently opened within SQL Manager for InterBase/Firebird IDE.

To activate this panel as a DB Explorer tab, select the Windows | Window List main menu item, or use the Ctrl+Alt+0 shortcut.

Appendix - Window List

If necessary, you can right-click within the list area to call the popup menu which allows you to bring a window to foreground, close windows one by one or in groups, and to arrange the windows according to your preferences.


Customize toolbars and menus

For your convenience SQL Manager for InterBase/Firebird provides toolbars and menus that you can customize, so the commands you use frequently are readily available and easily identifiable.

The Customize dialog allows you to create and personalize SQL Manager menus and toolbars.

To call this dialog, click More buttons... btnMoreButtons on the right side of any toolbar, then click Add or Remove Buttons and select Customize... from the drop-down menu. Alternatively, you can right-click any toolbar and select the Customize... popup menu item.

Toolbars

Toolbars

This list displays all currently existing toolbars of SQL Manager (both default and user-defined toolbars). Check/uncheck the box at a toolbar name to show/hide the toolbar.

New...

Use this button to add a new user-defined toolbar to the Toolbars list. Set a name for the newly created toolbar and dock it by dragging it to any permitted location within the application window.

Rename...

Use this button to rename the selected user-defined toolbar.

Delete

Use this button to delete the selected user-defined toolbar.

Appendix - Customize - Toolbars

Commands

This tab allows you to browse the list of all commands available within the menus and toolbars of the application window. Selecting categories in the Categories list displays commands of the selected category (e.g. 'Database' or 'Tools') in the Commands list.

If necessary, you can pick a command and drag it to any toolbar to create a button for this command.

Appendix - Customize - Commands

Options

Personalized Menus and Toolbars

CheckBox Menus show recently used commands first

This option determines whether the most frequently used items will be placed in menus at first position.

If this option is enabled, frequently used menu items are "promoted" and displayed higher on the list. Unused and infrequently used menu items are visually suppressed and appear "collapsed".

CheckBox Show full menus after a short delay

This option is available only if the Menus show recently used commands first option is selected.

If this option is enabled, infrequently used menu items (if they appear "collapsed") will be automatically expanded after a delay upon setting mouse cursor (or upon selection with the Up/Down keys) on the bottom of the menu. Otherwise, the menu expands only after clicking its bottom-most button (or using the Ctrl+Down shortcut).

Reset my usage data

Resets the lists of recently used commands in the toolbars and menus.

Appendix - Customize - Options

Other

CheckBox Large icons

This option displays larger icons on the parent window toolbars.

CheckBox Show ToolTips on toolbars

If this option is selected, ToolTips (hints) popup when the mouse cursor is positioned over a toolbar button.

CheckBox Show shortcut keys in ToolTips

If this option is selected, the corresponding shortcuts are displayed in ToolTips (hints) for toolbar buttons.

Menu animations

Use the drop-down list to specify the menu animation effects:

None (no animation)

Random (random choice: Unfold, Slide, Fade)

Unfold (unfolding menus)

Slide (sliding menus)

Fade (menus fade in when appearing)


SSH tunneling options

SSH (Secure Shell Host) protocol is used to heighten computer security when working with Unix systems on the Internet. SSH uses several encryption algorithms of different reliability. The spread of SSH is also related to the fact that a number of *nix operating systems (e.g. FreeBSD) include SSH server in their standard distributions. To learn more about SSH, please visit http://openssh.org.

The SSH tunneling feature of SQL Manager is a means of ensuring secure connection to InterBase/Firebird servers when working over insecure connection channels. You can also use SSH tunnel to get access to the remote InterBase/Firebird servers when port 3306 is closed for external connections for some reasons.

The connection via SSH tunnel works in the following way.

First, a connection is established and the process of authentication between SSH client built in SQL Manager and remote InterBase/Firebird server is performed. Then all incoming and outgoing information between the application and InterBase/Firebird is transmitted through SSH server with the help of a communication port (regularly port 22), and SSH server transfers this information directly to InterBase/Firebird server.

To setup the connection via SSH tunnel, input the following values in the corresponding fields:

  • SSH host name is the name of the host where SSH server is running
  • SSH port indicates the port where SSH server is activated
  • SSH user name stands for the user on the machine where SSH server is running (Note: it is a Linux/Windows user, not a user of InterBase/Firebird server)
  • SSH password is the Linux/Windows user password

Please note that InterBase/Firebird host name should be set relatively to the SSH server in this case. For example, if both InterBase/Firebird and SSH servers are located on the same computer, you should specify localhost as host name instead of the server external host name or IP address.

Appendix - SSH tunneling options

CheckBox Use Private Key for authentication

If the SSH encryption is enabled on the SSH server, a user can generate a pair of cryptographic keys (the Private key and the Public key). The Public key is placed on the SSH server, and the Private key is the part you keep secret inside a secure box that can only be opened with the correct passphrase (or an empty string as the passphrase). When you wish to access the remote system, you open the secure box with your passphrase (if any), and use the private key to authenticate yourself with the Public key on the remote Linux computer.

SSH Key file

Specify the location (the secure box) of the Private key file on your local machine.

Supported Private Key file formats are:

OpenSSH

Putty

SSH.com

Note that you need to trust your local machine not to scrape your passphrase or a copy of your Private key file while it is out of its secure box.

SSH Private Key - Passphrase


Quick save / Quick load

The Quick save / Quick load features available on the Navigation bar of most object editors allow you to save/load object's DDL quickly bypassing standard means by saving/loading changes to/from from internal buffers.

Appendix - Quick Save and Quick Load


Connection Lost dialog

When InterBase/Firebird server connection loss is detected by SQL Manager, the Connection Lost dialog is displayed. You can choose one of available options in this case:

RadioButton Close database
The application closes the database, and its objects are no more displayed in DB Explorer and child windows.

RadioButton Try to reconnect
The application tries to reconnect to the server.

Appendix - Connection Lost


SQL Manager Direct

SQL Manager Direct is a feature of SQL Manager for InterBase/Firebird which provides you with quick access to the related Internet resources and allows you to keep your SQL Manager version up-to-date.

To open the SQL Manager Direct window, select the Help | SQL Manager Direct item from the main menu.

On opening SQL Manager Direct or pressing the Update button, program checks for updates available at EMS Software Development server.

Links to sqlmanager.net resources provided by the SQL Manager Direct window are grouped into several sections:

  • SQL Manager for InterBase/Firebird News
  • General Information
  • Downloads
  • Related Products

Upon a link selection you will be immediately forwarded to the corresponding resource.

SQL Manager for InterBase/Firebird News

This section takes you directly to the latest EMS news column. Using the links you can get up-to-date news, product information and downloads from sqlmanager.net.

General Information

This section offers a number of links to product news, features, Feature Matrix, system requirements, testimonials and much more.

Downloads

Using links of this section you can download other product versions and documentation from the download page.

Related Products

This section allows you to browse the list of related products developed by EMS Database Management Solutions, Inc.

Appendix - SQL Manager Direct

Use the btnBack btnForward buttons to navigate in the same way as you normally do it using a web browser.

Click the Update button to refresh the page.

If a newer version of SQL Manager is available on the server the program will inform you via corresponding dialog window. You can use this window to download this version.

CheckBox Automatically poll network in interval (in days)

If this option is selected, the page is refreshed automatically after the specified time interval. Use the spinner control to set the interval (in days).

In the Status area at the bottom of the SQL Manager Direct window you can find the status of your request to the sqlmanager.net website.

Note: Internet connection settings defined at Windows Control panel affect this page displaying. If a proxy-server requiring authorization is used, then authorization parameters should be defined via dialog window, that appears on opening SQL Manager Direct page or on pressing the Update button.


Login Host / Login Database dialogs

The Login Host dialog appears each time a connection request is sent to a server which requires authentication, i.e. on attempt to connect to a host if no password was specified to authorize the user or if the Login prompt before connection option is enabled on the Options page of the Host Registration Info dialog.

Appendix - Login Host

The application prompts you to specify host connection parameters to access the specified host: user name, password, role, and SSH tunneling settings (if used).

Note: The SSH login info group is available only if SSH tunneling is used for the host connection.

The Login Database dialog appears each time a connection request is sent to a database which requires authentication, i.e. on attempt to connect to a database if no password was specified to authorize the user or if the Login prompt before connection option is enabled on the Options page of the Database Registration Info dialog.

Appendix - Login Database

The application prompts you to specify host connection parameters to access the specified database: user name, password, role, and SSH tunneling settings (if used).

Note: The SSH login info group is available only if SSH tunneling is used for the database connection.


Overwriting existing output file

If a file having the same name as specified for an output file generated by SQL Manager already exists, a warning dialog is displayed.

Appendix - Overwrite File Warning dialog

You can Overwrite the file, Make it Unique, or Cancel both and change the path or file name manually.

The application makes the file unique by adding the current timestamp to the specified file name if the CheckBox Add Timestamp to filename option is enabled, or by adding a simple numeric postfix to the file name if this option is disabled.


Script conversion

The Script conversion dialog allows you to select encoding to be used for script conversion upon loading script to one of SQL Manager editors (Query Data, Execute Script Editor) from an external file.

Appendix - Script conversion

RadioButton Windows default

Specifies that the standard Windows encoding will be used for the script conversion.

RadioButton Database default

Specifies that the default encoding of the database will be used for the script conversion.

RadioButton Other encoding

Allows you to select the encoding that will be used for the script conversion.

Preview

This area displays the script with the current encoding parameters applied.


Select Object dialog

The Select Object dialog appears each time the application requests a database object selection, e.g. upon a root object selection for the Dependency Tree tool, or when choosing an object to be added to a Favorite Objects folder.

Appendix - Select Object

First select the object type in the list on the left-hand side of the window. Pick the object you need and click OK the apply your selection.


SQL Manager shortcuts

Database management

Shift+Ctrl+R | Register a InterBase/Firebird host using Register Host Wizard
Shift+Alt+R | Register a database using Register Database Wizard
Shift+Alt+U | Unregister the selected database
Shift+Ctrl+C | Connect to a database
Shift+Ctrl+D | Disconnect from a database

Database objects management

Ctrl+N | Create a new object (the object type depends on the current selection)
Ctrl+O | Edit the selected object in its editor
Ctrl+R | Rename the selected object
Shift+Del | Drop the selected object
Ctrl+Shift+C | Collapse the current DB Explorer tree branch and switch selection to the parent tree node
F9 | Execute a procedure
Shift+Ctrl+F9 | Debug a procedure

SQL Manager tools

F11 | View/hide Database Explorer
Ctrl+F | Search for an item in the DB Explorer tree
Shift+Ctrl+T | Open the To-Do List window
F12 | Show Query Data Editor
Shift+F12 | Open a new instance of Query Data Editor
Shift+Ctrl+M | Open SQL Monitor
Shift+Ctrl+S | Open Execute Script Editor
Shift+Ctrl+L | Open Localization Editor
Ins | Add a new table subobject (the subobject type depends on the current tab selection)

Data Grid

Ctrl+Shift+0

Set the selected column value to NULL

Query Data and Execute Script (fixed and default)

F9 | Execute query/script
Alt+F9 | Execute selected only
Ctrl+Alt+F9 | Execute under cursor
Ctrl+Alt+F2 | Reset execution point (Query Data only)
Shift+Ctrl+<digit> | Toggle bookmark #<digit>
Ctrl+<digit> | Go to bookmark #<digit>
Ctrl+Q,N | Go to next bookmark
Ctrl+Q,P | Go to previous bookmark
F2 | Drop marker to current position
Ctrl+Z; Alt+BkSp | Undo
Shift+Ctrl+Z; Shift+Alt+BkSp | Redo
Ctrl+F | Search for text using the Find Text dialog
Ctrl+R | Replace text using the Replace Text dialog
F3 | Search next
Ctrl+I | Start incremental search
Alt+G | Go to line number (an input number dialog prompts for the number)
Ctrl+L | Load a script from an external file
Ctrl+S | Load the script to an external file
Shift+Ctrl+Q | Save text as Favorite
Shift+Ctrl+F | Format SQL text using SQL Formatter
Alt+<symbol> | Switch to the query with <&symbol> in its name (Query Datacx` only)
Ctrl+J | Insert a keyboard template
Shift+Ctrl+F | Format SQL
Ctrl+Alt+Left | Switch to the next tab of Query Data
Ctrl+Alt+Right | Switch to the previous tab of Query Data
Ctrl+Alt+PgUp | Switch to the last tab of Query Data
Ctrl+Alt+PgDown | Switch to the first tab of Query Data
Shift+Ctrl+Left | Select the previous word
Shift+Ctrl+Right | Select the next word
Shift+Home | Select text to the beginning of the line
Shift+End | Select text to the end of the line
Shift+PageUp | Select one page up
Shift+PageDown | Select one page down
Shift+Ctrl+PageUp | Select text to the first line on the page
Shift+Ctrl+PageDown | Select text to the last line on the page
Shift+Ctrl+Home | Select text to the absolute beginning
Shift+Ctrl+End | Select text to the absolute end
Shift+Alt+Left | Select column symbol-by-symbol to the left
Shift+Alt+Right | Select column symbol-by-symbol to the right
Shift+Alt+Up | Select column upwards
Shift+Alt+Down | Select column downwards
Shift+Alt+Home | Select column to the first char of line
Shift+Alt+End | Select column to the last char of line
Shift+Alt+PageUp | Select column to the beginning of the page
Shift+Alt+PageDown | Select column to the end of the page
Shift+Ctrl+Alt+Home | Select column from the current cursor position to the beginning of the first line
Shift+Ctrl+Alt+End | Select column from the current cursor position to the beginning of the last line
Ctrl+Up | Scroll up one line with cursor position unchanged
Ctrl+Down | Scroll down one line with cursor position unchanged
Alt+Down, Alt+Up | Toggle case of a current word
Ctrl+G,Ctrl+F | Collapse block at current line
Ctrl+G,Ctrl+E | Expand block at current line
Ctrl+G,Ctrl+M | Collapse all blocks in the text
Ctrl+G,Ctrl+P | Expand all blocks in the text
Ctrl+= | Collapse/expand the nearest block
Esc | Collect marker (jump back)
Shift+Esc | Swap marker to current position
Shift+Ctrl+B | Jump to matching bracket (change range side)
Shift+Ctrl+I | Indent selected block
Shift+Ctrl+U; Shift+Tab | Unindent selected block
Ctrl+/ | Comment/uncomment selected block
Ctrl+Space | Show code completion
Ctrl+Shift+Space | Call a hint listing parameters for added procedures and UDFs
Ctrl+Alt+Space | Show character map
Ctrl+Alt+P | Show procedures
Ctrl+Alt+V | Show views
Ctrl+Alt+T | Show tables
Ctrl+Alt+G | Show triggers
Ctrl+Alt+U | Show UDFs
Ctrl+Alt+Enter | Show table in SQL Assistant
Ctrl+Alt+M | Show domains
Ctrl+Alt+E | Show generators
Ctrl+Alt+X | Show exceptions
Ctrl+Alt+R | Show roles
Ctrl+C; Ctrl+Ins | Copy selection to Clipboard
Ctrl+X; Shift+Del | Cut selection to Clipboard
Ctrl+V; Shift+Ins | Paste Clipboard to current position
Ctrl+T | Delete from cursor to the next word
Ctrl+BkSp | Delete from cursor to the beginning of the word
Ctrl+B | Delete from cursor to the beginning of the line
Shift+Ctrl+Y | Delete from cursor to the end of the line
Ctrl+Y | Delete the current line
Ctrl+O,N | Normal selection mode
Ctrl+O,C | Column selection mode
Ctrl+O,L | Line selection mode
Ctrl+M; Enter; Shift+Enter | Break line at current position, move caret to a new line
Ctrl+Alt+I | Insert Tab char
F5 | Toggle breakpoint
Shift+F5 | Enable/disable brakpoint

Print Data View

Ctrl+O | Load a printing report from a file
Ctrl+S | Save the report to file
Ctrl+P | Open the Print dialog
Ctrl+Home | Go to the first page
Ctrl+Up | Go to the previous page
Ctrl+Down | Go to the next page
Ctrl+End | Go to the last page
Ctrl+D | Open Report Formatter
Ctrl+\ | Zoom 100%
Ctrl+0 | Zoom page width
Ctrl+1 | Whole page
Ctrl+2 | Two pages
Ctrl+4 | Four pages
Ctrl+W | Widen to source width
Ctrl+M | Show/hide margins
Ctrl+K | Set background color for the report

Working with windows, menus and tabs

Ctrl+Tab | Switch to the next tab
Ctrl+Alt-0 | Open Windows List
Ctrl+Alt+D | Set defaults to all windows
Ctrl+F6 | Switch to the previous window
F6 | Switch to the next window
Ctrl+W | Close the active window
Ctrl+Down | Expand a collapsed menu
Ctrl+Shift+N | Move to the next tab in DB Explorer
Ctrl+Shift+P | Move to the previous tab in DB Explorer